<?php

namespace App\Exports;

use Maatwebsite\Excel\Concerns\FromCollection;
use Illuminate\Support\Collection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\Exportable;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithStyles;
use PhpOffice\PhpSpreadsheet\Worksheet\Worksheet;

class CityBillUnsubmittedExportReport implements FromCollection, WithHeadings, ShouldAutoSize, WithStyles
{
    use Exportable;

    protected $data;

    public function __construct(Collection $data)
    {
        $this->data = $data;
    }

    public function collection()
    {
        return $this->data;
    }

    public function headings(): array
    {
        // Define your header row here dynamically
        return [
            'Reference No.',
            'Functionary ID',
            'Functionary Name',
            'Exam Name',
            'Bill Status',
            'Functionary Role',
            'Center No.',
            'Exam ID',
            'Mobile No.',
            'Bill Submitted Date',
        ];
    }

    public function styles(Worksheet $sheet)
    {
        // Apply styles to header row (A1:C1 in Excel)
        $sheet->getStyle('A1:J1')->applyFromArray([
            'font' => [
                'bold' => true,
            ],
            'fill' => [
                'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                'startColor' => [
                    'rgb' => 'FFFF00', // Yellow background color
                ],
            ],
        ]);
        // Freeze the first row
        $sheet->freezePane('A2');
    }
}
