<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;
use Illuminate\Pagination\LengthAwarePaginator;
use Illuminate\Support\Collection;
use DB;
use Auth;
use Redirect;
use Config;


class ActivityLogController extends Controller
{
    public function __construct()
    {
        $this->middleware(function ($request, $next) {
            if (auth()->guest()) {
                return redirect()->route('home');
            }
            // echo 
            return $next($request);
        });
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index(Request $request)
    {   
        try{
            $user = Auth::user();
            $userName = $user ? str_replace(' ', '_', $user->UserName) : 'guest';
            $path = 'customlog/' . $userName . '.json';
    
            if (Storage::disk('local')->exists($path)) {
                $logData = Storage::disk('local')->get($path);
                $logEntries = explode(PHP_EOL, trim($logData));
    
                $logs = array_map(function ($entry) {
                    return json_decode($entry, true);
                }, $logEntries);
                $data=array_values(array_filter($logs));
                krsort($data);
                
                $page = $request->input('page', 1);

                // Number of items per page
                $perPage = 10;
            
                // Convert array to Laravel Collection
                $collection = Collection::make($data);
            
                // Slice the collection to get the items for the current page
                $currentPageItems = $collection->slice(($page - 1) * $perPage, $perPage)->values();
            
                // Create the paginator
                $paginator = new LengthAwarePaginator(
                    $currentPageItems,
                    $collection->count(),
                    $perPage,
                    $page,
                    ['path' => $request->url(), 'query' => $request->query()]
                );

            return view('activitylog.index',['data'=>$paginator]);
            }
        return view('activitylog.index',['data'=>'']);

        } catch (\Exception $e) {
            $message = $e->getMessage();
            dd($message);
            return redirect()->back()->with('error',$message);
        }
    }


     

    
}
