<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use Auth;
use Redirect;
use Config;
use Illuminate\Pagination\LengthAwarePaginator;
use Illuminate\Pagination\Paginator;
use Illuminate\Support\Collection;

class ExamDetailController extends Controller
{

    public function index(Request $request)
    {

        if (empty(Auth::user()->UserName)) {
            return redirect('/');
        }

        $username = Auth::user()->UserName;
        try {

             $examDetails= DB::select(DB::raw("getExamListSP '$username'"));
            
        $currentPage = Paginator::resolveCurrentPage() ?? 1;
        $perPage = 10;
        $collection = collect($examDetails);
        $currentPageItems = $collection->slice(($currentPage - 1) * $perPage, $perPage)->all();
        $paginatedItems = new LengthAwarePaginator($currentPageItems, count($collection), $perPage, $currentPage, [
                'path' => Paginator::resolveCurrentPath(),
                'query' => $request->query(),
            ]);
        // prd($collection);
        $serialNo=($perPage*$currentPage)-$perPage;

            return view('examdetail.examdetail')->with(['data' => $paginatedItems,'page' => $serialNo]);
        } catch (\Exception $e) {
            $message = $e->getMessage();
            dd($message);
            return redirect()->back()->with('error', $message);
        }
    }
}
