<?php

namespace App\Http\Controllers;

use App\Traits\CommonBillData;
use Illuminate\Support\Facades\Log;
use PDF;
use setasign\Fpdi\Fpdi;
// use setasign\Fpdi\PdfReader\StreamReader;


class PdfDownloadController extends Controller
{
    use CommonBillData;
    public function index()
    {
        try {
            dd('ddd');
        } catch (\Exception $e) {
            $message = $e->getMessage();
            dd($message);
            return redirect()->back()->with('error', $message);
        }
    }

    public function old___downloadPdf($ReferenceNo = NULL, $ExamType = NULL, $role = NULL, $pdf = NULL,$ObserverID = NULL)
    {

        try {

            $data = $this->getCCBilldata($ReferenceNo, $ExamType, $role, $pdf);
            $pdfView = PDF::loadView('submitbillsreport.cc-preview-bill', $data);
            return $pdfView->download($ReferenceNo . '-' . $ExamType . '-' . '.pdf');
        } catch (\Exception $e) {
            $message = $e->getMessage();
            Log::error('Form submission error: ' . $e->getMessage(), [
                'exception' => $e
            ]);
            return redirect()->back()->with('error', $message);
        }
    }

    public function old_____CS_PDF_Report($ReferenceNo = NULL, $ExamType = NULL, $role = NULL, $pdf = NULL, $CenterNo = NULL)
    {

        try {

            $CSdata = $this->getCSuperBilldata($ReferenceNo, $ExamType, $role, $pdf,$CenterNo);
            $pdfView = PDF::loadView('submitbillsreport.csbill', $CSdata);
            return $pdfView->download($ReferenceNo . '-' . $ExamType . '-' . '.pdf');
        } catch (\Exception $e) {
            $message = $e->getMessage();
            Log::error('Form submission error: ' . $e->getMessage(), [
                'exception' => $e
            ]);
            return redirect()->back()->with('error', $message);
        }
    }

    public function old____OBS_PDF_Report($ReferenceNo = NULL, $ExamType = NULL, $role = NULL, $pdf = NULL, $ObserverID = NULL, $centers = NULL)
    {

        try {

            $data = $this->getObsBillData($ReferenceNo, $ExamType, $role, $pdf);
           // prd($data);
            $pdfView = PDF::loadView('submitbillsreport.obs-preview-bill', $data);
            return $pdfView->download($ReferenceNo . '-' . $ExamType . '-' . '.pdf');
        } catch (\Exception $e) {
            $message = $e->getMessage();
            Log::error('Form submission error: ' . $e->getMessage(), [
                'exception' => $e
            ]);
            return redirect()->back()->with('error', $message);
        }
    }

    public function OBS_PDF_Report($ReferenceNo = NULL, $ExamType = NULL, $role = NULL, $pdf = NULL, $ObserverID = NULL, $centers = NULL)
    {

        try {
            if (is_array($ReferenceNo)) {
                // Initialize FPDI for PDF merging
                $pdfMerger = new Fpdi();

                for ($i = 0; $i < count($ReferenceNo); $i++) {
                    // Get data for the PDF
                    $data = $this->getObsBillDataNewBulk($ReferenceNo[$i], $ExamType[$i], $role[$i], $pdf, $ObserverID[$i], $centers[$i]);

                    $pdfView = PDF::loadView('submitbillsreport.obs-preview-bill', $data);
                    $pdfContent = $pdfView->output();

                    // Create a temporary file and write the PDF content to it
                    $tempFile = tempnam(sys_get_temp_dir(), 'pdf'); // Create a temporary file
                    file_put_contents($tempFile, $pdfContent); // Write PDF content to temporary file

                    $pdfMerger->addPage();
                    $pdfMerger->setSourceFile($tempFile); // Set the source from the temporary file
                    $templateId = $pdfMerger->importPage(1); // Import the first page (or adjust if needed)
                    $pdfMerger->useTemplate($templateId);
                    unlink($tempFile);
                }
                $mergedPdfContent = $pdfMerger->Output('S');
                return response($mergedPdfContent, 200, [
                    'Content-Type' => 'application/pdf',
                    'Content-Disposition' => 'attachment; filename="merged.pdf"',
                ]);
            } else {
                // Process single file (original code) if ReferenceNo is not an array
                $data = $this->getObsBillDataNewBulk($ReferenceNo, $ExamType, $role, $pdf, $ObserverID, $centers);
                $pdfView = PDF::loadView('submitbillsreport.obs-preview-bill', $data);
                return $pdfView->download($ReferenceNo . '-' . $ExamType . '-' . '.pdf');
            }
        } catch (\Exception $e) {
            $message = $e->getMessage();
            Log::error('Form submission error: ' . $e->getMessage(), ['exception' => $e]);
            return redirect()->back()->with('error', $message);
        }




        // try {
        //     // if(is_array($ReferenceNo)){
        //     // }else{
        //     //     $ReferenceNo[]=$ReferenceNo;
        //     // }
        //     if(is_array($ReferenceNo)){
        //         $pdfFiles = [];
        //         for($i = 0; $i < count($ReferenceNo); $i++) {

        //             $data = $this->getObsBillDataNewBulk($ReferenceNo[$i], $ExamType[$i], $role[$i], $pdf, $ObserverID[$i], $centers[$i]);

        //             $pdfView = PDF::loadView('submitbillsreport.obs-preview-bill', $data);
        //             $pdfContent = $pdfView->output();
        //             $pdfFiles[] = [
        //                 'content' => $pdfContent,
        //                 'name' => $ReferenceNo[$i] . '-' . $ExamType[$i] . '.pdf'
        //             ];
        //         }
        //     }else{
        //         // $data = $this->getObsBillData($ReferenceNo, $ExamType, $role, $pdf);
        //         $data = $this->getObsBillDataNewBulk($ReferenceNo, $ExamType, $role, $pdf, $ObserverID, $centers);
        //         $pdfView = PDF::loadView('submitbillsreport.obs-preview-bill', $data);
        //         return $pdfView->download($ReferenceNo . '-' . $ExamType . '-' . '.pdf');
        //     }
        // } catch (\Exception $e) {
        //     $message = $e->getMessage();
        //     Log::error('Form submission error: ' . $e->getMessage(), ['exception' => $e]);
        //     return redirect()->back()->with('error', $message);
        // }

        // if(is_array($ReferenceNo)){
        //     // After generating all PDFs, create a zip in memory
        //     if (!empty($pdfFiles)) {
        //         $zip = new \ZipArchive();
        //         $zipFile = tempnam(sys_get_temp_dir(), 'zip');
        //         $zip->open($zipFile, \ZipArchive::CREATE);
        //         foreach ($pdfFiles as $file) {
        //             $zip->addFromString($file['name'], $file['content']);
        //         }
        //         $zip->close();
        //         $zipContent = file_get_contents($zipFile);
        //         unlink($zipFile);
        //         return response($zipContent, 200, [
        //             'Content-Type' => 'application/zip',
        //             'Content-Disposition' => 'attachment; filename="pdfs.zip"',
        //         ]);
        //     }
        //     return response()->json(['message' => 'No PDFs generated.']);
        // }
    }

    public function downloadPdf($ReferenceNo = NULL, $ExamType = NULL, $role = NULL, $pdf = NULL, $ObserverID = NULL, $centers = NULL){

        try {
            if(is_array($ReferenceNo)){
                $pdfMerger = new Fpdi();
                for($i = 0; $i < count($ReferenceNo); $i++) {

                    $data = $this->getCCBilldataNewBulk($ReferenceNo[$i], $ExamType[$i], $role[$i], $pdf, $ObserverID[$i], $centers[$i]);
                    $pdfView = PDF::loadView('submitbillsreport.cc-preview-bill', $data);
                    $pdfContent = $pdfView->output();

                    // Create a temporary file and write the PDF content to it
                    $tempFile = tempnam(sys_get_temp_dir(), 'pdf'); // Create a temporary file
                    file_put_contents($tempFile, $pdfContent); // Write PDF content to temporary file

                    $pdfMerger->addPage();
                    $pdfMerger->setSourceFile($tempFile); // Set the source from the temporary file
                    $templateId = $pdfMerger->importPage(1); // Import the first page (or adjust if needed)
                    $pdfMerger->useTemplate($templateId);
                    unlink($tempFile);
                }
                $mergedPdfContent = $pdfMerger->Output('S');
                return response($mergedPdfContent, 200, [
                    'Content-Type' => 'application/pdf',
                    'Content-Disposition' => 'attachment; filename="merged.pdf"',
                ]);
            }else{
                // $data = $this->getCCBilldata($ReferenceNo, $ExamType, $role, $pdf);
                $data = $this->getCCBilldataNewBulk($ReferenceNo, $ExamType, $role, $pdf, $ObserverID, $centers);
                $pdfView = PDF::loadView('submitbillsreport.cc-preview-bill', $data);
                return $pdfView->download($ReferenceNo . '-' . $ExamType . '-' . '.pdf');
            }
        } catch (\Exception $e) {
            $message = $e->getMessage();
            Log::error('Form submission error: ' . $e->getMessage(), ['exception' => $e]);
            return redirect()->back()->with('error', $message);
        }

    }

    public function CS_PDF_Report($ReferenceNo = NULL, $ExamType = NULL, $role = NULL, $pdf = NULL, $ObserverID = NULL, $centers = NULL){
        try {
            if(is_array($ReferenceNo)){
                $pdfMerger = new Fpdi();
                $pdfFiles = [];
                for ($i = 0; $i < count($ReferenceNo); $i++) {
                    $CSdata = $this->getCSuperBilldataNewBulk($ReferenceNo[$i], $ExamType[$i], $role[$i], $pdf, $ObserverID[$i], $centers[$i]);
                    $pdfView = PDF::loadView('submitbillsreport.csbill', $CSdata);
                    $pdfContent = $pdfView->output();

                    // Create a temporary file and write the PDF content to it
                    $tempFile = tempnam(sys_get_temp_dir(), 'pdf'); // Create a temporary file
                    file_put_contents($tempFile, $pdfContent); // Write PDF content to temporary file

                    $pdfMerger->addPage();
                    $pdfMerger->setSourceFile($tempFile); // Set the source from the temporary file
                    $templateId = $pdfMerger->importPage(1); // Import the first page (or adjust if needed)
                    $pdfMerger->useTemplate($templateId);
                    unlink($tempFile);
                }
                $mergedPdfContent = $pdfMerger->Output('S');
                return response($mergedPdfContent, 200, [
                    'Content-Type' => 'application/pdf',
                    'Content-Disposition' => 'attachment; filename="merged.pdf"',
                ]);
            }else{
                $CSdata = $this->getCSuperBilldataNewBulk($ReferenceNo, $ExamType, $role, $pdf, $ObserverID, $centers);
                // $CSdata = $this->getCSuperBilldata($ReferenceNo, $ExamType, $role, $pdf,$centers);
                $pdfView = PDF::loadView('submitbillsreport.csbill', $CSdata);
                return $pdfView->download($ReferenceNo . '-' . $ExamType . '-' . '.pdf');
            }
        } catch (\Exception $e) {
            $message = $e->getMessage();
            Log::error('Form submission error: ' . $e->getMessage(), ['exception' => $e]);
            return redirect()->back()->with('error', $message);
        }

    }



}
