<?php

namespace App\Http\Controllers;

use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Session;
use Illuminate\Http\Request;
use App\Services\MasterServices;
use Illuminate\Support\Facades\Log;
use Auth;
use Redirect;
use Config;
use Illuminate\Support\Facades\URL;

class SubmitBillController extends Controller
{
    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */


    public function index()
    {
        // try {
            //   $a =   getUserInformation();
            //   print_r($a);die;
            //========================== Tabels Section ========================//
            $CRHTable = config('constants.CentralizedRemunerationHeaderTable');
            $CRLTable = config('constants.CentralizedRemunerationLineTableShiftWise');
            $CentralizedFormFields = config('constants.CentralizedFormFields');
            $VendorPanTbl = config('constants.VendorPanTbl');
            $VendorContactTbl = config('constants.VendorContactTbl');
            $VendorBankTbl = config('constants.VendorBankTbl');
            $ExamProfile = config('constants.ExamProfile');
            $ExamProfileShiftWise = config('constants.ExamProfileShiftWise');
            $ExamDates = config('constants.ExamDates');
            $ObserverOfflineTbl = config('constants.TABillHeaderTbl');

            //========================== Tabels Section ========================//

            $ExamType =  Session::get('examType');
            $ObserverID =  Session::get('ObserverID');
            $Role =  Session::get('role');
            $centerNos =  Session::get('centers');
            // prd($Role);
            if($Role == 1){
                $DocCkeck = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                    'select' => "[Submitted Documents] as submitDoc",
                    'input' => "WHERE ObserverID = '$ObserverID' AND ExamType = '$ExamType'",
                    'table' => "[$ExamProfile]",
                ]);
                
                if(isset($DocCkeck) && !empty($DocCkeck) && $DocCkeck->submitDoc==1)
                {
                    return redirect()->back()->with('error', 'Bill Already Submitted.');
                }
            }
            $RemunerationFieldsData = [];
            // $FieldsDataParams = config('constants.FieldsName')[$Role];
            $RemunerationFieldsData = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
                'select' => "*",
                'input' => "join [$CRLTable] ON [$CRHTable].ID = [$CRLTable].[Document No_] WHERE [$CRHTable].[Exam Type] = '$ExamType' AND [$CRLTable].[Source Type] = '$Role'", //AND [$CRLTable].isActive = 1
                'table' => "[$CRHTable]",
                'orderBy' => "order by displayOrder asc",
            ]);
            // prd($RemunerationFieldsData);
            $ArrayFields = [];
            $FieldsData = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
                'select' => "fieldName, fieldLabel, isRequired, fieldType, maxLength, minLength,readonly, displayOrder",
                'input' => "WHERE ExamType = '" . $ExamType . "' AND Role = '" . $Role . "' And isActive = '1'",
                'table' => "[$CentralizedFormFields]",
                'orderBy' => 'order by displayOrder asc',
            ]);
            //  prd($FieldsData);
            if (isset($FieldsData) && !empty($FieldsData)) {
                $ArrayFields = json_decode(json_encode($FieldsData), true);
            }
            // prd($ArrayFields);

            //=========== City Should be multiple here need to be changed in future ============/
            // $UserData = DB::table($ExamProfile)
            // ->join($VendorPanTbl, "$ExamProfile.ObserverID", "=", "$VendorPanTbl.No_")
            // ->join($VendorContactTbl, "$ExamProfile.ObserverID", "=", "$VendorContactTbl.No_")
            // ->join($VendorBankTbl, "$ExamProfile.ObserverID", "=", "$VendorBankTbl.No_")
            // ->join($ExamDates, "$ExamProfile.ExamType", "=", "$ExamDates.Exam Type")
            // ->where('ExamType', $ExamType)
            // ->where('ObserverID', $ObserverID)
            // ->select("*")
            // ->first();
            // ->first();

            $UserData = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "*",
                'input' => " join [$VendorContactTbl] on  [$VendorPanTbl].No_ = [$VendorContactTbl].No_
                join [$VendorBankTbl] on  [$VendorPanTbl].No_ = [$VendorBankTbl].No_
                join [$ExamProfile] on  [$VendorPanTbl].No_ = [$ExamProfile].ObserverID
                WHERE [$VendorPanTbl].No_='$ObserverID' and [$ExamProfile].ExamType='$ExamType'",
                'table' => "[$VendorPanTbl]",
            ]);
            //prd($UserData);

            if (isset($UserData) && !empty($UserData)) {
                $UserDataToArray = (array) $UserData;
            } else {
                $UserDataToArray = [];
            }
            //  prd($UserDataToArray);

            $centerNameAddress = getCenterNamesaddress();
            $removeNA = array();
            $setValueNotFieldExists = array();
            $setValueNotFieldExists['No_ of Duty Days'] = $UserDataToArray['A_Dutydays'] ?? 0;
            $setValueNotFieldExists['Observer Name'] = $UserDataToArray['Name'] ?? 'NA';
            $setValueNotFieldExists['Mobile No_'] = $UserDataToArray['Mobile Phone No_'] ?? 0;
            if($Role == 1){
               $setValueNotFieldExists['Center City'] = $UserDataToArray['City'];
            }
            $setValueNotFieldExists['PAN No_'] = $UserDataToArray['P_A_N_ No_'] ?? 0;

            $setValueNotFieldExists['Bank Name'] = $UserDataToArray['Bank Name'] ?? 'NA';
            $setValueNotFieldExists['Bank Branch Name'] = $UserDataToArray['Branch'] ?? 'NA';
            $setValueNotFieldExists['Bank_Account_No'] = $UserDataToArray['Vendor Account No_'] ?? 0;
            $setValueNotFieldExists['IFSC Code'] = $UserDataToArray['IFSC Code'] ?? 'NA';
            $centerNoInString = "'" . join("','", Session::get('centers')) . "'";

            $observersCount = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "ObserverID",
                'input' => "where ExamType = '$ExamType' AND [Observer Type]='5' AND  CENTNO  in ($centerNoInString)",
                'table' => "[$ExamProfile]",
            ]);

            $DobserversCount = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "ObserverID",
                'input' => "where ExamType = '$ExamType' AND [Observer Type]='2' AND  CENTNO  in ($centerNoInString)",
                'table' => "[$ExamProfile]",
            ]);
            $ObserversList = array_unique(array_column($observersCount, 'ObserverID'));
            $DeputyObserversList = array_unique(array_column($DobserversCount, 'ObserverID'));
            $observersCount = count($ObserversList) ?? 0;

            $rcName = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "Name",
                'input' => "where ExamType = '$ExamType' AND [Observer Type]='12'",
                'table' => "[$ExamProfile]",
            ]);
            $outSideValue['Name of RC'] = $rcName->Name ?? 'NA';
            $outSideValue['ExamName'] = Session::get('examName');
            $outSideValue['City Coordinator Name'] = Session::get('Name');
            $outSideValue['No_ of Alloted Centres'] = count(Session::get('centers'));
            $outSideValue['No_ of Alloted Observer'] = $observersCount ?? '0';
            $setValueNotFieldExists['CenterNo'] = isset($centerNos) && !empty($centerNos) ?  $centerNos : [];
            $setValueNotFieldExists['Center Address'] = $centerNameAddress;


            foreach ($ArrayFields as $key => $val) {
                if (array_key_exists($val['fieldName'], $outSideValue)) {
                    $ArrayFields[$key]['fieldValue'] = $outSideValue[$val['fieldName']]; //set value
                } else {
                    if (in_array($val['fieldName'], ['No_ of Candidate Alloted', 'No_ of Candidate Present', 'No_ of Candidate Absent'])) {
                        $ArrayFields[$key]['fieldValue'] = ''; //set value ''
                    } elseif (in_array($val['fieldName'], array_keys($setValueNotFieldExists))) {
                        $ArrayFields[$key]['fieldValue'] = $setValueNotFieldExists[$val['fieldName']] ?? ''; //set value
                    } else {
                        $ArrayFields[$key]['fieldValue'] = $UserDataToArray[$val['fieldName']] ?? 'NA'; //set value NA
                    }
                }
            }
            // prd($ArrayFields);
            // space cover to use this function

            $RemunerationFieldsData = array_map(function ($item) {
                $item->Field_Name =  str_replace(' ', '##', $item->Field_Name);
                $item->MockDrillFiledName =  str_replace(' ', '##', $item->MockDrillFiledName);
                return $item;
            }, $RemunerationFieldsData);

            $ArrayFields = array_map(function ($item) {
                $item['fieldName'] =  str_replace(' ', '##', $item['fieldName']);
                return $item;
            }, $ArrayFields);
            // prd($ArrayFields);
            // prd($RemunerationFieldsData);

            //advance payment
            $advancePayment = MasterServices::AdvancePayment();
            $ID = auth()->user()->NTA_Unique_Admin_ID;
            $examType = Session::get('examType'); // Assuming you're storing ExamType in the session

            $DutyDays = DB::selectOne(DB::raw("SELECT p.* FROM [{$ExamProfile}] p WHERE p.ObserverID = :ID AND p.ExamType = :examType"), [
                'ID' => $ID,
                'examType' => $examType
            ]);
            // prd($DutyDays);
            // Convert the result to an array if it's not null
            $DutyDaysArray = $DutyDays ? (array) $DutyDays : [];
            $totalDutyDays = isset($DutyDaysArray['A_Dutydays']) && !empty($DutyDaysArray['A_Dutydays']) ? $DutyDaysArray['A_Dutydays'] : 0;
            // prd($totalDutyDays);

            // Shiftwise table data here
            $ExamProfileShiftWiseData = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "*",
                'input' => "where [Exam Type] = '$ExamType' AND [Observer ID]='$ObserverID' AND CenterNo in ($centerNoInString)",
                'table' => "[$ExamProfileShiftWise]",
            ]);

            $CC_center_nO = Session::get('centers')[0] ?? '';

            // get mock days
            $examDays = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "mockval",
                'input' => "where [Exam Type] = '$ExamType'",
                'table' => "[$ExamDates]",
            ]);

            // prd($examDays);

            $examDaysMock=$examDays[0]->mockval;

            // for calculation day wise attendance
            $DaywiseCountDetails = (array)DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                ':select' => '*',
                ':input' => "WHERE [Exam Type] = '$ExamType' AND [Observer ID] = '$ObserverID'",
                ':table' => "[$ExamProfileShiftWise]",
            ]);
            $attendanceCountR = [];
            for ($day = 1; $day <= 12; $day++) {
                $shiftCountR = 0;
                for ($shift = 1; $shift <= 4; $shift++) {
                    $key = "A{$day}S{$shift}";
                    if (!empty($DaywiseCountDetails[$key]) && $DaywiseCountDetails[$key] == 1) {
                        $shiftCountR++;
                    }
                }
                // If shifts are attended, add to attendance count
                if ($shiftCountR > 0) {
                    $attendanceCountR[] = $shiftCountR;
                }
            }
            $RemunerationAmountR = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
                'select' =>"[Remuneration Amount_S1] as rAmount1,[Remuneration Amount_S2] as rAmount2,[Remuneration Amount_S3] as rAmount3,[Remuneration Amount_S4] as rAmount4",
                'input' => "WHERE [$CRLTable].[Exam Type] = '$ExamType' AND [$CRLTable].[Source Type] = '$Role' AND [$CRLTable].isActive = 1",
                'table' => "[$CRLTable]",
                'orderBy' => "ORDER BY displayOrder ASC",
            ]);

            $RemunerationAmountTotalR=0;
            if(!empty($RemunerationAmountTotalR)){
                foreach($attendanceCountR as $shitCount)
                {
                    $RemunerationAmountTotalR  +=$RemunerationAmountR->{'rAmount'.$shitCount};
                }
             }
             $totalAttendanceDays=count($attendanceCountR) ?? 0;
            //  prd($RemunerationAmountTotalR);
            $ShiftCountArr = (array)DB::selectOne('EXEC GetNonZeroShiftCountsObserverSP ?, ?', [$ObserverID, $ExamType]);
            // prd($ShiftCountArr);
            return view('bills.cccs-bill', compact('RemunerationFieldsData', 'ArrayFields', 'advancePayment', 'ObserversList', 'DeputyObserversList', 'totalDutyDays', 'ShiftCountArr', 'CC_center_nO','RemunerationAmountTotalR','examDaysMock'));
        // } catch (\Exception $e) {
        //     $message = $e->getMessage();
        //     dd($message);
        //     return redirect()->back()->with('error', $message);
        // }
    }

    public function tabill()
    {
        // try {
            // Get constant table names
            $CRHTable = config('constants.CentralizedRemunerationHeaderTable');
            $CRLTable = config('constants.CentralizedRemunerationLineTableShiftWise');
            $VendorPanTbl = config('constants.VendorPanTbl');
            $VendorContactTbl = config('constants.VendorContactTbl');
            $VendorBankTbl = config('constants.VendorBankTbl');
            $ExamProfile = config('constants.ExamProfile');
            $ExamProfileShiftWise = config('constants.ExamProfileShiftWise');
            $ExamDates = config('constants.ExamDates');
            $TABillHeaderTbl = config('constants.TABillHeaderTbl');
            $CentralizedFormFields = config('constants.CentralizedFormFields');
            $TABillLocalTbl = config('constants.TABillLocalTbl');

            // Get session variables
            $ExamType = Session::get('examType');
            $ObserverID = Session::get('ObserverID');
            $Role = Session::get('role');
            $centers = Session::get('centers');

            $CENTNOArray = array_map(function ($item) {
                return "'" . $item . "'";
            }, $centers);
            $CENTNOSTR = implode(',', $CENTNOArray);
           
            // Fetch remuneration fields data
            $RemunerationFieldsData = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
                'select' => "*",
                'input' => "join [$CRLTable] ON [$CRHTable].ID = [$CRLTable].[Document No_] WHERE [$CRHTable].[Exam Type] = '$ExamType' AND [$CRLTable].[Source Type] = '$Role'", //AND [$CRLTable].isActive = '1'
                'table' => "[$CRHTable]",
                'orderBy' => "order by displayOrder asc",
            ]);
            

            $ArrayFields = [];
            $FieldsData = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
                'select' => "fieldName, fieldLabel, isRequired, fieldType, maxLength, minLength,readonly, displayOrder",
                'input' => "WHERE ExamType = '" . $ExamType . "' AND Role = '" . $Role . "' And isActive = '1'",
                'table' => "[$CentralizedFormFields]",
                'orderBy' => 'order by displayOrder asc',
            ]);
            if (!empty($FieldsData)) {
                $ArrayFields = json_decode(json_encode($FieldsData), true);
            }
            //prd($ArrayFields);

            // Fetch user data
            // $UserData = DB::table($ExamProfile)
            //     ->join($VendorPanTbl, "$ExamProfile.ObserverID", "=", "$VendorPanTbl.No_")
            //     ->join($VendorContactTbl, "$ExamProfile.ObserverID", "=", "$VendorContactTbl.No_")
            //     ->join($VendorBankTbl, "$ExamProfile.ObserverID", "=", "$VendorBankTbl.No_")
            //     ->join($ExamDates, "$ExamProfile.ExamType", "=", "$ExamDates.Exam Type")
            //     ->where("$ExamProfile.ExamType", $ExamType)
            //     ->where("$ExamProfile.ObserverID", $ObserverID)
            //     ->select("*")
            //     ->first();
            

            // $UserData = DB::selectOne(DB::raw("getUserDataForObserverSP '$ExamType','$ObserverID'"));
            $UserData = DB::select(DB::raw("getUserDataForObserverSP '$ExamType','$ObserverID'"));
          
            $UserDataToArray = $UserData ??  [];

            if(isset($UserData) && !empty($UserData)){
                $centersNos = [];
                $adress = [];
                foreach ($UserDataToArray as $item) {
                    $centersNos[] = $item->CENTNO;
                    $shortAddress = substr($item->Centre_Address, 0, 50);
                    $adress[] = $shortAddress;
                }
                // Use the first item as the base
                $UserDataToArray = (array) $UserDataToArray[0];
                // Replace CENTNO with the merged string
                $UserDataToArray['CENTNO'] = implode(',', $centersNos);
                $UserDataToArray['Centre_Address'] = implode(", ", $adress);
                // prd($UserDataToArray);
            }

            $ccName = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "Name,Mobile",
                'input' => "WHERE ExamType = '" . $ExamType . "' And [Observer Type] = '1' And  CENTNO IN ($CENTNOSTR) ",
                'table' => "[$ExamProfile]",
            ]);


            $rcName = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "Name",
                'input' => "where ExamType = '$ExamType' AND [Observer Type]='12'",
                'table' => "[$ExamProfile]",
            ]);

            $setValue = [];
            if (!empty($UserDataToArray)) {
                $setValue = [
                    'Observer Name' => $UserDataToArray['Name'],
                    'Contact No' => $UserDataToArray['Mobile Phone No_'],
                    'PAN_No' => $UserDataToArray['P_A_N_ No_'],
                    'Bank_Branch_Name' => $UserDataToArray['Branch'],
                    'Bank_Account_No' => $UserDataToArray['Vendor Account No_'],
                    'IFSC Code' => $UserDataToArray['IFSC Code'],
                    'Exam Date' => $UserDataToArray['Exam_Duration'],
                    'Centre No_' => $UserDataToArray['CENTNO'],
                    'Centre Address' => $UserDataToArray['Centre_Address'],
                    'Observer ID' => $ObserverID,
                    'Address For Communication' => $UserDataToArray['Address'],
                    'CcName' => (isset($ccName->Name, $ccName->Mobile) && !empty($ccName->Name) && !empty($ccName->Mobile)) ? $ccName->Name . ', ' . $ccName->Mobile : 'NA',
                    'RC Name' => $rcName->Name ?? '',
                ];
            }

            // Ensure 'fieldValue' key is initialized for each element in $ArrayFields
            foreach ($ArrayFields as &$field) {
                if (isset($field['fieldName'])) {
                    if (array_key_exists($field['fieldName'], $setValue)) {
                        $field['fieldValue'] = $setValue[$field['fieldName']] ?? 'NA';
                    } else {
                        $field['fieldValue'] = $UserDataToArray[$field['fieldName']] ?? 'NA';
                    }
                    $field['fieldName'] = str_replace(' ', '##', $field['fieldName']);
                }
            }

            $centers = "'" . implode("','", $centers) . "'";
            // prd($centers);
            // $BillData   = DB::selectOne(DB::raw("
            //     exec getCommonDataSP :select, :input, :table
            // "), [
            //     'select' => "*",
            //     'input' => "join [$ExamDates] ON [$ExamProfile].ExamType = [$ExamDates].[Exam Type] WHERE [$ExamDates].[Exam Type] = '$ExamType' AND [$ExamProfile].ObserverID ='$ObserverID' AND [$ExamProfile].CENTNO in($centers)",
            //     'table' => "[$ExamProfile]",
            // ]);

             // For Single and Muiple Center Number Check Duty Days
            $BillData   = DB::select(DB::raw("
            exec getCommonDataSP :select, :input, :table
                "), [
                    'select' => "*",
                    'input' => "join [$ExamDates] ON [$ExamProfile].ExamType = [$ExamDates].[Exam Type] WHERE [$ExamDates].[Exam Type] = '$ExamType' AND [$ExamProfile].ObserverID ='$ObserverID' AND [$ExamProfile].CENTNO in($centers)",
                    'table' => "[$ExamProfile]",
                ]);


            ####### Show for Mock Drill section  #######
            $mockDrillHideShow = false;
            foreach ($BillData as $bill) {
                if ($bill->A_MT == 1) {
                    $mockDrillHideShow = true;
                    break; // Stop loop once we find ExamType 1
                }
            }
            #######  Show for Mock Drill section   #######
          
        

            ############ Mock dril  checked and unchecked #############
            $merged = (array) $BillData[0];
            $merged['Dutydays'] = 0;
            $merged['A_Dutydays'] = 0;
            
            $checkArrayMockDrilsNew = [];
            foreach ($BillData as $obj) {
                $merged['Dutydays'] += (int) $obj->Dutydays;
                $merged['A_Dutydays'] += (int) $obj->A_Dutydays;

                $checkArrayMockDrilslocal = [];
                $checkArrayMockDrilsNew[$obj->CENTNO] = $obj->A_MT;

            }
            $BillData = (object) $merged;
            ############ Mock dril  checked and unchecked #############


            if (!empty($BillData) && $BillData->ATT == 0) {
                return redirect()->back()->with('error', 'Attendance not created, please create attendance first.');
            }

            // $ShiftWiseBillData   = DB::selectOne(DB::raw("
            //     exec getCommonDataSP :select, :input, :table
            // "), [
            //     'select' => "*",
            //     'input' => "join [$ExamDates] ON [$ExamProfileShiftWise].[Exam Type] = [$ExamDates].[Exam Type] WHERE [$ExamDates].[Exam Type] = '$ExamType' AND [$ExamProfileShiftWise].[Observer ID] ='$ObserverID' AND [$ExamProfileShiftWise].CenterNo in ($centers)",
            //     'table' => "[$ExamProfileShiftWise]",
            // ]);

            ############ For Single and Muiple Center Number Check Duty Days#############
            $ShiftWiseBillData   = DB::select(DB::raw("
                exec getCommonDataSP :select, :input, :table
            "), [
                'select' => "*",
                'input' => "join [$ExamDates] ON [$ExamProfileShiftWise].[Exam Type] = [$ExamDates].[Exam Type] WHERE [$ExamDates].[Exam Type] = '$ExamType' AND [$ExamProfileShiftWise].[Observer ID] ='$ObserverID' AND [$ExamProfileShiftWise].CenterNo in ($centers)",
                'table' => "[$ExamProfileShiftWise]",
            ]);

            
            $final = !empty($ShiftWiseBillData[0]) ? (array) $ShiftWiseBillData[0] : []; // Start with the first object
            $checkArrayMockDrils  = [];
            foreach ($ShiftWiseBillData as $index => $obj) {
               if (array_key_exists($obj->CenterNo, $checkArrayMockDrilsNew)) {
                    $obj->A_MT = $checkArrayMockDrilsNew[$obj->CenterNo];
                    $checkArrayMockDrils[] = $obj;
                }

                if ($index === 0) continue;
                    foreach ((array) $obj as $key => $value) {
                        if (preg_match('/^A(1[0-2]|[1-9])S[1-3]$/', $key)) {
                            if ((int)$value === 1) {
                            $final[$key] = 1;
                        }
                    }
                } 
            }
            $ShiftWiseBillData = (object) $final;
            ############ For Single and Muiple Center Number Check Duty Days#############

            $checkfrom = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "Submitted, [Advance Payment], [Total Deduction Amount]",
                'input' => "WHERE [Observer ID] = '$ObserverID' AND [Exam Code] = '$ExamType'",
                'table' => "[$TABillHeaderTbl]",
            ]);

            if (!empty($checkfrom) && $checkfrom->Submitted == '1') {
                return redirect()->back()->with('error', 'Bill Already Submitted');
            }

            // Modify RemunerationFieldsData
            $RemunerationFieldsData = array_map(function ($item) {
                $item->Field_Name = str_replace(' ', '##', $item->Field_Name);
                $item->MockDrillFiledName = str_replace(' ', '##', $item->MockDrillFiledName);
                return $item;
            }, $RemunerationFieldsData);

            //prd($RemunerationFieldsData);

            $getlocalbillDetail = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "*",
                'input' => "join [$TABillLocalTbl] ON [$TABillHeaderTbl].[Reference No_] = [$TABillLocalTbl].[Reference No_] WHERE [$TABillHeaderTbl].[Exam Code] = '$ExamType' AND [$TABillHeaderTbl].[Observer ID] = '$ObserverID'",
                'table' => "[$TABillHeaderTbl]",
            ]);

            // Fetch advance payment details
            $advancePayment = MasterServices::AdvancePayment();

            $ShiftCountArr = (array)DB::selectOne('EXEC GetNonZeroShiftCountsObserverSP ?, ?', [$ObserverID, $ExamType]);
            //    prd($ShiftCountArr);
            return view('bills.obs-bill', compact('RemunerationFieldsData', 'BillData', 'checkfrom', 'ArrayFields', 'advancePayment', 'getlocalbillDetail', 'ShiftCountArr','ShiftWiseBillData','mockDrillHideShow','checkArrayMockDrils'));
        // } catch (\Exception $e) {
        //     $message = $e->getMessage();
        //     dd($message);
        //     return redirect()->back()->with('error', $message);
        // }
    }

    public function examBillSave(Request $request)
    {
        // dd($request->all());
        // Check if the request is a POST request
        if ($request->isMethod('post')) {

            //========================== Tabels Section ========================//
            $CRHTable = config('constants.CentralizedRemunerationHeaderTable');
            $CRLTable = config('constants.CentralizedRemunerationLineTableShiftWise');
            $CityCoordinatorOfflineTbl = config('constants.CityCoordinatorOfflineTbl');   // table name
            $CentralizedFormFields = config('constants.CentralizedFormFields');
            $VendorPanTbl = config('constants.VendorPanTbl');
            $VendorContactTbl = config('constants.VendorContactTbl');
            $VendorBankTbl = config('constants.VendorBankTbl');
            $ExamProfile = config('constants.ExamProfile');
            $ExamDates = config('constants.ExamDates');    // table name
            $DaysPersonsTable = config('constants.DaysPersonsTable');    // table name
            $CityCoordinatorObservrTbl = config('constants.ObserverDetailsTable');
            $ExamProfileShiftWise = config('constants.ExamProfileShiftWise');
            $ExamType =  Session::get('examType');
            $ObserverID =  Session::get('ObserverID');
            $Role =  Session::get('role');
            $centerNos =  Session::get('centers');
            $CC_center_nO = Session::get('centers')[0] ?? '';

            //========================== end ========================//

            $uniqueRandomString = $this->generateUniqueRandomString(); // unique reference no generator
            $examId = DB::table($ExamDates)->where('Exam Type', Session::get('examType'))->value('Exam Type Id'); // get exam type id

            // file upload code
            if ($request->hasFile('files')) {
                $fileNameArray = [];
                $files = $request->file('files');
                $ExtensionTypes = ['jpg', 'jpeg', 'png', 'pdf', 'doc', 'docx', 'xls', 'xlsx'];
                $maxFileSize = 2 * 1024 * 1024; //2mb
                foreach ($files as $key => $file) {
                    $uploadedFileNameSame = str_replace('##', ' ', $key);

                    if (!in_array(strtolower($file->getClientOriginalExtension()), $ExtensionTypes)) {
                        return redirect()->route('exambill')->with('error', 'File upload error: The file type is invalid for ' . $uploadedFileNameSame);
                    }
                    if ($file->getSize() > $maxFileSize) {
                        return redirect()->route('exambill')->with('error', 'File upload error: The file size cannot exceed 2MB for ' . $uploadedFileNameSame);
                    }
                }


                foreach ($files as $key => $file) {
                    $uploadedFileName = str_replace('##', '_', $key);
                    $uploadedFileNameSame = str_replace('##', ' ', $key);
                    if ($file->isValid()) {
                        $destinationPath = public_path('uploads/' . Auth::user()->UserName);
                        // Create the destination path if it doesn't exist
                        if (!file_exists($destinationPath)) {
                            mkdir($destinationPath, 0755, true);
                        }
                        // Get the original file name or you can set a custom file name
                        $fileName = time() . '_' . $uploadedFileName . '.' . $file->getClientOriginalExtension();
                        // Move the file to the destination path
                        $file->move($destinationPath, $fileName);
                        $fileNameArray[$uploadedFileNameSame] = url('/uploads/' . Auth::user()->UserName . '/' . $fileName);
                    } else {
                        return redirect()->route('exambill')->with('error', 'File upload error: ' . $file->getErrorMessage());
                    }
                }

                // prd($fileNameArray);
            }


            $data = $request->all();
            // prd($data);
            $keys = array_keys($data);
            $modified_keys = array_map(function ($key) {
                return str_replace('##', ' ', $key);
            }, $keys);
            $data = array_combine($modified_keys, $data);

            //  prd($data);
            //  if(isset($data) && !empty($data['ExtraFields'])){
            //     $ExtraDataSum = array_sum(array_values($data['ExtraFields']));
            //     $keys_extra = array_keys($data['ExtraFields']);
            //     $modified_keys_extra = array_map(function ($key) {
            //         return str_replace('##', ' ', $key);
            //     }, $keys_extra);
            //     $data_extra = array_combine($modified_keys_extra, $data['ExtraFields']);
            //     $data = array_merge($data_extra,$data);
            //  }
            //  prd($data);
            //  $remValues = 0;
            //  if(isset($data) && !empty($data['ExtraRemunerationSection'])){
            //     foreach ($data['ExtraRemunerationSection'] as $remuneration) {
            //       $remValues += array_sum($remuneration);
            //     }
            //     // prd($remValues);
            // $ExtraRemunerationSection=0;
            //  if(isset($data['ExtraRemunerationSection']))
            //  {
            //      $ExtraRemunerationSection = array_sum(array_values($data['ExtraRemunerationSection']));

            //     //prd($ExtraRemunerationSection);
            //     $keys_ExtraRemunerationSection = array_keys($data['ExtraRemunerationSection']);
            //     $modified_keys_ExtraRemunerationSection = array_map(function ($key) {
            //         return str_replace('##', ' ', $key);
            //     }, $keys_ExtraRemunerationSection);
            //      $data_ExtraRemunerationSection = array_combine($modified_keys_ExtraRemunerationSection, $data['ExtraRemunerationSection']);
            //      $data = array_merge($data_ExtraRemunerationSection,$data);
            //   }

            $ExtraRemunerationSection = 0;
            if (isset($data['ExtraRemunerationSection'])) {
                // Loop through each sub-array and sum all the values
                foreach ($data['ExtraRemunerationSection'] as $subArray) {
                    $ExtraRemunerationSection += array_sum($subArray);
                }

                // Store the total sum in 'Other Charges'
                $data['Other Charges'] = $ExtraRemunerationSection ? $ExtraRemunerationSection : 0;
            }
            //  prd($data);
            // +++++++++++++++++++++++++++++++++++++++++++++ Server Validations & Calculation Starts ============================================//

            $RemunerationFieldsData = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
                'select' => "*",
                'input' => "join [$CRLTable] ON [$CRHTable].ID = [$CRLTable].[Document No_] WHERE [$CRHTable].[Exam Type] = '$ExamType' AND [$CRLTable].[Source Type] = '$Role' AND [$CRLTable].isActive = '1'",
                'table' => "[$CRHTable]",
                'orderBy' => "order by displayOrder asc",
            ]);

            // prd($RemunerationFieldsData);

            $sourceCodeMst = [];
            foreach ($RemunerationFieldsData as $valR) {
                $sourceCodeMst[$valR->{'Source Code'}] = array('Mock Drill Charge' => $valR->{'Mock Drill Charge'});
            }

            if (isset($RemunerationFieldsData) && !empty($RemunerationFieldsData)) {
                // ============== Field Section ================//

                $manPowerColumn = $data['ManPower'] ?? [];
                $DutyDaysColumn = $data['DutyDays'] ?? [];
                $AdvancePaymentColumn = $data['Advance Payment'] ?? 0;
                $MiscellaneousCharge = $data['Miscellaneous Charge'] ?? 0;
                $OtherChargesColumn = array_column($RemunerationFieldsData, 'Other Charges');
                $tdsPrecentageColumn = array_column($RemunerationFieldsData, 'tdsPrecentage');

                // $fieldsToCalculate = array_column($RemunerationFieldsData,'Field_Name');
                // $MocdrillfieldsToCalculate = array_column($RemunerationFieldsData,'MockDrillFiledName');
                // $valuesToRemove = ['Advance Payment', 'TDS_Amount'];
                // $fieldsToCalculate = array_diff($fieldsToCalculate, $valuesToRemove);
                //$AllFieldsColumns = array_filter(array_merge($fieldsToCalculate,$MocdrillfieldsToCalculate));
                // $RemunerationAmountColumn = array_column($RemunerationFieldsData,'Remuneration Amount');
                // $ConveyanceAmountColumn = array_column($RemunerationFieldsData,'Conveyance Amount');
                // $MockDrillChargeColumn = array_column($RemunerationFieldsData,'Mock Drill Charge');
                // $MockDrillConveyanceColumn = array_column($RemunerationFieldsData,'Mock Drill Conveyance');
                //pr($tdsPrecentageColumn);
                // ============== Remuneration Section ================//
                $AmountCalculation = [];
                $attendanceCountR = [];
                //  prd($RemunerationFieldsData);

                /************** start *****************/
                    // for calculation day wise attendance
                    $DaywiseCountDetails = (array)DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                        ':select' => '*',
                        ':input' => "WHERE CenterNo='$CC_center_nO' AND [Exam Type] = '$ExamType' AND [Observer ID] = '$ObserverID'",
                        ':table' => "[$ExamProfileShiftWise]",
                    ]);
                    for ($day = 1; $day <= 12; $day++) {
                        $shiftCountR = 0;
                        for ($shift = 1; $shift <= 4; $shift++) {
                            $key = "A{$day}S{$shift}";
                            if (!empty($DaywiseCountDetails[$key]) && $DaywiseCountDetails[$key] == 1) {
                                $shiftCountR++;
                            }
                        }
                        // If shifts are attended, add to attendance count
                        if ($shiftCountR > 0) {
                            $attendanceCountR[] = $shiftCountR;
                        }
                    }

                    $RemunerationAmountTotalR=0;

                    $totalAttendanceDays=count($attendanceCountR) ?? 0;

                /************* end *************/
                foreach ($RemunerationFieldsData as $row) {
                    if($row->{'Source Code'}=='CITY COORDINATOR')
                    {
                        foreach($attendanceCountR as $shitCount)
                        {
                            $RemunerationAmountTotalR  +=$RemunerationFieldsData[0]->{'Remuneration Amount_S'.$shitCount};
                        }
                        $AmountCalculation[] = array(
                            array('Remuneration' => $RemunerationAmountTotalR, 'Conveyance' => ($row->{'Conveyance Amount'}*$totalAttendanceDays)),
                            array('Mock' => $row->{'Mock Drill Charge'}, 'Mockc' => $row->{'Mock Drill Conveyance'})
                        );
                    }
                    $AmountCalculation[] = array(
                        array('Remuneration' => ($row->{'Remuneration Amount_S1'} + $row->{'Remuneration Amount_S2'} + $row->{'Remuneration Amount_S3'} + $row->{'Remuneration Amount_S4'}), 'Conveyance' => $row->{'Conveyance Amount'}),
                        array('Mock' => $row->{'Mock Drill Charge'}, 'Mockc' => $row->{'Mock Drill Conveyance'})
                    );
                }
                //   prd($RemunerationFieldsData);
                $TotalClaimed = [];
                $TotalClaimedTds = [];
                $k = 0;
                // foreach ($AmountCalculation as $index => $val) {
                //     $tdsPercentage = $tdsPrecentageColumn[$index] ?? 0;
                //     foreach ($val as $key => $subArray) {
                //         $manPower = $manPowerColumn[$k] ?? 1;
                //         $dutyDays = $DutyDaysColumn[$k] ?? 1;


                //         if ($key == 0) {
                //             $CalculatedAmount = ($subArray['Remuneration'] + $subArray['Conveyance']) * $manPower * $dutyDays;
                //             $CalculatedTDSAmount = ($subArray['Remuneration'] * $tdsPercentage / 100) * $manPower * $dutyDays;
                //             if ($CalculatedAmount > 0) {
                //                 $TotalClaimed[] = $CalculatedAmount;
                //                 $TotalClaimedTds[] = $CalculatedTDSAmount;
                //                 $k++;
                //             }
                //         } else {
                //             $CalculatedAmount = ($subArray['Mock'] + $subArray['Mockc']) * $manPower * $dutyDays;
                //             $CalculatedTDSAmount = ($subArray['Mock'] * $tdsPercentage / 100) * $manPower * $dutyDays;
                //             if ($CalculatedAmount > 0) {
                //                 $TotalClaimed[] = $CalculatedAmount;
                //                 $TotalClaimedTds[] = $CalculatedTDSAmount;
                //                 $k++;
                //             }
                //         }
                //     }
                // }

                //pr($TotalClaimedTds);
                // prd(array_sum($TotalClaimedTds));
                $totalExtraAmount = $ExtraDataSum ?? 0;
                $TotalClaimedAmount = array_sum($TotalClaimed) + array_sum($OtherChargesColumn) + $MiscellaneousCharge + $totalExtraAmount + $ExtraRemunerationSection;
                $NetPayableAmount = $TotalClaimedAmount - (array_sum($TotalClaimedTds) + $AdvancePaymentColumn);
                //pr(array_sum($TotalClaimedTds));
                // pr($NetPayableAmount);
                // prd($data);
                // if($data['Net Amount Payable'] != $NetPayableAmount){
                //     $message = 'Bill not submitted due to amount not proper';
                //     return redirect()->back()->with('error', $message);
                // }

            }
            // +++++++++++++++++++++++++++++++++++++++++++++ Server Validations & Calculation eNDS ============================================//

            // prd($AmountCalculation);
            $ArrayFields = [];

            $FieldsData = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
                'select' => "fieldName",
                'input' => "WHERE ExamType = '" . $ExamType . "' AND Role = '" . $Role . "' And isActive = '1'",
                'table' => "[$CentralizedFormFields]",
                'orderBy' => 'order by displayOrder asc',
            ]);
            if (isset($FieldsData) && !empty($FieldsData)) {
                $ArrayFields = json_decode(json_encode($FieldsData), true);
            }

            $UserData = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "*",
                'input' => " join [$VendorContactTbl] on  [$VendorPanTbl].No_ = [$VendorContactTbl].No_
                join [$VendorBankTbl] on  [$VendorPanTbl].No_ = [$VendorBankTbl].No_
                join [$ExamProfile] on  [$VendorPanTbl].No_ = [$ExamProfile].ObserverID
                WHERE [$VendorPanTbl].No_='$ObserverID'",
                'table' => "[$VendorPanTbl]",
            ]);

            if (isset($UserData) && !empty($UserData)) {
                $UserDataToArray = (array) $UserData;
            } else {
                $UserDataToArray = [];
            }

            if (isset($UserData) && !empty($UserData)) {
                $UserDataToArray = (array) $UserData;
            } else {
                $UserDataToArray = [];
            }
            $centerNameAddress = getCenterNamesaddress();
            $setValueNotFieldExists = array();
            $setValueNotFieldExists['No_ of Duty Days'] = $UserDataToArray['Dutydays'];
            $setValueNotFieldExists['Observer Name'] = $UserDataToArray['Name'];
            $setValueNotFieldExists['Mobile No_'] = $UserDataToArray['Mobile Phone No_'];
            $setValueNotFieldExists['Center City'] = $UserDataToArray['City'];
            $setValueNotFieldExists['PAN No_'] = $UserDataToArray['P_A_N_ No_'];
            $setValueNotFieldExists['Bank Name'] = $UserDataToArray['Bank Name'];
            $setValueNotFieldExists['Bank Branch Name'] = $UserDataToArray['Branch'];
            $setValueNotFieldExists['Bank_Account_No'] = $UserDataToArray['Vendor Account No_'];
            $setValueNotFieldExists['IFSC Code'] = $UserDataToArray['IFSC Code'];
            $centerNoInString = "'" . join("','", Session::get('centers')) . "'";
            $observersCount = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "*",
                'input' => "where ExamType = '$ExamType' AND [Observer Type]='5' AND  CENTNO  in ($centerNoInString)",
                'table' => "[$ExamProfile]",
            ]);
            $observersCount = count($observersCount);

            $rcName = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "Name",
                'input' => "where ExamType = '$ExamType' AND [Observer Type]='12'",
                'table' => "[$ExamProfile]",
            ]);
            $outSideValue['Name of RC'] = $rcName->Name ?? 'NA';
            $outSideValue['ExamName'] = Session::get('examName');
            $outSideValue['City Coordinator Name'] = Session::get('Name');
            $outSideValue['No_ of Alloted Centres'] = count(Session::get('centers'));
            $outSideValue['No_ of Alloted Observer'] = $observersCount ?? '0';
            $setValueNotFieldExists['CenterNo'] = isset($centerNos) && !empty($centerNos) ? implode(',', $centerNos) : '';
            $setValueNotFieldExists['Center Address'] = $centerNameAddress;


            foreach ($ArrayFields as $key => $val) {
                if (array_key_exists($val['fieldName'], $outSideValue)) {
                    $ArrayFields[$key]['fieldValue'] = $outSideValue[$val['fieldName']]; //set value
                } else {
                    if (in_array($val['fieldName'], array_keys($setValueNotFieldExists))) {
                        $ArrayFields[$key]['fieldValue'] = $setValueNotFieldExists[$val['fieldName']] ?? ''; //set value
                    } else {
                        $ArrayFields[$key]['fieldValue'] = $UserDataToArray[$val['fieldName']] ?? 'NA'; //set value NA
                    }
                }
            }

            $fieldValues =  array_column($ArrayFields, 'fieldValue', 'fieldName');
            unset($fieldValues['No_ of Candidate Alloted'], $fieldValues['No_ of Candidate Present'], $fieldValues['No_ of Candidate Absent']); // unset value
            //prd($fieldValues);
            foreach ($fieldValues as $key => $value) {
                $data[$key] = $value;
            }

            $data['Reference No_'] = $uniqueRandomString;
            $data['No_ of Person'] = implode(',', $data['ManPower']);
            $data['No_ of Days'] = implode(',', $data['DutyDays']);
            $data['Bill Status'] = 0;
            $data['IsSubmitted'] = 1;
            $data['IsNewBill'] = 1;
            $data['Exam Type'] = Session::get('examType');
            $data['Exam Name'] = Session::get('examName');
            $data['Role'] = Session::get('role');
            $data['Observer ID'] = Session::get('ObserverID');
            $data['CenterNo'] = isset($centerNos) && !empty($centerNos) ? implode(',', $centerNos) : '';
            $data['Created On'] = date('Y-m-d');
            $data['Exam ID'] = $examId;
            $data['File Path'] = $fileNameArray['Miscellaneous Charge'] ?? 'NA';
            $data['Observer File Path'] = $fileNameArray['Mock Drill Amount Observer'] ?? 'NA';
            $data['DObserver File Path'] = $fileNameArray['Mock Drill Amount DObserver'] ?? 'NA';
            //unset($data['_token'],$data['ManPower'],$data['DutyDays'],$data['submit'],$data['files']);
            // =========================================== Inserting Duty Days & Persons in New Table ========================================================//
            // prd($data);
            $remunerationSourceCodeArray = array_column($RemunerationFieldsData, 'Source Code');
            // $remunerationRemTextArray = array_column($RemunerationFieldsData,'Source Code');
            // $remunerationSourceCodeArray = array_column($RemunerationFieldsData,'Source Code');
            $nR = 0;
            $idR = 0;
            foreach ($data['ManPower'] as $mpKey => $mpVal) {
                $remSC = $remunerationSourceCodeArray[$idR];
                if ($nR == 1) {
                    $remSC .= ' MOCK';
                }
                $remDD = $data['DutyDays'][$mpKey] ?? 0;
                if (array_key_exists($remSC, $sourceCodeMst) && $sourceCodeMst[$remSC]['Mock Drill Charge'] > 0 && $nR == 0) {
                    $nR = 1;
                    DB::statement('exec insertCommonDataSP :fields, :values, :table', [
                        'fields' => "[Reference No_],[Source Code],[No of Days],[No of Person]",
                        'values' => "'$uniqueRandomString','$remSC','$remDD','$mpVal'",
                        'table' => "[$DaysPersonsTable]",
                    ]);
                } else {
                    DB::statement('exec insertCommonDataSP :fields, :values, :table', [
                        'fields' => "[Reference No_],[Source Code],[No of Days],[No of Person]",
                        'values' => "'$uniqueRandomString','$remSC','$remDD','$mpVal'",
                        'table' => "[$DaysPersonsTable]",
                    ]);
                    $nR = 0;
                    $idR++;
                }
            }
            // prd($centerNoInString);
            // ========================================== Observer/Deputy Observer Data Section ==================================//
            if (isset($data['observers']) && !empty($data['observers'])) {
                // echo '<pre>';print_r($data); die;
                foreach ($data['observers']['observer_id'] as $obIndex => $observerId) {
                    // Initialize an empty array to store observer data
                    $obDataArray = [];

                    // Safely assign observer details, ensuring the index exists to avoid errors
                    $obDataArray['Observer_ID'] = $data['observers']['observer_id_sec'][$obIndex] ?: null;
                    $obDataArray['Observer_Type'] = 5;
                    $obDataArray['Observer_Name'] = $data['observers']['observer_name'][$obIndex] ?: null;
                    $obDataArray['Observer_Phone'] = $data['observers']['observer_phone'][$obIndex] ?: null;
                    $obDataArray['Observer_Email'] = $data['observers']['observer_email'][$obIndex] ?: null;
                    $obDataArray['Account_Holder_Name'] = $data['observers']['account_holder_name'][$obIndex] ?: null;
                    $obDataArray['Account_Number'] = $data['observers']['account_number'][$obIndex] ?: null;
                    $obDataArray['IFSC_CODE'] = $data['observers']['ifsc_code'][$obIndex] ?: null;
                    $obDataArray['Branch_Name'] = $data['observers']['branch_name'][$obIndex] ?: null;
                    $obDataArray['PAN'] = $data['observers']['pan_number'][$obIndex] ?: null;
                    $obDataArray['Duty_Days'] = $data['observers']['duty_days'][$obIndex] ?: null;
                    $obDataArray['Mock Duty Days'] = $data['observers']['mock_duty_days'][$obIndex] ?: null;
                    $obDataArray['Amount To Paid'] = $data['observers']['amount_to_paid'][$obIndex] ?: null;
                    $obDataArray['Advance_Payment'] = $data['observers']['advance_payment'][$obIndex] ?: null;
                    $obDataArray['TDS'] = $data['observers']['tds_percent'][$obIndex] ?: null;
                    $obDataArray['Observer TDS'] = $data['ObserverTotalTDSAmount'] ?: null;
                    $obDataArray['Reference_No'] = $uniqueRandomString;

                    $obDataArray['Observer Remuneration'] = $data['observers']['Observer_Remuneration'][$obIndex] ?: null;
                    $obDataArray['Observer Conveyance'] = $data['observers']['Observer_Conveyance'][$obIndex] ?: null;
                    $obDataArray['Observer Mock Remuneration'] = $data['observers']['Observer_Mock_Remuneration'][$obIndex] ?: null;
                    $obDataArray['Observer Mock Conveyance'] = $data['observers']['Observer_Mock_Conveyance'][$obIndex] ?: null;
                    $obDataArray['Observer Foods'] = $data['observers']['Observer_Foods'][$obIndex] ?: null;
                    // Insert the observer data into the database
                    DB::table($CityCoordinatorObservrTbl)->insert($obDataArray);
                }
            }
            if (isset($data['deputy_observers']) && !empty($data['deputy_observers'])) {
                foreach ($data['deputy_observers']['deputy_observer_id'] as $dobIndex => $dobserverId) {
                    // Initialize an empty array to store observer data
                    $dobDataArray = [];
                    // Safely assign observer details, ensuring the index exists to avoid errors
                    $dobDataArray['Observer_ID'] = $data['deputy_observers']['deputy_observer_id_sec'][$dobIndex] ?: null;
                    $dobDataArray['Observer_Type'] = 2;
                    $dobDataArray['Observer_Name'] = $data['deputy_observers']['deputy_observer_name'][$dobIndex] ?: null;
                    $dobDataArray['Observer_Phone'] = $data['deputy_observers']['deputy_observer_phone'][$dobIndex] ?: null;
                    $dobDataArray['Observer_Email'] = $data['deputy_observers']['deputy_observer_email'][$dobIndex] ?: null;
                    $dobDataArray['Account_Holder_Name'] = $data['deputy_observers']['deputy_account_holder_name'][$dobIndex] ?: null;
                    $dobDataArray['Account_Number'] = $data['deputy_observers']['deputy_account_number'][$dobIndex] ?: null;
                    $dobDataArray['IFSC_CODE'] = $data['deputy_observers']['deputy_ifsc_code'][$dobIndex] ?: null;
                    $dobDataArray['Branch_Name'] = $data['deputy_observers']['deputy_branch_name'][$dobIndex] ?: null;
                    $dobDataArray['PAN'] = $data['deputy_observers']['deputy_pan_number'][$dobIndex] ?: null;
                    $dobDataArray['Duty_Days'] = $data['deputy_observers']['deputy_duty_days'][$dobIndex] ?: null;
                    $dobDataArray['Mock Duty Days'] = $data['deputy_observers']['deputy_mock_duty_days'][$dobIndex] ?: null;
                    $dobDataArray['Amount To Paid'] = $data['deputy_observers']['deputy_amount_to_paid'][$dobIndex] ?: null;
                    $dobDataArray['Advance_Payment'] = $data['deputy_observers']['deputy_advance_payment'][$dobIndex] ?: null;
                    $dobDataArray['TDS'] = $data['deputy_observers']['deputy_tds_percent'][$dobIndex] ?: null;
                    $dobDataArray['Observer TDS'] = $data['DObserverTotalTDSAmount'] ?: null;
                    $dobDataArray['Reference_No'] = $uniqueRandomString;

                    $dobDataArray['Observer Remuneration'] = $data['deputy_observers']['Observer_Remuneration'][$dobIndex] ?: null;
                    $dobDataArray['Observer Conveyance'] = $data['deputy_observers']['Observer_Conveyance'][$dobIndex] ?: null;
                    $dobDataArray['Observer Mock Remuneration'] = $data['deputy_observers']['Observer_Mock_Remuneration'][$dobIndex] ?: null;
                    $dobDataArray['Observer Mock Conveyance'] = $data['deputy_observers']['Observer_Mock_Conveyance'][$dobIndex] ?: null;
                    $dobDataArray['Observer Foods'] = $data['deputy_observers']['Observer_Foods'][$dobIndex] ?: null;

                    // prd($dobDataArray);
                    // Insert the observer data into the database
                    DB::table($CityCoordinatorObservrTbl)->insert($dobDataArray);
                }
            }
            // ========================================== Observer/Deputy Observer Data Section ==================================//

            // =========================================== Inserting Duty Days & Persons in New Table ========================================================//
            unset(
                $data['_token'],
                $data['ManPower'],
                $data['DutyDays'],
                $data['submit'],
                $data['files'],
                $data['ExtraFields'],
                $data['ExtraRemunerationSection'],
                $data['observers'],
                $data['deputy_observers'],
                $data['ObserverTotalAdvanceAmount'],
                $data['ObserverTotalTDSAmount'],
                $data['ObserverNetAmount'],
                $data['DObserverTotalAdvanceAmount'],
                $data['DObserverTotalTDSAmount'],
                $data['DObserverNetAmount']
            );
            //    prd($data);
            // $tableColumnsData = '[' . join('],[', array_keys($data)) . ']';
            // $tableValuesData = "'" . join("','", array_values($data)) . "'";
            // DB::statement('exec insertCommonDataSP :fields, :values, :table', [
            //     'fields' => "$tableColumnsData",
            //     'values' => "$tableValuesData",
            //     'table' => "[$CityCoordinatorOfflineTbl]",
            // ]);

            DB::table($CityCoordinatorOfflineTbl)->insert($data);
            DB::statement('exec updateCommonDataSP :updatefields, :where, :table', [
                'updatefields' => "[Submitted Documents]=1",
                'where' => "where ObserverID = '$ObserverID' AND ExamType = '$ExamType'",
                'table' => "[$ExamProfile]",
            ]);
            MasterServices::customlog('Submit bill', 'User Submit Bill.');

            return redirect()->route('submit-bill-report')->with('success', 'Data save successfully.');
        }
        return redirect()->route('dashboard');
    }

    public function examBillSaveCS_bkp4apr(Request $request)
    {
        // Check if the request is a POST request
        if ($request->isMethod('post')) {

            // prd($request->all());

            // try {

            //========================== Tabels Section ========================//
            $CRHTable = config('constants.CentralizedRemunerationHeaderTable');
            // $CRLTable = config('constants.CentralizedRemunerationLineTable');
            $CRLTable = config('constants.CentralizedRemunerationLineTableShiftWise');
            $CenterCoordinatorOfflineTbl = config('constants.CentreBillTbl');   // table name
            $CentralizedFormFields = config('constants.CentralizedFormFields');
            $VendorPanTbl = config('constants.VendorPanTbl');
            $VendorContactTbl = config('constants.VendorContactTbl');
            $VendorBankTbl = config('constants.VendorBankTbl');
            $ExamProfile = config('constants.ExamProfile');
            $ExamDates = config('constants.ExamDates');    // table name
            $DaysPersonsTable = config('constants.DaysPersonsTable');    // table name
            $ExamType =  Session::get('examType');
            $ObserverID =  Session::get('ObserverID');
            $Role =  Session::get('role');
            $centerNos =  Session::get('centers');
            //========================== end ========================//

            $uniqueRandomString = $this->generateUniqueRandomString(); // unique reference no generator

            $examId = DB::table($ExamDates)->where('Exam Type', Session::get('examType'))->value('Exam Type Id'); // get exam type id

            // file upload code
            if ($request->hasFile('files')) {
                $fileNameArray = [];
                $files = $request->file('files');

                $ExtensionTypes = ['jpg', 'jpeg', 'png', 'pdf', 'doc', 'docx', 'xls', 'xlsx'];
                $maxFileSize = 2 * 1024 * 1024; //2mb
                foreach ($files as $key => $file) {
                    $uploadedFileNameSame = str_replace('##', ' ', $key);

                    if (!in_array(strtolower($file->getClientOriginalExtension()), $ExtensionTypes)) {
                        return redirect()->route('exambill')->with('error', 'File upload error: The file type is invalid for ' . $uploadedFileNameSame);
                    }
                    if ($file->getSize() > $maxFileSize) {
                        return redirect()->route('exambill')->with('error', 'File upload error: The file size cannot exceed 2MB for ' . $uploadedFileNameSame);
                    }
                }

                foreach ($files as $key => $file) {
                    $uploadedFileName = str_replace('##', '_', $key);
                    $uploadedFileNameSame = str_replace('##', ' ', $key);
                    if ($file->isValid()) {
                        $destinationPath = public_path('uploads/' . Auth::user()->UserName);
                        // Create the destination path if it doesn't exist
                        if (!file_exists($destinationPath)) {
                            mkdir($destinationPath, 0755, true);
                        }
                        // Get the original file name or you can set a custom file name
                        $fileName = time() . '_' . $uploadedFileName . '.' . $file->getClientOriginalExtension();
                        // Move the file to the destination path
                        $file->move($destinationPath, $fileName);
                        $fileNameArray[$uploadedFileNameSame] = url('/uploads/' . Auth::user()->UserName . '/' . $fileName);
                    } else {
                        return redirect()->route('exambill')->with('error', 'File upload error: ' . $file->getErrorMessage());
                    }
                }
            }


            $data = $request->all();
            $keys = array_keys($data);
            $modified_keys = array_map(function ($key) {
                return str_replace('##', ' ', $key);
            }, $keys);
            $data = array_combine($modified_keys, $data);

            $ExtraRemunerationSection = 0;
            if (isset($data['ExtraRemunerationSection'])) {
                // Loop through each sub-array and sum all the values
                foreach ($data['ExtraRemunerationSection'] as $subArray) {
                    $ExtraRemunerationSection += array_sum($subArray);
                }

                // Store the total sum in 'Other Charges'
                $data['Other Charges'] = $ExtraRemunerationSection ? $ExtraRemunerationSection : 0;
            }

            // prd($data);

            // +++++++++++++++++++++++++++++++++++++++++++++ Server Validations & Calculation Starts ============================================//
            $RemunerationFieldsData = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
                'select' => "*",
                'input' => "join [$CRLTable] ON [$CRHTable].ID = [$CRLTable].[Document No_] WHERE [$CRHTable].[Exam Type] = '$ExamType' AND [$CRLTable].[Source Type] = '$Role' ", //AND [$CRLTable].isActive = '1'
                'table' => "[$CRHTable]",
                'orderBy' => "order by displayOrder asc",
            ]);
            // prd($RemunerationFieldsData);

            $sourceCodeMst = [];
            foreach ($RemunerationFieldsData as $valR) {
                $sourceCodeMst[$valR->{'Source Code'}] = array('Mock Drill Charge' => $valR->{'Mock Drill Charge'});
            }
            if (isset($RemunerationFieldsData) && !empty($RemunerationFieldsData)) {
                // ============== Field Section ================//

                $manPowerColumn = $data['ManPower'] ?? [];
                $DutyDaysColumn = $data['DutyDays'] ?? [];
                $AdvancePaymentColumn = $data['Amount Rec_ in Advance'] ?? 0;
                $MiscellaneousCharge = $data['Miscellaneous Charge'] ?? 0;
                $OtherChargesColumn = array_column($RemunerationFieldsData, 'Other Charges');
                $tdsPrecentageColumn = array_column($RemunerationFieldsData, 'tdsPrecentage');
                // pr($manPowerColumn);
                // pr($DutyDaysColumn);
                // pr($AdvancePaymentColumn);
                // pr($MiscellaneousCharge);
                // pr($OtherChargesColumn);
                // prd($tdsPrecentageColumn);
                // $fieldsToCalculate = array_column($RemunerationFieldsData,'Field_Name');
                // $MocdrillfieldsToCalculate = array_column($RemunerationFieldsData,'MockDrillFiledName');
                // $valuesToRemove = ['Advance Payment', 'TDS_Amount'];
                // $fieldsToCalculate = array_diff($fieldsToCalculate, $valuesToRemove);
                //$AllFieldsColumns = array_filter(array_merge($fieldsToCalculate,$MocdrillfieldsToCalculate));
                // $RemunerationAmountColumn = array_column($RemunerationFieldsData,'Remuneration Amount');
                // $ConveyanceAmountColumn = array_column($RemunerationFieldsData,'Conveyance Amount');
                // $MockDrillChargeColumn = array_column($RemunerationFieldsData,'Mock Drill Charge');
                // $MockDrillConveyanceColumn = array_column($RemunerationFieldsData,'Mock Drill Conveyance');
                //pr($tdsPrecentageColumn);
                // ============== Remuneration Section ================//
                $AmountCalculation = [];
                foreach ($RemunerationFieldsData as $row) {
                    $AmountCalculation[] = array(
                        array('Remuneration' => $row->{'Remuneration Amount_S1'}, 'Conveyance' => $row->{'Conveyance Amount'}),
                        array('Mock' => $row->{'Mock Drill Charge'}, 'Mockc' => $row->{'Mock Drill Conveyance'})
                    );
                }
                // pr($AmountCalculation);
                $TotalClaimed = [];
                $TotalClaimedTds = [];
                $k = 0;
                foreach ($AmountCalculation as $index => $val) {
                    $tdsPercentage = $tdsPrecentageColumn[$index] ?? 0;
                    foreach ($val as $key => $subArray) {
                        $manPower = $manPowerColumn[$k] ?? 1;
                        $dutyDays = $DutyDaysColumn[$k] ?? 1;

                        if ($key == 0) {
                            $CalculatedAmount = ($subArray['Remuneration'] + $subArray['Conveyance']) * $manPower * $dutyDays;
                            $CalculatedTDSAmount = ($subArray['Remuneration'] * $tdsPercentage / 100) * $manPower * $dutyDays;
                            if ($CalculatedAmount > 0) {
                                $TotalClaimed[] = $CalculatedAmount;
                                $TotalClaimedTds[] = $CalculatedTDSAmount;
                                $k++;
                            }
                        } else {
                            $CalculatedAmount = ($subArray['Mock'] + $subArray['Mockc']) * $manPower * $dutyDays;
                            $CalculatedTDSAmount = ($subArray['Mock'] * $tdsPercentage / 100) * $manPower * $dutyDays;
                            if ($CalculatedAmount > 0) {
                                $TotalClaimed[] = $CalculatedAmount;
                                $TotalClaimedTds[] = $CalculatedTDSAmount;
                                $k++;
                            }
                        }
                    }
                }

                // pr(array_sum($TotalClaimedTds));
                // prd($TotalClaimed);
                $TotalClaimedAmount = array_sum($TotalClaimed) + array_sum($OtherChargesColumn) + $MiscellaneousCharge + $ExtraRemunerationSection;
                $NetPayableAmount = $TotalClaimedAmount - (array_sum($TotalClaimedTds) + $AdvancePaymentColumn);
                // pr(array_sum($TotalClaimedTds));
                // pr($TotalClaimedAmount);
                // prd($NetPayableAmount);
                // prd($data);
                // if($data['Net Amount Payable'] != $NetPayableAmount){
                //     $message = 'Bill not submitted due to amount not proper';
                //     return redirect()->back()->with('error', $message);
                // }

            }
            // +++++++++++++++++++++++++++++++++++++++++++++ Server Validations & Calculation eNDS ============================================//

            $ArrayFields = [];
            $FieldsData = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
                'select' => "fieldName",
                'input' => "WHERE ExamType = '" . $ExamType . "' AND Role = '" . $Role . "' And isActive = '1'",
                'table' => "[$CentralizedFormFields]",
                'orderBy' => 'order by displayOrder asc',
            ]);
            if (isset($FieldsData) && !empty($FieldsData)) {
                $ArrayFields = json_decode(json_encode($FieldsData), true);
            }

            $UserData = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "*",
                'input' => " join [$VendorContactTbl] on  [$VendorPanTbl].No_ = [$VendorContactTbl].No_
                join [$VendorBankTbl] on  [$VendorPanTbl].No_ = [$VendorBankTbl].No_
                join [$ExamProfile] on  [$VendorPanTbl].No_ = [$ExamProfile].ObserverID
                WHERE [$VendorPanTbl].No_='$ObserverID'",
                'table' => "[$VendorPanTbl]",
            ]);

            $SelectedCenterNo = isset($data['CentrebillMst']) && !empty($data['CentrebillMst']['CentreNumberList']) ? $data['CentrebillMst']['CentreNumberList'] : 'NA';

            if (isset($UserData) && !empty($UserData)) {
                $UserDataToArray = (array) $UserData;
            } else {
                $UserDataToArray = [];
            }

            if (isset($UserData) && !empty($UserData)) {
                $UserDataToArray = (array) $UserData;
            } else {
                $UserDataToArray = [];
            }
            // $centerNameAddress = getCenterNamesaddress();
            $setValueNotFieldExists = array();
            $setValueNotFieldExists['No_ of Duty Days'] = $UserDataToArray['Dutydays'];
            $setValueNotFieldExists['Observer Name'] = $UserDataToArray['Name'];
            $setValueNotFieldExists['Mobile No_'] = $UserDataToArray['Mobile Phone No_'];
            //    $setValueNotFieldExists['Center City'] = $UserDataToArray['City'];
            $setValueNotFieldExists['PAN No_'] = $UserDataToArray['P_A_N_ No_'];

            $setValueNotFieldExists['Bank Name'] = $UserDataToArray['Bank Name'];
            $setValueNotFieldExists['Bank Branch Name'] = $UserDataToArray['Branch'];
            $setValueNotFieldExists['Bank_Account_No'] = $UserDataToArray['Vendor Account No_'];
            $setValueNotFieldExists['IFSC Code'] = $UserDataToArray['IFSC Code'];
            $centerNoInString = "'" . join("','", Session::get('centers')) . "'";
            $observersCount = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "*",
                'input' => "where ExamType = '$ExamType' AND [Observer Type]='5' AND  CENTNO  in ($centerNoInString)",
                'table' => "[$ExamProfile]",
            ]);
            $observersCount = count($observersCount);

            $rcName = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "Name",
                'input' => "where ExamType = '$ExamType' AND [Observer Type]='12'",
                'table' => "[$ExamProfile]",
            ]);
            $outSideValue['Name of RC'] = $rcName->Name ?? 'NA';
            $outSideValue['ExamName'] = Session::get('examName');
            $outSideValue['City Coordinator Name'] = Session::get('Name');
            $outSideValue['No_ of Alloted Centres'] = count(Session::get('centers'));
            $outSideValue['No_ of Alloted Observer'] = $observersCount ?? '0';
            $setValueNotFieldExists['CenterNo'] = isset($centerNos) && !empty($centerNos) ? implode(',', $centerNos) : '';
            $setValueNotFieldExists['Center Address'] = $centerNameAddress;


            foreach ($ArrayFields as $key => $val) {
                if (array_key_exists($val['fieldName'], $outSideValue)) {
                    $ArrayFields[$key]['fieldValue'] = $outSideValue[$val['fieldName']]; //set value
                } else {
                    if (in_array($val['fieldName'], array_keys($setValueNotFieldExists))) {
                        $ArrayFields[$key]['fieldValue'] = $setValueNotFieldExists[$val['fieldName']] ?? ''; //set value
                    } else {
                        $ArrayFields[$key]['fieldValue'] = $UserDataToArray[$val['fieldName']] ?? 'NA'; //set value NA
                    }
                }
            }

            // prd($data);
            $fieldValues =  array_column($ArrayFields, 'fieldValue', 'fieldName');


            $remunerationSourceCodeArray = array_column($RemunerationFieldsData, 'Source Code');
            $nR = 0;
            $idR = 0;
            foreach ($data['ManPower'] as $mpKey => $mpVal) {
                $remSC = $remunerationSourceCodeArray[$idR];
                if ($nR == 1) {
                    $remSC .= ' MOCK';
                }
                $remDD = $data['DutyDays'][$mpKey] ?? 0;
                if (array_key_exists($remSC, $sourceCodeMst) && $sourceCodeMst[$remSC]['Mock Drill Charge'] > 0 && $nR == 0) {
                    $nR = 1;
                    DB::statement('exec insertCommonDataSP :fields, :values, :table', [
                        'fields' => "[Reference No_],[Source Code],[No of Days],[No of Person]",
                        'values' => "'$uniqueRandomString','$remSC','$remDD','$mpVal'",
                        'table' => "[$DaysPersonsTable]",
                    ]);
                } else {
                    DB::statement('exec insertCommonDataSP :fields, :values, :table', [
                        'fields' => "[Reference No_],[Source Code],[No of Days],[No of Person]",
                        'values' => "'$uniqueRandomString','$remSC','$remDD','$mpVal'",
                        'table' => "[$DaysPersonsTable]",
                    ]);
                    $nR = 0;
                    $idR++;
                }
            }

            unset($fieldValues['No_ of Candidate Alloted'], $fieldValues['No_ of Candidate Present'], $fieldValues['No_ of Candidate Absent']); // unset value
            //prd($fileNameArray);
            foreach ($fieldValues as $key => $value) {
                $data[$key] = $value;
            }

            //========================================= end form field ===========================================================//

            $data['Reference No_'] = $uniqueRandomString;
            $data['No_ of Person'] = implode(',', $data['ManPower']);
            $data['No_ of Days'] = implode(',', $data['DutyDays']);
            $data['Bill Status'] = 0;
            $data['IsSubmitted'] = 1;
            $data['IsNewBill'] = 1;
            $data['Exam Type'] = Session::get('examType');
            $data['Exam Name'] = Session::get('examName');
            $data['Role'] = Session::get('role');
            $data['Observer ID'] = Session::get('ObserverID');
            $data['Exam ID'] = $examId;
            $data['Created on'] = date('Y-m-d H:i:s');
            $data['Total Expenditure Amount'] = $TotalClaimedAmount ?? 0;
            $data['File Path'] = $fileNameArray['Miscellaneous Charge'] ?? 0;
            unset(
                $data['_token'],
                $data['ManPower'],
                $data['DutyDays'],
                $data['submit'],
                $data['files'],
                $data['serverCalculationTDSPer'],
                $data['serverCalculationRemunerationAmount'],
                $data['serverCalculationConvenceAmount'],
                $data['serverCalculationTDSPer'],
                $data['serverCalculationAdditions'],
                $data['ExtraRemunerationSection'],
                $data['observers'],
                $data['deputy_observers'],
                $data['AllottedCandidatesCount'],
                $data['CentrebillMst'],
                $data['ObserverTotalAdvanceAmount'],
                $data['ObserverTotalTDSAmount'],
                $data['ObserverNetAmount'],
                $data['DObserverTotalAdvanceAmount'],
                $data['DObserverTotalTDSAmount'],
                $data['DObserverNetAmount']
            );
            // prd($data);

            $tableColumnsData = '[' . join('],[', array_keys($data)) . ']';
            $tableValuesData = "'" . join("','", array_values($data)) . "'";
            DB::statement('exec insertCommonDataSP :fields, :values, :table', [
                'fields' => "$tableColumnsData",
                'values' => "$tableValuesData",
                'table' => "[$CenterCoordinatorOfflineTbl]",
            ]);

            DB::statement(DB::raw("exec updateCommonDataSP :updatefields, :where, :table"), [
                ':updatefields' => "[Submitted Documents]='1'",
                ':where' => "WHERE ObserverID = '$ObserverID' AND ExamType = '$ExamType' AND CENTNO = '$SelectedCenterNo'",
                ':table' => "[$ExamProfile]",
            ]);

            MasterServices::customlog('Submit bill', 'User Submit Bill.');
            return redirect()->route('submit-bill-report')->with('success', 'Bill Submitted Successfully.');
            // } catch (\Exception $e) {
            //     $message = $e->getMessage();
            //     Log::error('Form submission error: ' . $e->getMessage(), [
            //         'exception' => $e,
            //         'data' => $request->all(),
            //     ]);
            //     return redirect()->back()->with('error', $message);
            // }
        }
        return redirect()->route('dashboard');
    }

    public function examBillSaveCS(Request $request)
    {
        // Check if the request is a POST request
        if ($request->isMethod('post')) {

            // prd($request->all());

            // try {

            //========================== Tabels Section ========================//
            $CRHTable = config('constants.CentralizedRemunerationHeaderTable');
            // $CRLTable = config('constants.CentralizedRemunerationLineTable');
            $CRLTable = config('constants.CentralizedRemunerationLineTableShiftWise');
            $CenterCoordinatorOfflineTbl = config('constants.CentreBillTbl');   // table name
            $CentralizedFormFields = config('constants.CentralizedFormFields');
            $VendorPanTbl = config('constants.VendorPanTbl');
            $VendorContactTbl = config('constants.VendorContactTbl');
            $VendorBankTbl = config('constants.VendorBankTbl');
            $ExamProfile = config('constants.ExamProfile');
            $ExamDates = config('constants.ExamDates');    // table name
            $DaysPersonsTable = config('constants.DaysPersonsTable');    // table name
            $ExamType =  Session::get('examType');
            $ObserverID =  Session::get('ObserverID');
            $Role =  Session::get('role');
            $centerNos =  Session::get('centers');
            //========================== end ========================//

            $uniqueRandomString = $this->generateUniqueRandomString(); // unique reference no generator

            $examId = DB::table($ExamDates)->where('Exam Type', Session::get('examType'))->value('Exam Type Id'); // get exam type id

            // file upload code
            if ($request->hasFile('files')) {
                $fileNameArray = [];
                $files = $request->file('files');

                $ExtensionTypes = ['jpg', 'jpeg', 'png', 'pdf', 'doc', 'docx', 'xls', 'xlsx'];
                $maxFileSize = 2 * 1024 * 1024; //2mb
                foreach ($files as $key => $file) {
                    $uploadedFileNameSame = str_replace('##', ' ', $key);

                    if (!in_array(strtolower($file->getClientOriginalExtension()), $ExtensionTypes)) {
                        return redirect()->route('exambill')->with('error', 'File upload error: The file type is invalid for ' . $uploadedFileNameSame);
                    }
                    if ($file->getSize() > $maxFileSize) {
                        return redirect()->route('exambill')->with('error', 'File upload error: The file size cannot exceed 2MB for ' . $uploadedFileNameSame);
                    }
                }

                foreach ($files as $key => $file) {
                    $uploadedFileName = str_replace('##', '_', $key);
                    $uploadedFileNameSame = str_replace('##', ' ', $key);
                    if ($file->isValid()) {
                        $destinationPath = public_path('uploads/' . Auth::user()->UserName);
                        // Create the destination path if it doesn't exist
                        if (!file_exists($destinationPath)) {
                            mkdir($destinationPath, 0755, true);
                        }
                        // Get the original file name or you can set a custom file name
                        $fileName = time() . '_' . $uploadedFileName . '.' . $file->getClientOriginalExtension();
                        // Move the file to the destination path
                        $file->move($destinationPath, $fileName);
                        $fileNameArray[$uploadedFileNameSame] = url('/uploads/' . Auth::user()->UserName . '/' . $fileName);
                    } else {
                        return redirect()->route('exambill')->with('error', 'File upload error: ' . $file->getErrorMessage());
                    }
                }
            }


            $data = $request->all();
            $keys = array_keys($data);
            $modified_keys = array_map(function ($key) {
                return str_replace('##', ' ', $key);
            }, $keys);
            $data = array_combine($modified_keys, $data);

            $ExtraRemunerationSection = 0;
            if (isset($data['ExtraRemunerationSection'])) {
                // Loop through each sub-array and sum all the values
                foreach ($data['ExtraRemunerationSection'] as $subArray) {
                    $ExtraRemunerationSection += array_sum($subArray);
                }

                // Store the total sum in 'Other Charges'
                $data['Other Charges'] = $ExtraRemunerationSection ? $ExtraRemunerationSection : 0;
            }

            // prd($data);

            // +++++++++++++++++++++++++++++++++++++++++++++ Server Validations & Calculation Starts ============================================//
            $RemunerationFieldsData = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
                'select' => "*",
                'input' => "join [$CRLTable] ON [$CRHTable].ID = [$CRLTable].[Document No_] WHERE [$CRHTable].[Exam Type] = '$ExamType' AND [$CRLTable].[Source Type] = '$Role' ", //AND [$CRLTable].isActive = '1'
                'table' => "[$CRHTable]",
                'orderBy' => "order by displayOrder asc",
            ]);
            // prd($RemunerationFieldsData);

            $sourceCodeMst = [];
            foreach ($RemunerationFieldsData as $valR) {
                $sourceCodeMst[$valR->{'Source Code'}] = array('Mock Drill Charge' => $valR->{'Mock Drill Charge'});
            }
            //if (isset($RemunerationFieldsData) && !empty($RemunerationFieldsData)) {
                // ============== Field Section ================//

                // $manPowerColumn = $data['ManPower'] ?? [];
                // $DutyDaysColumn = $data['DutyDays'] ?? [];
                // $AdvancePaymentColumn = $data['Amount Rec_ in Advance'] ?? 0;
                // $MiscellaneousCharge = $data['Miscellaneous Charge'] ?? 0;
                // $OtherChargesColumn = array_column($RemunerationFieldsData, 'Other Charges');
                // $tdsPrecentageColumn = array_column($RemunerationFieldsData, 'tdsPrecentage');
                // pr($manPowerColumn);
                // pr($DutyDaysColumn);
                // pr($AdvancePaymentColumn);
                // pr($MiscellaneousCharge);
                // pr($OtherChargesColumn);
                // prd($tdsPrecentageColumn);
                // $fieldsToCalculate = array_column($RemunerationFieldsData,'Field_Name');
                // $MocdrillfieldsToCalculate = array_column($RemunerationFieldsData,'MockDrillFiledName');
                // $valuesToRemove = ['Advance Payment', 'TDS_Amount'];
                // $fieldsToCalculate = array_diff($fieldsToCalculate, $valuesToRemove);
                //$AllFieldsColumns = array_filter(array_merge($fieldsToCalculate,$MocdrillfieldsToCalculate));
                // $RemunerationAmountColumn = array_column($RemunerationFieldsData,'Remuneration Amount');
                // $ConveyanceAmountColumn = array_column($RemunerationFieldsData,'Conveyance Amount');
                // $MockDrillChargeColumn = array_column($RemunerationFieldsData,'Mock Drill Charge');
                // $MockDrillConveyanceColumn = array_column($RemunerationFieldsData,'Mock Drill Conveyance');
                //pr($tdsPrecentageColumn);
                // ============== Remuneration Section ================//
                // $AmountCalculation = [];
                // foreach ($RemunerationFieldsData as $row) {
                //     $AmountCalculation[] = array(
                //         array('Remuneration' => $row->{'Remuneration Amount_S1'}, 'Conveyance' => $row->{'Conveyance Amount'}),
                //         array('Mock' => $row->{'Mock Drill Charge'}, 'Mockc' => $row->{'Mock Drill Conveyance'})
                //     );
                // }
                // pr($AmountCalculation);
                // $TotalClaimed = [];
                // $TotalClaimedTds = [];
                // $k = 0;
                // foreach ($AmountCalculation as $index => $val) {
                //     $tdsPercentage = $tdsPrecentageColumn[$index] ?? 0;
                //     foreach ($val as $key => $subArray) {
                //         $manPower = $manPowerColumn[$k] ?? 1;
                //         $dutyDays = $DutyDaysColumn[$k] ?? 1;

                //         if ($key == 0) {
                //             $CalculatedAmount = ($subArray['Remuneration'] + $subArray['Conveyance']) * $manPower * $dutyDays;
                //             $CalculatedTDSAmount = ($subArray['Remuneration'] * $tdsPercentage / 100) * $manPower * $dutyDays;
                //             if ($CalculatedAmount > 0) {
                //                 $TotalClaimed[] = $CalculatedAmount;
                //                 $TotalClaimedTds[] = $CalculatedTDSAmount;
                //                 $k++;
                //             }
                //         } else {
                //             $CalculatedAmount = ($subArray['Mock'] + $subArray['Mockc']) * $manPower * $dutyDays;
                //             $CalculatedTDSAmount = ($subArray['Mock'] * $tdsPercentage / 100) * $manPower * $dutyDays;
                //             if ($CalculatedAmount > 0) {
                //                 $TotalClaimed[] = $CalculatedAmount;
                //                 $TotalClaimedTds[] = $CalculatedTDSAmount;
                //                 $k++;
                //             }
                //         }
                //     }
                // }


                // pr(array_sum($TotalClaimedTds));
                // prd($TotalClaimed);
                //$TotalClaimedAmount = array_sum($TotalClaimed) + array_sum($OtherChargesColumn) + $MiscellaneousCharge + $ExtraRemunerationSection;
                //$NetPayableAmount = $TotalClaimedAmount - (array_sum($TotalClaimedTds) + $AdvancePaymentColumn);
                // pr(array_sum($TotalClaimedTds));
                // pr($TotalClaimedAmount);
                // prd($NetPayableAmount);
                // prd($data);
                // if($data['Net Amount Payable'] != $NetPayableAmount){
                //     $message = 'Bill not submitted due to amount not proper';
                //     return redirect()->back()->with('error', $message);
                // }

            //}
            // pr($TotalClaimedAmount);
            // prd($data);
            $TotalClaimedAmount = $data['Net Amount Payable'] + ($data['TDS_Amount'] + $data['Amount Rec_ in Advance']);
            // +++++++++++++++++++++++++++++++++++++++++++++ Server Validations & Calculation eNDS ============================================//

            $ArrayFields = [];
            $FieldsData = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
                'select' => "fieldName",
                'input' => "WHERE ExamType = '" . $ExamType . "' AND Role = '" . $Role . "' And isActive = '1'",
                'table' => "[$CentralizedFormFields]",
                'orderBy' => 'order by displayOrder asc',
            ]);
            if (isset($FieldsData) && !empty($FieldsData)) {
                $ArrayFields = json_decode(json_encode($FieldsData), true);
            }

            $UserData = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "*",
                'input' => " join [$VendorContactTbl] on  [$VendorPanTbl].No_ = [$VendorContactTbl].No_
                join [$VendorBankTbl] on  [$VendorPanTbl].No_ = [$VendorBankTbl].No_
                join [$ExamProfile] on  [$VendorPanTbl].No_ = [$ExamProfile].ObserverID
                WHERE [$VendorPanTbl].No_='$ObserverID'",
                'table' => "[$VendorPanTbl]",
            ]);

            $SelectedCenterNo = isset($data['CentrebillMst']) && !empty($data['CentrebillMst']['CentreNumberList']) ? $data['CentrebillMst']['CentreNumberList'] : '';

            if (isset($UserData) && !empty($UserData)) {
                $UserDataToArray = (array) $UserData;
            } else {
                $UserDataToArray = [];
            }

            if (isset($UserData) && !empty($UserData)) {
                $UserDataToArray = (array) $UserData;
            } else {
                $UserDataToArray = [];
            }
            // $centerNameAddress = getCenterNamesaddress();
            $setValueNotFieldExists = array();
            $setValueNotFieldExists['No_ of Duty Days'] = $UserDataToArray['Dutydays'];
            $setValueNotFieldExists['Observer Name'] = $UserDataToArray['Name'];
            $setValueNotFieldExists['Mobile No_'] = $UserDataToArray['Mobile Phone No_'];
            //    $setValueNotFieldExists['Center City'] = $UserDataToArray['City'];
            $setValueNotFieldExists['PAN No_'] = $UserDataToArray['P_A_N_ No_'];

            $setValueNotFieldExists['Bank Name'] = $UserDataToArray['Bank Name'];
            $setValueNotFieldExists['Bank Branch Name'] = $UserDataToArray['Branch'];
            $setValueNotFieldExists['Bank_Account_No'] = $UserDataToArray['Vendor Account No_'];
            $setValueNotFieldExists['IFSC Code'] = $UserDataToArray['IFSC Code'];
            $centerNoInString = "'" . join("','", Session::get('centers')) . "'";
            $observersCount = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "*",
                'input' => "where ExamType = '$ExamType' AND [Observer Type]='5' AND  CENTNO  in ($centerNoInString)",
                'table' => "[$ExamProfile]",
            ]);
            $observersCount = count($observersCount);

            $rcName = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                'select' => "Name",
                'input' => "where ExamType = '$ExamType' AND [Observer Type]='12'",
                'table' => "[$ExamProfile]",
            ]);
            $outSideValue['Name of RC'] = $rcName->Name ?? 'NA';
            $outSideValue['ExamName'] = Session::get('examName');
            $outSideValue['City Coordinator Name'] = Session::get('Name');
            $outSideValue['No_ of Alloted Centres'] = count(Session::get('centers'));
            $outSideValue['No_ of Alloted Observer'] = $observersCount ?? '0';
            // $setValueNotFieldExists['CenterNo'] = isset($centerNos) && !empty($centerNos) ? implode(',', $centerNos) : '';
            $setValueNotFieldExists['CenterNo'] = $SelectedCenterNo;
            $setValueNotFieldExists['Center Address'] = getCenterNamesaddress($SelectedCenterNo);
            $setValueNotFieldExists['Center City'] = $data['Center City'];


            foreach ($ArrayFields as $key => $val) {
                if (array_key_exists($val['fieldName'], $outSideValue)) {
                    $ArrayFields[$key]['fieldValue'] = $outSideValue[$val['fieldName']]; //set value
                } else {
                    if (in_array($val['fieldName'], array_keys($setValueNotFieldExists))) {
                        $ArrayFields[$key]['fieldValue'] = $setValueNotFieldExists[$val['fieldName']] ?? ''; //set value
                    } else {
                        $ArrayFields[$key]['fieldValue'] = $UserDataToArray[$val['fieldName']] ?? 'NA'; //set value NA
                    }
                }
            }

            // prd($data);
            $fieldValues =  array_column($ArrayFields, 'fieldValue', 'fieldName');


            $remunerationSourceCodeArray = array_column($RemunerationFieldsData, 'Source Code');
            $nR = 0;
            $idR = 0;
            foreach ($data['ManPower'] as $mpKey => $mpVal) {
                $remSC = $remunerationSourceCodeArray[$idR];
                if ($nR == 1) {
                    $remSC .= ' MOCK';
                }
                $remDD = $data['DutyDays'][$mpKey] ?? 0;
                if (array_key_exists($remSC, $sourceCodeMst) && $sourceCodeMst[$remSC]['Mock Drill Charge'] > 0 && $nR == 0) {
                    $nR = 1;
                    DB::statement('exec insertCommonDataSP :fields, :values, :table', [
                        'fields' => "[Reference No_],[Source Code],[No of Days],[No of Person]",
                        'values' => "'$uniqueRandomString','$remSC','$remDD','$mpVal'",
                        'table' => "[$DaysPersonsTable]",
                    ]);
                } else {
                    DB::statement('exec insertCommonDataSP :fields, :values, :table', [
                        'fields' => "[Reference No_],[Source Code],[No of Days],[No of Person]",
                        'values' => "'$uniqueRandomString','$remSC','$remDD','$mpVal'",
                        'table' => "[$DaysPersonsTable]",
                    ]);
                    $nR = 0;
                    $idR++;
                }
            }

            unset($fieldValues['No_ of Candidate Alloted'], $fieldValues['No_ of Candidate Present'], $fieldValues['No_ of Candidate Absent']); // unset value
            //prd($fileNameArray);
            foreach ($fieldValues as $key => $value) {
                $data[$key] = $value;
            }
            // prd($data);
            //========================================= end form field ===========================================================//

            $data['Reference No_'] = $uniqueRandomString;
            $data['No_ of Person'] = implode(',', $data['ManPower']);
            $data['No_ of Days'] = implode(',', $data['DutyDays']);
            $data['Bill Status'] = 0;
            $data['IsSubmitted'] = 1;
            $data['IsNewBill'] = 1;
            $data['Exam Type'] = Session::get('examType');
            $data['Exam Name'] = Session::get('examName');
            $data['Role'] = Session::get('role');
            $data['Observer ID'] = Session::get('ObserverID');
            $data['Exam ID'] = $examId;
            $data['Created on'] = date('Y-m-d H:i:s');
            $data['Total Expenditure Amount'] = $TotalClaimedAmount ?? 0;
            $data['File Path'] = $fileNameArray['Miscellaneous Charge'] ?? 0;
            unset(
                $data['_token'],
                $data['ManPower'],
                $data['DutyDays'],
                $data['submit'],
                $data['files'],
                $data['serverCalculationTDSPer'],
                $data['serverCalculationRemunerationAmount'],
                $data['serverCalculationConvenceAmount'],
                $data['serverCalculationTDSPer'],
                $data['serverCalculationAdditions'],
                $data['ExtraRemunerationSection'],
                $data['observers'],
                $data['deputy_observers'],
                $data['AllottedCandidatesCount'],
                $data['CentrebillMst'],
                $data['ObserverTotalAdvanceAmount'],
                $data['ObserverTotalTDSAmount'],
                $data['ObserverNetAmount'],
                $data['DObserverTotalAdvanceAmount'],
                $data['DObserverTotalTDSAmount'],
                $data['DObserverNetAmount']
            );
            // prd($data);

            $tableColumnsData = '[' . join('],[', array_keys($data)) . ']';
            $tableValuesData = "'" . join("','", array_values($data)) . "'";
            DB::statement('exec insertCommonDataSP :fields, :values, :table', [
                'fields' => "$tableColumnsData",
                'values' => "$tableValuesData",
                'table' => "[$CenterCoordinatorOfflineTbl]",
            ]);

            DB::statement(DB::raw("exec updateCommonDataSP :updatefields, :where, :table"), [
                ':updatefields' => "[Submitted Documents]='1'",
                ':where' => "WHERE ObserverID = '$ObserverID' AND ExamType = '$ExamType' AND CENTNO = '$SelectedCenterNo'",
                ':table' => "[$ExamProfile]",
            ]);

            MasterServices::customlog('Submit bill', 'User Submit Bill.');
            return redirect()->route('submit-bill-report')->with('success', 'Bill Submitted Successfully.');
            // } catch (\Exception $e) {
            //     $message = $e->getMessage();
            //     Log::error('Form submission error: ' . $e->getMessage(), [
            //         'exception' => $e,
            //         'data' => $request->all(),
            //     ]);
            //     return redirect()->back()->with('error', $message);
            // }
        }
        return redirect()->route('dashboard');
    }

    public function tabillSave(Request $request)
    {
        // prd($request->all());
        $CentralizedFormFields = config('constants.CentralizedFormFields');
        $VendorPanTbl = config('constants.VendorPanTbl');
        $VendorContactTbl = config('constants.VendorContactTbl');
        $VendorBankTbl = config('constants.VendorBankTbl');
        $ExamProfile = config('constants.ExamProfile');
        $CRHTable = config('constants.CentralizedRemunerationHeaderTable');
        $CRLTable = config('constants.CentralizedRemunerationLineTable');
        $ExamDates = config('constants.ExamDates');
        $ObserverOfflineTbl = config('constants.TABillHeaderTbl');   // table name
        $TABillLocalTbl = config('constants.TABillLocalTbl');
        $TABillHotelTbl = config('constants.TABillHotelTbl');
        $TABillOutstationTbl = config('constants.TABillOutstationTbl');
        $ExamType =  Session::get('examType');
        $ObserverID =  Session::get('ObserverID');
        $Role =  Session::get('role');
        $uniqueRandomString = $this->generateUniqueRandomString();
        $examId = DB::table($ExamDates)->where('Exam Type', Session::get('examType'))->value('Exam Type Id');
        $centersSess =  Session::get('centers');
        $RemunerationFieldsData = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
            'select' => "[$CRLTable].[Remuneration Amount],[$CRLTable].tdsPrecentage,[$CRLTable].[Source Code]",
            'input' => "join [$CRLTable] ON [$CRHTable].ID = [$CRLTable].[Document No_] WHERE [$CRHTable].[Exam Type] = '$ExamType' AND [$CRLTable].[Source Type] = '$Role'", //AND [$CRLTable].isActive = '1'
            'table' => "[$CRHTable]",
            'orderBy' => "order by displayOrder asc",
        ]);

        $centers = "'" . implode("','", $centersSess) . "'";
        $BillData   = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table
                "), [
            'select' => "Dutydays,A_MT",
            'input' => "join [$ExamDates] ON [$ExamProfile].ExamType = [$ExamDates].[Exam Type] WHERE [$ExamProfile].[ExamType] = '$ExamType' AND [$ExamProfile].ObserverID ='$ObserverID' AND [$ExamProfile].CENTNO = $centers",
            'table' => "[$ExamProfile]",
        ]);

        $Dutydays = isset($BillData)  && !empty($BillData) ? $BillData->Dutydays :  0;

        // try {
            $data = $request->all();
            $submited = 0;
            if ($request->billType == '1') {
                $submited = 1;
            }

            if ($request->event_type == 1) {
                if ($request->hasFile('files')) {
                    $fileNameArray = [];
                    $files = $request->file('files');

                    $ExtensionTypes = ['jpg', 'jpeg', 'png', 'pdf', 'doc', 'docx', 'xls', 'xlsx'];
                    $maxFileSize = 2 * 1024 * 1024; //2mb
                    foreach ($files as $key => $file) {
                        $uploadedFileNameSame = str_replace('##', ' ', $key);

                        if (!in_array(strtolower($file->getClientOriginalExtension()), $ExtensionTypes)) {
                            return redirect()->route('tabill')->with('error', 'File upload error: The file type is invalid for ' . $uploadedFileNameSame);
                        }
                        if ($file->getSize() > $maxFileSize) {
                            return redirect()->route('tabill')->with('error', 'File upload error: The file size cannot exceed 2MB for ' . $uploadedFileNameSame);
                        }
                    }


                    foreach ($files as $key => $file) {

                        $uploadedFileName = str_replace('##', '_', $key);
                        $uploadedFileNameSame = str_replace('##', ' ', $key);
                        if ($file->isValid()) {

                            $destinationPath = public_path('uploads/' . Auth::user()->UserName);
                            // Create the destination path if it doesn't exist
                            if (!file_exists($destinationPath)) {
                                mkdir($destinationPath, 0755, true);
                            }
                            // Get the original file name or you can set a custom file name
                            $fileName =  rand(10000000, 99999999) . '_' . $uploadedFileName . '.' . $file->getClientOriginalExtension();
                            // Move the file to the destination path
                            $file->move($destinationPath, $fileName);
                            $fileNameArray[$uploadedFileNameSame] = $fileName;
                            $fileName = url('/uploads/' . Auth::user()->UserName . '/' . $fileName) ?? 'NA';
                        } else {
                            return redirect()->route('exambill')->with('error', 'File upload error: ' . $file->getErrorMessage());
                        }
                    }
                }
                $keys = array_keys($data);
                $modified_keys = array_map(function ($key) {
                    return str_replace('##', ' ', $key);
                    return str_replace('##', '_', $key);
                }, $keys);
                $data = array_combine($modified_keys, $data);
                $dataExtraFeild = [];
                if ($data && !empty($data['Extrafields'])) {
                    $ExtraFieldsSum = array_sum(array_values($data['Extrafields']));
                    $keys_extra = array_keys($data['Extrafields']);
                    $modified_keys_extra = array_map(function ($key) {
                        return str_replace('##', ' ', $key);
                        return str_replace('##', '_', $key);
                    }, $keys_extra);
                    $dataExtraFeild = array_combine($modified_keys_extra, $data['Extrafields']);
                }
                $data = array_merge($dataExtraFeild, $data);

                //pr($RemunerationFieldsData);
                //  ======================================= Server Calculation ====================================//
                if (!empty($RemunerationFieldsData)) {
                    $totalRemunerationAmount = 0;
                    $mockDrillAndConvence = 0;
                    $tdsAmount = 0;
                    foreach ($RemunerationFieldsData as $info) {
                        $RemunerationAmount = $info->{'Remuneration Amount'};

                        if ($info->tdsPrecentage > 0) {
                            $tdsPrecentage = $info->tdsPrecentage ?? 10;
                            if ($info->{'Source Code'} == 'MOCKDRILL' && $BillData->A_MT == 1) {
                                $tdsAmount += (number_format($RemunerationAmount, 0, '', '') / $tdsPrecentage);
                                $totalRemunerationAmount += (number_format($RemunerationAmount, 0, '', ''));
                            } else if ($info->{'Source Code'} == 'MOCKDRILL' && $BillData->A_MT == 0) {
                                //
                            } else {
                                $tdsAmount += (number_format($RemunerationAmount, 0, '', '') / $tdsPrecentage) * $Dutydays;
                                $totalRemunerationAmount += (number_format($RemunerationAmount, 0, '', '')) * $Dutydays;
                            }
                        } else {
                            if ($info->{'Source Code'} == 'MOCKDRILL CONVEYANCE' && $BillData->A_MT == 1) {
                                $totalRemunerationAmount += (number_format($RemunerationAmount, 0, '', ''));
                            } else if ($info->{'Source Code'} == 'MOCKDRILL CONVEYANCE' && $BillData->A_MT == 0) {
                                //
                            } else {
                                $totalRemunerationAmount += (number_format($RemunerationAmount, 0, '', '')) * $Dutydays;
                            }
                        }
                    }

                    $advancePayment = $data['Advance Payment'] ?? 0;
                    $MiscellanousCharges = $data['Amount'] ?? 0;

                    $totalExtraFields =  $ExtraFieldsSum ?? 0;
                    $totalRemuneration = ($totalRemunerationAmount) + $mockDrillAndConvence;
                    $totalAmount = $totalRemuneration + $MiscellanousCharges + $totalExtraFields;
                    $netPayableAfterDeductions = $totalAmount - ($tdsAmount + $advancePayment);
                    //prd($mockDrillAndConvence);
                }
                // pr($netPayableAfterDeductions);
                // prd($data['Net Payable After Deduction']);
                // if ($netPayableAfterDeductions != $data['Net Payable After Deduction']) {
                //     $message = 'Error while submitting your bill.';
                //     return redirect()->back()->with('error', $message);
                // }

                //  ======================================= Server Calculation ====================================//

                //-------------------------------------------Start form field ---------------------------------------------

                $ArrayFields = [];
                $FieldsData = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
                    'select' => "fieldName",
                    'input' => "WHERE ExamType = '" . $ExamType . "' AND Role = '" . $Role . "' And isActive = '1'",
                    'table' => "[$CentralizedFormFields]",
                    'orderBy' => 'order by displayOrder asc',
                ]);

                if (!empty($FieldsData)) {
                    $ArrayFields = json_decode(json_encode($FieldsData), true);
                }

                // Fetch user data
                // $UserData = DB::table($ExamProfile)
                //     ->join($VendorPanTbl, "$ExamProfile.ObserverID", "=", "$VendorPanTbl.No_")
                //     ->join($VendorContactTbl, "$ExamProfile.ObserverID", "=", "$VendorContactTbl.No_")
                //     ->join($VendorBankTbl, "$ExamProfile.ObserverID", "=", "$VendorBankTbl.No_")
                //     ->join($ExamDates, "$ExamProfile.ExamType", "=", "$ExamDates.Exam Type")
                //     ->where("$ExamProfile.ExamType", $ExamType)
                //     ->where("$ExamProfile.ObserverID", $ObserverID)
                //     ->select("*")
                //     ->first();

                $UserData = DB::selectOne(DB::raw("getUserDataForObserverSP '$ExamType','$ObserverID'"));

                if (isset($UserData) && !empty($UserData)) {
                    $UserDataToArray = (array) $UserData;
                } else {
                    $UserDataToArray = [];
                }

                if (isset($UserData) && !empty($UserData)) {
                    $UserDataToArray = (array) $UserData;
                } else {
                    $UserDataToArray = [];
                }

                // Fetch RC and CC names

                $ccName = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                    'select' => "Name,Mobile",
                    'input' => "WHERE ExamType = '" . $ExamType . "' And [Observer Type] = '1'",
                    'table' => "[$ExamProfile]",
                ]);

                $rcName = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                    'select' => "Name",
                    'input' => "where ExamType = '$ExamType' AND [Observer Type]='12'",
                    'table' => "[$ExamProfile]",
                ]);

                $setValue = [];
                if (!empty($UserDataToArray)) {
                    $setValue = [
                        'Observer Name' => $UserDataToArray['Name'],
                        'Contact No' => $UserDataToArray['Mobile Phone No_'],
                        'PAN_No' => $UserDataToArray['P_A_N_ No_'],
                        'Bank_Branch_Name' => $UserDataToArray['Branch'],
                        'Bank_Account_No' => $UserDataToArray['Vendor Account No_'],
                        'IFSC Code' => $UserDataToArray['IFSC Code'],
                        'Exam Date' => $UserDataToArray['Exam_Duration'],
                        'Centre No_' => $UserDataToArray['CENTNO'],
                        'Centre Address' => $UserDataToArray['Centre_Address'],
                        'Observer ID' => $ObserverID,
                        'Address For Communication' => $UserDataToArray['Address'],
                        'CcName' => $ccName ? $ccName->Name . ', ' . $ccName->Mobile : '',
                        'RC Name' => $rcName ?? 'NA',

                    ];
                }

                foreach ($ArrayFields as $key => $val) {
                    if (array_key_exists($val['fieldName'], $setValue)) {
                        $ArrayFields[$key]['fieldValue'] = $setValue[$val['fieldName']]; //set value
                    } else {
                        $ArrayFields[$key]['fieldValue'] = $UserDataToArray[$val['fieldName']] ?? 'NA';
                    }
                }
                $fieldValues =  array_column($ArrayFields, 'fieldValue', 'fieldName');
                // prd($fieldValues);
                foreach ($fieldValues as $key => $value) {
                    $data[$key] = $value;
                }
                //-------------------------------------------end form field ---------------------------------------------
                // prd($data);
                $data['Reference No_'] = $uniqueRandomString;
                $data['Observer ID'] = Session::get('ObserverID');
                $data['Exam Date'] = date('Y-m-d');
                $data['Bill Submit Type'] = 0;
                $data['Other Charges'] = $otherCharges ?? 0;
                $data['Exam Code'] = Session::get('examType');
                $data['Exam Name'] = Session::get('examName');
                // $data['Claimed Amount'] = $netPayableAfterDeductions ?? 0;
                $data['Claimed Amount'] = $data['Net Payable After Deduction'] ?? 0;
                $data['Status'] = 0;
                $data['Submitted'] = $submited;
                $data['IsNewBill'] = 1;
                $data['Role ID'] = Session::get('role');
                $data['NTA Unique ID'] = Session::get('ObserverID');
                $data['Exam_ID'] = $examId;
                $data['Exam_Mode'] = 0;
                $data['Bill Status'] = 0;
                //$data['Net Payable Amount'] = $netPayableAfterDeductions ?? 0;
                $data['Net Payable Amount'] = $data['Net Payable After Deduction'] ?? 0;
                $data['Observer Type'] = Session::get('role');
                $data['Created Time'] = date('Y-m-d');
                $data['CreatedDate'] = date('Y-m-d H:i:s');
                $data['Posting Date'] = date('Y-m-d H:i:s');
                $misce = $data['Miscellaneous Charge'];
                //$data['Net Payable After Deduction'] = 0;

                unset($data['Observer Name'], $data['Address'], $data['Name'], $data['ObserverID'], $data['CcName'], $data['_token'], $data['dutydates'], $data['Dutydays'], $data['event_type'], $data['files'], $data['Amount'], $data['submit']);

                $json['TabillHeader'] = $data;

                //prd($json['TabillHeader']);
                $jsonParam = json_encode($json);
                $Key = '[' . Join('],[', array_keys($json['TabillHeader'])) . ']';
                $values = "'" . Join("','", array_values($json['TabillHeader'])) . "'";

                //echo $centers .'=='.$ExamType .'=='.$Role;die;

                DB::statement('exec insertCommonDataSP :fields, :values, :table', [
                    'fields' => "$Key",
                    'values' => "$values",
                    'table' => "[$ObserverOfflineTbl]",
                ]);

                $taBillLocal = [
                    'Reference No_' => $uniqueRandomString,
                    'Line No_' => rand(10, 999),
                    'Amount' =>  $misce ?? 0,
                    'File Path' =>  $fileName ?? 'NA',
                ];
                $json['TabillLocal'] = $taBillLocal;
                $jsonParam = json_encode($json);
                $Key = '[' . Join('],[', array_keys($json['TabillLocal'])) . ']';
                $values = "'" . Join("','", array_values($json['TabillLocal'])) . "'";

                DB::statement('exec insertCommonDataSP :fields, :values, :table', [
                    'fields' => "$Key",
                    'values' => "$values",
                    'table' => "[$TABillLocalTbl]",
                ]);

                DB::table($ExamProfile)
                    ->where('Observer Type', $Role)
                    ->whereIn('CENTNO', $centersSess)
                    ->where('ExamType', $ExamType)
                    ->update([
                        'Submitted Documents' => 1
                    ]);


                MasterServices::customlog('Submit bill', 'User Submit Local Bill.');
            } else {
                $check_Reference_no = DB::table($ObserverOfflineTbl)->select('Reference No_')->where('Exam Code', $ExamType)
                    ->where('Observer ID', $ObserverID)->first();
                $ReferenceNo = $check_Reference_no->{'Reference No_'};
                $userdataOutside =  $data['TabillMst'];

                if (isset($userdataOutside['DepartureDate'][0]) && !empty($userdataOutside['DepartureDate'][0])) {
                    $TravelDataArr = [];

                    $ExtensionTypes = ['jpg', 'jpeg', 'png', 'pdf', 'doc', 'docx', 'xls', 'xlsx'];
                    $maxFileSize = 2 * 1024 * 1024; //2mb
                    foreach ($userdataOutside['DepartureDate'] as $i => $travelData) {
                        if ($request->hasFile("TabillMst.TravelFile.$i")) {
                            $file = $request->file("TabillMst.TravelFile.$i");

                            if (!in_array(strtolower($file->getClientOriginalExtension()), $ExtensionTypes)) {
                                return redirect()->route('tabill')->with('error', 'File upload error: The file type is invalid');
                            }
                            if ($file->getSize() > $maxFileSize) {
                                return redirect()->route('tabill')->with('error', 'File upload error: The file size cannot exceed 2MB');
                            }
                        }
                    }
                    $travelAmount = 0;
                    foreach ($userdataOutside['DepartureDate'] as $i => $travelData) {

                        if ($request->hasFile("TabillMst.TravelFile.$i")) {
                            $file = $request->file("TabillMst.TravelFile.$i");

                            if ($file->isValid()) {
                                $destinationPath = public_path('uploads/' . Auth::user()->UserName);
                                if (!file_exists($destinationPath)) {
                                    mkdir($destinationPath, 0755, true);
                                }
                                $fileName = rand(10000000, 99999999) . '_.' . $file->getClientOriginalExtension();
                                $file->move($destinationPath, $fileName);
                                $fileName = url('/uploads/' . Auth::user()->UserName . '/' . $fileName);
                            }
                        }



                        $TravelDataArr_1 = [];
                        $TravelDataArr_1['Reference No_'] = $ReferenceNo;
                        $TravelDataArr_1['Departure Date'] = $userdataOutside['DepartureDate'][$i] ?? 'NA';
                        $TravelDataArr_1['Departure Time'] = $userdataOutside['DepartureTime'][$i] ?? 'NA';
                        $TravelDataArr_1['Departure From'] = $userdataOutside['DepartureFrom'][$i] ?? 'NA';
                        $TravelDataArr_1['Arrival Date'] = $userdataOutside['ArrivalDate'][$i] ?? 'NA';
                        $TravelDataArr_1['Arrival Time'] = $userdataOutside['ArrivalTime'][$i] ?? 'NA';
                        $TravelDataArr_1['Arrival To'] = $userdataOutside['ArrivalTo'][$i] ?? 'NA';
                        if ($userdataOutside['JourneyMode'][$i] == "Others") {
                            $TravelDataArr_1['Mode Of Journey'] = $userdataOutside['OtherJourneyMode'][$i] ?? 'NA';
                        } else {
                            $TravelDataArr_1['Mode Of Journey'] = $userdataOutside['JourneyMode'][$i] ?? 'NA';
                        }
                        $TravelDataArr_1['Receipt No'] = $userdataOutside['ReceiptNo'][$i] ?? 'NA';
                        $TravelDataArr_1['Distance Of Journey'] = $userdataOutside['Distance'][$i] ?? 'NA';
                        $TravelDataArr_1['Travel Type'] = $userdataOutside['TravelType'][$i] ?? 'NA';

                        $TravelDataArr_1['Amount'] = $userdataOutside['FareAmount'][$i] ?? 'NA';
                        $TravelDataArr_1['File Path'] = $fileName ?? 'NA';
                        //$TravelDataArr['Bill ID'] = $lastInsertedBillId;
                        $TravelDataArr_1['Last Modified On'] = date("Y-m-d") . ' 00:00:00.000';
                        $TravelDataArr_1['Approved Amount'] = $userdataOutside['EligibleTax'][$i] ?? 0;
                        $TravelDataArr_1['Line No_'] = rand(10, 999);

                        $json['TabillTraveller'] = $TravelDataArr_1;
                        $jsonParam = json_encode($json);
                        $Key = '[' . Join('],[', array_keys($json['TabillTraveller'])) . ']';

                        $values = "'" . Join("','", array_values($json['TabillTraveller'])) . "'";

                        DB::statement('exec insertCommonDataSP :fields, :values, :table', [
                            'fields' => "$Key",
                            'values' => "$values",
                            'table' => "[$TABillOutstationTbl]",
                        ]);
                        //DB::table($TABillOutstationTbl)->insert($TravelDataArr_1);
                        $travelAmount += $userdataOutside['FareAmount'][$i] +  $userdataOutside['EligibleTax'][$i] ?? 0;
                    }
                }

                $totalHotelFareAmount = 0;
                $totalHotelFareAmountSum = 0;
                $hotelDataOutSide =  $data['TabillHotel'];
                $hotelAmount = 0;
                if (isset($hotelDataOutSide['HotelName'][0]) && !empty($hotelDataOutSide['HotelName'][0])) {
                    $HotelDataArr = [];
                    $ExtensionTypes = ['jpg', 'jpeg', 'png', 'pdf', 'doc', 'docx', 'xls', 'xlsx'];
                    $maxFileSize = 2 * 1024 * 1024; //2mb

                    foreach ($hotelDataOutSide['HotelName'] as $j => $hotelData) {
                        if ($request->hasFile("TabillHotel.HotelFile.$j")) {
                            $file = $request->file("TabillHotel.HotelFile.$j");

                            if (!in_array(strtolower($file->getClientOriginalExtension()), $ExtensionTypes)) {
                                return redirect()->route('tabill')->with('error', 'File upload error: The file type is invalid');
                            }
                            if ($file->getSize() > $maxFileSize) {
                                return redirect()->route('tabill')->with('error', 'File upload error: The file size cannot exceed 2MB');
                            }
                        }
                    }
                    foreach ($hotelDataOutSide['HotelName'] as $j => $hotelData) {

                        if ($request->hasFile("TabillHotel.HotelFile.$j")) {
                            $file = $request->file("TabillHotel.HotelFile.$j");

                            if ($file->isValid()) {
                                $destinationPath = public_path('uploads/' . Auth::user()->UserName);
                                if (!file_exists($destinationPath)) {
                                    mkdir($destinationPath, 0755, true);
                                }
                                $fileName =  rand(10000000, 99999999) . '_.' . $file->getClientOriginalExtension();
                                $file->move($destinationPath, $fileName);
                                $fileName = url('/uploads/' . Auth::user()->UserName . '/' . $fileName);
                            }
                        }

                        $HotelDataArr['Reference No_']  = $ReferenceNo;
                        $HotelDataArr['Hotel Name & Address'] = $hotelDataOutSide['HotelName'][$j] ?? null;
                        $HotelDataArr['No of Days'] = $hotelDataOutSide['DaysNumber'][$j] ?? null;
                        $HotelDataArr['Hotel Bill No'] = $hotelDataOutSide['BillNoDate'][$j] ?? null;
                        $HotelDataArr['Room Rent'] = $hotelDataOutSide['RoomRentPaid'][$j] ?? null;
                        $HotelDataArr['Food Charges'] = $hotelDataOutSide['FoodCharge'][$j] ?? null;
                        $HotelDataArr['Total Amount'] = $hotelDataOutSide['TotalAmount'][$j] ?? null;
                        $HotelDataArr['File Path'] = $fileName ?? 'NA';
                        $HotelDataArr['Hotel Bill Date'] = $hotelDataOutSide['BillDate'][$j] ?? null;
                        $HotelDataArr['Last Modified on'] = date("Y-m-d") . ' 00:00:00.000';
                        $HotelDataArr['Line No_'] = rand(10, 999);
                        $json['TabillHotel'] = $HotelDataArr;
                        $jsonParam = json_encode($json);
                        $Key = '[' . Join('],[', array_keys($json['TabillHotel'])) . ']';
                        $values = "'" . Join("','", array_values($json['TabillHotel'])) . "'";

                        DB::statement('exec insertCommonDataSP :fields, :values, :table', [
                            'fields' => "$Key",
                            'values' => "$values",
                            'table' => "[$TABillHotelTbl]",
                        ]);
                        $hotelAmount += $hotelDataOutSide['TotalAmount'][$j] ?? 0;
                    }
                }
                $TATBL = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
                    'select' => "[Net Payable Amount],[Total Deduction Amount]",
                    'input' => "WHERE [Reference No_] = '" . $ReferenceNo . "'",
                    'table' => "[$ObserverOfflineTbl]",
                ]);

                $OutstationTotalAmount = $travelAmount + $hotelAmount;
                $NetPayableAmount = $TATBL->{'Net Payable Amount'} +  $OutstationTotalAmount;
                $deductionAmount = $TATBL->{'Total Deduction Amount'};
                $NetPayableAfterDeduction = $NetPayableAmount - $deductionAmount;
               // Net Payable After Deduction

                $OutstationStatus = [
                    'Submitted' => '1',
                    'Net Payable Amount' => $NetPayableAmount,
                    'Claimed Amount' => $NetPayableAmount,
                ];
                $response =  DB::statement(DB::raw("exec updateCommonDataSP :updatefields, :where, :table"), [
                    ':updatefields' => "Submitted='1',[Net Payable Amount] = $NetPayableAmount,[Claimed Amount] = $NetPayableAmount, [Net Payable After Deduction] = $NetPayableAfterDeduction,[Outstation Hotal & Food]=$hotelAmount,[Outstation_Travelling_Expenses]=$travelAmount",
                    ':where' => "WHERE [Reference No_]= '$ReferenceNo'",
                    ':table' => "[$ObserverOfflineTbl]",
                ]);
                MasterServices::customlog('Submit bill', 'User Submit Outstation Bill.');
            }
            return redirect()->route('submit-bill-report')->with('success', 'Data save successfully.');
        // } catch (\Exception $e) {
        //     $message = $e->getMessage();
        //     dd($message);
        //     return redirect()->back()->with('error', $message);
        // }
    }

    function generateUniqueRandomString($prefix = 'REF')
    {
        $randomNumber = mt_rand(1, 999999999); // Generate a random number
        $uniqueString = $prefix . str_pad($randomNumber, 6, '0', STR_PAD_LEFT);
        return $uniqueString;
    }

    public function getObserverDetails($observer_id)
    {
        // Get session and table parameters
        $examType = Session::get('examType');
        $ProfileTable = config('constants.ExamProfile');
        $VendorBankTable = config('constants.VendorBankTbl');
        $VendorPanTbl = config('constants.VendorPanTbl');

        // Parameterized query to fetch observer details
        $observer = DB::table($ProfileTable . ' as p')
            ->leftJoin($VendorBankTable . ' as b', 'p.ObserverID', '=', 'b.No_')
            ->leftJoin($VendorPanTbl . ' as pt', 'p.ObserverID', '=', 'pt.No_')
            ->select([
                'p.Name',
                'p.Mobile',
                'p.Email',
                'b.IFSC Code as ifsc_code',
                'b.Branch as branch',
                'b.Vendor Account No_ as account_no',
                'b.Account Holder Name as account_holder_name',
                'pt.P_A_N_ No_ as pan_no',
                'p.ATT',
            ])
            ->where('p.ObserverID', $observer_id)
            ->where('p.ExamType', $examType)
            ->first();

        // Return the details as JSON
        if ($observer) {

            $ShiftCountArr = $observer_id && $observer->ATT ? $this->getShiftWiseDataObserver($observer_id,1) : [];
            $TotalRemunerationAmount = $ShiftCountArr['TotalRemunerationAmount'] ?? 0;
            $TotalConveyanceAmount = $ShiftCountArr['TotalConveyanceAmount'] ?? 0;
            $DutyDays = isset($ShiftCountArr['DayWiseShiftCount']) && !empty($ShiftCountArr['DayWiseShiftCount']) ? count($ShiftCountArr['DayWiseShiftCount']) : 0;
            return response()->json([
                'observer_name' => $observer->Name ?? '',
                'observer_phone' => $observer->Mobile ?? '',
                'observer_email' => $observer->Email ?? '',
                'ifsc_code' => $observer->ifsc_code ?? '',
                'branch' => $observer->branch ?? '',
                'account_no' => $observer->account_no ?? '',
                'pan_no' => $observer->pan_no ?? '',
                'account_holder_name' => $observer->account_holder_name ?? '',
                'ATT' => $observer->ATT ?? '',
                'DutyDays' => $DutyDays,
                'TotalRemunerationAmount' => $TotalRemunerationAmount,
                'TotalConveyanceAmount' => $TotalConveyanceAmount,
            ]);
        } else {
            return response()->json(['error' => 'Observer details not found, please add details!'], 404);
        }
    }

    public function checkBillStatus()
    {
        $CentreBillTbl = config('constants.CentreBillTbl');
        $ID = auth()->user()->NTA_Unique_Admin_ID;
        $examType = Session::get('examType');
        $centerno = request()->post('centerno');
        // echo $centerno;die;

        $chkSubmittedBill = DB::table($CentreBillTbl)
            ->select('IsSubmitted')
            ->where('Observer ID', $ID)
            ->where('CenterNo', $centerno)
            ->where('Exam Type', $examType)
            ->whereIn('Bill Status', [0, 5, 1, 4])
            ->first();

        //print_r($chkSubmittedBill);die;

        if ($chkSubmittedBill && $chkSubmittedBill->IsSubmitted == 1) {
            return true;
        }
        return false;
    }

    public function getCenterDetails()
    {
        $ProfileTable = config('constants.ExamProfile');
        $centerno = request()->post('centerno');
        $examType = Session::get('examType');
        $ID = auth()->user()->NTA_Unique_Admin_ID;


        $CentreDetails = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
            ':select' => 'TC_NAME, Centre_Address, City',
            ':input' => "WHERE [CENTNO]='$centerno' AND Examtype = '$examType' AND ObserverID='$ID'",
            ':table' => "[$ProfileTable]",
        ]);
        //$CentreDetails = json_decode(json_encode($CentreDetailsObj), true);


        if (!empty($CentreDetails) && !empty($CentreDetails->TC_NAME)) {
            $centerAddress = $CentreDetails->TC_NAME . ', ' . $CentreDetails->Centre_Address;
            $cityName = $CentreDetails->City;
            $result = json_encode(['centerAddress' => $centerAddress, 'cityName' => $cityName]);
        } else {
            $result = json_encode(['NA']);
        }

        return $result;
    }

    public function getDaywiseCountDetails()
    {
        $finaldata = [];
        $CandidateCountTable = config('constants.CandidateCountTable');
        $ProfileTable = config('constants.ExamProfile');
        $centerno = request()->post('centerno');
        $examType = Session::get('examType');

        $DaywiseCountDetails = (array)DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
            ':select' => '*',
            ':input' => "WHERE CenterNo='$centerno' AND [Exam Type] = '$examType'",
            ':table' => "[$CandidateCountTable]",
        ]);

        // prd($DaywiseCountDetails);
        $jsonData = [];
        if ($DaywiseCountDetails) {
            for ($i = 1; $i <= 12; $i++) {
                if ($DaywiseCountDetails['D' . $i . 'Max'] != 0) {
                    $jsonData['allottedCandidatesCount'][] = $DaywiseCountDetails['D' . $i . 'Max'];
                }

                for ($ij = 1; $ij <= 4; $ij++) {
                    if ($DaywiseCountDetails['D' . $i . 'S' . $ij] != 0) {
                        $jsonData['shiftwisecount']['D' . $i . 'S' . $ij] = $DaywiseCountDetails['D' . $i . 'S' . $ij];
                    }
                }
            }
            $jsonData['AllottedCandidates'] = $DaywiseCountDetails['Total Candidate Count in Exam'];
            $jsonData['maxDayCount'] = $DaywiseCountDetails['Max Count Exam'];
        } else {
            $jsonData['AllottedCandidates'] = 0;
            for ($i = 1; $i <= 12; $i++) {
                $jsonData['allottedCandidatesCount'][] = 0;
            }
        }

        return json_encode($jsonData);
    }

    public function getShiftWiseData()
    {
        // Get configuration values
        $ExamProfileShiftWise = config('constants.ExamProfileShiftWise');
        $CRLTable = config('constants.CentralizedRemunerationLineTableShiftWise');

        // Get request and session values
        $centerno = request()->post('centerno');
        $ExamType = Session::get('examType');
        $ObserverID = Session::get('ObserverID');  // This variable seems unused, consider removing if not needed
        $Role = Session::get('role');

        // Fetch day-wise count details for the given center and exam type
        $DaywiseCountDetails = (array)DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
            ':select' => '*',
            ':input' => "WHERE CenterNo='$centerno' AND [Exam Type] = '$ExamType' AND [Observer ID] = '$ObserverID'",
            ':table' => "[$ExamProfileShiftWise]",
        ]);
        // prd($DaywiseCountDetails);
        // If no data found, return error response
        if (!$DaywiseCountDetails) {
            return response()->json(['error' => 'No data found for the given center and exam type'], 404);
        }

        // Initialize attendance count array
        $attendanceCount = [];

        // Loop through days and shifts to calculate attendance count
        for ($day = 1; $day <= 12; $day++) {
            $shiftCount = 0;

            // Check each shift for the current day
            for ($shift = 1; $shift <= 4; $shift++) {
                $key = "A{$day}S{$shift}";
                if (!empty($DaywiseCountDetails[$key]) && $DaywiseCountDetails[$key] == 1) {
                    $shiftCount++;
                }
            }

            // If shifts are attended, add to attendance count
            if ($shiftCount > 0) {
                $attendanceCount["Day {$day}"] = $shiftCount;
            }
        }

        // prd($attendanceCount);

        // If no attendance count exists, return false or empty response
        if (empty($attendanceCount)) {
            return response()->json(['error' => 'No shifts attended'], 404);
        }

        // Build select clause for remuneration fields
        $select = '';
        foreach ($attendanceCount as $key => $attendanceDays) {
            $dayNumber = preg_replace('/[^0-9]/', '', $key);
            $select .= '[Remuneration Amount_S' . $attendanceDays . '] Remuneration' . $dayNumber . ', [Conveyance Amount] Conveyance' . $dayNumber . ',';
        }

        // Remove trailing comma
        $select = rtrim($select, ',');
        // prd($select);
        // If select clause is built, fetch remuneration data
        if ($select) {
            $RemunerationFieldsData = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
                'select' => $select,
                'input' => "WHERE [$CRLTable].[Exam Type] = '$ExamType' AND [$CRLTable].[Source Type] = '$Role' AND [$CRLTable].isActive = 1",
                'table' => "[$CRLTable]",
                'orderBy' => "ORDER BY displayOrder ASC",
            ]);
            // prd($RemunerationFieldsData);
            // If remuneration data found, calculate the shift-wise amount
            if ($RemunerationFieldsData) {
                $RemunerationFieldsData = (array) $RemunerationFieldsData;

                $TotalRemunerationAmount = [];
                $TotalConveyanceAmount = [];

                // Loop through fetched data
                foreach ($RemunerationFieldsData as $key => $amount) {
                    if (strpos($key, 'Remuneration') !== false) {
                        $TotalRemunerationAmount[$key] = (float)$amount; // Store remuneration amounts
                    }
                    if (strpos($key, 'Conveyance') !== false) {
                        $TotalConveyanceAmount[$key] = (float)$amount; // Store conveyance amounts
                    }
                }

                // Extract totals
                $TotalRemuneration = array_sum($TotalRemunerationAmount);
                $TotalConveyance = array_sum($TotalConveyanceAmount);
                $GrandTotal = $TotalRemuneration + $TotalConveyance;

                // Prepare JSON response
                $response = response()->json([
                    'DayWiseShiftCount' => $attendanceCount,
                    'shiftWiseAmount' => $RemunerationFieldsData,
                    'TotalRemunerationAmount' => $TotalRemuneration,
                    'TotalConveyanceAmount' => $TotalConveyance,
                    'GrandTotal' => $GrandTotal, // Added Grand Total
                ]);
                return $response;
            }

        }


        // If no remuneration data found, return false or empty response
        return response()->json(['error' => 'No remuneration data found'], 404);
    }

    public function getShiftWiseDataObserver($ObserverID,$Role)
    {

        // Get configuration values
        $ExamProfileShiftWise = config('constants.ExamProfileShiftWise');
        $CRLTable = config('constants.CentralizedRemunerationLineTableShiftWise');
        $ExamType = Session::get('examType');

        $attendanceCount = (array)DB::selectOne('EXEC GetNonZeroShiftCountsObserverSP ?, ?', [$ObserverID, $ExamType]);
        // prd($attendanceCount);

        // If no attendance count exists, return false or empty response
        if (empty($attendanceCount)) {
            return response()->json(['error' => 'No shifts attended'], 404);
        }

        // Build select clause for remuneration fields
        $select = '';
        foreach ($attendanceCount as $key => $attendanceDays) {
            $dayNumber = preg_replace('/[^0-9]/', '', $key);
            $select .= '[Remuneration Amount_S' . $attendanceDays . '] Remuneration' . $dayNumber . ', [Conveyance Amount] Conveyance' . $dayNumber . ',';
        }

        // Remove trailing comma
        $select = rtrim($select, ',');
        // prd($select);
        // If select clause is built, fetch remuneration data
        if ($select) {
            $RemunerationFieldsData = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
                'select' => $select,
                'input' => "WHERE [$CRLTable].[Exam Type] = '$ExamType' AND [$CRLTable].[Source Type] = '$Role' AND [$CRLTable].isActive = 1",
                'table' => "[$CRLTable]",
                'orderBy' => "ORDER BY displayOrder ASC",
            ]);
            // prd($RemunerationFieldsData);
            // If remuneration data found, calculate the shift-wise amount
            if ($RemunerationFieldsData) {
                $RemunerationFieldsData = (array) $RemunerationFieldsData;

                $TotalRemunerationAmount = [];
                $TotalConveyanceAmount = [];

                // Loop through fetched data
                foreach ($RemunerationFieldsData as $key => $amount) {
                    if (strpos($key, 'Remuneration') !== false) {
                        $TotalRemunerationAmount[$key] = (float)$amount; // Store remuneration amounts
                    }
                    if (strpos($key, 'Conveyance') !== false) {
                        $TotalConveyanceAmount[$key] = (float)$amount; // Store conveyance amounts
                    }
                }

                // Extract totals
                $TotalRemuneration = array_sum($TotalRemunerationAmount);
                $TotalConveyance = array_sum($TotalConveyanceAmount);
                $GrandTotal = $TotalRemuneration + $TotalConveyance;

                // Prepare JSON response
                $response = [
                    'DayWiseShiftCount' => $attendanceCount,
                    'shiftWiseAmount' => $RemunerationFieldsData,
                    'TotalRemunerationAmount' => $TotalRemuneration,
                    'TotalConveyanceAmount' => $TotalConveyance,
                    'GrandTotal' => $GrandTotal, // Added Grand Total
                ];
                return $response;
            }

        }
        // If no remuneration data found, return false or empty response
        return false;
    }
}
