<?php

namespace App\Http\Controllers\admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\ShiftWiseDutyDaysRequest;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Maatwebsite\Excel\Facades\Excel;
use Maatwebsite\Excel\HeadingRowImport;
use App\Models\CandidateWiseCountData;


class ImportremMasterController extends Controller
{
    //
    public function index(Request $request)
    {

        $examName = $request->get('examName') ?? '';
        $NTA_Observer_ID = $request->get('source_type') ?? '';
        $ExamProfile = config('constants.ExamDates');
        $searchData = $request->get('searchData') ?? '';

        $perPage = 15;
        if ($request->perPage) {
            $perPage = $request->perPage;
        }

        $RoleName = config('constants.RoleName');
        $RoleNameCheck = config('constants.RoleNameCheck');

        $title = 'Duty Data List';
        $importList = getAllExamProfileList($perPage, $examName, $NTA_Observer_ID, $searchData);
        $ExamType = DB::table($ExamProfile)->select('Exam Name')->distinct()->get();
        return view('admin.masters.importremList', ['importList' => $importList, 'title' => $title, 'ExamType' => $ExamType, 'RoleName' => $RoleName, 'RoleNameCheck' => $RoleNameCheck]);
    }

    public function indexshift(Request $request)
    {
        $NTA_Observer_ID = $request->get('NTA_Observer_ID') ?? '';
        $searchData = $request->get('searchData') ?? '';
        $perPage = 15;
        if ($request->perPage) {
            $perPage = $request->perPage;
        }
        $importList = getAllExamProfileShiftList($perPage, $NTA_Observer_ID, $searchData);
        $title = 'Shift Wise Duty Data List';
        return view('admin.masters.importremshiftList', ['importList' => $importList, 'title' => $title]);
    }

    public function add()
    {
        $title = 'Import Duty Data';
        $examList = getExamDateList();
        return view('admin.masters.addimportre', ['title' => $title, 'examList' => $examList]);
    }
    public function addshift()
    {
        $title = 'Import Shift Wise Duty Data';
        $examList = getExamDateList();
        return view('admin.masters.addimportreshift', ['title' => $title, 'examList' => $examList]);
    }
    public function editShiftwiseDutyDays()
    {
        $exam_id = $_GET['exam_id'];
        $ExamDates = config('constants.ExamDates');
        $ExamProfileShiftWise = config('constants.ExamProfileShiftWise');
        $ExamShift = config('constants.ExamShiftTable');

        $labelName = "Edit Shiftwise Duty Data";

        $aliases = [];

        for ($d = 1; $d <= 12; $d++) {
            for ($s = 1; $s <= 4; $s++) {
                $col = "D{$d}S{$s}";
                //$aliases[] = "EP.[$col] AS EP_$col";  // Alias columns from EP table
                $aliases[] = "ES.[$col] AS ES_$col";  // Alias columns from ES table
            }
        }

        // Convert alias array to a comma-separated string
        $aliasString = implode(", ", $aliases);

        $query = "SELECT EP.*, ED.*, $aliasString
          FROM [$ExamProfileShiftWise] EP
          LEFT JOIN [$ExamDates] ED ON EP.[Exam Type] = ED.[Exam Type]
          LEFT JOIN [$ExamShift] ES ON EP.[Exam Type] = ES.[Exam Type]
          WHERE EP.ID = :exam_id";

        // Execute the query using Laravel's DB::selectOne
        $examData = DB::selectOne($query, [
            'exam_id' => $exam_id  // Using parameter binding for safety
        ]);

        $dutyDay = [];

        foreach ($examData as $key => $value) {
            if (preg_match('/^ES_D(\d+)S(\d+)$/', $key, $matches) && !empty($value)) {
                $day = "D" . $matches[1];
                $shift = "S" . $matches[2];

                if (!isset($dutyDay[$day])) {
                    $dutyDay[$day] = [];
                }
                $dutyDay[$day][$shift] = $value;
            }
        }
        $examData->DutyDay = $dutyDay;

        $title = 'Edit Shiftwise Duty Data';

        $shiftDateCount = [];
        for ($day = 1; $day <= 12; $day++) {
            $dateKey = "Date_" . $day;
            if (!empty($examData->$dateKey)) {
                $shiftDateCount[] = $examData->$dateKey;
            }
        }

        return view('admin.shiftwiseDutydata.editshiftwisedutydata', ['examData' => $examData, 'labelName' => $labelName, 'ExamShift' => $ExamShift, 'title' => $title, 'shiftDateCount' => $shiftDateCount]);
    }

    public function editDutyDays()
    {
        $exam_id = $_GET['id'];
        $ExamDates = config('constants.ExamDates');
        $AdvanceTable = config('constants.AdvanceTable');
        $ExamProfile = config('constants.ExamProfile');
        $RoleNameArray = config('constants.RoleName');
        $ExamProfileShiftWise = config('constants.ExamProfileShiftWise');
        $ExamShift = config('constants.ExamShiftTable');

        $labelName = "Edit Duty Data";
        $examData = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
            'select' => "ED.*,EP.*,EP.ID as NewID",
            'input' => "LEFT join [$ExamDates] ED on EP.[ExamType] = ED.[Exam Type]  WHERE ID= '$exam_id' ",
            'table' => "[$ExamProfile ] EP",
        ]);

        // prd($examData);die;

        $ObserverId =  $examData->ObserverID;
        $ExamType =  $examData->ExamType;
        $CENTNO =  $examData->CENTNO;

        $getAdvDetails = DB::table($AdvanceTable)->where('NTA Observer ID', $ObserverId)->where('Exam Type', $ExamType)->get()->first();

        $labelName = "Edit Shiftwise Duty Data";
        $aliases = [];
        for ($d = 1; $d <= 12; $d++) {
            for ($s = 1; $s <= 4; $s++) {
                $col = "D{$d}S{$s}";
                //$aliases[] = "EP.[$col] AS EP_$col";  // Alias columns from EP table
                $aliases[] = "ES.[$col] AS ES_$col";  // Alias columns from ES table
            }
        }
        // Convert alias array to a comma-separated string
        $aliasString = implode(", ", $aliases);
        $query = "SELECT EP.*, ED.*, $aliasString
          FROM [$ExamProfileShiftWise] EP
          LEFT JOIN [$ExamDates] ED ON EP.[Exam Type] = ED.[Exam Type]
          LEFT JOIN [$ExamShift] ES ON EP.[Exam Type] = ES.[Exam Type]
          WHERE EP.[Observer ID] = :ObserverId and EP.[Exam Type] = :ExamType and EP.[CenterNo] = :CenterNo";
        // Execute the query using Laravel's DB::selectOne
        $examDatas = DB::selectOne($query, [
            'ObserverId' => $ObserverId,  // Using parameter binding for safety
            'ExamType' => $ExamType,
            'CenterNo' => $CENTNO,
        ]);
        

        if ($examDatas) {

            $dutyDay = [];
            foreach ($examDatas as $key => $value) {
                if (preg_match('/^ES_D(\d+)S(\d+)$/', $key, $matches) && !empty($value)) {
                    $day = "D" . $matches[1];
                    $shift = "S" . $matches[2];

                    if (!isset($dutyDay[$day])) {
                        $dutyDay[$day] = [];
                    }
                    $dutyDay[$day][$shift] = $value;
                }
            }
            $examDatas->DutyDay = $dutyDay;
            $title = 'Edit Shiftwise Duty Data';
            $shiftDateCount = [];
            for ($day = 1; $day <= 12; $day++) {
                $dateKey = "Date_" . $day;
                if (!empty($examDatas->$dateKey)) {
                    $shiftDateCount[] = $examDatas->$dateKey;
                }
            }
        } else {
            $examDatas = [];
            $shiftDateCount = [];
        }

        $titles = 'Edit Candidate Wise Count Details';
        $examsList = getExamDateList();
        $examArray = [];
        foreach ($examsList as $exam) {
            $examArray[$exam->{'Exam Type'}] = $exam->{'Exam Name'};
        }

        $title = 'Edit Duty Data';
        return view('admin.shiftwiseDutydata.editdutydata', ['examData' => $examData, 'labelName' => $labelName, 'title' => $title, 'getAdvDetails' => $getAdvDetails, 'shiftDateCount' => $shiftDateCount, 'examDatas' => $examDatas, 'examArray' => $examArray, 'titles' => $titles, 'RoleNameArray' => $RoleNameArray]);
    }

    public function updateDutyDay(Request $request)
    {


        try {
            if ($request->isMethod('post')) {
                $ExamProfile = config('constants.ExamProfile');
                $ExamProfileShiftWise = config('constants.ExamProfileShiftWise');
                $AdvanceTable = config('constants.AdvanceTable');
                $idCenter = $request->NewID;
                $centerNos = $request->CenterNo ?? '';
                $advanced = isset($request->totalAdvanceAmt) ? $request->totalAdvanceAmt : '0';
                $hiddenIDAdv = $request->hiddenIDAdv;
                $observerType = $request->ObserverType;

                DB::table($ExamProfileShiftWise)->where('ID', $idCenter)->update(['CenterNo' => $centerNos]);

                $dutysCount = [];

                if (isset($request->ShiftWise) && !empty($request->ShiftWise)) {
                    for ($i = 1; $i <= 12; $i++) {
                        $dayKey = 'D' . $i;
                        $dayKeyAtt = 'A_D' . $i;
                        $dutysCount[$dayKey] = 0; // Default value
                        $dutysCountAtt[$dayKeyAtt] = 0; // Default value

                        for ($j = 1; $j <= 4; $j++) {
                            $shiftKey = $dayKey . 'S' . $j;
                            if (isset($request->ShiftWise[$shiftKey]) && $request->ShiftWise[$shiftKey] == 1) {
                                $dutysCount[$dayKey] = 1;
                                $dutysCountAtt[$dayKeyAtt] = ($request->{'ObserverType'} == 1 || $request->{'ObserverType'} == 14) ? 1 : 0;
                                break;
                            }
                        }
                    }

                    $totalDays = array_sum($dutysCount);
                    $aDutyDays = ($request->{'ObserverType'} == 1 || $request->{'ObserverType'} == 14) ? $totalDays : 0;

                    // Now create the final $dutyData array including all values
                    $dutyData = array_merge($dutysCount, $dutysCountAtt, [
                        'Dutydays' => $totalDays,
                        'A_Dutydays' => $aDutyDays,
                        'CENTNO' => $request->CenterNo,
                        'Observer Type' => $request->{'ObserverType'},
                        'Name' => $request->ObserverName,
                        'Designation' => $request->Designation,
                        'Mobile' => $request->Mobile,
                        'Email' => $request->EmailID,
                        'Address' => $request->Address,
                        'CITY_CD' => $request->CityCode,
                        'TC_CODE' => $request->TCCode,
                    ]);

                    // Check the final array before insert
                    DB::beginTransaction();

                    DB::table($ExamProfile)->where('ID', $request->hiddenID)->update($dutyData);
                    DB::table($AdvanceTable)->where('Advance No_', $hiddenIDAdv)->update(['Advance Amount' => $advanced]);

                    if (isset($observerType)) { // && $obserTye !=5 && $obserTye !=2

                        $updateString = '';
                        foreach ($request->ShiftWise as $dateKey => $shiftArray) {
                            $updateString .= "{$dateKey}='" . $shiftArray . "', ";
                            if ($observerType == 1 || $observerType == 14) {
                                $newKey = str_replace('D', 'A', $dateKey);
                                $updateString .= "{$newKey}='" . $shiftArray . "', ";
                            }
                        }
                        $updateString = rtrim($updateString, ', ');
                        DB::update("exec updateCommonDataSP :updatefields, :where, :table", [
                            'updatefields' => $updateString,
                            'where' => "Where [Exam Type]='$request->Exam_Type' AND [CenterNo]='$request->CenterNo' AND [Observer ID]='$request->ObserverID'",
                            'table' => "[$ExamProfileShiftWise]"
                        ]);
                    }
                    DB::commit();
                }

                return redirect()->route('importrem.index')->with('success', 'Datass Updated successfully.');
            } else {
                return redirect()->route('importrem.index')->with('error', 'Something went wrong, data not updated.');
            }
        } catch (\Exception $e) {
            DB::rollBack();
            $message = $e->getMessage();
            return redirect()->back()->with('error', $message);
        }
    }

    public function updateShiftwiseDutyDays(ShiftWiseDutyDaysRequest $request)
    {

        try {

            if ($request->isMethod('post')) {
                $ExamProfileShiftWise = config('constants.ExamProfileShiftWise');
                // Retrieve form inputs
                $CenterNo = $request->CenterNo;
                $CityCode = $request->CityCode;
                $TCCode = $request->TCCode;
                $ShiftWiseData = $request->ShiftWise;
                $hiddenID = $request->hiddenID;
                // Prepare update string for ShiftWise data
                $updateString = "CenterNo='$CenterNo', CityCode='$CityCode', TCCode='$TCCode', ";

                //prd($ShiftWiseData);

                DB::beginTransaction();

                foreach ($ShiftWiseData as $dateKey => $shiftArray) {
                    $updateString .= "{$dateKey}='" . $shiftArray . "', ";
                }
                // Remove the last comma and space
                $updateString = rtrim($updateString, ', ');
                // Execute the stored procedure
                DB::update("exec updateCommonDataSP :updatefields, :where, :table", [
                    'updatefields' => $updateString,
                    'where' => "Where [ID]='$hiddenID'",
                    'table' => "[$ExamProfileShiftWise]"
                ]);
                DB::commit();
                return redirect()->route('importrem.indexshift')->with('success', 'Shiftwise duty days updated successfully!');
            } else {
                return redirect()->route('importrem.indexshift')->with('error', 'Something went wrong, data not updated.');
            }
        } catch (\Exception $e) {
            DB::rollBack();
            $message = $e->getMessage();
            return redirect()->back()->with('error', $message);
        }
    }

    public function saveDetail_______OLd(Request $request)
    {
        // $request->validate([
        //     'file' => 'required|mimes:xlsx,xls'
        // ]);

        $validator = Validator::make($request->all(), [
            'file' => 'required|mimes:xlsx,xls', // Valid file extensions
            'ExamType' => 'required', // Valid file extensions
        ]);
        if ($validator->fails()) {
            return back()->withErrors($validator)->withInput();
        }

        try {
            $file = $request->file('file');

            // Get the first row as headers to validate column names
            $headings = (new HeadingRowImport)->toArray($file);
            //$expectedHeaders = ['Exam ID/OBS_ID,CCID,SCID', 'exam_type', 'exam_name', 'exam_mode', 'year', 'examdisp', 'is_examover'];

            $expectedHeaders = [
                'ObserverID',
                'Name',
                'Designation',
                'Mobile',
                'Email',
                'Address',
                'State',
                'City',
                'State_ID',
                'city_id',
                'City_code',
                'CENTNO',
                'CITY_CD',
                'TC_CODE',
                'TC_NAME',
                'TC_STATE',
                'TC_CITY',
                'Centre_Address',
                'MT',
                'D1',
                'D2',
                'D3',
                'D4',
                'D5',
                'D6',
                'D7',
                'D8',
                'D9',
                'D10',
                'D11',
                'D12',
                'Dutydays',
                'ExtraDutyAs',
                'ATT',
                'A_MT',
                'A_D1',
                'A_D2',
                'A_D3',
                'A_D4',
                'A_D5',
                'A_D6',
                'A_D7',
                'A_D8',
                'A_D9',
                'A_D10',
                'A_D11',
                'A_D12',
                'A_Dutydays',
                'Observer_Type',
                'Bill_Type',
            ];
            //   print_r($headings);
            //  echo '<br>';
            //  print_r($expectedHeaders);

            // die; return back()->withErrors(['error' => 'Error: Invalid file format. Headers missing or incorrect.']);
            if (!isset($headings[0][0]) || !is_array($headings[0][0])) {
                return back()->withErrors(['error' => 'Error: Invalid file format. Headers missing or incorrect.']);
            }

            // Trim the input array to match the expected headers count
            $fileHeaders = array_slice($headings[0][0], 0, count($expectedHeaders));

            $expectedHeaders = array_map('trim', array_map('strtolower', $expectedHeaders));
            $fileHeaders = array_map('trim', array_map('strtolower', $fileHeaders));

            $missingHeaders = array_diff($expectedHeaders, $fileHeaders);

            // Check for extra headers
            $extraHeaders = array_diff($fileHeaders, $expectedHeaders);

            if (!empty($missingHeaders) || !empty($extraHeaders)) {
                return back()->withErrors(['error', 'Error : Selected file headers do not match.
                Missing: ' . implode(', ', $missingHeaders) .
                    ' | Extra: ' . implode(', ', $extraHeaders)]);
            }
            //  print_r($headings[0][0]);die;
            // if (array_diff($expectedHeaders, $headings[0][0])) {
            //     print_r($headings);die;
            //     return back()->with('error', 'Invalid Excel headers. Expected: ' . implode(', ', $expectedHeaders));
            // }
            // if (!isset($headings[0]) || !is_array($headings[0]) || !isset($headings[0][0]) || !is_array($headings[0][0])) {
            //     return back()->with('error', 'Invalid file format. Please check the headers.');
            // }

            // if (array_diff_assoc($expectedHeaders, $headings[0])) {
            //     return back()->with('error', 'The uploaded file has incorrect headers.');
            // }
            //  print_r($headings);die;
            // Convert file data to an array
            $data = Excel::toArray([], $file);

            //  $ExamDates = config('constants.ExamDates');
            $examDatesTableName = config('constants.ExamProfile');
            $RoleName = config('constants.RoleName');


            // Insert data into the database
            $skippedRows = []; // Array to store skipped row numbers or IDs
            $rowNumber = 1; // Track row number (or use an actual ID if available)
            //  foreach ($data as $row) {
            foreach ($data as $sheetIndex => $sheetData) {
                // Remove the header row from the sheet data
                array_shift($sheetData);
                // Loop through the rows in the sheet
                foreach ($sheetData as $rowIndex => $row) {
                    // Check if rowIndex is 1 (second row) and echo the value at index 1
                    //  if ($rowIndex == 1) {

                    //   try {
                    $row = array_map(function ($value, $key) {
                        $columnsToReplace = [
                            10,
                            11,
                            20,
                            21,
                            22,
                            23,
                            24,
                            25,
                            26,
                            27,
                            28,
                            29,
                            30,
                            31,
                            32,
                            33,
                            34,
                            35,
                            36,
                            37,
                            38,
                            39,
                            40,
                            41,
                            42,
                            43,
                            44,
                            45,
                            46,
                            47,
                            48,
                            49,
                        ];

                        // Convert "NULL" string to actual NULL
                        if ($value === 'NULL' || $value === '') {
                            return null;
                        }

                        // Replace NULL with 0 for specific columns
                        return (in_array($key, $columnsToReplace) && is_null($value)) ? 0 : $value;
                    }, $row, array_keys($row));

                    // Check data before insert
                    //  print_r($row);
                    // echo "<br>";
                    $observerID = $row[0] ?? null;
                    $examType = $request->post('ExamType') ?? null;
                    $CENTNO = $row[11] ?? null; // Example: Checking ObserverID, ExamType, and Mobile

                    // Check if a record with the same values already exists
                    $exists = DB::table($examDatesTableName)
                        ->where('ObserverID', $observerID)
                        ->where('ExamType', $examType)
                        ->where('CENTNO', $CENTNO)
                        ->exists();

                    if (!$exists) {

                        $searchValue = $row[48];
                        $key = array_search($searchValue, $RoleName);
                        DB::table($examDatesTableName)->insert([
                            'ObserverID' => $row[0] ?? null,
                            'ExamType' => $request->post('ExamType') ?? null,
                            'Name' => $row[1] ?? null,
                            'Designation' => $row[2] ?? null,
                            'Mobile' => $row[3] ?? null,
                            'Email' => $row[4] ?? null,
                            'Address' => $row[5] ?? null,
                            'State' => $row[6] ?? null,
                            'City' => $row[7] ?? null,
                            'State_id' => $row[8] ?? null,
                            'city_id' => $row[9] ?? null,
                            'City_code' => $row[10] ?? null,
                            'CENTNO' => $CENTNO ?? null,
                            'CITY_CD' => $row[12] ?? null,
                            'TC_CODE' => $row[13] ?? null,
                            'TC_NAME' => $row[14] ?? null,
                            'TC_STATE' => $row[16] ?? null,
                            'TC_CITY' => $row[16] ?? null,
                            'Centre_Address' => $row[17] ?? null,
                            'MT' => $row[18] ?? null,
                            'D1' => $row[19] ?? null,
                            'D2' => $row[20] ?? null,
                            'D3' => $row[21] ?? null,
                            'D4' => $row[22] ?? null,
                            'D5' => $row[23] ?? null,
                            'D6' => $row[24] ?? null,
                            'D7' => $row[25] ?? null,
                            'D8' => $row[26] ?? null,
                            'D9' => $row[27] ?? null,
                            'D10' => $row[28] ?? null,
                            'D11' => $row[29] ?? null,
                            'D12' => $row[30] ?? null,
                            'Dutydays' => $row[31] ?? null,
                            'ExtraDutyAs' => $row[32] ?? null,
                            'ATT' => $row[33] ?? null,
                            'A_MT' => $row[34] ?? null,
                            'A_D1' => $row[35] ?? null,
                            'A_D2' => $row[36] ?? null,
                            'A_D3' => $row[37] ?? null,
                            'A_D4' => $row[38] ?? null,
                            'A_D5' => $row[39] ?? null,
                            'A_D6' => $row[40] ?? null,
                            'A_D7' => $row[41] ?? null,
                            'A_D8' => $row[42] ?? null,
                            'A_D9' => $row[43] ?? null,
                            'A_D10' => $row[44] ?? null,
                            'A_D11' => $row[45] ?? null,
                            'A_D12' => $row[46] ?? null,
                            'A_Dutydays' => $row[47] ?? null,
                            'Observer Type' => $key ?? null,
                            'BillType' => $row[49] && strtolower($row[49]) == 'outstation' ? 2 : 1,

                        ]);
                    } else {
                        // Store row number or relevant ID in skippedRows array
                        $skippedRows[] = $rowNumber;
                    }
                    $rowNumber++; // Increment row number for next iteration

                    // echo "Row Inserted Successfully! <br>";
                    // } catch (\Exception $e) {
                    //     echo "Error: " . $e->getMessage() . "<br>";
                    // }
                }
            }

            if (!empty($skippedRows)) {
                $skipp = "Skipped rows (already exist): " . implode(", ", $skippedRows);
                return back()->with('success', $skipp);
            } else {
                return back()->with('success', 'Remunetion excel fie imported successfully!');
            }

            //    return back()->with('success', 'Remunetion excel fie imported successfully!');
        } catch (\Exception $e) {
            return back()->with('error', 'Error: ' . $e->getMessage());
        }
    }




    public function saveDetail(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'file' => 'required|mimes:xlsx,xls',
            'ExamType' => 'required',
        ]);

        if ($validator->fails()) {
            return back()->withErrors($validator)->withInput();
        }

        try {
            $file = $request->file('file');
            $headings = (new HeadingRowImport)->toArray($file);

            if (!isset($headings[0][0]) || !is_array($headings[0][0])) {
                return back()->withErrors(['error' => 'Invalid file format. Headers missing or incorrect.']);
            }

            $expectedHeaders = [
                'ObserverID',
                'Name',
                'Designation',
                'Mobile',
                'Email',
                'Address',
                'State',
                'City',
                'State_ID',
                'city_id',
                'City_code',
                'CENTNO',
                'CITY_CD',
                'TC_CODE',
                'TC_NAME',
                'TC_STATE',
                'TC_CITY',
                'Centre_Address',
                'MT',
                'D1S1',
                'D1S2',
                'D1S3',
                'D1S4',
                'D2S1',
                'D2S2',
                'D2S3',
                'D2S4',
                'D3S1',
                'D3S2',
                'D3S3',
                'D3S4',
                'D4S1',
                'D4S2',
                'D4S3',
                'D4S4',
                'D5S1',
                'D5S2',
                'D5S3',
                'D5S4',
                'D6S1',
                'D6S2',
                'D6S3',
                'D6S4',
                'D7S1',
                'D7S2',
                'D7S3',
                'D7S4',
                'D8S1',
                'D8S2',
                'D8S3',
                'D8S4',
                'D9S1',
                'D9S2',
                'D9S3',
                'D9S4',
                'D10S1',
                'D10S2',
                'D10S3',
                'D10S4',
                'D11S1',
                'D11S2',
                'D11S3',
                'D11S4',
                'D12S1',
                'D12S2',
                'D12S3',
                'D12S4',
                'Dutydays',
                'A_MT',
                'Observer_Type',
                'Bill_Type',
                'Advance_Amount',
                // 'Day_1_Max_Count',
                // 'Day_2_Max_Count',
                // 'Day_3_Max_Count',
                // 'Day_4_Max_Count',
                // 'Day_5_Max_Count',
                // 'Day_6_Max_Count',
                // 'Day_7_Max_Count',
                // 'Day_8_Max_Count',
                // 'Day_9_Max_Count',
                // 'Day_10_Max_Count',
                // 'Day_11_Max_Count',
                // 'Day_12_Max_Count',
            ];
            $fileHeaders = array_map('strtolower', array_map('trim', $headings[0][0]));
            $expectedHeadersLower = array_map('strtolower', $expectedHeaders);

            $missingHeaders = array_diff($expectedHeadersLower, $fileHeaders);
            $extraHeaders = array_diff($fileHeaders, $expectedHeadersLower);

            if (!empty($missingHeaders) || !empty($extraHeaders)) {
                return back()->withErrors(['error' => 'Header mismatch. Missing: ' . implode(', ', $missingHeaders) . ' | Extra: ' . implode(', ', $extraHeaders)]);
            }

            $data = Excel::toArray([], $file);
            $examType = $request->post('ExamType');

            $examDatesTable = config('constants.ExamProfile');
            $shiftWiseTable = config('constants.ExamProfileShiftWise');
            $advanceTable = config('constants.AdvanceTable');
            $countTable = config('constants.CandidateCountTable');
            $RoleName = config('constants.RoleName');

            $batchInsertData = [];
            $shiftWiseData = [];
            $advanceData = [];
            $countData = [];
            $skippedRows = [];

            foreach ($data as $sheetData) {
                array_shift($sheetData);
                foreach ($sheetData as $index => $row) {
                    $rowAssoc = array_combine($fileHeaders, $row);
                    $this->normalizeRowData($rowAssoc, $RoleName);

                    $observerID = $rowAssoc['observerid'] ?? null;
                    $CENTNO = $rowAssoc['centno'] ?? null;

                    if (DB::table($examDatesTable)->where(['ObserverID' => $observerID, 'ExamType' => $examType, 'CENTNO' => $CENTNO])->exists()) {
                        $skippedRows[] = $index + 2;
                        continue;
                    }

                    $batchInsertData[] = $this->prepareExamData($rowAssoc, $examType, $CENTNO, $observerID);
                    $shiftWiseData[] = $this->prepareShiftWiseData($rowAssoc, $observerID, $CENTNO, $examType);
                    $advanceData[] = $this->prepareAdvanceData($rowAssoc, $observerID, $examType);
                    // if (!empty($rowAssoc['observer_type']) && $rowAssoc['observer_type'] == '14') {
                    //     $countData[] = []; //$this->prepareCountData($rowAssoc, $CENTNO, $examType);
                    // }
                }
            }
            // prd($batchInsertData);
            // pr($shiftWiseData);
            // pr($advanceData);
            // prd($countData);

            DB::transaction(function () use ($batchInsertData, $shiftWiseData, $advanceData, $examDatesTable, $shiftWiseTable, $advanceTable) {
                if (!empty($batchInsertData)) DB::table($examDatesTable)->insert($batchInsertData);
                if (!empty($shiftWiseData)) DB::table($shiftWiseTable)->insert($shiftWiseData);
                if (!empty($advanceData)) DB::table($advanceTable)->insert($advanceData);
                // if (!empty($countData)) DB::table($countTable)->insert($countData);
            });

            $successMessage = 'File imported successfully!';
            if (!empty($skippedRows)) {
                $successMessage .= ' Skipped rows: ' . implode(', ', $skippedRows);
            }

            return back()->with('success', $successMessage);


            //return back()->with('success', 'File imported successfully! Skipped rows: ' . implode(', ', $skippedRows));
        } catch (\Exception $e) {
            return back()->with('error', 'Error: ' . $e->getMessage());
        }
    }

    private function normalizeRowData(&$row, $RoleName)
    {
        foreach ($row as $key => &$value) {
            $value = trim($value);

            if ($value === '' || strtolower($value) === 'null') {
                $value = null;
            } elseif (strtolower($value) === 'yes') {
                $value = 1;
            } elseif (strtolower($value) === 'no') {
                $value = 0;
            }
        }

        // Normalize observer_type and bill_type
        $row['observer_type'] = array_search($row['observer_type'] ?? null, $RoleName);
        $row['bill_type'] = isset($row['bill_type']) && strtolower($row['bill_type']) == 'outstation' ? 2 : 1;
    }


    private function prepareExamData($rowAssoc, $examType, $CENTNO, $observerID)
    {
        $examData = [
            'ObserverID' => $observerID,
            'Name' => $rowAssoc['name'] ?? null,
            'Designation' => $rowAssoc['designation'] ?? null,
            'Mobile' => $rowAssoc['mobile'] ?? null,
            'ExamType' => $examType,
            'Email' => $rowAssoc['email'] ?? null,
            'Address' => $rowAssoc['address'] ?? null,
            'State' => $rowAssoc['state'] ?? null,
            'City' => $rowAssoc['city'] ?? null,
            'State_ID' => $rowAssoc['state_id'] ?? null,
            'city_id' => $rowAssoc['city_id'] ?? null,
            'City_code' => $rowAssoc['city_code'] ?? null,
            'TC_CODE' => $rowAssoc['tc_code'] ?? null,
            'TC_NAME' => $rowAssoc['tc_name'] ?? null,
            'Centre_Address' => $rowAssoc['centre_address'] ?? null,
            'CENTNO' => $CENTNO,
            'MT' => $rowAssoc['mt'] ?? null,
            'A_MT' => (!empty($rowAssoc['observer_type']) && !in_array($rowAssoc['observer_type'], [5, 2])) && $rowAssoc['mt'] ?? null,
            'ATT' => (!empty($rowAssoc['observer_type']) && !in_array($rowAssoc['observer_type'], [5, 2])) && $rowAssoc['mt'] ?? null,
            'Dutydays' => $rowAssoc['dutydays'] ?? null,
            'A_Dutydays' => (!empty($rowAssoc['observer_type']) && !in_array($rowAssoc['observer_type'], [5, 2])) ? $rowAssoc['dutydays'] : 0,
            'Observer Type' => $rowAssoc['observer_type'] ?? null,
            'BillType' => $rowAssoc['bill_type'] ?? null,
            'Submitted Documents' => 0
        ];

        // Process D1-D12 based on D1S1-D12S4 values
        for ($i = 1; $i <= 12; $i++) {
            $sessionFields = ["D{$i}S1", "D{$i}S2", "D{$i}S3", "D{$i}S4"];
            $examData["D{$i}"] = array_reduce($sessionFields, function ($carry, $field) use ($rowAssoc) {
                return $carry || (!empty($rowAssoc[strtolower($field)]) && $rowAssoc[strtolower($field)] == 1);
            }, false) ? 1 : 0;

            $examData["A_D{$i}"] = array_reduce($sessionFields, function ($carry, $field) use ($rowAssoc) {
                return $carry || (!empty($rowAssoc[strtolower($field)]) && $rowAssoc[strtolower($field)] == 1 && !empty($rowAssoc['observer_type']) && !in_array($rowAssoc['observer_type'], [5, 2]));
            }, false) ? 1 : 0;
        }

        return $examData;
    }

    private function prepareShiftWiseData($rowAssoc, $observerID, $CENTNO, $examType)
    {
        $shiftWiseRow = [
            'Observer ID' => $observerID,
            'CenterNo' => $CENTNO,
            'Exam Type' => $examType,
            'CityCode' => $rowAssoc['city_code'] ?? null,
            'TCCode' => $rowAssoc['tc_code'] ?? null
        ];

        // Add all shift-wise fields
        foreach (range(1, 12) as $i) {
            foreach (range(1, 4) as $j) {
                $shiftWiseRow["D{$i}S{$j}"] = $rowAssoc["d{$i}s{$j}"] ?? null;
                if (!empty($rowAssoc['observer_type']) && !in_array($rowAssoc['observer_type'], [5, 2])) {
                    $shiftWiseRow["A{$i}S{$j}"] = $rowAssoc["d{$i}s{$j}"] ?? null;
                } else {
                    $shiftWiseRow["A{$i}S{$j}"] = 0;
                }
            }
        }
        return $shiftWiseRow;
    }

    private function prepareAdvanceData($rowAssoc, $observerID, $examType)
    {
        return [
            'NTA Observer ID' => $observerID,
            'Exam Type' => $examType,
            'Observer Name' => $rowAssoc['name'] ?? null,
            'Advance No_' => 'ADV-' . rand(1000, 9999),
            'Advance Amount' => $rowAssoc['advance_amount'] ?? null,
        ];
    }

    private function prepareCountData($rowAssoc, $CENTNO, $examType)
    {
        $maxCounts = [];

        // Dynamically populate $maxCounts using a loop
        for ($i = 1; $i <= 12; $i++) {
            $maxCounts[$i] = $rowAssoc["day_{$i}_max_count"] ?? 0;
        }

        return array_merge(
            [
                'CenterNo' => $CENTNO,
                'Exam Type' => $examType,
            ],
            // Generate D1Max to D12Max dynamically
            array_combine(
                array_map(fn($i) => "D{$i}Max", range(1, 12)),
                $maxCounts
            ),
            [
                'Max Count Exam' => max($maxCounts), // Maximum value from D1Max to D12Max
                'Total Candidate Count in Exam' => array_sum($maxCounts), // Sum of all values from D1Max to D12Max
            ]
        );
    }


    public function saveDetailshift(Request $request)
    {
        // $request->validate([
        //     'file' => 'required|mimes:xlsx,xls'
        // ]);

        $validator = Validator::make($request->all(), [
            'file' => 'required|mimes:xlsx,xls', // Valid file extensions
            'ExamType' => 'required', // Valid file extensions
        ]);
        if ($validator->fails()) {
            return back()->withErrors($validator)->withInput();
        }

        try {
            $file = $request->file('file');

            // Get the first row as headers to validate column names
            $headings = (new HeadingRowImport)->toArray($file);
            //$expectedHeaders = ['Exam ID/OBS_ID,CCID,SCID', 'exam_type', 'exam_name', 'exam_mode', 'year', 'examdisp', 'is_examover'];
            // print_r($headings);die;

            $expectedHeaders = [
                'observer_id', // Any of these is valid
                'centerno',
                'citycode',
                'tccode',
                'd1s1',
                'd1s2',
                'd1s3',
                'd2s1',
                'd2s2',
                'd2s3',
                'd3s1',
                'd3s2',
                'd3s3',
                'd4s1',
                'd4s2',
                'd4s3',
                'd5s1',
                'd5s2',
                'd5s3',
                'd6s1',
                'd6s2',
                'd6s3',
                'd7s1',
                'd7s2',
                'd7s3',
                'd8s1',
                'd8s2',
                'd8s3',
                'd9s1',
                'd9s2',
                'd9s3',
                'd10s1',
                'd10s2',
                'd10s3',
                'd11s1',
                'd11s2',
                'd11s3',
                'd12s1',
                'd12s2',
                'd12s3',
                'advance_amount',
            ];

            if (!isset($headings[0][0]) || !is_array($headings[0][0])) {
                return back()->withErrors(['error' => 'Error: Invalid file format. Headers missing or incorrect.']);
            }

            // Normalize headers (trim spaces and convert to lowercase)
            $expectedHeaders = array_map('trim', array_map('strtolower', $expectedHeaders));
            // Trim the input array to match the expected headers count
            $fileHeaders = array_slice($headings[0][0], 0, count($expectedHeaders));

            $expectedHeaders = array_map('trim', array_map('strtolower', $expectedHeaders));
            $fileHeaders = array_map('trim', array_map('strtolower', $fileHeaders));

            // pr($expectedHeaders);
            // prd($fileHeaders);

            // Check for missing headers
            $missingHeaders = array_diff($expectedHeaders, $fileHeaders);

            // Check for extra headers
            $extraHeaders = array_diff($fileHeaders, $expectedHeaders);

            if (!empty($missingHeaders) || !empty($extraHeaders)) {
                return back()->withErrors(['error', 'Error : Selected file headers do not match.
                Missing: ' . implode(', ', $missingHeaders) .
                    ' | Extra: ' . implode(', ', $extraHeaders)]);
            }
            //  print_r($headings[0][0]);die;
            // if (array_diff($expectedHeaders, $headings[0][0])) {
            //     print_r($headings);die;
            //     return back()->with('error', 'Invalid Excel headers. Expected: ' . implode(', ', $expectedHeaders));
            // }
            // if (!isset($headings[0]) || !is_array($headings[0]) || !isset($headings[0][0]) || !is_array($headings[0][0])) {
            //     return back()->with('error', 'Invalid file format. Please check the headers.');
            // }

            // if (array_diff_assoc($expectedHeaders, $headings[0])) {
            //     return back()->with('error', 'The uploaded file has incorrect headers.');
            // }
            //  print_r($headings);die;
            // Convert file data to an array
            $data = Excel::toArray([], $file);
            //  $ExamDates = config('constants.ExamDates');
            $examDatesTableName = config('constants.ExamProfileShiftWise');
            $AdvanceTable = config('constants.AdvanceTable');
            // Remove the header row
            //     array_shift($data);
            // print_r($data);die;

            // Insert data into the database
            $skippedRows = []; // Array to store skipped row numbers or IDs
            $rowNumber = 1; // Track row number (or use an actual ID if available)
            //  foreach ($data as $row) {
            foreach ($data as $sheetIndex => $sheetData) {
                // Remove the header row from the sheet data
                array_shift($sheetData);

                // Loop through the rows in the sheet
                foreach ($sheetData as $rowIndex => $row) {
                    // Check if rowIndex is 1 (second row) and echo the value at index 1
                    //  if ($rowIndex == 1) {

                    //   try {

                    $columnsToReplace = range(5, 40); // Define column indexes outside

                    $row = array_map(function ($value, $key) use ($columnsToReplace) {
                        // Convert "NULL" string or empty string to actual NULL
                        if ($value === 'NULL' || $value === '') {
                            $value = null;
                        }

                        // Convert "Yes" to 1 and "No" to 0 (only if it's a string)
                        if (is_string($value)) {
                            $lowerValue = strtolower(trim($value));
                            if ($lowerValue === 'yes') {
                                return 1;
                            } elseif ($lowerValue === 'no') {
                                return 0;
                            }
                        }

                        // Replace NULL with 0 for specific columns
                        if (in_array($key, $columnsToReplace, true) && is_null($value)) {
                            return 0;
                        }

                        return $value;
                    }, $row, array_keys($row));

                    $observerID = $row[0] ?? null;
                    $examType = $request->post('ExamType') ?? null;
                    $CENTNO = $row[1] ?? null; // Example: Checking ObserverID, ExamType, and Mobile

                    //    // Check if a record with the same values already exists
                    $exists = DB::table($examDatesTableName)
                        ->where('Observer ID', $observerID)
                        ->where('Exam Type', $examType)
                        ->where('CenterNo', $CENTNO)
                        ->exists();

                    if (!$exists) {

                        try {

                            DB::table($examDatesTableName)->insert([
                                'Observer ID' => $observerID,
                                'Exam Type' => $examType ?? null,
                                'CenterNo' => $CENTNO ?? null,
                                'CityCode' => $row[2] ?? null,
                                'TCCode' => $row[3] ?? null,
                                'D1S1' => $row[4] ?? null,
                                'D1S2' => $row[5] ?? null,
                                'D1S3' => $row[6] ?? null,
                                'D2S1' => $row[7] ?? null,
                                'D2S2' => $row[8] ?? null,
                                'D2S3' => $row[9] ?? null,
                                'D3S1' => $row[10] ?? null,
                                'D3S2' => $row[11] ?? null,
                                'D3S3' => $row[12] ?? null,
                                'D4S1' => $row[13] ?? null,
                                'D4S2' => $row[14] ?? null,
                                'D4S3' => $row[15] ?? null,
                                'D5S1' => $row[16] ?? null,
                                'D5S2' => $row[17] ?? null,
                                'D5S3' => $row[18] ?? null,
                                'D6S1' => $row[19] ?? null,
                                'D6S2' => $row[20] ?? null,
                                'D6S3' => $row[21] ?? null,
                                'D7S1' => $row[22] ?? null,
                                'D7S2' => $row[23] ?? null,
                                'D7S3' => $row[24] ?? null,
                                'D8S1' => $row[25] ?? null,
                                'D8S2' => $row[26] ?? null,
                                'D8S3' => $row[27] ?? null,
                                'D9S1' => $row[28] ?? null,
                                'D9S2' => $row[29] ?? null,
                                'D9S3' => $row[30] ?? null,
                                'D10S1' => $row[31] ?? null,
                                'D10S2' => $row[32] ?? null,
                                'D10S3' => $row[33] ?? null,
                                'D11S1' => $row[34] ?? null,
                                'D11S2' => $row[35] ?? null,
                                'D11S3' => $row[36] ?? null,
                                'D12S1' => $row[37] ?? null,
                                'D12S2' => $row[38] ?? null,
                                'D12S3' => $row[39] ?? null,
                                'A1S1' => $row[4] ?? null,
                                'A1S2' => $row[5] ?? null,
                                'A1S3' => $row[6] ?? null,
                                'A2S1' => $row[7] ?? null,
                                'A2S2' => $row[8] ?? null,
                                'A2S3' => $row[9] ?? null,
                                'A3S1' => $row[10] ?? null,
                                'A3S2' => $row[11] ?? null,
                                'A3S3' => $row[12] ?? null,
                                'A4S1' => $row[13] ?? null,
                                'A4S2' => $row[14] ?? null,
                                'A4S3' => $row[15] ?? null,
                                'A5S1' => $row[16] ?? null,
                                'A5S2' => $row[17] ?? null,
                                'A5S3' => $row[18] ?? null,
                                'A6S1' => $row[19] ?? null,
                                'A6S2' => $row[20] ?? null,
                                'A6S3' => $row[21] ?? null,
                                'A7S1' => $row[22] ?? null,
                                'A7S2' => $row[23] ?? null,
                                'A7S3' => $row[24] ?? null,
                                'A8S1' => $row[25] ?? null,
                                'A8S2' => $row[26] ?? null,
                                'A8S3' => $row[27] ?? null,
                                'A9S1' => $row[28] ?? null,
                                'A9S2' => $row[29] ?? null,
                                'A9S3' => $row[30] ?? null,
                                'A10S1' => $row[31] ?? null,
                                'A10S2' => $row[32] ?? null,
                                'A10S3' => $row[33] ?? null,
                                'A11S1' => $row[34] ?? null,
                                'A11S2' => $row[35] ?? null,
                                'A11S3' => $row[36] ?? null,
                                'A12S1' => $row[37] ?? null,
                                'A12S2' => $row[38] ?? null,
                                'A12S3' => $row[39] ?? null,
                            ]);
                            //=================== Inserting Advance Payment data here ++++++++++++++++++++++++//
                            DB::table($AdvanceTable)->insert([
                                'NTA Observer ID' => $observerID,
                                'Exam Type' => $examType ?? null,
                                'Observer Name' => null,
                                'Advance No_' => 'ADV-' . rand(1000, 9999),
                                'Advance Amount' => $row[40] ?? null,
                            ]);
                            //=================== Inserting Advance Payment data here ++++++++++++++++++++++++//
                        } catch (\Exception $e) {
                            echo "Error: " . $e->getMessage() . "<br>";
                        }
                    } else {
                        // Store row number or relevant ID in skippedRows array
                        $skippedRows[] = $rowNumber;
                    }
                    $rowNumber++; // Increment row number for next iteration

                    // echo "Row Inserted Successfully! <br>";
                    // } catch (\Exception $e) {
                    //     echo "Error: " . $e->getMessage() . "<br>";
                    // }
                }
            }

            if (!empty($skippedRows)) {
                $skipp = "Skipped rows (already exist): " . implode(", ", $skippedRows);
                return back()->with('success', $skipp);
            } else {
                return back()->with('success', 'Remunetion excel fie imported successfully!');
            }

            //    return back()->with('success', 'Remunetion excel fie imported successfully!');
        } catch (\Exception $e) {
            return back()->with('error', 'Error: ' . $e->getMessage());
        }
    }

    public function editExamDetail(Request $request)
    {
        $request->validate([
            'exam_name' => 'required|string|max:255',
            'exam_type' => 'required|string|max:15',
            'exam_disp' => 'required|string|max:255',
            'exam_mode' => 'required', // Assuming exam_mode is either Online or Offline
            'year' => 'required|digits:4',
            'is_exam_over' => 'required', // Assuming these are the options for exam status
            // 'ExamDate' => 'required',
            // 'ExamShift' => 'required', // An array of exam shifts
            // 'fromOne' => 'required',
            // 'toOne' => 'required',
        ]);
        $examData = $request->all();
        $exam_id = $examData['exam_id'];
        $examType = $examData['exam_type'];
        $examName = $examData['exam_name'];
        $examMode = $examData['exam_mode'];
        $examYear = $examData['year'];
        $ExamDisp = $examData['exam_disp'];
        $Is_ExamOver = $examData['is_exam_over'];
        $ExamDates = config('constants.ExamDates');
        $ExamShiftTable = config('constants.ExamShiftTable');

        $ExamDate = $examData['ExamDate'];
        $fromOne = $examData['fromOne'];
        $toOne = $examData['toOne'];
        $ExamShift = $examData['ExamShift'];
        $result = [];
        //Iterate through each shift array
        if (isset($ExamDate) && !empty($ExamDate)) {
            foreach ($ExamDate as $key => $value) {
                foreach ($ExamShift as $shiftIndex => $shiftArray) {
                    foreach ($shiftArray as $date => $shiftValue) {
                        // Initialize the result array for the specific date if not already set
                        if (!isset($result[$date])) {
                            $result[$date] = [];
                        }

                        // Collect fromOne and toOne times for the current date
                        if (isset($fromOne[$shiftIndex][$date]) && isset($toOne[$shiftIndex][$date])) {
                            $fromTime = $fromOne[$shiftIndex][$date];
                            $toTime = $toOne[$shiftIndex][$date];
                            $result[$date][$shiftValue] = $fromTime . '-' . $toTime; // Store the time range with shift value as key
                        }
                    }
                }
            }
        }

        // Sort by date in ascending order
        uksort($result, function ($a, $b) {
            return strtotime($a) - strtotime($b);
        });

        DB::table($ExamDates)
            ->where('Exam Type Id', $exam_id)
            ->update([
                'Exam Type' => $examType,
                'Exam Name' => $examName,
                'Exam_Mode' => $examMode,
                'Year' => $examYear,
                'ExamDisp' => $ExamDisp,
                'Is_ExamOver' => $Is_ExamOver,
                'Is_Active' => 1,
            ]);

        // Insert exam details into ExamDates table

        // $lastInsertId = $newExamID;
        // // echo $lastInsertId;die;
        // //Update the exam dates table with the exam dates
        // $DateIndex = 0;
        // foreach ($result as $index => $examDate) {
        //     $DateIndex++;
        //     DB::table($ExamDates)
        //         ->where('Exam Type Id', $lastInsertId)
        //         ->update(['Date_' . $DateIndex => $index]);
        // }

        // // Insert into ExamShiftTable
        // DB::table($ExamShiftTable)->insert(['Exam Type' => $examType]);
        // $lastInsertIdShift = DB::getPdo()->lastInsertId();

        // $updayteString = '';
        // $dateIndex = 0;

        // // Iterate over the result array
        // foreach ($result as $dateKey => $shiftArray) {
        //     $dateIndex++; // Increment index for each date (D1, D2, etc.)

        //     // Iterate over each shift for the current date
        //     foreach ($shiftArray as $shiftIndex => $shiftvalue) {
        //         // $shiftIndex++; // Increment shift index for each shift (S1, S2, etc.)
        //         $updayteString .= "D{$dateIndex}S{$shiftIndex}='" . $shiftvalue . "',";
        //     }
        // }

        // // Remove the trailing comma from the final string
        // $updayteString = rtrim($updayteString, ',');
        // //print_r($updayteString);die;
        // // Use DB facade to run the stored procedure (if required in Laravel)
        // // DB::table('EXEC updateCommonDataSP :updatefields, :where, :table', [
        // //     'updatefields' => $updayteString,
        // //     'where' => "ID='$lastInsertIdShift' AND [Exam Type]='$examType'",
        // //     'table' => $ExamShiftTable
        // // ]);

        // // Parse the update string into an associative array
        // $updateParts = explode("=", $updayteString);
        // $updateArray = [
        //     $updateParts[0] => $updateParts[1]
        // ];

        // $updateArrayData = preg_replace("/^'(.*)'$/", "$1", $updateArray);

        // // Perform the update
        // DB::table($ExamShiftTable)
        //     ->where(['ID' => $lastInsertIdShift, 'Exam Type' => $examType])
        //     ->update($updateArrayData);
        return $this->index();
    }

    public function ntausersIdSearch(Request $request)
    {
        $searchTerm = $request->input('q'); // Safer way to get input
        $ExamProfile = config('constants.ExamProfile');
        // if (empty($searchTerm)) {
        //     return response()->json(['error' => 'Search term is required.'], 400);
        // }
        $results = DB::table($ExamProfile)
            ->where('ObserverID', 'like', '%' . $searchTerm . '%')
            ->select('ObserverID')
            ->get();
        // print_r($results);
        if ($results->isEmpty()) {
            return response()->json(['message' => 'No results found.'], 404);
        }
        return response()->json($results);
    }

    public function ntausersIdSearchSiftWise(Request $request)
    {
        $searchShiftWise = $request->input('q');
        $ExamProfileShiftWise = config('constants.ExamProfileShiftWise');
        $results = DB::table($ExamProfileShiftWise)
            ->where('Observer ID', 'like', '%' . $searchShiftWise . '%')
            ->select('Observer ID as ObserverID')
            ->get();
        if ($results->isEmpty()) {
            return response()->json(['message' => 'No results found.'], 404);
        }
        return response()->json($results);
    }
}
