<?php

namespace App\Http\Controllers\admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use Illuminate\Contracts\Session\Session as SessionSession;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Log;
use Session;

use Maatwebsite\Excel\Facades\Excel;
use Maatwebsite\Excel\HeadingRowImport;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Support\Facades\Validator;

class ImportremVendorMasterController extends Controller
{
    //
    public function index(Request $request)
    {
        $searchData = $request->get('searchData') ?? '';
        $perPage = 15;
        if($request->perPage){
            $perPage = $request->perPage;
        }
        $vendorList  = getVendorDetailsNew($perPage,$searchData);
        return view('admin.vendorMaster.vendorList', ['vendorList' => $vendorList]);
    }
    public function add()
    {   
        $labelName = 'Add Functionary';
        return view('admin.vendorMaster.addimport', ['labelName' => $labelName]);
    }
    public function edit(Request $request,$edit)
    {   
        $editId = $edit;
        $examDatesTableName = config('constants.VendorContactTbl');
        $vendorBankTbl = config('constants.VendorBankTbl');  
        $VendorPanTbl = config('constants.VendorPanTbl');
        $examData = DB::select("exec getCommonDataSP :select, :input, :table", [
            'select' => "*",
            'input' => " where No_='$editId' ",    
            'table' => "[$examDatesTableName]"
        ]);

        $bankDetails = DB::select("exec getCommonDataSP :select, :input, :table", [
            'select' => 'cc.[Vendor Account No_] as AccountNo,cc.[IFSC Code] as IFSCCode,cc.[Bank Name] as BankName,cc.Branch as branchName, cc.[Account Holder Name] as accountHolderName ',
            'input' => " where No_='$editId' ",    
            'table' => "[$vendorBankTbl] as cc "
        ]);

        $PanCard = DB::select("exec getCommonDataSP :select, :input, :table", [
            'select' => 'cc.[P_A_N_ No_] as panNo',
            'input' => " where No_='$editId' ",    
            'table' => "[$VendorPanTbl] as cc "
        ]);
        $labelName = 'Edit Functionary';
        return view('admin.vendorMaster.addEditVendorDetails',['getData'=>$examData,'bankDetails'=>$bankDetails,'panDetails'=>$PanCard,'labelName' => $labelName]);
    }

    public function saveSingleDetail(Request $request){
        
        $examDatesTableName = config('constants.VendorContactTbl');  
        $vendorBankTbl = config('constants.VendorBankTbl');
        $VendorPanTbl = config('constants.VendorPanTbl');
        $eid = Crypt::decrypt($request->ntaId);

        $request->validate([
            'name'=>'required|regex:/^[a-zA-Z .]+$/|max:30|Min:2',
           'email' => ['required', 'email', 'regex:/^[\w\.]+@[a-zA-Z0-9\-]+\.[a-zA-Z]{2,6}$/'],
            'mobile' => ['required', 'regex:/^\d{10}$/'],
            'address'=>'required|min:2|max:100',
            'city'=>'required|min:2|max:50',
            'pincode'=>'required|numeric|digits:6',
            'bankName'=>'required|min:2|max:50',
            'bankAccount'=>'required|max:16|min:11',
            'ifscCode' => ['required', 'regex:/^(?=.*[A-Za-z])(?=.*\d)[A-Za-z0-9]{11,15}$/'],
           'pancard' => ['required', 'regex:/^[A-Z]{5}\d{4}[A-Z]{1}$/'],
            'branchName'=>'required|min:2|max:100',
            'accountHolderName'=>'required|min:2|max:50',
        ]);

        try {

            DB::table($examDatesTableName)
            ->where('No_', $eid)
            ->update([
                'Name' => $request->name ?? null,
                'Address' => $request->address ?? null,
                'City' => $request->city ?? null,
                'Post Code' => $request->pincode ?? null,
                'Mobile Phone No_' => $request->mobile ?? null,
                'Search Name' => $request->name ?? null,
                'E-Mail' => $request->email ?? null,
            ]);

            DB::table($vendorBankTbl)
            ->where('No_', $eid)
            ->update([
                'Bank Name' => $request->bankName ?? null,
                'Vendor Account No_' => $request->bankAccount ?? null,
                'IFSC Code' => $request->ifscCode ?? null,
                'Branch' => $request->branchName ?? null,
                'Account Holder Name' => $request->accountHolderName ?? null,
            ]);
           
            
            DB::table($VendorPanTbl)
            ->where('No_', $eid)
            ->update([
                'P_A_N_ No_' => $request->pancard ?? null,
            ]);
            return redirect()->route('import-vendor-details')->with('success', 'Vendors Details Updated');
        } catch (\Exception $e) {
            return back()->with('error', 'Error: ' . $e->getMessage());
        } 
    }

    public function saveDetail(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'file' => 'required|mimes:xlsx,xls', // Valid file extensions
        ]);
        if ($validator->fails()) {
            return back()->withErrors($validator)->withInput();
        } 

       
        try {
            $file = $request->file('file');
            // Get the first row as headers to validate column names
            $headings = (new HeadingRowImport)->toArray($file);
          
            $expectedHeaders = [
                'observeridcccs',
                // 'user_type',
                'name',
                'address',
                'city',
                'state',
                'postcode',
                'mobileno',
                'e_mail',
                'bankaccountno',
                'accountholdername',
                'bankname',
                'ifsccode',
                'bankbranchname',
                'panno'  // Any of these is valid
            ];

            if (array_diff($expectedHeaders, $headings[0][0])) {
                // print_r($headings);die;
                return back()->with('error', 'Invalid Excel headers. Expected: ' . implode(', ', $expectedHeaders));
            } 
            if (!isset($headings[0]) || !is_array($headings[0]) || !isset($headings[0][0]) || !is_array($headings[0][0])) {
                return back()->with('error', 'Invalid file format. Please check the headers.');
            }
            
            if (array_diff_assoc($expectedHeaders, $headings[0][0])) {
                return back()->with('error', 'The uploaded file has incorrect headers.');
            }

            // Convert file data to an array
            $data = Excel::toArray([], $file);
            
           
          //  $ExamDates = config('constants.ExamDates');
            $examDatesTableName = config('constants.VendorContactTbl');  
            $vendorBankTbl = config('constants.VendorBankTbl');
            $VendorPanTbl = config('constants.VendorPanTbl');
            

            // Insert data into the database
            $skippedRows = []; // Array to store skipped row numbers or IDs
            $rowNumber = 1; // Track row number (or use an actual ID if available)
            $skippedRowsBank = []; // Array to store skipped row numbers or IDs
            $rowNumberBank = 1; // Track row number (or use an actual ID if available)
            $skippedRowsPan = []; // Array to store skipped row numbers or IDs
            $rowNumberPan = 1; // Track row number (or use an actual ID if available)

            $uploadedCountVendor = 0;
            $skippedCountVendor = 0;

            $uploadedCountBank = 0;
            $skippedCountBank = 0;

            $uploadedCountPan = 0;
            $skippedCountPan = 0;



          //  foreach ($data as $row) {
            foreach ($data as $sheetIndex => $sheetData) {
                // Remove the header row from the sheet data
                array_shift($sheetData);
             
    
                // Loop through the rows in the sheet
                foreach ($sheetData as $rowIndex => $row) {
                  //  Check if rowIndex is 1 (second row) and echo the value at index 1
                  //  if ($rowIndex == 1) {
                   
             //   try {

                    // $row = array_map(function ($value, $key) {
                    //     $columnsToReplace = [
                    //         10, 11, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 
                    //         38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49
                    //     ]; 

                    //     // Convert "NULL" string to actual NULL
                    //     if ($value === 'NULL' || $value === '') {
                    //         return null;
                    //     }
                
                    //     // Replace NULL with 0 for specific columns
                    //     return (in_array($key, $columnsToReplace) && is_null($value)) ? 0 : $value;
                    // }, $row, array_keys($row));
                 
                // Insert records in Vendor Contact Details
                $observerID = $row[0] ?? null;
                // Check if a record with the same values already exists
                $exists = DB::table($examDatesTableName)
                    ->where('No_', $observerID)
                    ->exists();
                if(!$exists) {
                    DB::table($examDatesTableName)->insert([
                        'No_'  => $row[0] ?? null,
                        'Name' => $row[1] ?? null,
                        'Address' => $row[2] ?? null,
                        'City' => $row[3] ?? null,
                        'Post Code' => $row[5] ?? null,
                        'Mobile Phone No_' => $row[6] ?? null,
                        'Search Name' => $row[1] ?? null,
                        'E-Mail' => $row[7] ?? null
                    ]);
                    $uploadedCountVendor++;
                } else {
                    // Store row number or relevant ID in skippedRows array
                    $skippedRows[] = $rowNumber;
                    $skippedCountVendor++;
                }
                $rowNumber++; // Increment row number for next iteration

              

                // Insert records in Vendor Bank Details
                // Check if a record with the same values already exists
                $existsBnk = DB::table($vendorBankTbl)
                     ->where('No_', $observerID)
                     ->exists();
                if(!$existsBnk) {
                     DB::table($vendorBankTbl)->insert([
                         'No_'  => $row[0] ?? null,
                         'IFSC Code' => $row[11] ?? null,
                         'Bank Name' => $row[10] ?? null,
                         'Vendor Account No_' => $row[8] ?? null,
                         'Account Holder Name' => $row[9] ?? null,
                         'Branch' => $row[12] ?? null
                     ]);
                     $uploadedCountBank++;
                } else {
                     // Store row number or relevant ID in skippedRows array
                     $skippedRowsBank[] = $rowNumberBank;
                     $skippedCountBank++;
                }
                
                $rowNumberBank++; // Increment row number for next iteration

                // Insert records in Vendor Pan Details
                // Check if a record with the same values already exists
                $existsPan = DB::table($VendorPanTbl)
                     ->where('No_', $observerID)
                     ->exists();
                if(!$existsPan) {
                     DB::table($VendorPanTbl)->insert([
                         'No_'  => $row[0] ?? null,
                         'P_A_N_ No_' => $row[13] ?? null,
                     ]);
                     $uploadedCountPan++;
                 } else {
                     // Store row number or relevant ID in skippedRows array
                     $skippedRowsPan[] = $rowNumberPan;
                     $skippedCountPan++;
                 }
                 $rowNumberPan++; // Increment row number for next iteration


                // echo "Row Inserted Successfully! <br>";
                // } catch (\Exception $e) {
                //     echo "Error: " . $e->getMessage() . "<br>";
                // }
            }
        }
           
            // $messages = [];
            // if (!empty($skippedRows)) {
            //     $messages[] = " Vendors Details (Already Exist Row No): " . implode(", ", $skippedRows);
            // }

            // if (!empty($skippedRowsBank)) {
            //     $messages[] = " Vendors Bank Details (Already Exist Row No): " . implode(", ", $skippedRowsBank);
            // }

            // if (!empty($skippedRowsPan)) {
            //     $messages[] = " Vendors Pan Details (Already Exist Row No): " . implode(", ", $skippedRowsPan);
            // }

            // // If we have any skipped messages, we can combine them
            // if (!empty($messages)) {
            //     $message = implode(" | ", $messages);
            //     return back()->with('success', $message);
            // }

                $messages = [];
                $messages[] = "Uploaded Details: $uploadedCountVendor,             Skipped Details : $skippedCountVendor";
                // $messages[] = "Uploaded Vendor Bank Details: $uploadedCountBank,             Skipped Vendor Bank Details : $skippedCountBank";
                // $messages[] = "Uploaded Vendor PAN Details: $uploadedCountPan,             Skipped Vendor PAN Details : $skippedCountPan";

                // Combine and display the messages
                $message = implode(" | <br>", $messages);
                return back()->with('successR',$message);


           return back()->with('success', 'Vendors details saved successfully!');

        
        } catch (\Exception $e) {
            return back()->with('error', 'Error: ' . " Something went wrong. Please provide valid data according to the sample and try again.");
        }    
    }
}