<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Session;
use Illuminate\View\View;
use DB;
use Auth;
use App\Services\MasterServices;
use Illuminate\Pagination\LengthAwarePaginator;
use Illuminate\Pagination\Paginator;
use Illuminate\Support\Collection;

class markAttendanceController extends Controller
{
    //
    public function index(Request $request): View
    {

        $mockDrillShow = 'yes';

        $TATBL = config('constants.TABillHeaderTbl');
        $OBSProfile = config('constants.ExamProfile');
        $ExamDates = config('constants.ExamDates');
        $ShiftWiseData = config('constants.ShiftWiseData');
        $ShiftWiseAttendance = config('constants.ShiftWiseAttendance');

        $ExamType = Session::get('examType');
        MasterServices::CheckIsShift($ExamType); //setexam type session
        // $request->session()->set('ShiftWiseExam', 'Yes');
        Session::put('ShiftWiseExam', 'yes');

        // prd(Session::get('ShiftWiseExam'));

        $NTA_Unique_Admin_ID = Auth::user()->UserName;
        $observer = DB::select("exec getCommonDataSP :select, :input, :table", [
            'select' => 'ExamType,CENTNO',
            'input' => "WHERE ObserverID='$NTA_Unique_Admin_ID' and ExamType='$ExamType'",
            'table' => "[$OBSProfile]"
        ]);


        $CENTNO = array_column($observer, 'CENTNO');
        $GetFilter = '';
        $showData = 'All';
        $attenanceFilter = null;
        if ($request->input('filter')) {
            $GetFilter = $request->input('filter');
            $showData = $request->input('showData');
        }
        if ($request->input('showData')) {
            $showData = $request->input('showData');
        }
        if ($request->input('attendance')) {
            if ($request->input('attendance') == 'yes') {
                $attenanceFilter = 1;
            } elseif ($request->input('attendance') == 'no') {
                $attenanceFilter = 2;
            }
        }


        /************************************************** Shift wise******************************************************************/
        $CENTNO = implode(',', $CENTNO);
        if ($request->session()->get('ShiftWiseExam') == 'yes') {
            $observerList = DB::select(DB::raw("getObserverListShiftSP '$ExamType','$CENTNO','$GetFilter','$attenanceFilter'"));
            // prd($observerList);
        } else {
            /************************************************** without Shift wise******************************************************************/
            $observerList = DB::select(DB::raw("getObserverListSP '$ExamType','$CENTNO','$GetFilter','$attenanceFilter'"));
        }

        $examDates = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
            'select' => "Date_1,Date_2,Date_3,Date_4,Date_5,Date_6,Date_7,Date_8,Date_9,Date_10,Date_11,Date_12",
            'input' => "WHERE [Exam Type]='$ExamType'",
            'table' => "[$ExamDates]"
        ]);

        if (empty($observerList)) {
            return view('markattendance.index', [
                'data' => new LengthAwarePaginator([], 0, 1),
                'examDates' => [],
                'mockDrillShow' => false,
                'page' => 0
            ]);
        }

        $currentPage = Paginator::resolveCurrentPage() ?? 1;
        $perPage = $showData == 'All' ? count($observerList) : (int) $showData;
        $collection = collect($observerList);
        $currentPageItems = $collection->slice(($currentPage - 1) * $perPage, $perPage)->all();
        $paginatedItems = new LengthAwarePaginator($currentPageItems, count($collection), $perPage, $currentPage, [
            'path' => Paginator::resolveCurrentPath(),
            'query' => $request->query(),
        ]);

        $serialNo = ($perPage * $currentPage) - $perPage;

        return view('markattendance.index', ['data' => $paginatedItems, 'examDates' => (array)$examDates, 'mockDrillShow' => $mockDrillShow, 'page' => $serialNo]);
    }
    public function marked(Request $request)
    {
        MasterServices::customlog('Mark Attendance', 'User Mark Attendance.');
        $OBSProfile = config('constants.ExamProfile');
        $ShiftWiseAttendance = config('constants.ExamProfileShiftWise');
        $ShiftWiseData = config('constants.ShiftWiseData');

        $return = array('status' => 0);
        if ($request->isMethod('post')) {
            $allval = $request->all();
            $data = $allval['jsonData'];
            // prd($data);
            $ExamType = $request->session()->get('examType');

            if ($request->session()->get('ShiftWiseExam') == 'yes') {
                /***************************************************** shift wise ***************************************************************/
                //prd($data);
                foreach ($data as $id => $row) {

                        $insertData = [];
                        $CENTNO = $row['CENTNO'];
                        $insertData['Observer ID'] = $row['ID'];
                        // $insertData['Total Shift'] = $row['totalAttendance'];

                        $obsData = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
                            'select' => "ExamType,CENTNO,City_code,TC_CODE",
                            'input' => "WHERE [ExamType]='$ExamType' and ObserverID='$row[ID]' and CENTNO='$CENTNO'",
                            'table' => "[$OBSProfile]"
                        ]);

                        // prd($obsData);
                        $insertData['Exam Type'] = $obsData->ExamType;
                        $insertData['CenterNo'] = $obsData->CENTNO;
                        $insertData['CityCode'] = $obsData->City_code;
                        $insertData['TCCode'] = $obsData->TC_CODE;
                        for ($i = 1; $i <= 12; $i++) {
                            for ($k = 1; $k <= 4; $k++) {
                                if (isset($row['D' . $i . 'S' . $k]) && ($row['D' . $i . 'S' . $k] == 1)) {
                                    $insertData['D' . $i . 'S' . $k] = 1;
                                } else {
                                    $insertData['D' . $i . 'S' . $k] = 0;
                                }
                            }
                        }
                        // prd($insertData);
                        $isblock = $row['isblock'];
                        $totalAtt = 0;
                        $days = [];
                        if(isset($row) && !empty($row)){
                            foreach ($row as $key => $value) {
                                if (preg_match('/^D(\d+)S\d+$/', $key, $matches) && $value == 1) {
                                    $days[$matches[1]] = true;
                                }
                            }
                            $totalAtt = count($days);
                        }

                        //$totalAttendance = $row['totalAttendance'];
                        $totalAttendance = $totalAtt;
                        $mokedrill = $row['mokedrill']; //mokedrill
                        $reset_profile = array();

                        $shiftAtt_Total_Shift = $totalAttendance;
                        $shiftAtt = '';
                        for ($i = 1; $i <= 12; $i++) {
                            for ($k = 1; $k <= 4; $k++) {
                                if (isset($row['D' . $i . 'S' . $k]) && ($row['D' . $i . 'S' . $k] == 1)) {
                                    $shiftAtt .= "A{$i}S{$k}='1',";
                                }
                            }
                        }

                        //end attendance

                        //reset start
                        $reset_Attendance = '';
                        for ($ik = 1; $ik <= 12; $ik++) {
                            for ($kj = 1; $kj <= 4; $kj++) {
                                $reset_Attendance .= "A{$ik}S{$kj}='0',";
                            }
                        }
                        $reset_Attendance = rtrim($reset_Attendance, ','); //remove right ,
                        $shiftAtt = rtrim($shiftAtt, ','); //remove right ,
                        // set value
                        // prd($reset_Attendance);
                        $string_ATT = 0;
                        if ($totalAttendance > 0) {
                            $string_ATT = 1;
                        }
                        $string_A_Dutydays = $totalAttendance;
                        $string_A_MT = $mokedrill;

                        //Reset mark attendance
                        $resetVal = DB::statement('exec updateCommonDataSP :updatefields, :where, :table', [
                            'updatefields' => "ATT='0', A_Dutydays='0', IsBlocked='0', A_MT='0'",
                            'where' => "where ObserverID='$row[ID]' and ExamType='$ExamType' and CENTNO='$CENTNO' ",
                            'table' => "[$OBSProfile]",
                        ]);

                        $resetVal = DB::statement('exec updateCommonDataSP :updatefields, :where, :table', [
                            'updatefields' => "$reset_Attendance",
                            'where' => "where [Observer ID]='$row[ID]' and [Exam Type]='$ExamType' and CenterNo='$CENTNO' ",
                            'table' => "[$ShiftWiseAttendance]",
                        ]);
                        // echo $reset_Attendance;
                        // // echo $CENTNO;
                        // die;
                        //end reset

                        if ($isblock == 1) {
                            //update set block candidate
                            $update = DB::statement('exec updateCommonDataSP :updatefields, :where, :table', [
                                'updatefields' => "IsBlocked='1'",
                                'where' => "where ObserverID='$row[ID]' and ExamType='$ExamType' and CENTNO='$CENTNO' ",
                                'table' => "[$OBSProfile]",
                            ]);
                        } else {
                            //set mark attendance
                            $update = DB::statement('exec updateCommonDataSP :updatefields, :where, :table', [
                                'updatefields' => "ATT='$string_ATT', A_Dutydays='$string_A_Dutydays', A_MT='$string_A_MT'",
                                'where' => "where ObserverID='$row[ID]' and ExamType='$ExamType' and CENTNO='$CENTNO' ",
                                'table' => "[$OBSProfile]",
                            ]);
                            //check point exists
                            $checkDataExists = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
                                'select' => "*",
                                'input' => "WHERE [Exam Type]='$ExamType' and [Observer ID]='$row[ID]' and CenterNo='$CENTNO'",
                                'table' => "[$ShiftWiseAttendance]"
                            ]);

                            //prd($shiftAtt);


                            $checkDataExists = (array) $checkDataExists; // convert array
                            $insert = 0;
                            if (isset($checkDataExists['Observer ID']) && !empty($checkDataExists['Observer ID'])) { //update
                                $update = DB::statement('exec updateCommonDataSP :updatefields, :where, :table', [
                                    'updatefields' => "{$shiftAtt}", //, [Total Shift]='$shiftAtt_Total_Shift'
                                    'where' => "where [Observer ID]='$row[ID]' and [Exam Type]='$ExamType' and CenterNo='$CENTNO' ",
                                    'table' => "[$ShiftWiseAttendance]",
                                ]);
                            } else {
                                //insert

                                $tableColumns = '[' . join('],[', array_keys($insertData)) . ']';
                                // echo $tableColumns;
                                // die;
                                $tableValues = "'" . join("','", array_values($insertData)) . "'";
                                // echo $tableValues;
                                // die;
                                DB::statement('exec insertCommonDataSP :fields, :values, :table', [
                                    'fields' => "$tableColumns",
                                    'values' => "$tableValues",
                                    'table' => "[$ShiftWiseAttendance]",
                                ]);
                            }
                        }

                        if ($resetVal == 1 && ($update == 1 || $insert == 1)) {
                            $message = "<span class='badge bg-success messageR'>Attendance updated successfully.</span>";
                            $return = ['status' => 'true', 'message' => $message];
                        } else {
                            $return = ['status' => 'false', 'message' => "<span class='badge bg-danger messageR'>Some thing went wrong.</span>"];
                        }

                }
            } else {
                /********************************************** without shift **********************************************************************/

                foreach ($data as $id => $row) {

                    $CENTNO = $row['CENTNO'];
                    $isblock = $row['isblock'];
                    $totalAttendance = $row['totalAttendance']; //totalAttendance
                    $mokedrill = $row['mokedrill']; //mokedrill
                    $string_ATT = 0;
                    if ($totalAttendance > 0) {
                        $string_ATT = 1;
                    }
                    $string_A_Dutydays = $totalAttendance;
                    $string_A_MT = $mokedrill;
                    $string_Attendance = '';
                    for ($i = 1; $i <= 12; $i++) {
                        if (isset($row['A_D' . $i]) && !empty($row['A_D' . $i])) {
                            $string_Attendance .= "A_D{$i}='1',";
                        }
                    }

                    //reset
                    $reset_Attendance = '';
                    for ($i = 1; $i <= 12; $i++) {
                        $reset_Attendance .= "A_D{$i}='0',";
                    }
                    $reset_Attendance = rtrim($reset_Attendance, ','); // remove right side ,
                    $string_Attendance = rtrim($string_Attendance, ','); // remove right side ,
                    //Reset mark attendance
                    $resetVal = DB::statement('exec updateCommonDataSP :updatefields, :where, :table', [
                        'updatefields' => "ATT='0', A_Dutydays='0', IsBlocked='0', A_MT='0', $reset_Attendance",
                        'where' => "where ObserverID='$row[ID]' and ExamType='$ExamType' and CENTNO='$CENTNO' ",
                        'table' => "[$OBSProfile]",
                    ]);

                    if ($isblock == 1) {
                        //update set block candidate
                        $update = DB::statement('exec updateCommonDataSP :updatefields, :where, :table', [
                            'updatefields' => "IsBlocked='1'",
                            'where' => "where ObserverID='$row[ID]' and ExamType='$ExamType' and CENTNO='$CENTNO' ",
                            'table' => "[$OBSProfile]",
                        ]);
                    } else {
                        //set mark attendance
                        $update = DB::statement('exec updateCommonDataSP :updatefields, :where, :table', [
                            'updatefields' => "ATT='$string_ATT', A_Dutydays='$string_A_Dutydays', A_MT='$string_A_MT',$string_Attendance",
                            'where' => "where ObserverID='$row[ID]' and ExamType='$ExamType' and CENTNO='$CENTNO' ",
                            'table' => "[$OBSProfile]",
                        ]);
                    }
                    if ($update == 1 && $resetVal == 1) {
                        $message = "<span class='badge bg-success messageR'>Attendance updated successfully.</span>";
                        $return = ['status' => 'true', 'message' => $message];
                    } else {
                        $return = ['status' => 'false', 'message' => "<span class='badge bg-danger messageR'>Some thing went wrong.</span>"];
                    }
                }
                /********************************************end************************************************************************/
            }
        }
        return json_encode($return);
    }
}
