<?php

namespace App\Http\Requests;

use Illuminate\Foundation\Http\FormRequest;

class AddNewExamRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array<string, mixed>
     */
    public function rules()
    {
        return [
            'exam_name' => 'required|string|min:2|max:255',
            'exam_mode' => 'required|string|in:CBT,PNP,Both',
            'ExamYear' => 'required|digits:4',
            // 'exam_status' => 'required',
        ];
    }

    public function messages()
    {
        return [
            'exam_name.required' => ':attribute cannot be blank.',
            'exam_name.string' => ':attribute must be a string.',
            'exam_name.min' => ':attribute should  be at least 2 characters.',
            'exam_name.max' => ':attribute must not exceed 255 characters.',

            'exam_mode.required' => ':attribute is required.',
            'exam_mode.string' => ':attribute must be a string.',
            'exam_mode.in' => ':attribute must be either CBT or PNP.',

            'ExamYear.required' => ':attribute is required.',
            'ExamYear.digits' => ':attribute must be exactly 4 digits.',

            // 'exam_status.required' => ':attribute is required.',
            //'exam_status.in' => 'The exam status must be either Active or Inactive.',
        ];
    }

    public function attributes()
    {
        return [

            'exam_name' => 'Exam Name',
            'exam_type' => 'Exam Type',
            'exam_disp' => 'Exam display name',
            'exam_mode' => 'Exam Mode',
            'ExamYear' => 'Exam Year',
            // 'exam_status' => 'Exam Status'
        ];
    }
}
