<?php

namespace App\Http\Requests;

use Illuminate\Foundation\Http\FormRequest;

class ChangePaswordRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     */
    public function authorize(): bool
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array<string, \Illuminate\Contracts\Validation\ValidationRule|array<mixed>|string>
     */
    public function rules(): array
    {
        return [
            'CurrentPassword' =>'required|min:8|max:16',
            'NewPassword' => 'required|min:8|max:16',
            'ConfirmPassword' => 'required|same:NewPassword'
        ];
    }

    public function messages()
    {
        return [
            'CurrentPassword.required' => 'Current Password cannot be blank.',
            'NewPassword.required' => 'New Password cannot be blank.',
            'ConfirmPassword.required' => 'Confirm Password cannot be blank.',
            'ConfirmPassword.same' => 'Confirm Password do not match.'
        ];
    }

}
