@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
<style>
    .field-icon {
        cursor: pointer;
        position: absolute;
        font-size: 20px;
        right: 40px;
        /* top: 50px; */
        transform: translateY(-170%);
    }
    /* Styles for Font Awesome icons */
    .fa-eye {
        color: #aaa;
    }
    .fa-eye-slash {
        color: #333;
    }
    .text-right {
        text-align: right !important;
    }

    .invalid {
        color: red;
    }
    
</style>
@endsection
@section('content')

    <main role="main" class="flex-shrink-0">
        <div class="container">

            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="content-body">
                                <div class="tab-content">
                                    <div class="tab-pane active" id="local">
                                        <div class="row no-gutters">
                                            <div class="col-sm-12">
                                                <div class="card">
                                                    <div class="card-header" style="background-color: #d0d9d4;">
                                                        <span class="font-weight-bold fs-5"> Change Password</span>
                                                    </div>

                                                    <div class="card-body">
                                                        <div class="custom-form">
                                                            <form id="PasswordChangeForm" action="{{ route('change-password.update') }}"
                                                                method="post" autocomplete="off">
                                                                @csrf
                                                                <div class="row">
                                                                    <div class="form-group col-12">
                                                                        <label>Current Password <span class="astric-sign text-danger">*</span></label>
                        
                                                                        <div class="mb-3 field-CurrentPassword">
                        
                                                                            <input type="password" id="CurrentPassword" class="form-control form-control-lg" value="<?= old('CurrentPassword') ? old('CurrentPassword') : ''; ?>" name="CurrentPassword" maxlength="16" placeholder="Enter Current Password" minlength="6" aria-required="true">
                                                                            <span toggle="#CurrentPassword" class="fa fa-fw fa-eye-slash field-icon toggle-password me-2"></span>
                                                                            @error('CurrentPassword')
                                                                                <div class="invalid">
                                                                                    {{ $message }}
                                                                                </div>
                                                                            @enderror
                                                                        </div>
                                                                       
                                                                    </div>

                                                                    <div class="form-group col-12">
                                                                        <label>
                                                                            New Password
                                                                            <span class="astric-sign text-danger">*</span>
                                                                            <i style="cursor:pointer" class="fa fa-info-circle" title="Your password must meet the following criteria:
                                                                            &#10;- It must contain at least one uppercase letter (A-Z).
                                                                            &#10;- It must contain at least one lowercase letter (a-z).
                                                                            &#10;- It must contain at least one digit (0-9).
                                                                            &#10;- It must contain at least one special character (such as !, @, #, $, etc.).
                                                                            &#10;- It must be between 8 and 15 characters in length."></i>
                                                                        </label>
                                                                        <div class="mb-3 field-NewPassword required">
                        
                                                                            <input type="password" id="NewPassword" class="form-control form-control-lg" value="<?= old('NewPassword') ? old('NewPassword') : ''; ?>" name="NewPassword" maxlength="15" placeholder="Enter New Password" aria-required="true">
                                                                            <span toggle="#NewPassword" class="fa fa-fw fa-eye-slash field-icon toggle-password me-2"></span>
                                                                            <span id="passwordError"></span>
                                                                            @error('NewPassword')
                                                                                <div class="invalid">
                                                                                    {{ $message }}
                                                                                </div>
                                                                            @enderror
                                                                            
                                                                        </div>                                                
                                                                       
                                                                    </div>

                                                                    <div class="form-group col-12">
                                                                        <label>Confirm Password <span class="astric-sign text-danger">*</span></label>
                                                                        <div class="mb-3 field-ConfirmPassword required">
                                                                            
                                                                            <input type="password" id="ConfirmPassword" class="form-control form-control-lg required" value="<?= old('ConfirmPassword') ? old('ConfirmPassword') : ''; ?>" name="ConfirmPassword" maxlength="16" placeholder="Enter Confirm Password" minlength="8" aria-required="true">
                                                                            <span toggle="#ConfirmPassword" class="fa fa-fw fa-eye-slash field-icon toggle-password me-2"></span>
                                                                            @error('ConfirmPassword')
                                                                                <div class="invalid">
                                                                                    {{ $message }}
                                                                                </div>
                                                                            @enderror
                                                                          
                                                                        </div>                                                
                                                                            
                                                                    </div>

                                                                    <div class="form-group col-md-12">
                                                                        <button type="submit" id="submitBtn" class="btn btn-warning mt-10" maxlength="10" style="margin-top:40px; float:right">Update</button>                                            
                                                                    </div>
                                                                </div>
                                                            </form>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
@section('script')
<script>
    $(document).ready(function () {
        $('#submitBtn').click(function (e) {
            e.preventDefault();
            let isValid = true;
            const currentPassword = $('#CurrentPassword').val().trim();
            const newPassword = $('#NewPassword').val().trim();
            const confirmPassword = $('#ConfirmPassword').val().trim();

            // Regular expression for the new password criteria
            const passwordRegex = /^(?=.*[a-z])(?=.*[A-Z])(?=.*\d)(?=.*[@$!%*?&])[A-Za-z\d@$!%*?&]{8,15}$/;

            // Clear previous error messages
            $('.text-danger').remove();

            // Check if all fields are filled
            if (!currentPassword) {
                isValid = false;
                $('#CurrentPassword').after('<span class="text-danger">Current Password is required.</span>');
            }

            if (!newPassword) {
                isValid = false;
                $('#NewPassword').after('<span class="text-danger">New Password is required.</span>');
            } else if (!passwordRegex.test(newPassword)) {
                isValid = false;
                $('#NewPassword').after('<span class="text-danger">New Password must meet the criteria: 1 uppercase letter, 1 lowercase letter, 1 digit, 1 special character, and length 8-15 characters.</span>');
            }

            if (!confirmPassword) {
                isValid = false;
                $('#ConfirmPassword').after('<span class="text-danger">Confirm Password is required.</span>');
            } else if (newPassword !== confirmPassword) {
                isValid = false;
                $('#ConfirmPassword').after('<span class="text-danger">Confirm Password must be the same as New Password.</span>');
            }

            // Submit the form if all validations pass
            if (isValid) {
                $('#PasswordChangeForm').submit();
            }
        });


        // Toggle password visibility
        $('.toggle-password').click(function () {
            $(this).toggleClass("fa-eye fa-eye-slash");
            let input = $($(this).attr("toggle"));
            if (input.attr("type") === "password") {
                input.attr("type", "text");
            } else {
                input.attr("type", "password");
            }
        });
    });

   
</script>
@endsection