@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
    <style>
        .small {
            display: none;
        }

        .filterSection {
            margin-top: 20px;
        }
        .form-label{
            font-weight: bold;
        }
    </style>
@endsection
@section('content')
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                {{ Breadcrumbs::render('billReports',$BillReport) }}
                                <div class="card">
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4"><?= $title ?></h4>
                                        <div class="d-flex">
                                            <a href="{{ route('admin.superdashboard') }}"
                                                class="btn btn-danger text-white fs-5">
                                                <i class="fa fa-angle-double-left" aria-hidden="true"></i> Back
                                            </a>
                                        </div>
                                    </div>

                                    <div class="card-body">
                                        <div class="filterSection mt-0">

                                            <form action="{{ route('billReports') }}" method="GET" id="perPageForm">
                                                <div class="row">
                                                    <!-- Left side: Per page dropdown -->
                                                    <div class="col-md-2 mb-2 d-flex align-items-center">
                                                        <select name="perPage" id="perPageSelect" class="form-select"
                                                            style="width: 70px" onchange="getloader()">
                                                            <option value="15"
                                                                {{ request('perPage') == 15 ? 'selected' : '' }}>15</option>
                                                            <option value="50"
                                                                {{ request('perPage') == 50 ? 'selected' : '' }}>50</option>
                                                            <option value="100"
                                                                {{ request('perPage') == 100 ? 'selected' : '' }}>100
                                                            </option>
                                                            <option value="200"
                                                                {{ request('perPage') == 200 ? 'selected' : '' }}>200
                                                            </option>
                                                            <option value="500"
                                                                {{ request('perPage') == 500 ? 'selected' : '' }}>500
                                                            </option>
                                                        </select>
                                                        <span class="ms-2">Per page</span>
                                                    </div>

                                                    <!-- Right side: Search input (with content aligned to the right) -->
                                                    <div class="col-md-10 mb-2 d-flex justify-content-end">
                                                        <div class="d-flex flex-wrap align-items-end gap-2">
                                                            <div>
                                                                <label class="form-label">Exam Name </label>
                                                                <select class="form-control form-control-sm" name="examType">
                                                                    <option value="">Select...</option>
                                                                    @forEach(getExamDateList() as $val)
                                                                    <option value="{{ $val->{'Exam Type'} }}"   {{ request('examType') == $val->{'Exam Type'} ? 'selected' : '' }}>{{ $val->{'Exam Name'} }}</option>
                                                                    @endforeach
                                                                </select>                                                                 
                                                            </div> 
                                                            <!-- User Type -->
                                                            <div>
                                                                <label class="form-label">User Type </label>
                                                                <select class="form-control form-control-sm" name="userType" id="userType">
                                                                    <option value="">Select...</option>
                                                                    <option value="CC"   {{ request('userType') =='CC' ? 'selected' : '' }}>CITY COORDINATOR Bill</option>
                                                                    <option value="CS"   {{ request('userType') =='CS' ? 'selected' : '' }}>CENTRE SUPERINTENDENT Bill</option>
                                                                    <option value="OB"   {{ request('userType') =='OB' ? 'selected' : '' }}>OBSERVER Bill</option>
                                                                </select>      
                                                            </div>                                                    
                                                            <!-- Reference no Search -->
                                                            <div>
                                                                <label class="form-label">Reference No </label>
                                                                <input type="text" class="form-control form-control-sm" id="referenceNo" name="referenceNo" placeholder="Search..."
                                                                    value="{{ request('referenceNo') }}" autocomplete="off">
                                                            </div>                                                    
                                                            <!-- ID Search -->
                                                            <div>
                                                                <label class="form-label">NTA ID</label>
                                                                <input type="text" class="form-control form-control-sm" id="ntaId" name="ntaId" placeholder="Search..."
                                                                    value="{{ request('ntaId') }}" autocomplete="off">
                                                            </div>                                                     
                                                            <!-- Buttons -->
                                                            <div>
                                                                <button type="submit" class="btn btn-primary btn-md">Search</button>
                                                                <a href="{{ route('billReports') }}" class="btn btn-danger text-white btn-md">Reset</a>
                                                            </div>
                                                        </div> 
                                                    </div>
                                                    <hr class="border-4"/>                                                                                                          
                                                </div>
                                            </form>
                                        </div>
                                        <div class="table-responsive">
                                            <?php if(count($BillReport)>0){?>
                                            <button type="button" class="btn btn-success exportExcelBtn m-2 float-end"
                                        >Download</button>
                                        <?php }?>
                                            <table class="table table-bordered table-striped" id="resultTable">
                                                <thead>
                                                    <tr>
                                                        <th>#</th>
                                                        <th>Reference No</th>
                                                        <th>NTA ID</th>
                                                        <th>Name</th>
                                                        <th>email</th>
                                                        <th>Mobile</th>
                                                        <th>Exam</th>
                                                        <th>User Type</th>
                                                        <th>Advance Payment</th>
                                                        <th>Net Payable Amt.</th>
                                                        <th>Bill Status</th>
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                    @php
                                                        $i = 0;
                                                    @endphp
                                                    @foreach ($BillReport as $val)   
                                                    @php
                                                    if($val->billStatus=='0')
                                                    $class='badge bg-primary';
                                                    elseif(in_array($val->billStatus,['1','2','4']))
                                                    $class='badge bg-info';
                                                    elseif($val->billStatus=='3')
                                                    $class='badge bg-danger';
                                                    elseif($val->billStatus=='5')
                                                    $class='badge bg-success';
                                                    @endphp                                                           
                                                        <tr>
                                                            <th>{{ ++$i }}.</th>
                                                            <td>{{ $val->referenceNo }}</td>
                                                            <td>{{ $val->observerId }}</td>
                                                            <td>{{ getUserDetailsByNTAID($val->observerId)->name??'' }}</td>
                                                            <td>{{ getUserDetailsByNTAID($val->observerId)->email??'' }}</td>
                                                            <td>{{ getUserDetailsByNTAID($val->observerId)->mobile??'' }}</td>
                                                            <td>{{ getExamNameByExamType($val->examType) }}</td>
                                                            <td>{{ config('constants.RoleName')[getExamRole($val->examType,$val->observerId)]}}</td>
                                                            <td>{{ number_format($val->advancePayment,'2','.','') }}</td>
                                                            <td>{{ number_format($val->netPayable,'2','.','') }}</td>
                                                            <td><span class="{{$class}}">{{ config('constants.BillStatus')[$val->billStatus]}}</span></td>
                                                        </tr>
                                                    @endforeach
                                                </tbody>
                                            </table>

                                            <!-- Pagination links -->
                                            <div class="d-flex justify-content-end">
                                                {{ $BillReport->appends(request()->query())->links('pagination::bootstrap-5') }}
                                            </div>

                                        </div>

                                    </div>

                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection

@section('script')
<script src="https://cdnjs.cloudflare.com/ajax/libs/xlsx/0.17.1/xlsx.full.min.js"></script>
    <script>
        function getloader() {
            $('.overlay').show();
            $('#perPageForm').submit();
        }
    </script>
    <script>
        let timeout;

        function debounceLoader() {
            // Clear the previous timeout if the user is still typing
            clearTimeout(timeout);

            // Set a new timeout to call getloader after 2 seconds
            timeout = setTimeout(function() {
                getloader();
            }, 500);
        }

        $(document).ready(function() {
        function checkInputs() {
            if ($('#referenceNo').val().trim() !== "" || $('#ntaId').val().trim() !== "") {
                $('#userType').attr('required', 'required');
            } else {
                $('#userType').removeAttr('required');
            }
        }

        // Run on page load
        checkInputs();

        // Run on input change
        $('#referenceNo, #ntaId').on('input', function() {
            checkInputs();
        });


    //export

    $(".exportExcelBtn").click(function() {
            // Get the table data
            var wb = XLSX.utils.table_to_book(document.getElementById('resultTable'), {
                sheet: "Sheet 1"
            });

            // Access the sheet from the workbook (first sheet)
            var ws = wb.Sheets["Sheet 1"];

            // Convert sheet to JSON (array of rows)
            var sheetData = XLSX.utils.sheet_to_json(ws, {
                header: 1
            });

            // Remove the first column from each row (starting from the second row)
            sheetData.forEach((row, index) => {
                row.shift(); // Removes the first column in each row
            });

            // Convert the modified data back to the worksheet
            var newWs = XLSX.utils.aoa_to_sheet(sheetData);

            // Assign the new sheet to the workbook
            wb.Sheets["Sheet 1"] = newWs;

            // Create and download the Excel file with the first column removed
            XLSX.writeFile(wb, "BillingReport.xlsx");
        });
    });
    </script>
@endsection
