@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/sweetalert2@11.7.4/dist/sweetalert2.min.css">
    <script src="https://cdn.ckeditor.com/ckeditor5/38.0.0/classic/ckeditor.js"></script>


   
@endsection
@section('content')
    <?php
    
    ?>
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                @if (isset($settingData) && !empty($settingData))
                                    {{ Breadcrumbs::render('EditSettingPayment', $settingData) }}
                                @else
                                    {{ Breadcrumbs::render('AddSettingPayment') }}
                                @endif

                                <div class="card">
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4"><?= $title ?></h4>
                                        <a href="{{ route('setting-list') }}" class="btn btn-danger text-white fs-5"> <i
                                                class="fa fa-angle-double-left" aria-hidden="true"> Back</i></a>
                                    </div>
                                    <?php
                                    // echo "<pre>";
                                    // print_r($examsList);die;
                                    ?>
                                    <div class="card-body">
                                        <div class="custom-form">
                                            <form
                                                action="{{ isset($settingData) && !empty($settingData) ? route('setting-edit', ['ID' => $settingData['id']]) : route('setting-add') }}"
                                                method="POST" enctype="multipart/form-data">
                                                @csrf
                                                <div class="row">
                                                    <div class="col-md-3">
                                                        <div class="form-group mb-3">
                                                            <label class="text-left labelName">Exam</label>
                                                            <select class="form-control required" name="Exam_Type">
                                                                <option selected disabled>--Select--</option>
                                                                @foreach ($examsList as $key => $val)
                                                                    <option value="{{ $key }}"
                                                                        {{ isset($settingData['Exam_Type']) && $settingData['Exam_Type'] == $key ? 'selected' : '' }}>
                                                                        {{ $val }}
                                                                    </option>
                                                                @endforeach
                                                            </select>
                                                            @error('Exam_Type')
                                                                <div class="text-danger mb-4">{{ $message }}</div>
                                                            @enderror
                                                        </div>
                                                    </div>
                                                    <div class="col-md-3">
                                                        <div class="form-group mb-3">
                                                            <label class="text-left labelName">Role</label>
                                                            <select class="form-control required" name="role">
                                                                <option selected disabled>--Select--</option>
                                                                @foreach ($RolesList as $keys => $vals)
                                                                    <option value="{{ $keys }}"
                                                                        {{ isset($settingData['role']) && $settingData['role'] == $keys ? 'selected' : '' }}>
                                                                        {{ $vals }}
                                                                    </option>
                                                                @endforeach
                                                            </select>
                                                            @error('role')
                                                                <div class="text-danger mb-4">{{ $message }}</div>
                                                            @enderror
                                                        </div>
                                                    </div>
                                                    <div class="col-md-3">
                                                        <div class="form-group mb-3">
                                                            <label class="text-left labelName">Travel Allowance (per km)</label>
                                                            <input type="text" name="travel_allowance"
                                                                class="form-control required"
                                                                value="{{ $settingData['travel_allowance'] ?? '' }}" onkeypress = 'return blockSpecialChar(event, "numeric")'>
                                                            @error('travel_allowance')
                                                                <div class="text-danger mb-4">{{ $message }}</div>
                                                            @enderror
                                                        </div>
                                                    </div>
                                                    <div class="col-md-3">
                                                        <div class="form-group mb-3">
                                                            <label class="text-left labelName">Hotel Allowance</label>
                                                            <input type="text" name="hotel_allowance"
                                                                class="form-control required"
                                                                value="{{ $settingData['hotel_allowance'] ?? '' }}" onkeypress = 'return blockSpecialChar(event, "numeric")'>
                                                            @error('hotel_allowance')
                                                                <div class="text-danger mb-4">{{ $message }}</div>
                                                            @enderror
                                                        </div>
                                                    </div>
                                                    <div class="col-md-3">
                                                        <div class="form-group mb-3">
                                                            <label class="text-left labelName">Attendance Note</label>
                                                                <textarea name="Attendance_Note" id="Attendance_Note" rows="1" class="form-control required">{{ $settingData['Attendance_Note'] ?? '' }}</textarea>
                                                            @error('Attendance_Note')
                                                                <div class="text-danger mb-4">{{ $message }}</div>
                                                            @enderror
                                                        </div>
                                                    </div>
                                                    <div class="col-md-3">
                                                        <div class="form-group mb-3">
                                                            <label class="text-left labelName">Miscellaneous File Note</label>
                                                                <textarea name="Miscellaneous_File_Note" id="Miscellaneous_File_Note" rows="1" class="form-control required">{{ $settingData['Miscellaneous_File_Note'] ?? '' }}</textarea>
                                                            @error('Miscellaneous_File_Note')
                                                                <div class="text-danger mb-4">{{ $message }}</div>
                                                            @enderror
                                                        </div>
                                                    </div>
                                                    <!-- <div class="col-md-3">
                                                        <div class="form-group mb-3">
                                                            <label class="text-left labelName">Status</label>
                                                            <select class="form-control required" name="is_active">
                                                                <option value="">--Select--</option>
                                                                <option value="1"
                                                                    {{ isset($settingData['is_active']) && $settingData['is_active'] == 1 ? 'selected' : '' }}>
                                                                    Active</option>
                                                                <option value="2"
                                                                    {{ isset($settingData['is_active']) && $settingData['is_active'] == 2 ? 'selected' : '' }}>
                                                                    Inactive</option>
                                                            </select>
                                                            @error('is_active')
                                                                <div class="text-danger mb-4">{{ $message }}</div>
                                                            @enderror
                                                        </div>
                                                    </div> -->
                                                    
                                                    <div class="col-md-6">
                                                        <div class="form-group mb-3">
                                                            <label class="text-left labelName"> Instruction </label>
                                                            <textarea class="form-control" id="instructions_texts" name="instructions_texts">
                                                            {!! $settingData['instructions_texts'] ?? '' !!}
                                                            </textarea>
                                                        </div>
                                                    </div> 

                                                </div>
                                                <br>
                                                <div class="row">
                                                    <div class="col-auto">
                                                        <div class="form-group">
                                                            <button type="submit"
                                                                class="btn btn-success DatePreference file">Submit</button>
                                                        </div>
                                                    </div>
                                                </div>
                                            </form>
                                        </div>
                                    </div>

                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
@section('script')
 

<script>

   ClassicEditor
       .create(document.querySelector('#instructions_texts'))
       .catch(error => {
           console.error(error);
       });
</script>

    <script>

        
        // $(document).ready(function() {
        //     $('form').on('submit', function(e) {
        //         let isValid = true;

        //         $(this).find('.required').each(function() {
        //             if (!$(this).val()) {
        //                 isValid = false;
        //                 $(this).addClass('is-invalid');
        //                 if (!$(this).next('.invalid-feedback').length) {
        //                     $(this).after(
        //                         '<div class="invalid-feedback fs-6">This field is required.</div>'
        //                     );
        //                 }
        //             } else {
        //                 $(this).removeClass('is-invalid');
        //                 $(this).next('.invalid-feedback').remove();
        //             }
        //         });

        //         if (!isValid) {
        //             e.preventDefault(); // Stop form from submitting
        //         }
        //     });

        //     // Remove error on input
        //     $('[required]').on('input change', function() {
        //         if ($(this).val()) {
        //             $(this).removeClass('is-invalid');
        //             $(this).next('.invalid-feedback').remove();
        //         }
        //     });
        // });
    </script>
@endsection
