@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/sweetalert2@11.7.4/dist/sweetalert2.min.css">
@endsection
@section('content')
    <style>
        .astric-sign {
            color: red;
        }
    </style>

    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">

            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                {{ Breadcrumbs::render('AddFinancialNorms') }}
                                <div class="card">
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4">{{ $title ?? 'Add New Financial Norms' }}</h4>
                                        <a href="{{ route('import-financial-norms') }}"
                                            class="btn btn-danger text-white fs-5"> <i class="fa fa-angle-double-left"
                                                aria-hidden="true"> Back</i></a>
                                    </div>
                                    <div class="card-body">
                                        <div class="custom-form">
                                            <form action="{{ route('financial-norms-save-detail') }}" method="POST"
                                                enctype="multipart/form-data" id="financialNorms">
                                                @csrf
                                                <div class="row">

                                                @php
                                                        $array = collect($ExamDateList)->sortBy('Exam Type')->toArray();
                                                    @endphp

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Exam Name <span
                                                                    class="astric-sign">*</span></label>
                                                            <select class="form-control form-select form-select-lg"
                                                                name="exam_type" onchange="ExamTypeId(this)">
                                                                <option value="">Select Here</option>
                                                                @foreach ($array as $rowExamDate)
                                                                    <option value="{{ $rowExamDate->{'Exam Type'} }}"
                                                                        data-key="{{ $rowExamDate->{'Exam Type Id'} }}"
                                                                        {{ old('exam_type') == $rowExamDate->{'Exam Type'} ? 'selected' : '' }}>
                                                                        {{ $rowExamDate->{'Exam Name'} }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>

                                                        <input type ="hidden" name="exam_type_id"
                                                            value="{{ old('exam_type_id') }}" class="form-control"
                                                            id="examtypeid" />

                                                        @error('exam_type')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6" style="display:none">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Exam Name <span
                                                                    class="astric-sign">*</span></label>

                                                            <input type ="text" name="exam_name"
                                                                value="{{ old('exam_name') }}"
                                                                class="form-control form-control-lg"
                                                                id="exam_name_data"
                                                                readonly />

                                                            <!-- <select class="form-control form-control-lg" name="exam_name">
                                                                    <option value="">Select Here</option>
                                                                    @foreach ($ExamDateList as $rowExamDate)
    <option {{ old('exam_name') == $rowExamDate->{'Exam Name'} ? 'selected' : '' }}>{{ $rowExamDate->{'Exam Name'} }}</option>
    @endforeach
                                                                </select>  -->

                                                        </div>
                                                        @error('exam_name')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6" style="display:none">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Exam Mode <span
                                                                    class="astric-sign">*</span></label>

                                                            <input type ="text" name="exam_mode"
                                                                value="{{ old('exam_mode') }}"
                                                                class="form-control form-control-lg"
                                                                id="exam_mode_data"
                                                                readonly />

                                                            <!-- <select class="form-control form-control-lg" name="exam_mode">
                                                                    <option value="">Select Here</option>
                                                                    @foreach ($ExamMode as $rowExamDate)
    <option value="{{ $rowExamDate }}" {{ old('exam_mode') == $rowExamDate ? 'selected' : '' }}>{{ $rowExamDate }}</option>
    @endforeach
                                                                </select>  -->
                                                        </div>
                                                        @error('exam_mode')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Role <span
                                                                    class="astric-sign" style="color:red">*</span></label>
                                                            <select class="form-control form-select form-select-lg"
                                                                onchange="SourceTypeId(this)" name="source_type">
                                                                <option value="">Select Here</option>
                                                                @foreach ($RoleName as $RoleNameKey => $rowrole)
                                                                    <option value="{{ $rowrole }}"
                                                                        {{ old('source_type') == $rowrole ? 'selected' : '' }}
                                                                        data-key="{{ $RoleNameKey }}">{{ $rowrole }}
                                                                    </option>
                                                                @endforeach
                                                            </select>
                                                        </div>
                                                        <input type ="hidden" value="{{ old('source_type_id') }}"
                                                            name="source_type_id" class="form-control" id="sourcetypeid" />
                                                        @error('source_type')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror

                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Category <span
                                                                    class="astric-sign">*</span></label>
                                                            <select class="form-control form-select form-select-lg"
                                                                onchange="SourceCodeId(this)" name="source_code">
                                                                <option value="">Select Here</option>
                                                                @foreach ($SourceCodeList as $rowsourcecode)
                                                                    <option value="{{ $rowsourcecode->{'Source Code'} }}"
                                                                        data-key="{{ $rowsourcecode->{'Source Name'} }}"
                                                                        {{ old('source_code') == $rowsourcecode->{'Source Code'} ? 'selected' : '' }}>
                                                                        {{ $rowsourcecode->{'Source Code'} }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>

                                                        @error('source_code')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                   
                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Attachment <span
                                                                    class="astric-sign">*</span></label>
                                                            <select class="form-control form-select form-select-lg"
                                                                name="attechment" id="attechment">
                                                                <option value="">Select Here</option>
                                                                @foreach ($IsAttachment as $keyAttribute => $rowAttachment)
                                                                    <option value="{{ $keyAttribute }}">
                                                                        {{ $rowAttachment }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>
                                                        @error('attechment')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6" id="Main_AttechmentNameDiv">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Attachment Required </label>
                                                            <select class="form-control form-select form-select-lg"
                                                                name="attechment_required" id="attechment_required">
                                                                <option value="">Select Here</option>
                                                                @foreach ($IsAttachment as $keyAttributeReq => $rowAttachmentReq)
                                                                    <option value="{{ $keyAttributeReq }}">
                                                                        {{ $rowAttachmentReq }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>
                                                        @error('attechment_required')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                   

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Non-Editable Field <span
                                                                    class="astric-sign">*</span></label>
                                                            <select class="form-control form-select form-select-lg"
                                                                name="read_only">
                                                                <option value="">Select Here</option>
                                                                @foreach ($IsReadonly as $keyReadOnly => $rowReadOnly)
                                                                    <option value="{{ $keyReadOnly }}">
                                                                        {{ $rowReadOnly }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>
                                                        @error('read_only')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>
                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Required<span
                                                                    class="astric-sign">*</span></label>
                                                            <select class="form-control form-select form-select-lg"
                                                                name="required">
                                                                <option value="">Select Here</option>
                                                                @foreach ($IsRequired as $keyRequired => $rowRequired)
                                                                    <option value="{{ $keyRequired }}">
                                                                        {{ $rowRequired }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>
                                                        @error('required')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>
                                                    
                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Display Order <span
                                                                    class="astric-sign">*</span></label>
                                                            <input type ="number" value="{{ old('display_order') }}"
                                                                placeholder ="Enter Display Order" name="display_order"
                                                                class="form-control form-control-lg" />
                                                        </div>
                                                        @error('display_order')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>
                                                   
                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Category Text<span
                                                                    class="astric-sign">*</span></label>
                                                            <input type="text" value="{{ old('source_name') }}"
                                                                class="form-control form-control-lg"
                                                                placeholder="Enter Norms Text" name="source_name">
                                                        </div>
                                                        @error('source_name')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Remuneratlon Description <span
                                                                    class="astric-sign">*</span></label>
                                                            <input type="text" value="{{ old('remuneratlon') }}"
                                                                class="form-control form-control-lg"
                                                                placeholder="Enter Remuneratlon Text" name="remuneratlon">
                                                        </div>
                                                        @error('remuneratlon')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Remuneratlon Amount  For Shift 1 <span
                                                                    class="astric-sign">*</span></label>
                                                            <input type="number"
                                                                value="{{ old('remuneratlon_amount_s1') }}"
                                                                class="form-control form-control-lg"
                                                                placeholder="Enter Remuneratlon Amount Shift 1"
                                                                name="remuneratlon_amount_s1">
                                                        </div>
                                                        @error('remuneratlon_amount_s1')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Remuneratlon Amount  For Shift 2 <span
                                                                    class="astric-sign">*</span></label>
                                                            <input type="number"
                                                                value="{{ old('remuneratlon_amount_s2') }}"
                                                                class="form-control form-control-lg"
                                                                placeholder="Enter Remuneratlon Amount Shift 2"
                                                                name="remuneratlon_amount_s2">
                                                        </div>
                                                        @error('remuneratlon_amount_s2')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Remuneratlon Amount  For Shift 3 <span
                                                                    class="astric-sign">*</span></label>
                                                            <input type="number"
                                                                value="{{ old('remuneratlon_amount_s3') }}"
                                                                class="form-control form-control-lg"
                                                                placeholder="Enter Remuneratlon Amount Shift 3"
                                                                name="remuneratlon_amount_s3">
                                                        </div>
                                                        @error('remuneratlon_amount_s3')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Remuneratlon Amount  For Shift 4 <span
                                                                    class="astric-sign">*</span></label>
                                                            <input type="number"
                                                                value="{{ old('remuneratlon_amount_s4') }}"
                                                                class="form-control form-control-lg"
                                                                placeholder="Enter Remuneratlon Amount Shift 4"
                                                                name="remuneratlon_amount_s4">
                                                        </div>
                                                        @error('remuneratlon_amount_s4')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Conveyance Amount <span
                                                                    class="astric-sign">*</span></label>
                                                            <input type ="number" value="{{ old('conveyance_amount') }}"
                                                                name="conveyance_amount"
                                                                placeholder="Enter Conveyance Amount"
                                                                class="form-control form-control-lg" />
                                                        </div>
                                                        @error('conveyance_amount')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Mock Drill Description <span
                                                                    class="astric-sign">*</span></label>
                                                            <input type ="text" name="mock_drill_text"
                                                                value="{{ old('mock_drill_text') }}"
                                                                class="form-control form-control-lg"
                                                                placeholder="Enter Mock Drill Text" />
                                                        </div>
                                                        @error('mock_drill_text')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>
                                                    
                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Mock Drill Amount <span
                                                                    class="astric-sign">*</span></label>
                                                            <input type="number"
                                                                value="{{ old('mock_drilling_amount') }}"
                                                                class="form-control form-control-lg"
                                                                placeholder="Enter Mock Drilling Amount"
                                                                name="mock_drilling_amount">
                                                        </div>
                                                        @error('mock_drilling_amount')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Mock Drill Conveyance
                                                                <span class="astric-sign">*</span></label>
                                                            <input type="number" class="form-control form-control-lg"
                                                                placeholder="Enter Mock Drilling Conveyance"
                                                                value="{{ old('mock_drilling_conveyance') }}"
                                                                name="mock_drilling_conveyance">
                                                        </div>
                                                        @error('mock_drilling_conveyance')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Max No Of Candidates <span
                                                                    class="astric-sign">*</span></label>
                                                            <input type="number" class="form-control form-control-lg"
                                                                placeholder="Enter Candidates Number"
                                                                value="{{ old('candidates') }}" name="candidates">
                                                        </div>
                                                        @error('candidates')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Food Amount <span
                                                                    class="astric-sign">*</span></label>
                                                            <input type ="number" value="{{ old('food_amount') }}"
                                                                placeholder ="Enter Food Amount" name="food_amount"
                                                                class="form-control form-control-lg" />
                                                        </div>
                                                        @error('food_amount')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Max No of Person <span
                                                                    class="astric-sign">*</span></label>
                                                            <input type ="number" name="no_of_person"
                                                                value="{{ old('no_of_person') }}"
                                                                placeholder="Enter No of Person"
                                                                class="form-control form-control-lg" />
                                                        </div>
                                                        @error('no_of_person')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Duty Days <span
                                                                    class="astric-sign">*</span></label>
                                                            <input type ="number" name="no_of_days"
                                                                value="{{ old('no_of_days') }}"
                                                                class="form-control form-control-lg"
                                                                placeholder="Enter No of Days" />
                                                        </div>
                                                        @error('no_of_days')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Fixed Amount <span
                                                                    class="astric-sign">*</span></label>
                                                            <input type ="number" name="fixed_amount"
                                                                value="{{ old('fixed_amount') }}"
                                                                class="form-control form-control-lg"
                                                                placeholder="Enter Fixed Amount" />
                                                        </div>
                                                        @error('fixed_amount')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">TDS Applicable? <span
                                                                    class="astric-sign">*</span></label>
                                                            <select class="form-control form-select form-select-lg"
                                                                name="tds" id="tds">
                                                                <option value="">Select Here</option>
                                                                @foreach ($IsTds as $keyTds => $rowTds)
                                                                    <option value="{{ $keyTds }}">
                                                                        {{ $rowTds }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>
                                                        @error('tds')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6" id ="Main_TdsPersentageNameDiv">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">TDS Precentage </label>
                                                            <input type ="number" name="tdsprecentage" id="tdsprecentage"
                                                                value="{{ old('tdsprecentage') }}"
                                                                class="form-control form-control-lg" />
                                                        </div>
                                                        @error('tdsprecentage')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    {{-- 
                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Field Name <span
                                                                    class="astric-sign">*</span></label>
                                                            <input type ="text" name="field_name"
                                                                value="{{ old('field_name') }}"
                                                                class="form-control form-control-lg"
                                                                placeholder ="Enter Filed Name" />
                                                        </div>
                                                        @error('field_name')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>
                                                    --}}
                                                    {{--          
                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Mock Drill Filed Name <span
                                                                    class="astric-sign">*</span></label>
                                                            <input type ="text" name="mock_drill_filed_name"
                                                                value="{{ old('mock_drill_filed_name') }}"
                                                                class="form-control form-control-lg"
                                                                placeholder="Enter Mock Drill Filed Name" />
                                                        </div>
                                                        @error('mock_drill_filed_name')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>
                                                    --}}

                                                    {{-- <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Is Active <span
                                                                    class="astric-sign">*</span></label>
                                                            <select class="form-control form-select form-select-lg"
                                                                name="is_active">
                                                                <option value="">Select Here</option>
                                                                @foreach ($IsActive as $keyActive => $rowActive)
                                                                    <option value="{{ $keyActive }}">
                                                                        {{ $rowActive }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>
                                                        @error('is_active')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div> --}}


                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Is Extra Field <span
                                                                    class="astric-sign">*</span></label>
                                                            <select class="form-control form-select form-select-lg"
                                                                name="is_extra_field">
                                                                <option value="">Select Here</option>
                                                                @foreach ($IsExtrafield as $keyExtrafield => $rowExtraField)
                                                                    <option value="{{ $keyExtrafield }}">
                                                                        {{ $rowExtraField }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>
                                                        @error('is_extra_field')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                </div>
                                                <br>
                                                <div class="row">
                                                    <div class="form-group text-end">
                                                        <button type="submit"
                                                            class="btn btn-success DatePreference file">Submit</button>
                                                    </div>
                                                </div>
                                            </form>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
@section('script')
    <script>
        function SourceTypeId(selectElement) {
            var selectedOption = selectElement.options[selectElement.selectedIndex];
            var roleNameKey = selectedOption.getAttribute('data-key');
            $('#sourcetypeid').val(roleNameKey);
        }

        function SourceCodeId(selectCodeElement) {
            var selectedCodeOption = selectCodeElement.options[selectCodeElement.selectedIndex];
            var roleCodeKey = selectedCodeOption.getAttribute('data-key');
            $('#sourcecodeid').val(roleCodeKey);
        }

        function ExamTypeId(examid) {
            var selectedExamOption = examid.options[examid.selectedIndex];
            var roleExamNameKey = selectedExamOption.getAttribute('data-key');
            $('#examtypeid').val(roleExamNameKey);

            $.ajax({
                url: "{{ route('get_exam_name') }}",
                method: 'GET',
                data: {
                    _token: '{{ csrf_token() }}',
                    Exam_ID: roleExamNameKey
                },
                dataType: 'json',
                success: function(response) {
                    console.log('response', response['Exam Name']);
                    $('#exam_name_data').val(response['Exam Name']);
                    $('#exam_mode_data').val(response['Exam_Mode']);

                    // BillData = response;
                    // buildIndex(); // Build index after fetching data
                    // filterResults(); // Display all data initially
                },
                error: function(data) {
                    console.error("Error fetching data");
                }
            });
        }


        $("#attechment").change(function() {
            var attechmentID = $.trim($("#attechment").val());
            if (attechmentID == 1) {
                $('#Main_AttechmentNameDiv').show();
            } else {
                $('#attechment_required').val('');
                $('#Main_AttechmentNameDiv').hide();
            }
        });


        $("#tds").change(function() {
            var tdsID = $.trim($("#tds").val());
            if (tdsID == 1) {
                $('#Main_TdsPersentageNameDiv').show();
            } else {
                $('#tdsprecentage').val('');
                $('#Main_TdsPersentageNameDiv').hide();
            }
        });



        $(document).ready(function() {

            var attechmentID = $.trim($("#attechment").val());
            if (attechmentID == 1) {
                $('#Main_AttechmentNameDiv').show();
            } else {
                $('#attechment_required').val('');
                $('#Main_AttechmentNameDiv').hide();
            }

            var tdsID = $.trim($("#tds").val());
            if (tdsID == 1) {
                $('#Main_TdsPersentageNameDiv').show();
            } else {
                $('#attechment_required').val('');
                $('#Main_TdsPersentageNameDiv').hide();
            }

        });
    </script>



    {!! $validator->selector('#financialNorms') !!}
@endsection
