
@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/sweetalert2@11.7.4/dist/sweetalert2.min.css">
@endsection
@section('content')

<main role="main" class="flex-shrink-0">
    <div class="container custom-container">

        <div class="login-5 mt-50 mb-50">
            <div class="container-fluid">
                <div class="row no-gutters">
                    <div class="col-sm-12">
                        <div class="container-fluid">
                            <div class="card">
                                {{-- <div class="card-header">
                                    <h4 class="mb-0 p-2 fw-bold">{{ $labelName ?? 'Add New Vendor Details ' }}</h4>
                                </div> --}}
                                <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                    <h4 class="mb-0 fw-bold fs-4">{{ $labelName ?? 'Add New  Vendor Details ' }}</h4>
                                    <a href="{{route('import-vendor-details')}}" class="btn btn-danger text-white fs-5"> <i class="fa fa-angle-double-left" aria-hidden="true"> Back</i></a>
                                </div>
                                    @if(session('success'))
                                        <div class="alert alert-success">
                                            {{ session('success') }}
                                        </div>
                                    @endif

                                    @if ($errors->has('file'))
                                        <div class="alert alert-danger">
                                            {{ $errors->first('file') }}
                                        </div>
                                    @endif
                                    <div class="card-body">
                                        <form action="{{ route('vendor-save-detail') }}" method="POST" enctype="multipart/form-data">
                                            @csrf
                                            <div class="row">
                                                <div class="col-md-6">
                                                        <div class="row">
                                                            <div class="col-md-9">
                                                                <div class="form-group">
                                                                <label class="text-left labelName">Attach Excel File</label>
                                                                    <input type="file" name="file" class="form-control form-control-sm DatePreference file" required>

                                                                </div>
                                                            </div>
                                                            <div class="col-md-3 text-center">
                                                                <label class="labelName">Click for Download</label>
                                                                    <a href="{{asset('MasterDataSample.xlsx')}}" class="btn btn-info" >Download Sample</a>
                                                            </div>
                                                        </div>
                                                </div>
                                            </div>
                                            <div class="row">
                                                <div class="col-md-6">
                                                    <div class="row">
                                                            <div class="col-md-9">
                                                                    <div class="form-group">
                                                                        <button type="submit" onclick="showLoader()"  class="form-control form-control-sm DatePreference file">submit</button>
                                                                    </div>
                                                            </div>
                                                    </div>
                                            </div>
                                        </form>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

</main>



<script>
    function showLoader(){
        $('.overlay').show();
    }

</script>

@endsection
@section('script')
