@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
@endsection
@section('content')
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">

            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                {{ Breadcrumbs::render('dutyDataadd') }}
                                <div class="card">
                                    @if ($errors->any())
                                        <div class="alert alert-danger">
                                            <ul>
                                                @foreach ($errors->all() as $error)
                                                    <li>{{ $error }}</li>
                                                @endforeach
                                            </ul>
                                        </div>
                                    @endif
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4">{{ $title ?? '' }}</h4>
                                        <a href="{{ route('importrem.index') }}" class="btn btn-danger text-white fs-5"> <i
                                                class="fa fa-angle-double-left" aria-hidden="true"> Back</i></a>
                                    </div>


                                    <div class="card-body">
                                        <div class="custom-form">
                                            <form action="{{ route('importrem.savedetail') }}" method="POST"
                                                enctype="multipart/form-data">
                                                @csrf

                                                <div class="row">
                                                    <div class="col-auto">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Exam Name</label>
                                                            <select name="ExamType" id="ExamType"
                                                                class="form-control form-select">
                                                                <option value="">--Select Exam--</option>
                                                                @if (isset($examList) && count($examList) > 0)
                                                                    @foreach ($examList as $exam)
                                                                        <option value="{{ $exam->{'Exam Type'} }}">
                                                                            {{ $exam->{'Exam Name'} }}</option>
                                                                    @endforeach
                                                                @endif
                                                            </select>
                                                            @error('ExamType')
                                                                <div class="text-danger mb-4">{{ $message }}</div>
                                                            @enderror
                                                        </div>
                                                    </div>
                                                    <div class="col-auto">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Attach Excel File</label>
                                                            <input type="file" name="file"
                                                                class="form-control form-control-lg DatePreference file">
                                                        </div>
                                                        @error('file')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>
                                                    <div class="col-auto mt-30 d-flex gap-2">
                                                        <a href="{{ asset('DutyDataSample.xlsx') }}"
                                                            class="btn btn-info text-white fs-5 fw-bold">Download Sample</a>
                                                        <a href="{{ asset('RolesDataSample.xlsx') }}"
                                                            class="btn btn-warning text-white fs-5 fw-bold" >Download Roles</a>
                                                    </div>


                                                </div>
                                                </br>

                                                <div class="row">
                                                    <div class="col-auto">
                                                        <div class="form-group">
                                                            <button type="submit"
                                                                class="btn btn-success DatePreference file">Submit</button>
                                                        </div>
                                                    </div>
                                                </div>
                                            </form>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
@section('script')
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.7.4/dist/sweetalert2.min.js"></script>

    <script>
        $(document).ready(function() {
            $('.btnAddRow').hide(); // Hide all buttons
            $('.btnAddRow').first().show(); // Show only the first button
            $('.btnRemoveRow').show(); // Hide all buttons
            $('.btnRemoveRow').first().hide(); // Show only the first button

            $(document).on('click', '.btnAddRow', function() {
                var totalFields = ($('#fieldsContainer .dateRow').length) + 1;
                var maxFields = 12;

                if (totalFields < maxFields) {
                    var row = $(this).closest('.dateRow').clone();
                    row.find('input').val(''); // Clear input values for cloned row
                    row.find('select').val('');
                    row.find('.btnAddRow').hide(); // Hide the add button for the cloned row
                    row.find('.btnAddRow').replaceWith(
                        '<a class="text-danger btnRemoveRow custom-white-text" style="cursor:pointer;font-size: 22px;"><i class="fa fa-trash"></i></a>'
                    ); // Replace with remove button
                    row.find('.ShiftColumn').remove(); // Remove any shift rows from the cloned dateRow
                    row.find('label').remove(); // Remove label from the cloned row
                    row.find('.shiftRow').first().removeClass('ShiftColumnEdit');
                    row.find('.ShiftColumnEdit').remove();
                    $('#fieldsContainer').append(row);
                } else {
                    Swal.fire({
                        icon: 'warning',
                        text: 'You can only add up to ' + maxFields + ' Shifts.'
                    });
                }
            });

            $(document).on('click', '.btnAddShift', function() {
                var examDate = $(this).closest('.dateRow').find('.DatePreference').val();
                if (examDate == '') {
                    Swal.fire({
                        icon: 'warning',
                        text: 'First select an exam date.'
                    });
                    return false;
                }
                var currentShiftsCount = $(this).closest('.dateRow').find('.shiftRow').length;
                var maxFields = 4;

                if (currentShiftsCount < maxFields) {
                    var shiftRow = $(this).closest('.dateRow').find('.shiftRow:last').clone();
                    shiftRow.find('input').val(''); // Clear input fields in the cloned shift row
                    shiftRow.find('select').val('');
                    shiftRow.find('label').remove();
                    shiftRow.find('.btnAddRow').hide();
                    shiftRow.find('.btnRemoveRow').remove();
                    shiftRow.find('.fromOne').attr('name', 'ExamMaster[fromOne][' + currentShiftsCount +
                        '][' + examDate + ']');
                    shiftRow.find('.toOne').attr('name', 'ExamMaster[toOne][' + currentShiftsCount + '][' +
                        examDate + ']');
                    shiftRow.find('.ExamShift').attr('name', 'ExamMaster[ExamShift][' + currentShiftsCount +
                        '][' + examDate + ']');
                    shiftRow.find('.btnAddShift').replaceWith(
                        '<a class="text-danger btnRemoveShiftRow custom-white-text mb-2" style="cursor:pointer;font-size: 22px;"><i class="fa fa-trash"></i></a>'
                    );

                    //row.find('.btnAddRow').replaceWith('<a class="text-danger btnRemoveRow custom-white-text" style="cursor:pointer;font-size: 22px;"><i class="fa fa-trash"></i></a>'); // Replace with remove button
                    $(this).closest('.dateRow').find('.shiftRow:last').after(shiftRow);
                } else {
                    Swal.fire({
                        icon: 'warning',
                        text: 'You can only add up to ' + maxFields + ' shifts.'
                    });
                }
            });

            $(document).on('click', '.btnRemoveShiftRow', function() {
                $(this).closest('.shiftRow').remove();
            });

            $(document).on('click', '.btnRemoveRow', function() {
                $(this).closest('.dateRow').remove();
            });

            $('#fieldsContainer').on('change', '.fromOne, .toOne', function() {
                validateShiftTimes($(this).closest('.dateRow'));
            });

            function validateShiftTimes(row) {
                let isValid = true;
                let errorMessage = "";

                row.find('.shiftRow').each(function() {
                    let fromTime = $(this).find('.fromOne').val();
                    let toTime = $(this).find('.toOne').val();

                    if (fromTime && toTime && fromTime >= toTime) {
                        isValid = false;
                        errorMessage = "From time must be less than To time.";
                        $(this).find('.fromOne, .toOne').val(''); // Clear the values
                    }
                });

                if (!isValid) {
                    Swal.fire({
                        icon: 'error',
                        text: errorMessage
                    });
                }
            }

            $('#fieldsContainer').on('change', '.DatePreference', function() {
                let selectedDate = $(this).val();
                let dateRow = $(this).closest('.dateRow');
                let shiftRow = dateRow.find('.shiftRow');

                // Reset names for new date
                shiftRow.find('.fromOne').attr('name', 'ExamMaster[fromOne][0][' + selectedDate + ']');
                shiftRow.find('.toOne').attr('name', 'ExamMaster[toOne][0][' + selectedDate + ']');
                shiftRow.find('.ExamShift').attr('name', 'ExamMaster[ExamShift][0][' + selectedDate + ']');

                // Check for duplicate date selection
                let isDuplicate = $('.DatePreference').not(this).filter(function() {
                    return $(this).val() == selectedDate;
                }).length > 0;

                if (isDuplicate) {
                    $(this).addClass('is-invalid');
                    $(this).parent().find('.invalid-feedback').html(
                        'This date has already been selected, please choose another.');
                    $(this).val('');
                } else {
                    $(this).removeClass('is-invalid');
                    $(this).parent().find('.invalid-feedback').text('');
                }

                // Validate shifts for the new date
                validateShiftsForDate(dateRow);
            });

            function validateShiftsForDate(row) {
                let selectedDate = row.find('.DatePreference').val();
                let shifts = {};

                row.find('.shiftRow').each(function() {
                    let shiftValue = $(this).find('.ExamShift').val();
                    if (shiftValue) {
                        if (shifts[shiftValue]) {
                            $(this).find('.ExamShift').addClass('is-invalid');
                            $(this).find('.invalid-feedback').html(
                                'This shift has already been selected for this date, please choose another.'
                            );
                        } else {
                            shifts[shiftValue] = true;
                        }
                    }
                });
            }

            $('#fieldsContainer').on('change', '.ExamShift', function() {
                let selectedShift = $(this).val();
                let dateRow = $(this).closest('.dateRow');

                // Check for duplicate shift selection
                let isDuplicate = dateRow.find('.ExamShift').not(this).filter(function() {
                    return $(this).val() == selectedShift;
                }).length > 0;

                if (isDuplicate) {
                    $(this).addClass('is-invalid');
                    $(this).parent().find('.invalid-feedback').html(
                        'This shift has already been selected, please choose another.');
                    $(this).val('');
                } else {
                    $(this).removeClass('is-invalid');
                    $(this).parent().find('.invalid-feedback').text('');
                }
            });

            // $('#exam-form').on('submit', function(event) {
            //     event.preventDefault(); // Prevent form from submitting right away
            //     var isValid = true;

            //     // Validate ExamDate[] fields
            //     $('#fieldsContainer input[name="ExamMaster[ExamDate][]"]').each(function() {
            //         var examDateVal = $(this).val();
            //         if (examDateVal === '' || examDateVal === null) {
            //             isValid = false;
            //             $(this).addClass('is-invalid');
            //             $(this).parent().find('.invalid-feedback').text('Exam Date cannot be blank.');
            //         } else {
            //             $(this).removeClass('is-invalid');
            //             $(this).parent().find('.invalid-feedback').text('');
            //         }
            //     });

            //     // Prevent form submission if validation fails
            //     if (!isValid) {
            //         return false; // Prevent form submission
            //     }

            //     // Allow Yii2 validation to continue if isValid is true
            //     return true;
            // });
        });


        const urlParams = new URLSearchParams(window.location.search);
        const EID = urlParams.get('EID');
        if (EID == null) {
            // $('#ExamName').on('change',function(){
            //     let ExamName = $(this).val();
            //     $.ajax({
            //             type: "POST",
            //             url: "</?= Yii::$app->urlManager->createUrl(['master/exam/check-exam-exist']) ?>",
            //             data: {
            //                 ExamName: ExamName,
            //                 _csrf: yii.getCsrfToken() // CSRF token for security
            //             },
            //             success: function(data) {
            //                 if (data.status === true) {
            //                     $('#ExamName').val('');
            //                     Swal.fire({
            //                         title: "Alert!",
            //                         text: data.message,
            //                         icon: "success",
            //                         confirmButtonText: "OK"
            //                     });
            //                 }
            //             },
            //             error: function(xhr, status, error) {
            //                 console.log("AJAX error:", error);
            //                 alert("An error occurred: " + xhr.responseText); // Display error message for failed AJAX requests
            //             }
            //         });
            // });

            // $('#ExamType').on('change',function(){
            //     let ExamType = $(this).val();
            //     $.ajax({
            //             type: "POST",
            //             url: "</?= Yii::$app->urlManager->createUrl(['master/exam/check-exam-type-exist']) ?>",
            //             data: {
            //                 ExamType: ExamType,
            //                 _csrf: yii.getCsrfToken() // CSRF token for security
            //             },
            //             success: function(data) {
            //                 if (data.status === true) {
            //                     $('#ExamType').val('');
            //                     Swal.fire({
            //                         title: "Alert!",
            //                         text: data.message,
            //                         icon: "success",
            //                         confirmButtonText: "OK"
            //                     });
            //                 }
            //             },
            //             error: function(xhr, status, error) {
            //                 console.log("AJAX error:", error);
            //                 alert("An error occurred: " + xhr.responseText); // Display error message for failed AJAX requests
            //             }
            //         });
            // });

        }
    </script>
@endsection
