@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
    <style>
        .small {
            display: none;
        }

        .filterSection {
            margin-top: 20px;
        }
    </style>
@endsection
@section('content')
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                {{ Breadcrumbs::render('AdvancePaymentList',$advanceList) }}
                                <div class="card">
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4"><?= $title ?></h4>
                                        <div class="d-flex">
                                            <a href="{{ route('admin.superdashboard') }}"
                                                class="btn btn-danger text-white fs-5">
                                                <i class="fa fa-angle-double-left" aria-hidden="true"></i> Back
                                            </a>

                                            <a href="{{ route('add-advance') }}"
                                                class="btn btn-success text-white mx-2 fs-5"> <i class="fa fa-plus-circle">
                                                    Add
                                                    New </i></a>

                                            <a href="{{ route('import-advance') }}" class="btn btn-warning text-white fs-5">
                                                <i class="fa fa-file"> Import </i></a>

                                        </div>
                                    </div>

                                    <div class="card-body">
                                        <div class="filterSection mt-0">

                                            <form action="{{ route('list-advance') }}" method="GET" id="perPageForm">
                                                <div class="row">
                                                    <!-- Left side: Per page dropdown -->
                                                    <div class="col-md-2 mb-2 d-flex align-items-center">
                                                        <select name="perPage" id="perPageSelect" class="form-select"
                                                            style="width: 70px" onchange="getloader()">
                                                            <option value="15"
                                                                {{ request('perPage') == 15 ? 'selected' : '' }}>15</option>
                                                            <option value="50"
                                                                {{ request('perPage') == 50 ? 'selected' : '' }}>50</option>
                                                            <option value="100"
                                                                {{ request('perPage') == 100 ? 'selected' : '' }}>100
                                                            </option>
                                                            <option value="200"
                                                                {{ request('perPage') == 200 ? 'selected' : '' }}>200
                                                            </option>
                                                            <option value="100000"
                                                                {{ request('perPage') == 100000 ? 'selected' : '' }}>All
                                                            </option>
                                                        </select>
                                                        <span class="ms-2">Per page</span>
                                                    </div>

                                                    <!-- Right side: Search input (with content aligned to the right) -->
                                                    <div class="col-md-10 mb-2 d-flex justify-content-end">
                                                        <div class="col-md-3 d-flex justify-content-end">
                                                            {{-- <input type="text" class="form-control form-control-sm"
                                                                placeholder="Search..." name="search" autocomplete="off" value="</?= $_GET['search'] ?? '' ?>" onblur="getloader()"/> --}}
                                                            <input type="text" class="form-control form-control-lg"
                                                                placeholder="Search..." name="search" autocomplete="off"
                                                                value="<?= $_GET['search'] ?? '' ?>" id="searchInput"
                                                                oninput="debounceLoader()" />
                                                            <a class="btn btn-danger ms-2 text-white fs-5"
                                                                href="{{ route('list-advance') }}">Reset</a>
                                                        </div>
                                                    </div>
                                                </div>
                                            </form>


                                        </div>

                                        <div class="table-responsive">
                                            <table class="table table-hover">
                                                <thead class="custom-header">
                                                    <tr>
                                                        <th>Sr. No.</th>
                                                        <th>NTA ID</th>
                                                        <th>Functionary Name</th>
                                                        <th>Exam Type</th>
                                                        <th>Advance Amount</th>
                                                        <th>Action</th>
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                    @php
                                                        $i = 1;
                                                    @endphp
                                                    @if (isset($advanceList) && !empty($advanceList))
                                                        @foreach ($advanceList as $index => $advance)
                                                            <tr>
                                                                <td>{{ $i++ }}</td>
                                                                <td>{{ $advance->{'NTA Observer ID'} ?? '-' }}</td>
                                                                <td>{{ $advance->{'Observer Name'} ?? '-' }}</td>
                                                                <td>{{ $advance->{'Exam Type'} ?? '-' }}</td>
                                                                <td>{{ number_format($advance->{'Advance Amount'}) ?? '-' }}
                                                                </td>
                                                                <td>
                                                                    <a href="{{ route('edit-advance', ['ID' => $advance->{'Advance No_'}]) }}"
                                                                        class="btn btn-success text-white">Edit</a>
                                                                </td>
                                                            </tr>
                                                        @endforeach
                                                    @endif
                                                </tbody>
                                            </table>

                                            <!-- Pagination links -->
                                            <div class="d-flex justify-content-between align-items-center">
                                                <div>
                                                    <span class="mb-0 text-muted">
                                                        Showing {{ $advanceList->firstItem() }} to
                                                        {{ $advanceList->lastItem() }}
                                                        of {{ $advanceList->total() }} results
                                                    </span>
                                                </div>
                                                <!-- Pagination (Right) -->
                                                <div>
                                                    {{ $advanceList->links('pagination::bootstrap-5') }}
                                                </div>
                                            </div>

                                        </div>

                                    </div>

                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection

@section('script')
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script>
        function getloader() {
            $('.overlay').show();
            $('#perPageForm').submit();
        }
    </script>
    <script>
        let timeout;

        function debounceLoader() {
            // Clear the previous timeout if the user is still typing
            clearTimeout(timeout);

            // Set a new timeout to call getloader after 2 seconds
            timeout = setTimeout(function() {
                getloader();
            }, 500);
        }

    </script>
@endsection
