@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
    <style>
        .small {
            display: none;
        }

        .filterSection {
            margin-top: 20px;
        }
    </style>
@endsection
@section('content')
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                {{ Breadcrumbs::render('CountPaymentList',$countList) }}
                                <div class="card">
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4"><?= $title ?></h4>
                                        <div class="d-flex">
                                            <a href="{{ route('admin.superdashboard') }}"
                                                class="btn btn-danger text-white fs-5">
                                                <i class="fa fa-angle-double-left" aria-hidden="true"></i> Back
                                            </a>

                                            <a href="{{ route('add-count') }}"
                                                class="btn btn-success text-white mx-2 fs-5"> <i class="fa fa-plus-circle">
                                                    Add
                                                    New </i></a>

                                            {{-- <a href="{{ route('import-count') }}" class="btn btn-warning text-white fs-5">
                                                <i class="fa fa-file"> Import </i></a> --}}

                                        </div>
                                    </div>

                                    <div class="card-body">
                                        <div class="filterSection mt-0">

                                            <form action="{{ route('list-count') }}" method="GET" id="perPageForm">
                                                <div class="row">
                                                    <!-- Left side: Per page dropdown -->
                                                    <div class="col-md-2 mb-2 d-flex align-items-center">
                                                        <select name="perPage" id="perPageSelect" class="form-select"
                                                            style="width: 70px" onchange="getloader()">
                                                            <option value="15"
                                                                {{ request('perPage') == 15 ? 'selected' : '' }}>15</option>
                                                            <option value="50"
                                                                {{ request('perPage') == 50 ? 'selected' : '' }}>50</option>
                                                            <option value="100"
                                                                {{ request('perPage') == 100 ? 'selected' : '' }}>100
                                                            </option>
                                                            <option value="200"
                                                                {{ request('perPage') == 200 ? 'selected' : '' }}>200
                                                            </option>
                                                            <option value="100000"
                                                                {{ request('perPage') == 100000 ? 'selected' : '' }}>All
                                                            </option>
                                                        </select>
                                                        <span class="ms-2">Per page</span>
                                                    </div>

                                                    <!-- Right side: Search input (with content aligned to the right) -->
                                                    <div class="col-md-10 mb-2 d-flex justify-content-end">
                                                        <div class="col-md-3 d-flex justify-content-end">
                                                            {{-- <input type="text" class="form-control form-control-sm"
                                                                placeholder="Search..." name="search" autocomplete="off" value="</?= $_GET['search'] ?? '' ?>" onblur="getloader()"/> --}}
                                                            <input type="text" class="form-control form-control-lg"
                                                                placeholder="Search..." name="search" autocomplete="off"
                                                                value="<?= $_GET['search'] ?? '' ?>" id="searchInput"
                                                                oninput="debounceLoader()" />
                                                            <a class="btn btn-danger ms-2 text-white fs-5"
                                                                href="{{ route('list-count') }}">Reset</a>
                                                        </div>
                                                    </div>
                                                </div>
                                            </form>


                                        </div>

                                        <div class="table-responsive">
                                            <table class="table table-hover">
                                                <thead class="custom-header">
                                                    <tr class="">
                                                        <th>Sr. No.</th>
                                                        <th>Exam Name</th>
                                                        <th>Action</th>
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                    @php
                                                        $i = 1;
                                                       
                                                    @endphp
                                                    @if (isset($countList) && !empty($countList))
                                                        @foreach ($countList as $index => $count)
                                                            <tr>
                                                                <td>{{ $i++ }}</td>
                                                                <!-- <td>{{ $count->{'Exam Type'} ?? '-' }}</td> -->
                                                               <td> {{ getExamNameByExamType($count->{'Exam Type'}) ?? '-' }}</td>
                                                                <td>
                                                                    <!-- <a href="{{ route('edit-count', ['ID' => $count->ID]) }}"
                                                                        class="btn btn-danger btn-sm text-white">Delete</a> -->
                                                                        <a href="javascript:void(0)" onclick="deleteFun({{$count->ID}})"
                                                                        class="btn btn-danger btn-sm text-white">Delete</a>
                                                                </td>
                                                            </tr>
                                                        @endforeach
                                                    @endif
                                                </tbody>
                                            </table>

                                            <!-- Pagination links -->
                                            <div class="d-flex justify-content-between align-items-center">
                                                <div>
                                                    <span class="mb-0 text-muted">
                                                        Showing {{ $countList->firstItem() }} to
                                                        {{ $countList->lastItem() }}
                                                        of {{ $countList->total() }} results
                                                    </span>
                                                </div>
                                                <!-- Pagination (Right) -->
                                                <div>
                                                    {{ $countList->links('pagination::bootstrap-5') }}
                                                </div>
                                            </div>

                                        </div>

                                    </div>

                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection

@section('script')
    <script>
        function getloader() {
            $('.overlay').show();
            $('#perPageForm').submit();
        }
    </script>
    <script>
        let timeout;

        function debounceLoader() {
            // Clear the previous timeout if the user is still typing
            clearTimeout(timeout);

            // Set a new timeout to call getloader after 2 seconds
            timeout = setTimeout(function() {
                getloader();
            }, 500);
        }

        function deleteFun(id){
                Swal.fire({
                    title: "Are you sure?",
                    text: "Do you want to delete this ?",
                    icon: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#3085d6",
                    cancelButtonColor: "#d33",
                    confirmButtonText: "Yes, change it!"
                }).then((result) => {
                    if (result.isConfirmed) {
                        // Make the AJAX request to delete the item
                        $.ajax({
                            url: '{{ route('delete-count', ':id') }}'.replace(':id', id),
                            type: 'POST',
                            data: {   
                                _token: '{{ csrf_token() }}', // CSRF token for security
                            },
                            success: function(response) {
                                if (response.success) {
                                    Swal.fire('Deleted!', response.success, 'success');
                                    location.reload();
                                } else {
                                    Swal.fire('Error!', 'Failed to delete the item.', 'error');
                                }
                            },
                            error: function(xhr, status, error) {
                                Swal.fire('Error!', 'Something went wrong.', 'error');
                            }
                        });
                    }    
                });
        }
    </script>
@endsection
