@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/sweetalert2@11.7.4/dist/sweetalert2.min.css">
@endsection
@section('content')
    <style>
        .size {
            font-size: 25px;
            padding-left: 10px;
        }

        .error {
            color: red;
        }

        .labelName::after {
            content: " *";
            color: red;
            /* You can change the color if needed */
        }
    </style>
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">

            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                {{ Breadcrumbs::render('ImportAdvancePayment') }}
                                <div class="card">
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4">{{ $title ?? '' }}</h4>
                                        <a href="{{ route('list-advance') }}" class="btn btn-danger text-white fs-5"> <i
                                                class="fa fa-angle-double-left" aria-hidden="true"> Back</i></a>
                                    </div>

                                    <div class="card-body">
                                        <form action="{{ route('save-import-advance') }}" method="POST"
                                            enctype="multipart/form-data" id="advanceForm">
                                            @csrf
                                            <div class="row">
                                                <div class="col-md-6">
                                                    <div class="form-group">
                                                        <label class="text-left labelName">Exam Type</label>
                                                        <select class="form-control form-select" name="exam_type"
                                                            id="exam_type">
                                                            <option value="">Select Here</option>
                                                            @foreach ($examsList as $exams)
                                                                <option >{{ $exams->{'Exam Type'} }}</option>
                                                            @endforeach
                                                        </select>
                                                    </div>
                                                    @error('exam_type')
                                                        <div class="text-danger mb-4">{{ $message }}</div>
                                                    @enderror
                                                </div>

                                                <div class="col-md-4">
                                                    <div class="form-group">
                                                        <label class="text-left labelName">Attach Excel File</label>
                                                        <input type="file" name="file" id="file"
                                                            class="form-control form-control-sm DatePreference file">
                                                    </div>
                                                    @error('file')
                                                        <div class="text-danger mb-4">{{ $message }}</div>
                                                    @enderror
                                                </div>

                                                <div class="col-md-2">
                                                    <div class="form-group"><br>
                                                        <label class="text-left">Download Sample Here</label>
                                                        <a href="{{ url('admin/data/AdvancePaymentSample.xlsx') }}"><i
                                                                class="fa fa-download size"></i></a>
                                                    </div>
                                                </div>
                                            </div>
                                            <br>
                                            <div class="form-group col-md-1">
                                                <button type="submit"
                                                    class="form-control form-control-sm DatePreference file btn btn-success">Submit</button>
                                            </div>
                                        </form>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
@section('script')
    <script type="text/javascript">
        $(document).ready(function() {
            // Validate the form
            $('#advanceForm').validate({
                rules: {
                    'exam_type': {
                        required: true,
                    },
                    'file': {
                        required: true,
                    },
                },
                messages: {

                    'exam_type': {
                        required: 'Please select the Exam Type',
                    },
                    'file': {
                        required: 'Please select the File',
                    },
                },

            });
        });
    </script>
@endsection
