@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
    <style>
        .small {
            display: none;
        }

        .filterSection {
            margin-top: 20px;
        }

        .form-control-sm,
        .form-control-sm {
            padding: 0.20rem 0.8rem !important;
        }

        .filterSection {
            margin-top: 18px;
            margin-bottom: 18px;
        }

        .resetbtn {
            padding: 7px 10px 3px 10px;
        }
    </style>
@endsection
@section('content')
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                {{ Breadcrumbs::render('financialNormsList', $importList) }}
                                <div class="card">
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4">{{ $title ?? '' }}</h4>

                                        <div class="d-flex">
                                            <a href="{{ route('admin.superdashboard') }}"
                                                class="btn btn-danger text-white fs-5 me-2">
                                                <i class="fa fa-angle-double-left" aria-hidden="true"></i> Back
                                            </a>

                                            {{-- <a href="{{ route('importfinancial.add') }}"
                                                class="btn btn-success text-white fs-5 me-2">
                                                <i class="fa fa-plus-circle"> Add New </i>
                                            </a> --}}
                                            <a href="{{ route('importfinancial_bulk.add') }}"
                                                class="btn btn-warning text-white fs-5">
                                                <i class="fa fa-file"> Import </i></a>
                                        </div>
                                    </div>

                                    <div class="card-body">
                                        <div class="filterSection mt-0">
                                            <div class="row">
                                                <form action="{{ route('import-financial-norms') }}" method="GET"   id="filterSelectForm">
                                                    <div class="d-flex justify-content-between align-items-center">
                                                        <!-- Show per page on the left -->
                                                        <div class="d-flex flex-column align-items-start">
                                                            <label for="perPageSelect" class="mb-1"><b>Show per
                                                                    page</b></label>
                                                            <select name="perPage" id="perPageSelect"
                                                                class="form-select form-select-lg" onchange="getloader1()"  style="padding: 0.45rem !important;">
                                                                <option value="15"
                                                                    {{ request('perPage') == 15 ? 'selected' : '' }}>15</option>
                                                                <option value="50"
                                                                    {{ request('perPage') == 50 ? 'selected' : '' }}>50</option>
                                                                <option value="100"
                                                                    {{ request('perPage') == 100 ? 'selected' : '' }}>100
                                                                </option>
                                                                <option value="200"
                                                                    {{ request('perPage') == 200 ? 'selected' : '' }}>200
                                                                </option>
                                                                <option value="100000"
                                                                    {{ request('perPage') == 100000 ? 'selected' : '' }}>All
                                                                </option>
                                                            </select>
                                                        </div>

                                                        <!-- Filters on the right side with 5px space between -->
                                                        <div class="d-flex align-items-center">
                                                            <!-- Filter by Exam Name -->
                                                            <div class="me-2 d-flex flex-column align-items-start" style="margin-right: 5px;width: 210px;">
                                                                <label for="examName" class="mb-1"><b>Exam Name</b></label>
                                                                <select id="examName" class="form-select form-select-lg" name="exam_type"
                                                                    onchange="getloader1()" style="padding: 0.45rem !important;">
                                                                    <option selected disabled>--Select--</option>
                                                                    @if(isset($importAllList) && !empty($importAllList))
                                                                        @foreach ($importAllList as $rowExamDate)
                                                                            <option value="{{ $rowExamDate->{'Exam Type ID'} }}"
                                                                                {{ request('exam_type') == $rowExamDate->{'Exam Type ID'} ? 'selected' : '' }}>
                                                                                {{ $rowExamDate->{'Exam Name'} }}</option>
                                                                        @endforeach
                                                                    @endif
                                                                </select>
                                                            </div>

                                                            <div class="me-2 d-flex flex-column align-items-start" style="margin-right: 5px;">
                                                                <label for="examName" class="mb-1"><b>Role</b></label>
                                                                <select class="form-control form-select form-select-lg"
                                                                onchange="getloader1()"  name="source_type" style="padding: 0.45rem !important;width: 197px;">
                                                                    <option selected disabled>--Select--</option>
                                                                    @foreach ($RoleName as $RoleNameKey => $rowrole)
                                                                        @if(array_key_exists($RoleNameKey, $RoleNameCheck))
                                                                            <option value="{{ $RoleNameKey }}" {{ request('source_type') == $RoleNameKey ? 'selected' : '' }} >
                                                                                {{ $rowrole }}
                                                                            </option>
                                                                        @endif
                                                                    @endforeach

                                                                </select>                               
                                                            </div>

                                                            <div class="me-2 mt-4">
                                                                <a href="{{ route('import-financial-norms') }}"
                                                                    class="form-control btn btn-danger text-white mt-3" style="padding: 0.45rem !important;" >Reset Filter
                                                                </a>
                                                            </div>

                                                        </div>
                                                    </div>
                                                </form>
                                            </div>
                                        </div>

                                        <div class="table-responsive">
                                            <table class="table table-hover">
                                                <thead class="custom-header">
                                                    <tr class="fs-5">
                                                        <th>#</th>
                                                        <th>Exam</th>
                                                        <th>Role</th>
                                                        <th>Category</th>
                                                        <th>Remuneration Amount S1</th>
                                                        <th>Remuneration Amount S2</th>
                                                        <th>Remuneration Amount S3</th>
                                                        <th>Remuneration Amount S4</th>
                                                        <th>Conveyance Amount</th>
                                                        <th>Mock Drill Charge</th>
                                                        <th>Mock Drill Conveyance</th>
                                                        <th>TDS Applicable?</th>
                                                        <th>Action</th>
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                    
                                                    <?php // prd($importList[0]); ?>
                                                    @if (isset($importList) && !empty($importList) && $importList->total() > 0)
                                                        @foreach ($importList as $index => $exam)
                                                            @php
                                                            @endphp
                                                            <tr>
                                                                <td>{{ $index + 1 }}</td>
                                                                <td>{{ $exam->{'Exam Name'} ?? 'NA' }}</td>
                                                                <td>
                                                                @php
                                                                   $role = isset($RoleName[$exam->{'Source Type'}]) ? $RoleName[$exam->{'Source Type'}] : null;
                                                                @endphp

                                                                @if($role)
                                                                    {{ $role }}
                                                                @endif
                                                               </td>
                                                                <td>{{ $exam->{'Source Name'} ?? 'NA' }}</td>
                                                                <td>{{ number_format($exam->{'Remuneration Amount_S1'}, 0) ?? 'NA' }}
                                                                </td>
                                                                <td>{{ number_format($exam->{'Remuneration Amount_S2'}, 0) ?? 'NA' }}
                                                                </td>
                                                                <td>{{ number_format($exam->{'Remuneration Amount_S3'}, 0) ?? 'NA' }}
                                                                </td>
                                                                <td>{{ number_format($exam->{'Remuneration Amount_S4'}, 0) ?? 'NA' }}
                                                                </td>
                                                                <td>{{ number_format($exam->{'Conveyance Amount'}, 0) ?? 'NA' }}
                                                                </td>
                                                                <td>{{ number_format($exam->{'Mock Drill Charge'}, 0) ?? 'NA' }}
                                                                </td>
                                                                <td>{{ number_format($exam->{'Mock Drill Conveyance'}, 0) ?? 'NA' }}
                                                                </td>
                                                                <td>{{ $exam->{'isTds'} == 1 ? 'Yes' : 'No' }}
                                                                </td>
                                                                @if(request()->has('perPage') && !empty(request('perPage')))
                                                                    <td>
                                                                        <a href="{{ route('importfinance.edit', [
                                                                                'document_id' => convert_uuencode($exam->{'Document No_'}),
                                                                                'line_id' => convert_uuencode($exam->{'Line No_'}),
                                                                                'perPage' => request('perPage', ''),
                                                                                'exam_type' => request('exam_type', ''),
                                                                                'source_type' => request('source_type','')
                                                                            ]) }}" class="btn btn-success text-white">Edit</a>
                                                                    </td>
                                                                @else
                                                                <td>
                                                                    <a href="{{ route('importfinance.edit', ['document_id' => convert_uuencode($exam->{'Document No_'}), 'line_id' => convert_uuencode($exam->{'Line No_'})]) }}"
                                                                        class="btn btn-success text-white">Edit</a>

                                                                </td>
                                                                @endif
                                                            </tr>
                                                        @endforeach
                                                    @else
                                                        <tr>
                                                            <td colspan="11" class="text-center">No Data Available!</td>
                                                        </tr>
                                                    @endif
                                                </tbody>
                                            </table>
                                            @if ($importList->total() > 0)
                                                <!-- Pagination links -->
                                                <div class="d-flex justify-content-between align-items-center">
                                                    <div>
                                                        <span class="mb-0 text-muted">
                                                            Showing {{ $importList->firstItem() }} to
                                                            {{ $importList->lastItem() }}
                                                            of {{ $importList->total() }} results
                                                        </span>
                                                    </div>
                                                    <!-- Pagination (Right) -->

                                                    <div>
                                                        {{ $importList->appends(request()->query())->links('pagination::bootstrap-5') }}
                                                    </div>

                                                </div>
                                            @endif
                                        </div>

                                    </div>

                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
@section('script')
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script>
        function getloader() {
            $('.overlay').show();
            $('#perPageForm').submit();
        }

        function getloader1() {
            $('.overlay').show();
            $('#filterSelectForm').submit();
        }
    </script>

    <script>
        let timeout;

        function debounceLoader() {
            // Clear the previous timeout if the user is still typing
            clearTimeout(timeout);
            // Set a new timeout to call getloader after 2 seconds
            timeout = setTimeout(function() {
                getloader();
            }, 500);
        }
    </script>
@endsection
