@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
    <style>
        .small {
            display: none;
        }

        .filterSection {
            margin-top: 20px;
        }

        .custom-width {
            width: 250px;
        }
    </style>
@endsection
@section('content')

    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                {{ Breadcrumbs::render('dutyDataList', $importList) }}
                                <div class="card">
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4">{{ $title ?? '' }}</h4>

                                        <div class="d-flex">
                                            <!-- <a href="{{ route('importrem.index') }}" class="btn btn-info text-white fs-5 me-2">
                                                       Reset-Filter
                                                    </a> -->
                                            <a href="{{ route('admin.superdashboard') }}"
                                                class="btn btn-danger text-white fs-5 me-2">
                                                <i class="fa fa-angle-double-left" aria-hidden="true"></i> Back
                                            </a>

                                            <a href="{{ route('importrem.add') }}" class="btn btn-success text-white fs-5">
                                                <i class="fa fa-plus-circle"> Import </i>
                                            </a>
                                        </div>
                                    </div>

                                    <div class="card-body">
                                        <div class="filterSection mt-0">
                                            <form action="{{ route('importrem.index') }}" method="GET" id="perPageForm">
                                                <div class="d-flex justify-content-between align-items-center">
                                                    <!-- Show per page on the left -->
                                                    <div class="d-flex flex-column align-items-start">
                                                        <label for="perPageSelect" class="mb-1"><b>Show per
                                                                page</b></label>
                                                        <select name="perPage" id="perPageSelect"
                                                            class="form-select form-select-lg" onchange="getloader()">
                                                            <option value="15"
                                                                {{ request('perPage') == 15 ? 'selected' : '' }}>15</option>
                                                            <option value="50"
                                                                {{ request('perPage') == 50 ? 'selected' : '' }}>50</option>
                                                            <option value="100"
                                                                {{ request('perPage') == 100 ? 'selected' : '' }}>100
                                                            </option>
                                                            <option value="200"
                                                                {{ request('perPage') == 200 ? 'selected' : '' }}>200
                                                            </option>
                                                            <option value="100000"
                                                                {{ request('perPage') == 100000 ? 'selected' : '' }}>All
                                                            </option>
                                                        </select>
                                                    </div>

                                                    <!-- Filters on the right side with 5px space between -->
                                                    <div class="d-flex align-items-center">
                                                        <!-- Filter by Exam Name -->
                                                        <div class="me-2 d-flex flex-column align-items-start"
                                                            style="margin-right: 20px !important;">
                                                            <label for="examName" class="mb-1"><b>Filter by Exam
                                                                    Name</b></label>
                                                            <select name="examName" id="examName"
                                                                class="form-select form-select-lg" onchange="getloader()">
                                                                <option value="">--Select--</option>
                                                                @foreach ($ExamType as $valExam)
                                                                    <option value="{{ $valExam->{'Exam Name'} }}"
                                                                        {{ request('examName') == $valExam->{'Exam Name'} ? 'selected' : '' }}>
                                                                        {{ $valExam->{'Exam Name'} }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>

                                                        <div class="me-2 d-flex flex-column align-items-start" style="margin-right: 5px;">
                                                                <label for="examName" class="mb-1"><b>Filter by Role</b></label>
                                                                <select class="form-control form-select form-select-lg"
                                                                onchange="getloader()"  name="source_type" style="padding: 0.45rem !important;width: 197px;">
                                                                    <option selected disabled>--Select--</option>
                                                                    @foreach ($RoleName as $RoleNameKey => $rowrole)
                                                                        @if(array_key_exists($RoleNameKey, $RoleNameCheck))
                                                                            <option value="{{ $RoleNameKey }}" {{ request('source_type') == $RoleNameKey ? 'selected' : '' }} >
                                                                                {{ $rowrole }}
                                                                            </option>
                                                                        @endif
                                                                    @endforeach

                                                                </select>                               
                                                            </div>

                                                        <!-- Search -->
                                                        <div class="me-2 d-flex flex-column align-items-start">
                                                            <label for="searchData" class="mb-1"><b>Search</b></label>
                                                            <input type="text" class="form-control form-control-lg"
                                                                placeholder="Enter Your keywords" id="searchData"
                                                                name="searchData" onchange="getloader()">
                                                        </div>

                                                        <div class="me-2 mt-4">
                                                            <a href="{{ route('importrem.index') }}"
                                                                class="form-control btn btn-danger text-white mt-3">Reset Filter
                                                            </a>
                                                        </div>

                                                    </div>
                                                </div>

                                            </form>
                                        </div>


                                        <div class="table-responsive">
                                            <table class="table table-hover">
                                                <thead class="">
                                                    <tr
                                                        class="fw-semibold fs-5 text-gray-800 border-bottom-2 border-gray-200">
                                                        <th>#</th>
                                                        <th>Observer ID</th>
                                                        <th>Name</th>
                                                        <th>Role</th>
                                                        <th>Exam Name</th>
                                                        <th>Center No</th>
                                                        <th>Email</th>
                                                        <th>Mobile</th>
                                                        <th>Actions</th>
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                        
                                                    @if (isset($importList) && !empty($importList) && $importList->total() > 0)
                                                        @foreach ($importList as $index => $exam)
                                                            <tr>
                                                                <td>{{ $importList->firstItem() + $index }}</td>
                                                                <td>{{ $exam->ObserverID ?? '-' }}</td>
                                                                <td>{{ $exam->Name ?? '-' }}</td>
                                                                <td>{{ config('constants.RoleName')[$exam->{'Observer Type'}] ?? '-' }}
                                                                </td>
                                                                <td>{{ $exam->{'Exam Name'} ?? '-' }}</td>
                                                                <td>{{ $exam->CENTNO ?? '-' }}</td>
                                                                <td>{{ $exam->Email ?? '-' }}</td>
                                                                <td>{{ $exam->Mobile ?? '-' }}</td>
                                                                @if(request()->has('perPage') && !empty(request('perPage')))
                                                                    <td>
                                                                        <a href="{{ route('edit.dutydays', [
                                                                                'id' => $exam->ID,
                                                                                'perPage' => request('perPage', ''),
                                                                                'examName' => request('examName', ''),
                                                                                'NTA_Observer_ID' => request('NTA_Observer_ID', '')
                                                                            ]) }}" class="btn btn-success text-white">Edit</a>
                                                                    </td>
                                                                @else
                                                                <td>
                                                                    <a href="{{ route('edit.dutydays', ['id' => $exam->ID]) }}"
                                                                        class="btn btn-success text-white">Edit</a>
                                                                </td>
                                                                @endif
                                                                
                                                            </tr>
                                                        @endforeach
                                                    @else
                                                        <tr>
                                                            <td colspan="8" class="text-center">No Data Available!</td>
                                                        </tr>
                                                    @endif
                                                </tbody>
                                            </table>
                                            @if ($importList->total() > 0)
                                                <!-- Pagination links -->
                                                <div class="d-flex justify-content-between align-items-center">
                                                    <div>
                                                        <span class="mb-0 text-muted">
                                                            Showing {{ $importList->firstItem() }} to
                                                            {{ $importList->lastItem() }}
                                                            of {{ $importList->total() }} results
                                                        </span>
                                                    </div>
                                                    <!-- Pagination (Right) -->
                                                    <div>
                                                        {{ $importList->appends(request()->query())->links('pagination::bootstrap-5') }}
                                                    </div>

                                                </div>
                                            @endif

                                        </div>

                                    </div>

                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
@section('script')
    <!-- <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> -->
    <script>
        function getloader() {
            $('.overlay').show();
            $('#perPageForm').submit();
        }

        $(document).ready(function() {
            $('.NTA_Observer_ID').select2();
        });

        $(document).ready(function() {
            $('#NTA_Observer_ID').select2({
                placeholder: "Search NTA ID",
                minimumInputLength: 2, // This ensures that the search is triggered only when the input length is at least 2 characters
                ajax: {
                    url: '{{ route('ntausers-id-search') }}', // Laravel route for the AJAX request
                    dataType: 'json',
                    delay: 250,
                    processResults: function(data) {
                        return {
                            results: data.map(function(item) {
                                return {
                                    id: item.ObserverID, // This will be the value of the option
                                    text: item
                                        .ObserverID // This will be displayed in the dropdown
                                };
                            })
                        };
                    },
                    cache: true
                }
            });
        });
    </script>
@endsection
