@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
<style>
    .small {
        display: none;
    }
    .filterSection{
        margin-top:20px;
    }
    .custom-width {
        width: 250px;
    }
</style>
@endsection
@section('content')
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                {{ Breadcrumbs::render('shiftRemunerationList', $importList) }}
                                <div class="card">
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4">{{ $title??'' }}</h4>
                                        <div class="d-flex">
                                            <a href="{{ route('admin.superdashboard') }}" class="btn btn-danger text-white fs-5 me-2">
                                                <i class="fa fa-angle-double-left" aria-hidden="true"></i> Back
                                            </a>
                                        <a href="{{ route('importrem.addshift') }}" class="btn btn-success text-white fs-5"> <i
                                                class="fa fa-plus-circle"> Import </i></a>
                                    </div>
                                    </div>
                                    <div class="card-body">
                                        <div class="filterSection mt-0">
                                            <form action="{{ route('importrem.indexshift')}}" method="GET" id="perPageForm">
                                                <div class="d-flex justify-content-between align-items-center">
                                                    <!-- Show per page on the left -->
                                                    <div class="d-flex flex-column align-items-start">
                                                        <label for="perPageSelect" class="mb-1"><b>Show per page</b></label>
                                                        <select name="perPage" id="perPageSelect" class="form-select form-select-sm" onchange="getloader()">
                                                            <option value="15" {{ request('perPage') == 15 ? 'selected' : '' }}>15</option>
                                                            <option value="50" {{ request('perPage') == 50 ? 'selected' : '' }}>50</option>
                                                            <option value="100" {{ request('perPage') == 100 ? 'selected' : '' }}>100</option>
                                                            <option value="200" {{ request('perPage') == 200 ? 'selected' : '' }}>200</option>
                                                            <option value="100000" {{ request('perPage') == 100000 ? 'selected' : '' }}>All</option>
                                                    </select>
                                                    </div>

                                                    <!-- Filters on the right side with 5px space between -->
                                                    <div class="d-flex align-items-center">
                                                        
                                                        <!-- Filter by Observer ID -->
                                                        <div class="me-2 d-flex flex-column align-items-start" style="margin-right: 5px;">
                                                            <label for="NTA_Observer_ID" class="mb-1"><b>Filter by Observer ID</b></label>
                                                            <select class="form-select form-select-lg custom-width" name="NTA_Observer_ID" id="NTA_Observer_ID" onchange="getloader()">
                                                                <!-- Dynamically populate the selected option based on the request -->
                                                                <option value="{{ request('NTA_Observer_ID') }}" 
                                                                        {{ null !== request('NTA_Observer_ID') ? 'selected' : '' }}>
                                                                    {{ null !== request('NTA_Observer_ID') ? request('NTA_Observer_ID') : 'Select Observer ID' }}
                                                                </option>
                                                            </select>
                                                        </div>


                                                        <!-- Search -->
                                                        <div class="me-2 d-flex flex-column align-items-start">
                                                            <label for="searchData" class="mb-1"><b>Search</b></label>
                                                            <input type="text" class="form-control form-control-lg" placeholder="Enter Your keywords" id="searchData" name="searchData" onchange="getloader()">
                                                        </div>

                                                        <div class="me-2 d-flex flex-column align-items-start mt-4">
                                                            <a  href="{{ route('importrem.indexshift') }}"  class="form-control btn btn-danger text-white" style="background: #81666dfa;margin-top: 8px;" >Reset Filter </a>
                                                        </div>

                                                    </div>
                                                </div>
                                            </form>

                                        </div>

                                        <div class="table-responsive">
                                            <table class="table table-hover">
                                                <thead class="custom-header">
                                                    <tr>
                                                        <th>#</th>
                                                        <!-- <th>Name</th> -->
                                                        <th>Observer ID</th>
                                                        <th>Exam Type</th>
                                                        <th>Center No</th>
                                                        <!-- <th>Exam Status</th> -->
                                                        <th>Actions</th>
                                                    </tr>
                                                </thead>
                                                <tbody>

                                                    @if(isset($importList) && !empty($importList))
                                                    @foreach ($importList as $index => $exam)
                                                        <tr>
                                                            <td>{{ $importList->firstItem() + $index }}</td>
                                                            <!-- <td>{{ $exam->Name ?? '-' }}</td> -->
                                                            <td>{{ data_get($exam, 'Observer ID', '-') }}</td>
                                                            <td>{{ data_get($exam, 'Exam Type', '-') }}</td>
                                                            <td>{{ $exam->CenterNo ?? '-' }}</td>

                                                             <td>

                                                                {{-- <a href="{{ route('importrem.view', $exam->ID) }}"
                                                                    class="btn btn-warning text-white">View</a> --}}
                                                                <a href="{{ route('importrem.edit', ['exam_id' => $exam->ID]) }}"
                                                                    class="btn btn-success text-white">Edit</a>
                                                            </td>
                                                        </tr>
                                                    @endforeach
                                                    @endif
                                                </tbody>
                                            </table>

                                            <!-- Pagination links -->
                                            <div class="d-flex justify-content-between align-items-center">
                                                <div>
                                                    <span class="mb-0 text-muted">
                                                        Showing {{ $importList->firstItem() }} to {{ $importList->lastItem() }}
                                                        of {{ $importList->total() }} results
                                                    </span>
                                                </div>
                                                <!-- Pagination (Right) -->
                                                <div>
                                                    {{ $importList->links('pagination::bootstrap-5') }}
                                                </div>
                                            </div>

                                        </div>

                                    </div>

                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
@section('script')
<!-- <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> -->
<script>

    function getloader() {
        $('.overlay').show();
        $('#perPageForm').submit();
    }

    $(document).ready(function() {
        $('.NTA_Observer_ID').select2();
    }); 

     $(document).ready(function() {
        $('#NTA_Observer_ID').select2({
            placeholder: "Search NTA ID",
            minimumInputLength: 2, // This ensures that the search is triggered only when the input length is at least 2 characters
            ajax: {
                url: '{{ route('ntausers-id-search-shift-wise-duty') }}', // Laravel route for the AJAX request
                dataType: 'json',
                delay: 250,
                processResults: function (data) {
                    return {
                        results: data.map(function(item) {
                            return {
                                id: item.ObserverID, // This will be the value of the option
                                text: item.ObserverID // This will be displayed in the dropdown
                            };
                        })
                    };
                },
                cache: true
            }
        });
    });

</script>
@endsection
