@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
    <style>
        /* Increase checkbox size */
        .form-check-input {
            transform: scale(1.5);
            /* Make checkboxes larger */
            appearance: auto !important;
            -webkit-appearance: auto !important;
            -moz-appearance: auto !important;
            margin-right: 8px;
        }

        /* Center align Day labels */
        /* Prevent line break in Day 1 */
        .day-label {
            white-space: nowrap;
            /* Ensures text stays on one line */
            font-weight: bold;
            text-align: left;
            display: inline-block;
            /* Avoid full width */
            margin-bottom: 8px;
            font-size: 16px;
        }

        /* Style for horizontal line */
        .day-divider {
            border-top: 2px solid #ccc;
            margin: 15px 0;
        }
    </style>
@endsection
@section('content')
    <main role="main" class="flex-shrink-0">

        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                {{ Breadcrumbs::render('UpdateShiftRemuneration') }}
                                <div class="card">
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4">{{ $title ?? 'Update Shiftwise Duty Data' }}
                                        </h4>
                                        <a href="{{ route('importrem.indexshift') }}"
                                            class="btn btn-danger text-white fs-5"> <i class="fa fa-angle-double-left"
                                                aria-hidden="true"> Back</i></a>
                                    </div>
                                    <div class="card-body">
                                        <form action="{{ route('shiftwise.dutyDays.update') }}" method="POST"
                                            id="shiftWiseDutyDaysForm" enctype="multipart/form-data">
                                            @csrf

                                            <div class="row">
                                                <div class="col-md-6">
                                                    <div class="form-group mb-3">
                                                        <label for="ObserverID"
                                                            class="text-left form-label fw-bold labelName">
                                                            Observer ID <span class="astric-sign text-danger">*</span>
                                                        </label>
                                                        <input type="text" name="ObserverID" id="ObserverID"
                                                            value="{{ isset($examData->{'Observer ID'}) ? $examData->{'Observer ID'} : old('ObserverID') }}"
                                                            class="form-control form-control-lg" readonly>
                                                        <input type="hidden" name="hiddenID"
                                                            value="{{ isset($examData->{'ID'}) ? $examData->{'ID'} : old('hiddenID') }}">
                                                    </div>
                                                </div>

                                                <div class="col-md-6">
                                                    <div class="form-group mb-3">
                                                        <label for="ExamName"
                                                            class="text-left form-label fw-bold labelName">
                                                            Exam Name <span class="astric-sign text-danger">*</span>
                                                        </label>
                                                        <input type="text" name="ExamName" id="ExamName"
                                                            value="{{ isset($examData->{'Exam Name'}) ? $examData->{'Exam Name'} : old('ExamName') }}"
                                                            class="form-control form-control-lg" readonly>
                                                    </div>
                                                </div>

                                                <div class="col-md-6">
                                                    <div class="form-group mb-3">
                                                        <label for="CenterNo"
                                                            class="text-left form-label fw-bold labelName">
                                                            Center No <span class="astric-sign text-danger">*</span>
                                                        </label>
                                                        <input type="text" name="CenterNo" id="CenterNo"
                                                            value="{{ isset($examData->CenterNo) ? $examData->CenterNo : old('CenterNo') }}"
                                                            class="form-control form-control-lg">
                                                        @error('CenterNo')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>
                                                </div>

                                                <div class="col-md-6">
                                                    <div class="form-group mb-3">
                                                        <label for="CityCode"
                                                            class="text-left form-label fw-bold labelName">
                                                            City Code No <span class="astric-sign text-danger">*</span>
                                                        </label>
                                                        <input type="text" name="CityCode" id="CityCode"
                                                            value="{{ isset($examData->CityCode) ? $examData->CityCode : old('CityCode') }}"
                                                            class="form-control form-control-lg">
                                                        @error('CityCode')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>
                                                </div>

                                                <div class="col-md-6">
                                                    <div class="form-group mb-3">
                                                        <label for="TCCode"
                                                            class="text-left form-label fw-bold labelName">
                                                            TC Code <span class="astric-sign text-danger">*</span>
                                                        </label>
                                                        <input type="text" name="TCCode" id="TCCode"
                                                            value="{{ isset($examData->TCCode) ? $examData->TCCode : old('TCCode') }}"
                                                            class="form-control form-control-lg">
                                                        @error('TCCode')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>
                                                </div>
                                                <!-- Dynamic Day and Shift Checkboxes -->
                                                <div class="col-md-12">
                                                    <h5 class="fw-bold">Select Daywise Shifts</h5>
                                                    @php
                                                    // Extract only non-empty Date_ values
                                                    // $shiftKeys = [];
                                                    // for ($i = 1; $i <= 12; $i++) {
                                                    //     $shiftKey = "D".$i."S".$i;
                                                    //     if (!empty($examData->$shiftKey)) {
                                                    //         $shiftKeys[$shiftKey] =$examData->$shiftKey; // Convert to dd-mm-yyyy format
                                                    //     }
                                                    // }

                                                    // prd($shiftKeys);
                                                @endphp
                                                    @for ($day = 1; $day <= count($shiftDateCount); $day++)
                                                        @php
                                                         $dateKey = "Date_" . $day;
                                                        @endphp
                                                        <div class="row mb-2">
                                                            <!-- Centered Day Checkbox -->
                                                            <div class="col-md-12 text-left" style="margin-left:10px;">
                                                                <div class="form-check d-inline-block">
                                                                    {{-- <input type="checkbox"
                                                                        class="form-check-input day-checkbox"
                                                                        id="D{{ $day }}"
                                                                        name="Day[{{ $day }}]"
                                                                        value="D{{ $day }}"> --}}
                                                                    <label class="form-check-label day-label"
                                                                        for="D{{ $day }}"><u>
                                                                        {{ \Carbon\Carbon::parse($examData->$dateKey)->format('Y-m-d') }}
                                                                         </u></label>
                                                                </div>
                                                            </div>

                                                            <!-- Shift Checkboxes -->
                                                            <div class="col-md-12">
                                                                <div class="row justify-content-center">
                                                                    @php //$shiftKeys = [];
                                                                    // for ($i = 1; $i <= count($shiftDateCount); $i++) {
                                                                    //     for($j =1 ;$j <=4 ;$j++){
                                                                    //         $shiftKey = "D".$i."S".$j;
                                                                    //     if (!empty($examData->$shiftKey)) {
                                                                    //         $shiftKeys[$shiftKey] =$examData->$shiftKey;
                                                                    //     }
                                                                    //     }

                                                                    // }

                                                                 // prd($examData->DutyDay['D'.$day]);
                                                                    @endphp

                                                                    @foreach ($examData->DutyDay['D'.$day] as $shiftKey => $shiftValue)
                                                                        @php
                                                                        //echo 'D'.$day.$shiftKey ;die;

                                                                            $shiftChecked = $examData->{'D'.$day.$shiftKey} == 1;
                                                                        @endphp
                                                                        <input type="hidden"
                                                                            name="ShiftWise[{{ 'D'.$day.$shiftKey }}]"
                                                                            value="0">
                                                                        <div class="col-md-1">
                                                                            <div class="form-check">
                                                                                <input type="checkbox"
                                                                                    class="form-check-input shift-checkbox"
                                                                                    id="{{ 'D'.$day.$shiftKey }}"
                                                                                    name="ShiftWise[{{ 'D'.$day.$shiftKey}}]"
                                                                                    value="{{ !empty($examData->{'D'.$day.$shiftKey}) ? $examData->{'D'.$day.$shiftKey} : 1 }}"
                                                                                    {{ $shiftChecked ? 'checked' : '' }}>
                                                                                <label class="form-check-label"
                                                                                    style="font-size:16px;"
                                                                                    for="{{ 'D'.$day.$shiftKey }}">
                                                                                     {{ $shiftValue }}
                                                                                </label>
                                                                                @error('ShiftWise[{{ $dayKey.$shiftKey }}]')
                                                                                    <div class="text-danger mb-4">
                                                                                        {{ $message }}</div>
                                                                                @enderror
                                                                            </div>
                                                                        </div>

                                                                    @endforeach
                                                                </div>
                                                            </div>
                                                        </div>

                                                        <!-- Horizontal Line After Each Day -->
                                                        <div class="col-md-12">
                                                            <hr class="day-divider">
                                                        </div>

                                                    @endfor
                                                </div>

                                                <div class="col-md-12 mt-5">
                                                    <div class="form-group text-end">
                                                        <button type="submit" class="btn btn-success">Submit</button>
                                                    </div>
                                                </div>
                                            </div>
                                        </form>
                                    </div>


                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
@section('script')
    <script>
    $(document).ready(function() {
        $('#shiftWiseDutyDaysForm').on('submit', function() {

            let shiftCheckboxes = document.querySelectorAll(".shift-checkbox");
            let checkedShifts = document.querySelectorAll(".shift-checkbox:checked").length;

            if (checkedShifts === 0) {
                Swal.fire({
                    title: "Warning!",
                    text: "You must select at least one shift before submitting.",
                    icon: "warning",
                    //timer: 2000,
                    //showConfirmButton: true
                });
                event.preventDefault(); // Stop form submission
            }
        });
    });
    </script>
@endsection
