@extends('layouts.adminLayout.dashboardLayout')
@section('content')
    <style>
        .custom-h5 {
            font-size: 1.5rem;
            /* Default font size */
            font-weight: bold;
        }

        @media (max-width: 1200px) {
            .custom-h5 {
                font-size: 1.3rem !important;
                /* For medium-sized screens like tablets */
            }
        }

        @media (max-width: 992px) {
            .custom-h5 {
                font-size: 1.1rem !important;
                /* For small screens */
            }
        }

        @media (max-width: 768px) {
            .custom-h5 {
                font-size: 1rem !important;
                /* For extra small screens (phones) */
            }
        }

        @media (max-width: 576px) {
            .custom-h5 {
                font-size: 0.9rem !important;
                /* For very small screens */
            }
        }
    </style>
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                <div class="card">
                                    <div class="card-header">
                                        <h4 class="mb-0 p-2 fw-bold fs-3">Super Admin Dashboard</h4>
                                    </div>
                                    <div class="card-body">
                                        <div class="container">
                                            <div class="row">
                                                <div class="col-md-3 col-sm-4 col-xs-6">
                                                    <a href="{{ route('exam.index') }}">
                                                        <div class="single-item custom-item-1 c1">
                                                            <div class="bg-layer"></div>
                                                            <h5 class="custom-h5">Exam Master</h5>
                                                        </div>
                                                    </a>
                                                </div>

                                                <div class="col-md-3 col-sm-4 col-xs-6">
                                                    <a href="{{ route('import-financial-norms') }}">
                                                        <div class="single-item custom-item-1 c2">
                                                            <div class="bg-layer"></div>

                                                            <h5 class="custom-h5">Import Financial Norms</h5>
                                                        </div>
                                                    </a>
                                                </div>

                                                <div class="col-md-3 col-sm-4 col-xs-6">
                                                    <a href="{{ route('importrem.index') }}">
                                                        <div class="single-item custom-item-1 c3">
                                                            <div class="bg-layer"></div>
                                                            <h5 class="custom-h5">Import Duty Data</h5>
                                                        </div>
                                                    </a>
                                                </div>

                                                <div class="col-md-3 col-sm-4 col-xs-6">
                                                    <a href="{{ route('list-count') }}">
                                                        <div class="single-item custom-item-1 c4">
                                                            <div class="bg-layer"></div>
                                                            <h5 class="custom-h5">Candidate Wise Count Data</h5>
                                                        </div>
                                                    </a>
                                                </div>

                                                <div class="col-md-3 col-sm-4 col-xs-6">
                                                    <a href="{{ route('import-vendor-details') }}">
                                                        <div class="single-item custom-item-1 c5">
                                                            <div class="bg-layer"></div>
                                                            <h5 class="custom-h5">Import Functionary Data Master</h5>
                                                        </div>
                                                    </a>
                                                </div>

                                                <div class="col-md-3 col-sm-4 col-xs-6">
                                                    <a href="{{ route('createcredentials') }}">
                                                        <div class="single-item custom-item-1 c6">
                                                            <div class="bg-layer"></div>
                                                            <h5 class="custom-h5">Create New Credentials</h5>
                                                        </div>
                                                    </a>
                                                </div>

                                                <div class="col-md-3 col-sm-4 col-xs-6">
                                                    <a href="#" data-bs-toggle="modal"
                                                        data-bs-target="#resetPasswordModal">
                                                        <div class="single-item custom-item-1 c7">
                                                            <div class="bg-layer"></div>
                                                            <h5 class="custom-h5">Reset Password To Default</h5>
                                                        </div>
                                                    </a>
                                                </div>

                                                <div class="col-md-3 col-sm-4 col-xs-6">
                                                    <a href="{{ route('changesLog') }}">
                                                        <div class="single-item custom-item-1 c8">
                                                            <div class="bg-layer"></div>
                                                            <h5 class="custom-h5">Log Reports</h5>
                                                        </div>
                                                    </a>
                                                </div>
                                                {{-- <div class="col-md-3 col-sm-4 col-xs-6">
                                                    <a href="{{ route('billReports') }}">
                                                        <div class="single-item custom-item-1 c9">
                                                            <div class="bg-layer"></div>
                                                            <h5 class="custom-h5">Bill Reports</h5>
                                                        </div>
                                                    </a>
                                                </div> --}}

                                                <div class="col-md-3 col-sm-4 col-xs-6">
                                                    <a href="{{ route('setting-list') }}">
                                                        <div class="single-item custom-item-1 c10">
                                                            <div class="bg-layer"></div>
                                                            <h5 class="custom-h5">Common Setting Master</h5>
                                                        </div>
                                                    </a>
                                                </div>

                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        {{-- Reset password modal --}}
        <div class="modal fade" tabindex="-1" id="resetPasswordModal">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h3 class="modal-title">Reset Password</h3>
                    </div>

                    <form action="{{ route('resetpassword') }}" method="post">
                        @csrf
                        <div class="modal-body">
                            <div class="row" id="inputContainer">
                                <div class="col-12 col-md-9 d-flex align-items-center gap-2 input-group">
                                    <input type="text" name="NTAID[]" class="form-control" autocomplete="off"
                                        placeholder="Enter Functionary ID">
                                    <span class="fs-2 fw-bold text-success addMore" style="cursor: pointer;">+</span>
                                </div>
                            </div>
                        </div>

                        <div class="modal-footer">
                            <button type="button" class="btn btn-light" data-bs-dismiss="modal">Close</button>
                            <button type="submit" class="btn btn-primary">Submit</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </main>
@endsection
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>

<script>
    $(document).ready(function() {
        // Add input field on clicking the Add button
        $(document).on("click", ".addMore", function() {
            let newInput = `
                <div class="col-12 col-md-9 d-flex align-items-center gap-2 input-group">
                    <input type="text" name="NTAID[]" class="form-control" autocomplete="off" placeholder="Enter Functionary ID">
                    <span class="fs-2 fw-bold text-danger removeInput" style="cursor: pointer;">&times;</span>
                </div>`;
            $("#inputContainer").append(newInput);
        });

        // Remove input field on clicking the Remove button
        $(document).on("click", ".removeInput", function() {
            $(this).parent().remove();
        });
    });
</script>
