@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
@endsection
@section('content')
    <?php
    
    ?>
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">

                            <div class="container-fluid">
                                {{ Breadcrumbs::render('EditVendor', $getData[0]) }}
                                <div class="card">
                                    {{-- <div class="card-header">
                                    <h4 class="mb-0 p-2 fw-bold">{{ $labelName ?? 'Add New Vendor Details ' }}</h4>
                                </div> --}}
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4">{{ $labelName ?? 'Add New Functionary Details' }}</h4>
                                        <a href="{{ route('import-vendor-details') }}"
                                            class="btn btn-danger text-white fs-5"> <i class="fa fa-angle-double-left"
                                                aria-hidden="true"> Back</i></a>
                                       
                                    </div>
                                    <div class="card-body">
                                        <div class="custom-form">
                                            <form action="{{ route('vendor-save-detail-Single') }}" method="POST"
                                                enctype="multipart/form-data">
                                                @csrf
                                                <div class="row">
                                                    <div class="form-group">
                                                        <label
                                                            class="form-control form-control-lg text-center btn btn-info">Functionary's
                                                            Details</label>
                                                    </div>
                                                    <div class="col-md-4">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Functionary ID</label>
                                                            <input type="text" class="form-control form-control-lg"
                                                                readonly
                                                                value="{{ isset($getData[0]->No_) ? $getData[0]->No_ : '' }}">
                                                        </div>
                                                    </div>
                                                    <input type="hidden" name="ntaId"
                                                        value="{{ isset($getData[0]->No_) ? Crypt::encrypt($getData[0]->No_) : '' }}">
                                                    <div class="col-md-4">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Name <span
                                                                    style="color:red">*</span></label>
                                                            <input type="text" class="form-control form-control-lg"
                                                                maxlength="50" name="name"
                                                                value="{{ old('name', isset($getData[0]->Name) ? $getData[0]->Name : '') }}"
                                                                placeholder="Enter Name">
                                                            @error('name')
                                                                <span style="color:red">{{ $message }}</span>
                                                            @enderror
                                                        </div>
                                                    </div>

                                                    <div class="col-md-4">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Email <span
                                                                    style="color:red">*</span></label>
                                                            <input type="text" class="form-control form-control-lg"
                                                                name="email" maxlength="50"
                                                                value="{{ old('email', isset($getData[0]->{'E-Mail'}) ? $getData[0]->{'E-Mail'} : '') }}"
                                                                placeholder="Enter Email">
                                                            @error('email')
                                                                <span style="color:red">{{ $message }}</span>
                                                            @enderror
                                                        </div>
                                                    </div>

                                                    <div class="col-md-4">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Mobile <span
                                                                    style="color:red">*</span></label>
                                                            <input type="text" class="form-control form-control-lg"
                                                                name="mobile"
                                                                onkeypress="return blockSpecialChar__(event, 'numeric')"
                                                              
                                                                value="{{ old('mobile', isset($getData[0]->{'Mobile Phone No_'}) ? $getData[0]->{'Mobile Phone No_'} : '') }}"
                                                                placeholder="Enter Mobile">
                                                            @error('mobile')
                                                                <span style="color:red">{{ $message }}</span>
                                                            @enderror
                                                        </div>
                                                    </div>

                                                    <div class="col-md-4">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Address <span
                                                                    style="color:red">*</span></label>
                                                            <input type="text" class="form-control form-control-lg"
                                                                maxlength="100" name="address"
                                                                value="{{ old('address', isset($getData[0]->Address) ? $getData[0]->Address : '') }}"
                                                                placeholder="Enter Address">
                                                            @error('address')
                                                                <span style="color:red">{{ $message }}</span>
                                                            @enderror
                                                        </div>
                                                    </div>

                                                    <div class="col-md-4">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">City <span
                                                                    style="color:red">*</span></label>
                                                            <input type="text" class="form-control form-control-lg"
                                                                name="city"
                                                                value="{{ old('city', isset($getData[0]->City) ? $getData[0]->City : '') }}"
                                                                placeholder="Enter City">
                                                            @error('city')
                                                                <span style="color:red">{{ $message }}</span>
                                                            @enderror
                                                        </div>
                                                    </div>

                                                    <div class="col-md-4">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Postal/Pin Code <span
                                                                    style="color:red">*</span></label>
                                                            <input type="text" class="form-control form-control-lg"
                                                                name="pincode"
                                                                value="{{ old('pincode', isset($getData[0]->{'Post Code'}) ? $getData[0]->{'Post Code'} : '') }}"
                                                                onkeypress="return blockSpecialChar(event, 'numeric')"
                                                                maxlength="6" minlength="6"
                                                                placeholder="Enter Postal/Pin Code">
                                                            @error('pincode')
                                                                <span style="color:red">{{ $message }}</span>
                                                            @enderror
                                                        </div>
                                                    </div>
                                                    <div class="form-group">
                                                        <label
                                                            class="form-control form-control-lg text-center btn btn-info mt-2">Bank
                                                            Details</label>
                                                    </div>
                                                    <div class="col-md-4">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Account Holder Name <span
                                                                    style="color:red">*</span></label>
                                                            <input type="text" class="form-control form-control-lg"
                                                                maxlength="50"
                                                                onkeypress="return blockSpecialChar(event, 'alpha')"
                                                                name="accountHolderName"
                                                                value="{{ old('accountHolderName', isset($bankDetails[0]->accountHolderName) ? $bankDetails[0]->accountHolderName : '') }}"
                                                                placeholder="Enter Account Holder Name">
                                                            @error('accountHolderName')
                                                                <span style="color:red">{{ $message }}</span>
                                                            @enderror
                                                        </div>
                                                    </div>
                                                    <div class="col-md-4">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Bank Name <span
                                                                    style="color:red">*</span></label>
                                                            <input type="text" class="form-control form-control-lg"
                                                                maxlength="50" name="bankName"
                                                                onkeypress="return blockSpecialChar(event, 'alpha')"
                                                                value="{{ old('bankName', isset($bankDetails[0]->BankName) ? $bankDetails[0]->BankName : '') }}"
                                                                placeholder="Enter Bank Name">
                                                            @error('bankName')
                                                                <span style="color:red">{{ $message }}</span>
                                                            @enderror
                                                        </div>
                                                    </div>
                                                    <div class="col-md-4">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Bank Account Number <span
                                                                    style="color:red">*</span></label>
                                                            <input type="text" class="form-control form-control-lg"
                                                                name="bankAccount"
                                                                onkeypress="return blockSpecialChar__(event, 'numeric')"
                                                                value="{{ old('bankAccount', isset($bankDetails[0]->AccountNo) ? $bankDetails[0]->AccountNo : '') }}"
                                                                placeholder="Enter Account No.">
                                                            @error('bankAccount')
                                                                <span style="color:red">{{ $message }}</span>
                                                            @enderror
                                                        </div>
                                                    </div>
                                                    <div class="col-md-4">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">IFSC Code <span
                                                                    style="color:red">*</span></label>
                                                            <input type="text" class="form-control form-control-lg"
                                                                name="ifscCode" maxlength="15"
                                                                value="{{ old('ifscCode', isset($bankDetails[0]->IFSCCode) ? $bankDetails[0]->IFSCCode : '') }}"
                                                                placeholder="Enter IFSC Code">
                                                            @error('ifscCode')
                                                                <span style="color:red">{{ $message }}</span>
                                                            @enderror
                                                        </div>
                                                    </div>
                                                    <div class="col-md-4">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Branch Name <span
                                                                    style="color:red">*</span></label>
                                                            <input type="text" class="form-control form-control-lg"
                                                                onkeypress="return blockSpecialChar(event, 'alpha')"
                                                                maxlength="100" name="branchName"
                                                                value="{{ old('branchName', isset($bankDetails[0]->branchName) ? $bankDetails[0]->branchName : '') }}"
                                                                placeholder="Enter Branch Name">
                                                            @error('branchName')
                                                                <span style="color:red">{{ $message }}</span>
                                                            @enderror
                                                        </div>
                                                    </div>
                                                    <div class="form-group">
                                                        <label
                                                            class="form-control form-control-lg text-center btn btn-info mt-2">Pancard
                                                            Details </label>
                                                    </div>
                                                    <div class="col-md-4">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Pancard <span
                                                                    style="color:red">*</span></label>
                                                            <input type="text" class="form-control form-control-lg"
                                                                name="pancard"
                                                                value="{{ old('pancard', isset($panDetails[0]->panNo) ? $panDetails[0]->panNo : '') }}"
                                                                placeholder="Enter Pancard">
                                                            @error('pancard')
                                                                <span style="color:red">{{ $message }}</span>
                                                            @enderror
                                                        </div>
                                                    </div>

                                                    @if( isset($getData[0]->No_) && !empty($getData[0]->No_) )
                                                    <div class="col-md-12 mt-5">
                                                        <div class="form-group text-end">
                                                            <button type="submit" class="btn btn-success">Update</button>
                                                        </div>
                                                    </div>
                                                    @else
                                                    <div class="col-md-12 mt-5">
                                                        <div class="form-group text-end">
                                                            <button type="submit" class="btn btn-success">Submit</button>
                                                        </div>
                                                    </div>
                                                    @endif
                                                </div>
                                            </form>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>

    <script>
        // Function to allow only alphabetic characters (A-Z, a-z)
        function blockSpecialChar(event, type) {
            const keyCode = event.keyCode || event.which;
            const key = String.fromCharCode(keyCode);
            // Allow only alphabetic characters (A-Z, a-z)
            const isAlphabet = /^[a-zA-Z]$/.test(key);
            // Block any key that is not alphabetic
            if (!isAlphabet && keyCode !== 8) { // Allow backspace (keyCode 8)
                event.preventDefault();
                return false;
            }
            return true;
        }
    </script>

@endsection

@section('script')
