@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
    <style>
        .small {
            display: none;
        }

        .filterSection {
            margin-top: 20px;
        }
    </style>
@endsection
@section('content')
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            {{ Breadcrumbs::render('vendorList', $vendorList) }}
                            <div class="container-fluid">
                                <div class="card">
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4">Functionary List</h4>

                                        <div class="d-flex">
                                            <a href="{{ route('admin.superdashboard') }}"
                                                class="btn btn-danger text-white fs-5 me-2">
                                                <i class="fa fa-angle-double-left" aria-hidden="true"></i> Back
                                            </a>
                                            <a href="{{ route('import-vendor-details.add') }}"
                                                class="btn btn-success text-white fs-5"> <i class="fa fa-plus-circle"> Add
                                                    New </i></a>
                                        </div>

                                    </div>
                                    <!-- @if (session('success'))
    <div class="alert alert-primary alert-dismissible fade show mt-5" role="alert">
                                                {{ session('success') }}
                                                <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                                            </div>
    @endif -->
                                    <div class="card-body">
                                        <div class="filterSection mt-0">
                                            <!-- <div class="col-md-1 mb-2">
                                                    <span class="me-2">Show per page</span>
                                                    <form action="{{ route('import-vendor-details') }}" method="GET" id="perPageForm">
                                                        <select name="perPage" id="perPageSelect" class="form-select" onchange="getloader()">
                                                            <option value="15" {{ request('perPage') == 15 ? 'selected' : '' }}>15</option>
                                                            <option value="50" {{ request('perPage') == 50 ? 'selected' : '' }}>50</option>
                                                            <option value="100" {{ request('perPage') == 100 ? 'selected' : '' }}>100</option>
                                                            <option value="200" {{ request('perPage') == 200 ? 'selected' : '' }}>200</option>
                                                            <option value="100000" {{ request('perPage') == 100000 ? 'selected' : '' }}>All</option>
                                                        </select>
                                                    </form>
                                                </div> -->

                                            <form action="{{ route('import-vendor-details') }}" method="GET"
                                                id="perPageForm">
                                                <div class="d-flex justify-content-between align-items-center">
                                                    <!-- Show per page on the left -->
                                                    <div class="d-flex flex-column align-items-start">
                                                        <label for="perPageSelect" class="mb-1"><b>Show per
                                                                page</b></label>
                                                        <select name="perPage" id="perPageSelect" class="form-select"
                                                            onchange="getloader()">
                                                            <option value="15"
                                                                {{ request('perPage') == 15 ? 'selected' : '' }}>15
                                                            </option>
                                                            <option value="50"
                                                                {{ request('perPage') == 50 ? 'selected' : '' }}>50
                                                            </option>
                                                            <option value="100"
                                                                {{ request('perPage') == 100 ? 'selected' : '' }}>100
                                                            </option>
                                                            <option value="200"
                                                                {{ request('perPage') == 200 ? 'selected' : '' }}>200
                                                            </option>
                                                            <option value="100000"
                                                                {{ request('perPage') == 100000 ? 'selected' : '' }}>All
                                                            </option>
                                                        </select>
                                                    </div>

                                                    <!-- Filters on the right side with 5px space between -->
                                                    <div class="d-flex align-items-center">

                                                        <!-- Search -->
                                                        <div class="me-2 d-flex flex-column align-items-start">
                                                            <label for="searchData" class="mb-1"><b>Search</b></label>
                                                            <input type="text" class="form-control form-control-lg"
                                                                placeholder="Enter Your keywords" id="searchData"
                                                                name="searchData" onchange="getloader()">
                                                        </div>

                                                        <div class="me-2 d-flex flex-column align-items-start mt-4">
                                                            <a href="{{ route('import-vendor-details') }}"
                                                                class="form-control btn btn-danger text-white mt-2">Reset Filter
                                                            </a>
                                                        </div>

                                                    </div>
                                                </div>
                                            </form>

                                        </div>

                                        <div class="table-responsive">
                                            <table class="table table-hover">
                                                <thead class="custom-header">
                                                    <tr class="fs-5">
                                                        <th>#</th>
                                                        <th>Functionary ID</th>
                                                        <th>Name</th>
                                                        <th>Email</th>
                                                        <th>Mobile</th>
                                                        <th>Action</th>
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                    @php
                                                        $i = 1;
                                                    @endphp
                                                    @if (isset($vendorList) && !empty($vendorList) && $vendorList->total() > 0)
                                                        @foreach ($vendorList as $index => $exam)
                                                            <tr>
                                                                <td>{{ $i++ }}</td>
                                                                <td>{{ $exam->{'No_'} ?? '-' }}</td>
                                                                <td>{{ $exam->Name ?? '-' }}</td>
                                                                <td>{{ $exam->{'E-Mail'} ?? '-' }}</td>
                                                                <td>{{ $exam->{'Mobile Phone No_'} ?? '-' }}</td>
                                                                <td>
                                                                    <a href="{{ route('admin.vendor-details-edit', ['edit' => $exam->{'No_'}]) }}"
                                                                        class="btn btn-success text-white">Edit</a>
                                                                </td>
                                                            </tr>
                                                        @endforeach
                                                    @else
                                                        <tr>
                                                            <td colspan="6" class="text-center">No Data Available!</td>
                                                        </tr>
                                                    @endif
                                                </tbody>
                                            </table>
                                            @if ($vendorList->total() > 0)
                                                <!-- Pagination links -->
                                                <div class="d-flex justify-content-between align-items-center">
                                                    <div>
                                                        <span class="mb-0 text-muted">
                                                            Showing {{ $vendorList->firstItem() }} to
                                                            {{ $vendorList->lastItem() }}
                                                            of {{ $vendorList->total() }} results
                                                        </span>
                                                    </div>
                                                    <!-- Pagination (Right) -->

                                                    <div>
                                                        {{ $vendorList->appends(request()->query())->links('pagination::bootstrap-5') }}
                                                    </div>

                                                </div>
                                            @endif
                                        </div>

                                    </div>

                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
@section('script')
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script>
        function getloader() {
            $('.overlay').show();
            $('#perPageForm').submit();
        }
    </script>
@endsection
