@extends('layouts.app')

@section('content')

<main role="main" class="flex-shrink-0">
    <div class="container custom-container">

        <div class="login-5 mt-50 mb-50">
            <div class="row align-items-stretch">
                @if(session('success'))    
                <div class="container">
                    <div class="d-flex justify-content-between alert alert-primary ">   
                        {{ session('success') }}            
                        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                    </div>
                </div>
                @endif 

                <div class="col-sm-6">
                    <div class="card card-white custom-card ovrflw h-100">
                        <div class="form-inner login-outside-container h-100">
                            <h3 class="mb-5 fw-bold">Login</h3>
                            <form method="POST" action="{{ route('username') }}">
                                @csrf
                                <div class="mb-3">
                                    <label for="username" class="field-loginformmodel-username required">{{ __('NTA ID as Username') }} <span class="astric-sign text-danger">*</span></label>
                                    <input id="username" type="text" class="form-control form-control-lg  @error('username') is-invalid @enderror" autocomplete="off" name="username" placeholder="Enter NTA ID as Username" value="{{ old('username') }}" autocomplete="username" autofocus>
                                    @error('username')
                                    <div class="invalid-feedback">
                                        {{ $message }}
                                    </div>
                                    @enderror
                                </div>
                                    <button type="submit" class="mt-5 btn btn-primary btn-lg btn-theme">
                                        Continue <i class="fa fa-angle-right" aria-hidden="true"></i>
                                    </button>
                                    <a href="{{route('forgot-password')}}"> <b>Forgot Password ?</b> </a>
                                    
                                </div>
                                  
                            </form>
                        </div>
                        
                </div>
                <div class="col-sm-6">
                    <div class="custom-card cust-crd overflow-hidden rounded">
                        <img class="img-fluid login-image" src="{{ URL::asset('assets/images/img-6.jpg') }}" alt="img-6.jpg" width="100%" height="100%">
                    </div>
                </div>
            </div>
        </div>

    </div>
</main>


@endsection