@extends('layouts.admin')
@section('content')
    <main role="main" class="flex-shrink-0">
        @if (Session::has('error'))
            <div class="container custom-container mb-0">
                <div class="d-flex justify-content-between alert alert-danger mt-3 mb-0">
                    {{ Session::get('error') }}
                    <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                </div>
            </div>
        @endif
        <div class="container custom-container">

            <style>
                .btn-header-link::after {
                    display: none !important;
                }

                .modal-dialog {
                    max-width: 90%;
                }
            </style>
            <div class="login-5 mt-50 mb-50">

                <div class="container-fluid">

                    <div class="row no-gutters">
                        @include('layouts.partials.left_navbar')
                        <div class="col-sm-8">
                            <div class="container">

                                <div class="card">
                                    <div class="card-header">
                                        <h4 class="mb-2 d-inline-block">Dashboard</h4>
                                        <div class="col-md-4 float-end text-end fw-bold fs-5">
                                            {{ session('examName') }}
                                        </div>
                                    </div>
                                    <div class="card-body">
                                        <div class="container">
                                            <div class="row justify-content-center">

                                                @if (session('role') == 1)
                                                    @if ($type == 1)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>" href="{{ route('exambill') }}">
                                                                <div class="single-item custom-item-1 c14">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">
                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>
                                                                    </div>
                                                                    <h5 class="custom-h5">Create/Submit Bill</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>"
                                                                href="{{ route('submit-bill-report') }}">
                                                                <div class="single-item custom-item-1 c15">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">Submitted Bill Status</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @elseif($type == 2)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>"
                                                                href="{{ route('mark-attendance') }}">
                                                                <div class="single-item custom-item-1 c14">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">Manage Attendance</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>" href="{{route('observer-report')}}">
                                                                <div class="single-item custom-item-1 c15">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">Submitted Bill Status</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @elseif($type == 3)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>" href="{{route('city-coordinator-report')}}">
                                                                <div class="single-item custom-item-1 c14">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">
                                                                        {{ config('constants.RoleName.' . session('role')) }}
                                                                    </h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>" href="{{route('observer-report')}}">
                                                                <div class="single-item custom-item-1 c15">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5"><a class="anchor<?= $type ?>"
                                                                            href="{{route('observer-report')}}">Observer</a></h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @endif
                                                @elseif(session('role') == 5 || session('role') == 2 || session('role') == 3 || session('role') == 10)
                                                    @if ($type == 1)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>" href="{{ route('tabill') }}">
                                                                <div class="single-item custom-item-1 c14">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">Create/Submit Bill</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>"
                                                                href="{{ route('submit-bill-report') }}">
                                                                <div class="single-item custom-item-1 c15">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">Submitted Bill Status</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @elseif ($type == 2 && session('role') != 3 && session('role') != 10)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>"
                                                                href="{{ route('contact-details') }}">
                                                                <div class="single-item custom-item-1 c14">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">City Coordinator List / Contact
                                                                        Details</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @elseif($type == 3)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>" href="{{route('observer-report')}}">
                                                                <div class="single-item custom-item-1 c15">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">
                                                                        <a class="anchor<?= $type ?>"
                                                                            href="{{route('observer-report')}}">{{ config('constants.RoleName.' . session('role')) }}</a>
                                                                    </h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @endif
                                                @elseif (session('role') == 13)
                                                    @if ($type == 1)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>" href="/centrebillexam/create">
                                                                <div class="single-item custom-item-1 c14">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">Create/Submit Bill</h5>
                                                                </div>
                                                            </a>
                                                        </div>

                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>" href="/centrebillexam/index">
                                                                <div class="single-item custom-item-1 c15">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">Submitted Bill Status</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @elseif ($type == 2)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>"
                                                                href="{{ route('contact-details') }}">
                                                                <div class="single-item custom-item-1 c14">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">City Coordinator List / Contact
                                                                        Details</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @elseif ($type == 3)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>"
                                                                href="{{route('cs-report')}}">
                                                                <div class="single-item custom-item-1 c14">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">Center Superintendent</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>" href="{{route('observer-report')}}">
                                                                <div class="single-item custom-item-1 c15">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5"><a class="anchor<?= $type ?>"
                                                                            href="{{route('observer-report')}}">Observer</a></h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @endif
                                                @elseif (session('role') == 14)
                                                    @if ($type == 1)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>"
                                                                href="{{ route('exambillcs') }}">
                                                                <div class="single-item custom-item-1 c14">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">Create/Submit Bill</h5>
                                                                </div>
                                                            </a>
                                                        </div>

                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>"
                                                                href="{{ route('submit-bill-report') }}">
                                                                <div class="single-item custom-item-1 c15">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">Submitted Bill Status</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @elseif($type == 2)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>"
                                                                href="{{ route('contact-details') }}">
                                                                <div class="single-item custom-item-1 c14">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">City Coordinator List / Contact
                                                                        Details</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @elseif($type == 3)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>"
                                                                href="{{route('cs-report')}}">
                                                                <div class="single-item custom-item-1 c14">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">Center Superintendent</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @endif
                                                @elseif (session('role') == 12)
                                                    @if ($type == 1)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>" href="/centrebillexam/create">
                                                                <div class="single-item custom-item-1 c14">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">Create/Submit Bill</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>" href="/centrebillexam/index">
                                                                <div class="single-item custom-item-1 c15">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">Submitted Bill Status</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @elseif($type == 2)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>"
                                                                href="{{ route('contact-details') }}">
                                                                <div class="single-item custom-item-1 c14">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">City Coordinator List / Contact
                                                                        Details</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @elseif($type == 3)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>" href="/report/index">
                                                                <div class="single-item custom-item-1 c14">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">Rigional Coordinator</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>" href="{{route('observer-report')}}">
                                                                <div class="single-item custom-item-1 c15">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5"><a class="anchor<?= $type ?>"
                                                                            href="{{route('observer-report')}}">Observer</a></h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @endif
                                                @elseif (session('role') == 11)
                                                    @if ($type == 1)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>" href="/centrebillexam/create">
                                                                <div class="single-item custom-item-1 c14">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">Create/Submit Bill</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>" href="/centrebillexam/index">
                                                                <div class="single-item custom-item-1 c15">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">Submitted Bill Status</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @elseif ($type == 2)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>"
                                                                href="{{ route('contact-details') }}">
                                                                <div class="single-item custom-item-1 c14">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">City Coordinator List / Contact
                                                                        Details</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @elseif ($type == 3)
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>" href="/report/index">
                                                                <div class="single-item custom-item-1 c14">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5">Zonal Coordinator</h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                        <div class="col-md-4 col-xs-6">
                                                            <a class=" anchor<?= $type ?>" href="{{route('observer-report')}}">
                                                                <div class="single-item custom-item-1 c15">
                                                                    <div class="bg-layer"></div>
                                                                    <div class="content_box custom-content-box ">

                                                                        <div class="icon-box"><img
                                                                                class="img-responsive icon-img"
                                                                                src="{{ asset('assets/images/plus.png') }}">
                                                                        </div>

                                                                    </div>
                                                                    <h5 class="custom-h5"><a class="anchor<?= $type ?>"
                                                                            href="{{route('observer-report')}}">Observer</a></h5>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    @endif
                                                @elseif ($type == 4)
                                                    <div class="col-md-4 col-xs-6">
                                                        <a class=" anchor<?= $type ?>" href="/report/index">
                                                            <div class="single-item custom-item-1 c15">
                                                                <div class="bg-layer"></div>
                                                                <div class="content_box custom-content-box ">

                                                                    <div class="icon-box"><img
                                                                            class="img-responsive icon-img"
                                                                            src="{{ asset('assets/images/plus.png') }}">
                                                                    </div>

                                                                </div>
                                                                <h5 class="custom-h5">Alloted Exam List</h5>
                                                            </div>
                                                        </a>
                                                    </div>
                                                @elseif($type == 5)
                                                    <div class="col-md-4 col-xs-6">
                                                        <a class=" anchor<?= $type ?>" href="/dashboard/update-profile">
                                                            <div class="single-item custom-item-1 c14">
                                                                <div class="bg-layer"></div>
                                                                <div class="content_box custom-content-box ">

                                                                    <div class="icon-box"><img
                                                                            class="img-responsive icon-img"
                                                                            src="{{ asset('assets/images/plus.png') }}">
                                                                    </div>

                                                                </div>
                                                                <h5 class="custom-h5">Update Profile</h5>
                                                            </div>
                                                        </a>
                                                    </div>
                                                    <div class="col-md-4 col-xs-6">
                                                        <a class=" anchor<?= $type ?>" href="/dashboard/change-password">
                                                            <div class="single-item custom-item-1 c15">
                                                                <div class="bg-layer"></div>
                                                                <div class="content_box custom-content-box ">

                                                                    <div class="icon-box"><img
                                                                            class="img-responsive icon-img"
                                                                            src="{{ asset('assets/images/plus.png') }}">
                                                                    </div>

                                                                </div>
                                                                <h5 class="custom-h5">Change Password</h5>
                                                            </div>
                                                        </a>
                                                    </div>
                                                @elseif($type == 6)
                                                    <div class="col-md-4 col-xs-6">
                                                        <a class=" anchor<?= $type ?>" href="/contact/index">
                                                            <div class="single-item custom-item-1 c14">
                                                                <div class="bg-layer"></div>
                                                                <div class="content_box custom-content-box ">

                                                                    <div class="icon-box"><img
                                                                            class="img-responsive icon-img"
                                                                            src="{{ asset('assets/images/plus.png') }}">
                                                                    </div>

                                                                </div>
                                                                <h5 class="custom-h5">Contact Details</h5>
                                                            </div>
                                                        </a>
                                                    </div>
                                                    <div class="col-md-4 col-xs-6">
                                                        <a class=" anchor<?= $type ?>" href="/contact/submit-feedback">
                                                            <div class="single-item custom-item-1 c15">
                                                                <div class="bg-layer"></div>
                                                                <div class="content_box custom-content-box ">

                                                                    <div class="icon-box"><img
                                                                            class="img-responsive icon-img"
                                                                            src="{{ asset('assets/images/plus.png') }}">
                                                                    </div>

                                                                </div>
                                                                <h5 class="custom-h5">Submit Feedback</h5>
                                                            </div>
                                                        </a>
                                                    </div>
                                                @endif
                                            </div>

                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
