<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">
    <title>{{ 'NTA:: ' . $title ?? 'Default' }}</title>
    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.bunny.net">
    <link href="https://fonts.bunny.net/css?family=Nunito" rel="stylesheet">
    <link rel="shortcut icon" href="{{ asset('assets/images/logo-icon.ico') }}">
    <!-- no need to menu only icon show -->
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/bootstrap.min.css') }}">
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/font-awesome.min.css') }}">
    <!--- no need to menu only icon show -->
    <!-- rsmenu CSS -->
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/rsmenu-main.css') }}">
    <!-- rsmenu transitions CSS -->
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/rsmenu-transitions.css') }}">
    <!-- style css -->
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/style.css') }}">
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/responsive.css') }}">
    <link rel="stylesheet" href="{{ asset('assets/css/outside.css') }}" />
    <link rel="stylesheet" type="text/css" href="{{ asset('admin/assets/css/style.css') }}">
    <link rel="stylesheet" href="{{ asset('assets/css/select2.min.css') }}" />
    <style>
    .cursor-pointer {
        cursor: pointer;
    }

    .sitemap-widget li a {
        text-decoration: none;
    }

    .nav-menu>li>a:hover {
        color: #fff !important;
    }

    .flexes a {
        text-decoration: none !important;
    }

    .card-header a {
        text-decoration: none !important;
    }
    </style>
</head>

<body>
    <div id="app">
        <nav class="menu-area nav-main-custom-admin menu-sticky">
            <div class="container custom-container">
                <div class="main-menu">
                    <div class="row">
                        <div class="col-sm-12">
                            <a class="rs-menu-toggle"><i class="fa fa-bars"></i>Menu</a>
                            <nav class="rs-menu rs-menu-close">
                                <ul class="nav-menu" style="padding: 10px">
                                    <li class="nav-item"> <img class="img-fluid"
                                            src="{{ asset('admin/assets/images/inside--logo.png') }}"
                                            alt="nta-logo.png"><span style="font-size:16px;color:#fff"
                                            class="mx-3">National Testing Agency</span></li>
                                </ul>
                            </nav>
                        </div>
                    </div>
                </div>
            </div>
        </nav>
        <main class="">
            {{-- @if ($errors->any())
                <div class="container custom-container" style="min-height:100px;">
                    <div class="d-flex justify-content-between alert alert-danger mt-3">
                        @foreach ($errors->all() as $error)
                            {{ $error }}
            @endforeach
            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
    </div>
    </div>
    @endif --}}
    @yield('content')
    </main>

    <footer class="bg3 rs-footer-admin " id="rs-footer" style="margin-top:432px;">
        <!-- Footer Bottom -->
        <div class="footer-bottom ">
            <div class="container custom-container-fluid">
                <div class="copyright">
                    <p> &copy; {{ date('Y') }} National Testing Agency. All rights reserved.
                        {{-- Last Updated: </?= date('F, d Y') ?></p> --}}
                </div>
            </div>
        </div>
    </footer>
    </div>
    <script src="{{ asset('assets/js/jquery.min.js') }}"></script>
    <script src="{{ asset('assets/js/rsmenu-main.js') }}"></script>
    <script src="{{ asset('assets/js/bootstrap.min.js') }}"></script>
    <script src="{{ asset('assets/js/bootstrap.bundle.min.js') }}"></script>
    <script src="{{ asset('assets/js/select2.min.js') }}"></script>
    @yield('script')
    <script>
    $(document).ready(function() {
        $('[data-toggle="tooltip"]').tooltip();

        jQuery('.selectBox').select2({
            placeholder: '--Select--',
            dropdownAutoWidth: true,
            allowClear: true
        });
        jQuery('.selectBoxMultiple').select2({
            placeholder: '--Select--',
            multiple: true,
            dropdownAutoWidth: true,
            allowClear: true
        });
    });
    </script>
</body>

</html>