<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>PDF Report</title>
    <link rel="stylesheet" href="path/to/your/css/file.css">
    <style>
        .AnnexureTable td {
            text-align: center !important;
        }

        /*this css work on print page default date time and page title print on page */
        @page {
            size: auto;
            margin: 5mm 5mm;
        }

        /*End of this css work on print page default date time and page title print on page */
        body {
            font-family: Arial, Helvetica, sans-serif;
            font-size: 12px;
            line-height: 14px;
            color: #000;
        }

        .logo {
            float: left;
            margin-right: 10px;
        }

        .logo_name {
            float: left;
            margin-top: 13px;
            font-size: 14px;
            font-weight: bold;
        }

        table tr td {
            padding: 2px;
        }

        .centered {
            text-align: center;
            white-space: nowrap;
        }

        /* this css work on page break to nest page */
        @media print {
            table {
                page-break-inside: auto
            }

            tr {
                page-break-inside: avoid;
                page-break-after: auto
            }
        }

        /* End of this css work on page break to nest page */
        p,
        td {
            font-family: freeserif;
        }

        .img-fluid {
            max-width: 100%;
            /* height: auto; */
            height: 100px !important;
        }
    </style>
</head>

<body>
    <div class="appendHtml">
        <div id="positionR">
            @if (isset($pdf) && $pdf == 'pdf')
                <table width="100%" cellspacing="0" cellpadding="5"
                    style="border-collapse: collapse; border-color: #000;">
                    <tr>
                        <th style="width: 20%; text-align: left;"><img
                                src="{{ asset('assets/images/Emblem-of-India.jpg') }}" alt="Emblem of India"
                                class="img-fluid" height="100px"></th>
                        <th style="width: 60%;"><img src="{{ asset('assets/images/logo-outside.jpg') }}"
                                alt="Logo Outside" class="img-fluid" height="100px"></th>
                        <th style="width: 20%;"><img src="{{ asset('assets/images/Azadi-Ka-Amrit-Mahotsav.jpg') }}"
                                alt="Azadi Ka Amrit Mahotsav" class="img-fluid" height="100px"></th>
                    </tr>
                </table>
            @endif

            <div class="table-responsive my-3">
                <table class="table cco-table table-bordered AnnexureTable" border="1" width="100%" cellspacing="0"
                    cellpadding="5" style="border-collapse: collapse; border-color: #000;">
                    <tbody>

                        @php
                            $counter = 0;
                        @endphp
                        <tr>
                            <th colspan="4" class="text-center">Annexure A-4 (TO BE FILLED BY
                                {{ strtoupper($ObserverType) }} )</th>
                        </tr>
                        @foreach ($FieldsArray as $key => $Fields)
                            {{-- Start a new row for the first column or after every second column --}}
                            @if ($counter % 2 == 0)
                                <tr>
                            @endif
                            {{-- Add the data in two columns --}}
                            <th>{{ htmlspecialchars($Fields['fieldLabel']) }}</th>
                            <td id="" width="25%">{{ $Fields['fieldValue'] }} </td>
                            @if (count($FieldsArray) - 1 == $key && count($FieldsArray) % 2 == 1)
                                <th></th>
                                <td></td>
                            @endif
                            {{-- Close the row after the second column --}}
                            @if ($counter % 2 == 1)
                                </tr>
                            @endif

                            {{-- Increment the counter --}}
                            @php $counter++@endphp
                        @endforeach

                        {{-- Close the last row if it is not closed --}}
                        @if ($counter % 2 != 0)
                            </tr>
                        @endif
                    </tbody>
                </table>
            </div><br>
          <?php  //prd($RemunerationFieldsArray)?> 
            <div class="table-responsive">
                <table class="table cco-table table-bordered RemunerationOnlineTable" border="1" width="100%"
                    cellspacing="0" cellpadding="5" style="border-collapse: collapse; border-color: #000;">
                    <thead>
                        <tr>
                            <th colspan="7" class="text-center">Details of Remuneration and Other
                                Expenses</th>
                        </tr>
                        <tr>
                            <th>S.No</th>
                            <th>Category</th>
                            <th width="40%">Remuneration And Conveyance Payable</th>
                            <th>No. Of Persons</th>
                            <th>No. Of Duty Days</th>
                            <th>Amount</th>
                            <th>Deduction Amount</th>
                        </tr>
                    </thead>
                    <tbody>


                        @if (isset($RemunerationFieldsArray) && !empty($RemunerationFieldsArray))
                            @php
                                $i = 0;
                                $k = 0;
                                $tottalDeductionAmount = 0;
                                $CityCoorConveyanceAmount = $UserDataToArray['City Coor_ Conveyance Amount'] ?? 0;
                            @endphp
                            @foreach ($RemunerationFieldsArray as $Remuneration)
                            @php
                                $deductionField = $Remuneration['Field_Name_Deduction'] ?? null;
                                $mockDrillField = $Remuneration['MockDrillFiledName_Deduction'] ?? null;
                                $deductionValue = '0';
                                if (isset($deductionField) && empty($deductionField)) {
                                    if (isset($UserDataToArray[$mockDrillField]) && is_numeric($UserDataToArray[$mockDrillField]) && ($UserDataToArray[$mockDrillField] > 0)) {
                                        $deductionValue = number_format($UserDataToArray[$mockDrillField], 2);
                                    }
                                } else {
                                    if (isset($UserDataToArray[$deductionField]) && is_numeric($UserDataToArray[$deductionField]) && ($UserDataToArray[$deductionField] > 0)) {
                                        $deductionValue = number_format($UserDataToArray[$deductionField], 2);
                                    }
                                }
                               
                            @endphp

                                @if ($Remuneration['Remuneration Text'] != '' && $Remuneration['Mock Drill Text'] != '')
                                @if($Remuneration['isExtrafield'] != 1)
                                    <tr>
                                        <td rowspan="2" class="centered">{{ ++$i }}</td>
                                        <td rowspan="2">{{ $Remuneration['Source Name'] }}</td>
                                        <td>{{ $Remuneration['Remuneration Text'] }}</td>
                                        <td class="centered"> {{ $NoofPerson[$k] ?? '' }}</td>
                                        <td class="centered">{{ $NoofDays[$k] ?? '' }}</td>
                                        <?php if($Remuneration['Source Code']=='CITY COORDINATOR'){?>
                                        <td class="centered">
                                            {{ number_format((($UserDataToArray['City Coor_ Remuneration Amount']??0)+($UserDataToArray['City Coor_ Conveyance Amount']??0)), 2) }}                                                                  
                                         <?php }else{?>
                                            <td class="centered">{{ isset($Remuneration['FieldValue']) && is_numeric($Remuneration['FieldValue']) 
                                                    ? number_format($Remuneration['FieldValue'], 2) : '0'}}
                                            <?php }?>
                                            @if (
                                                $Remuneration['Source Code'] == 'OBSERVER LOCAL' &&
                                                    ($Remuneration['FieldValue'] > 0 &&
                                                        !empty($UserDataToArray['Observer File Path']) &&
                                                        $UserDataToArray['Observer File Path'] != 'NA'))
                                                <br />
                                                <a href="{{ route('get-observer-data', ['referrence_no' => 'REF689382229', 'type' => 5]) }}" target="_blank"
                                                    style="margin-top:2px;">View Details</a> <br />
                                                    <a href="{{ $UserDataToArray['Observer File Path'] }}" target="_blank"
                                                        style="margin-top:2px;">View File</a>
                                            @endif
                                            @if (
                                                $Remuneration['Source Code'] == 'DEPUTY OBSERVER' &&
                                                    ($Remuneration['FieldValue'] > 0 &&
                                                        !empty($UserDataToArray['DObserver File Path']) &&
                                                        $UserDataToArray['DObserver File Path'] != 'NA'))
                                                <br />
                                                <a href="{{ route('get-observer-data', ['referrence_no' => 'REF689382229', 'type' => 2]) }}" target="_blank"
                                                    style="margin-top:2px;">View Details</a> <br />
                                                <a href="{{ $UserDataToArray['DObserver File Path'] }}" target="_blank"
                                                    style="margin-top:2px;">View File</a>
                                            @endif
                                        </td>
                                        <?php if($Remuneration['Source Code']=='CITY COORDINATOR'){?>
                                            <td class="centered">
                                                {{ number_format(
                                                    (($UserDataToArray['City Coor_ Conveyance Amount Deduction'] ?? 0) +
                                                     ($UserDataToArray['City Coor_ Remuneration Amount Deduction'] ?? 0)),
                                                    2
                                                ) }}
                                            </td>
                                            <?php }else{?>
                                        <td class="centered">{{ isset($UserDataToArray[$Remuneration['Field_Name_Deduction']]) && is_numeric($UserDataToArray[$Remuneration['Field_Name_Deduction']]) && ($UserDataToArray[$Remuneration['Field_Name_Deduction']] > 0) && ($UserDataToArray[$Remuneration['Field_Name_Deduction']] > 0) ? number_format($UserDataToArray[$Remuneration['Field_Name_Deduction']], 2) : '-' }}</td>
                                        <?php }?>
                                        @php  $k++;  @endphp
                                    </tr>
                                    <tr>
                                        <td>{{ $Remuneration['Mock Drill Text'] }}</td>
                                        <td class="centered"> {{ $NoofPerson[$k] ?? '' }}</td>
                                        <td class="centered">{{ $NoofDays[$k] ?? '' }}</td>
                                        <?php if($Remuneration['Source Code'] == 'CITY COORDINATOR'){ ?>
                                            <td class="centered">
                                                
                                                {{ number_format(
                                                    (
                                                        ($UserDataToArray['City Coor_ MockDrill Remuneration'] ?? 0) +
                                                        ($UserDataToArray['City Coor_ MockDrill Conveyance'] ?? 0) 
                                                    ),
                                                    2,
                                                    '.'
                                                ) }}                                            </td>
                                        <?php } else { ?>
                                            <td class="centered">
                                                {{ isset($Remuneration['MockDrillFieldValue']) && is_numeric($Remuneration['MockDrillFieldValue']) 
                                                    ? number_format($Remuneration['MockDrillFieldValue'], 2) : '0' }}
                                            </td>
                                        <?php } ?>
                                        <?php if($Remuneration['Source Code']=='CITY COORDINATOR'){?>
                                            <td class="centered">
                                                {{ number_format(
                                                    (($UserDataToArray['City Coor_MockDrill Remuneration Deduction'] ?? 0) +
                                                     ($UserDataToArray['City Coor_ MockDrill Conveyance Deduction'] ?? 0)),
                                                    2
                                                ) }}

                                            </td>
                                            <?php }else{?>    
                                        <td class="centered">{{ isset($UserDataToArray[$Remuneration['MockDrillFiledName_Deduction']]) && is_numeric($UserDataToArray[$Remuneration['MockDrillFiledName_Deduction']]) && ($UserDataToArray[$Remuneration['MockDrillFiledName_Deduction']] > 0) ? number_format($UserDataToArray[$Remuneration['MockDrillFiledName_Deduction']], 2) : '-' }}</td>    
                                                <?php }?>
                                    </tr>
                                    @endif
                                @elseif ($Remuneration['Remuneration Text'] != '' && $Remuneration['Mock Drill Text'] == '')
                                @if($Remuneration['isExtrafield'] != 1)
                                    <tr>
                                        <td class="centered">{{ ++$i }}</td>
                                        <td>{{ $Remuneration['Source Name'] }}</td>
                                        <td>{{ $Remuneration['Remuneration Text'] }}</td>
                                        @if (
                                            $Remuneration['Source Code'] != 'ADVANCEPAYMENT' &&
                                                $Remuneration['Source Code'] != 'TDS WITH LABEL' &&
                                                $Remuneration['Source Code'] != 'MISCELLANEOUS CHARGE')
                                            <td class="centered"> {{ $NoofPerson[$k] ?? '' }}</td>
                                            <td class="centered">{{ $NoofDays[$k] ?? '' }}</td>
                                        @else
                                            <td class="centered"></td>
                                            <td class="centered"></td>
                                        @endif
                                        <td class="centered">{{ number_format(($Remuneration['FieldValue']) , 2) }}</td> 
                                         <td class="centered">{{ $deductionValue }}</td>
                                    </tr>
                                    @endif
                                @elseif ($Remuneration['Remuneration Text'] == '' && $Remuneration['Mock Drill Text'] != '')
                                @if($Remuneration['isExtrafield'] != 1)
                                    <tr>
                                        <td class="centered">{{ ++$i }}</td>
                                        <td>{{ $Remuneration['Source Name'] }}</td>
                                        <td>{{ $Remuneration['Mock Drill Text'] }}</td>
                                        @if (
                                            $Remuneration['Source Code'] != 'ADVANCEPAYMENT' &&
                                                $Remuneration['Source Code'] != 'TDS WITH LABEL' &&
                                                $Remuneration['Source Code'] != 'MISCELLANEOUS CHARGE')
                                            <td class="centered"> {{ $NoofPerson[$k] ?? '' }}</td>
                                            <td class="centered">{{ $NoofDays[$k] ?? '' }}</td>
                                        @else
                                            <td class="centered"></td>
                                            <td class="centered"></td>
                                        @endif
                                        <td class="centered">
                                            {{ number_format($Remuneration['MockDrillFieldValue'], 2) }}
                                        </td>
                                        <td class="centered">{{ $deductionValue }}</td>
                                    </tr>
                                    @endif
                                @else
                                    @if($Remuneration['isExtrafield'] != 1)
                                        <tr>
                                            <td class="centered">{{ ++$i }}</td>
                                            <td>{{ $Remuneration['Source Name'] }}</td>
                                            <td>&nbsp;</td>
                                            @if (
                                                $Remuneration['Source Code'] !== 'ADVANCEPAYMENT' &&
                                                    $Remuneration['Source Code'] !== 'TDS WITH LABEL' &&
                                                    $Remuneration['Source Code'] !== 'MISCELLANEOUS CHARGE' &&
                                                    $Remuneration['Source Code'] !== 'REFRESHMENT CHARGES')
                                                <td class="centered"> {{ $NoofPerson[$k] ?? '' }}</td>
                                                <td class="centered">{{ $NoofDays[$k] ?? '' }}</td>
                                            @else
                                                <td class="centered"></td>
                                                <td class="centered"></td>
                                            @endif

                                            <td class="centered">
                                                {{ number_format($Remuneration['FieldValue'], 2) }}<br>

                                                @if (
                                                    $Remuneration['Source Code'] == 'MISCELLANEOUS CHARGE' &&
                                                        $Remuneration['FieldValue'] > 0 &&
                                                        !empty($UserDataToArray['File Path'] || $UserDataToArray['File Path'] != 'NA'))
                                                    <a href="<?= $UserDataToArray['File Path'] ?>" target="_blank"
                                                        style="margin-top:2px;">View</a>
                                                @endif
                                            </td>
                                            <td class="centered">{{ $deductionValue }}</td>

                                        </tr>
                                    @endif
                                @endif
                                @php  $k++;  @endphp
                            @endforeach
                          
                                    
                            <tr>
                                <td class="centered">{{ ++$i }}</td>
                                <th>Other Charges*</th>
                                <td></td>
                                <td></td>
                                <td></td>
                                <td class="centered">{{ number_format($UserDataToArray['Other Charges'], 2) }}
                                </td>
                                <td></td>
                            </tr>
                            <tr>
                                <td class="centered">{{ ++$i }}</td>
                                <th>Total Amount Claimed</th>
                                <td></td>
                                <td></td>
                                <td></td>
                                <td class="centered">{{ number_format($UserDataToArray['Net Amount Payable'], 2) }}
                                </td>
                                <td></td>
                            </tr>
                            <?php if($UserDataToArray['Total Deduction Amount'] > 0){ ?>
                            <tr>
                                <td class="centered">{{ ++$i }}</td>
                                <th>Total Deduction Amount</th>
                                <td></td>
                                <td></td>
                                <td></td>
                                <td class="centered">{{ number_format($UserDataToArray['Total Deduction Amount'], 2) }}
                                </td>
                                <td></td>
                            </tr>
                            <tr>
                                <td class="centered">{{ ++$i }}</td>
                                <th>Net Payable after Deduction</th>
                                <td></td>
                                <td></td>
                                <td></td>
                                <td class="centered">{{ number_format($UserDataToArray['Net Payable After Deduction'], 2) }}
                                </td>
                                <td></td>
                            </tr>
                            <?php } ?>
                    </tbody>
                </table>

                <p class="fs-4"><b>Bill Submitted Date: </b> {{(isset($UserDataToArray['Created On']) && !empty($UserDataToArray['Created On'])) ? date('d-m-Y', strtotime($UserDataToArray['Created On'])) : ''}}</p>
                @endif

            </div>
        </div>
    </div>
</body>

</html>
