<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>PDF Report</title>
    <link rel="stylesheet" href="path/to/your/css/file.css">
    <style>
        th {
            text-align: center !important;
        }

        /*this css work on print page default date time and page title print on page */
        @page {
            size: auto;
            margin: 5mm 5mm;
        }

        /*End of this css work on print page default date time and page title print on page */
        body {
            font-family: Arial, Helvetica, sans-serif;
            font-size: 12px;
            line-height: 14px;
            color: #000;
        }

        .logo {
            float: left;
            margin-right: 10px;
        }

        .logo_name {
            float: left;
            margin-top: 13px;
            font-size: 14px;
            font-weight: bold;
        }

        table tr td {
            padding: 2px;
        }

        /* this css work on page break to nest page */
        @media print {
            table {
                page-break-inside: auto
            }

            tr {
                page-break-inside: avoid;
                page-break-after: auto
            }
        }

        /* End of this css work on page break to nest page */
        p,
        td {
            font-family: freeserif;
        }

        .img-fluid {
            max-width: 100%;
            /* height: auto; */
            height: 100px !important;
        }
    </style>
</head>

<body>
    @php
        $numberOfPerson = explode(',', $data->{'No_ of Person'});
        $numberOfDays = explode(',', $data->{'No_ of Days'});
    @endphp
    <div class="appendHtml">
        <div id="positionR">
            @if (isset($pdf) && $pdf == 'pdf')
                <table width="100%" cellspacing="0" cellpadding="5"
                    style="border-collapse: collapse; border-color: #000;">
                    <tr>
                        <th style="width: 20%; text-align: left;"><img
                                src="{{ asset('assets/images/Emblem-of-India.jpg') }}" alt="Emblem of India"
                                class="img-fluid" height="100px"></th>
                        <th style="width: 60%;"><img src="{{ asset('assets/images/logo-outside.jpg') }}"
                                alt="Logo Outside" class="img-fluid" height="100px"></th>
                        <th style="width: 20%;"><img src="{{ asset('assets/images/Azadi-Ka-Amrit-Mahotsav.jpg') }}"
                                alt="Azadi Ka Amrit Mahotsav" class="img-fluid" height="100px"></th>
                    </tr>
                </table>
            @endif
            <?php //pr($data);
            ?>
            <table width="100%" class="table table-bordered" border="1" cellspacing="0" cellpadding="5"
                style="border-collapse: collapse; border-color: #000;">
                <thead class="">
                    <tr>
                        <th>Centre No.</th>
                        <th>City</th>
                        <th>Centre Name With Address</th>
                    </tr>
                </thead>
                <tbody>
                    <tr>
                        <td id="CentreNumberTd">
                            {{ strlen($data->CenterNo) > 150 ? substr($data->CenterNo, 0, 150) . '...' : $data->CenterNo }}
                        </td>
                        <td id="CentreCityTd">{{ $data->{'Center City'} }}</td>
                        <td id="CentreNameWithAddressTd">{{ substr($data->{'Center Address'}, 0, 150) }}...</td>
                    </tr>
                </tbody>
            </table>
            <div class="table-responsive">
                <h6 class="mb-1">Number of Candidates :</h6>
                <table width="100%" class="table table-bordered" border="1" cellspacing="0" cellpadding="5"
                    style="border-collapse: collapse; border-color: #000;">
                    <tbody>
                        <tr>
                            <th>Allotted Candidates</th>
                            <td id="AllottedCandidatesTd">{{ $data->{'No_ of Candidate Alloted'} }}</td>
                            <th> Present Candidates</th>
                            <td id="PresentCandidatesTd">{{ $data->{'No_ of Candidate Present'} }}</td>
                            <th> Absent Candidates</th>
                            <td id="AbsentCandidatesTd">{{ $data->{'No_ of Candidate Absent'} }}</td>
                        </tr>


                    </tbody>
                </table>
                <table width="100%" class="table table-bordered" border="1" cellspacing="0" cellpadding="5"
                    style="border-collapse: collapse; border-color: #000;">
                    <tbody>
                        <tr>
                            @php $kcount=0;@endphp
                            @for ($lt = 1; $lt <= $totalDutyDays; $lt++)
                                <th>Day {{ $lt }} Max Count</th>
                                <td><?= $ArrayData['allottedCandidatesCount'][$kcount] ?? 0 ?></td>
                                @php $kcount++ @endphp
                            @endfor
                        </tr>


                    </tbody>
                </table>




            </div>
            <br />
            <div class="table-responsive">
                <table width="100%" class="table table-bordered" border="1" cellspacing="0" cellpadding="5"
                    style="border-collapse: collapse; border-color: #000;">
                    <thead class="">
                        <tr>
                            <th>SI. No</th>
                            <th>Category</th>
                            <th width="50%">Remuneration and Conveyance Payable (Original Bills must be enclosed)
                            </th>
                            <th>No. of Persons</th>
                            <th>No. of Duty Days</th>
                            <th>Amount</th>
                            <th>Deduction Amount</th>
                        </tr>
                    </thead>
                    <tbody>
                        @php
                            $i = 0;
                            $k = 0;
                            // prd($CentralizedRemuneration);
                        @endphp
                        @foreach ($CentralizedRemuneration as $row)
                            @php
                                $deductionField = $row->{'Field_Name_Deduction'} ?? null;
                                $mockDrillField = $row->{'MockDrillFiledName_Deduction'} ?? null;

                                $deductionValue = '-';

                                if (isset($deductionField) && empty($deductionField)) {
                                    if (
                                        isset($data->{$mockDrillField}) &&
                                        is_numeric($data->{$mockDrillField}) &&
                                        $data->{$mockDrillField} > 0
                                    ) {
                                        $deductionValue = number_format($data[$mockDrillField], 2);
                                    }
                                } else {
                                    if (
                                        isset($data->{$deductionField}) &&
                                        is_numeric($data->{$deductionField}) &&
                                        $data->{$deductionField} > 0
                                    ) {
                                        $deductionValue = number_format($data->{$deductionField}, 2);
                                    }
                                }
                            @endphp
                            @if ($row->{'Remuneration Text'} != '' && $row->{'Mock Drill Text'} != '')
                                @if ($row->{'isExtrafield'} != 1)
                                    <tr>
                                        <td rowspan="2">{{ ++$i }}.</td>
                                        <td rowspan="2">{{ $row->{'Source Name'} }}</td>
                                        <td>{{ $row->{'Remuneration Text'} }}</td>
                                        <td>{{ $numberOfPerson[$k] ?? '' }}</td>
                                        <td>{{ $numberOfDays[$k] ?? '' }}</td>
                                        <td id="">
                                            {{ isset($data->{$row->Field_Name}) ? number_format($data->{$row->Field_Name}, 0, '', '') : 0 }}
                                        </td>
                                        <td>
                                            @if (isset($data->{$row->Field_Name_Deduction}) &&
                                                    is_numeric($data->{$row->Field_Name_Deduction}) &&
                                                    $data->{$row->Field_Name_Deduction} > 0)
                                                {{ number_format($data->{$row->Field_Name_Deduction}, 2) }}
                                            @else
                                                {{ '-' }}
                                            @endif
                                        </td>
                                        @php  $k++;  @endphp
                                    </tr>
                                    <tr>
                                        <td>{{ $row->{'Mock Drill Text'} }}</td>
                                        <td>{{ $numberOfPerson[$k] ?? '' }}</td>
                                        <td>{{ $numberOfDays[$k] ?? '' }}</td>
                                        <td id="">
                                            {{ isset($data->{$row->MockDrillFiledName}) ? number_format($data->{$row->MockDrillFiledName}, 0, '', '') : 0 }}
                                        </td>
                                        <td>
                                            @if (isset($data->{$row->MockDrillFiledName_Deduction}) &&
                                                    is_numeric($data->{$row->MockDrillFiledName_Deduction}) &&
                                                    $data->{$row->MockDrillFiledName_Deduction} > 0)
                                                {{ number_format($data->{$row->MockDrillFiledName_Deduction}, 2) }}
                                            @else
                                                {{ '-' }}
                                            @endif
                                        </td>
                                    </tr>
                                @endif
                            @else
                                @if ($row->{'isExtrafield'} != 1 && $row->{'Source Code'} != 'TDS WITH LABEL' && $row->{'Source Code'} != 'ADVANCEPAYMENT')
                                    <tr>
                                        <td>{{ ++$i }}.</td>
                                        <td>{{ $row->{'Source Name'} }}</td>
                                        <td>{{ $row->{'Remuneration Text'} }}</td>
                                        <td>{{ $numberOfPerson[$k] ?? '' }}</td>
                                        <td>{{ $numberOfDays[$k] ?? '' }}</td>
                                        <td id="">
                                            {{ isset($data->{$row->Field_Name}) ? number_format($data->{$row->Field_Name}, 0, '', '') : 0 }}
                                            <br>
                                            @if (
                                                $row->{'Source Code'} == 'MISCELLANEOUS CHARGE' && (!empty($data->{'File Path'} && $data->{'File Path'} != 'NA' && $data->{'File Path'} != 0)))
                                                <a href="{{ $data->{'File Path'} }}" target="_blank"
                                                    style="margin-top:2px;">View</a>
                                            @endif
                                        </td>
                                        <td>{{ $deductionValue }}</td>
                                    </tr>
                                @endif
                            @endif
                            @php $k++ @endphp
                        @endforeach
                        @if ($data->{'Other Charges'} > 0)
                            <tr>
                                <td class="centered">{{ ++$i }}</td>
                                <td>Other Charges*</td>
                                <td></td>
                                <td></td>
                                <td></td>
                                <td class="centered">{{ number_format($data->{'Other Charges'}, 2) }}
                                </td>
                                <td></td>
                            </tr>
                        @endif
                        <tr>
                            <td colspan="7" style="text-align: center !important;"><strong>*Note: In the case of a
                                    City Coordinator and Centre Superintendent being the same, you pluck a bill for the
                                    staff cannot be submitted.</strong></td>
                        </tr>
                        <tr>
                            <td colspan="2"><strong>Total Expenditure</strong></td>
                            <td></td>
                            <td></td>
                            <td></td>
                            <td id="TotalExpenditureTd">
                                <strong>{{ isset($data->{'Total Expenditure Amount'}) ? number_format($data->{'Total Expenditure Amount'}, 0, '', '') : 0 }}</strong>
                            </td>
                            <td></td>
                        </tr>

                        <tr>
                            <td colspan="2"><strong>Advance Amount</strong></td>
                            <td></td>
                            <td></td>
                            <td></td>
                            <td id="AdvancedNtaAmountTd"><strong>
                                    {{ isset($data->{'Amount Rec_ in Advance'}) ? number_format($data->{'Amount Rec_ in Advance'}, 0, '', '') : 0 }}</strong>
                            </td>
                            <td></td>
                        </tr>
                        <tr>
                            <td colspan="2"><strong>TDS on Remuneration</strong></td>
                            <td></td>
                            <td></td>
                            <td></td>
                            <td id=""><strong>
                                    {{ isset($data->{'TDS_Amount'}) ? number_format($data->{'TDS_Amount'}, 0, '', '') : 0 }}</strong>
                            </td>
                            <td></td>
                        </tr>
                        <tr>
                            <td colspan="2"><strong>Net Amount payable by NTA</strong></td>
                            <td></td>
                            <td></td>
                            <td></td>
                            <td id="NetPayableAmountTd">
                                <strong>{{ isset($data->{'Net Amount Payable'}) ? number_format($data->{'Net Amount Payable'}, 0, '', '') : 0 }}</strong>
                            </td>
                            <td></td>
                        </tr>
                        <?php if($data->{'Total Deductions Amount'} > 0){ ?>
                        <tr>
                            <td colspan="2"><strong>Total Deductions Amount</strong></td>
                            <td></td>
                            <td></td>
                            <td></td>
                            <td><strong>-
                                    {{ isset($data->{'Total Deductions Amount'}) ? number_format($data->{'Total Deductions Amount'}, 0, '', '') : 0 }}</strong>
                            </td>
                            <td></td>
                        </tr>
                        <tr>
                            <td colspan="2" class="fw-bold"><strong>Net Payable After Deductions</strong></td>
                            <td></td>
                            <td></td>
                            <td></td>
                            <td> <strong>
                                    {{ isset($data->{'Net Payable After Deductions'}) ? number_format($data->{'Net Payable After Deductions'}, 0, '', '') : 0 }}</strong>
                            </td>
                            <td></td>
                        </tr>
                        <?php } ?>
                    </tbody>
                </table>

                <p class="m-0 text-start"><strong>*This is computer generated hence, signature not required.</strong>
                </p>
                <p><b>Bill Submitted Date: </b>
                    {{ isset($data->{'Created on'}) && !empty($data->{'Created on'}) ? date('d-m-Y', strtotime($data->{'Created on'})) : '' }}
                </p>
            </div>
        </div>
    </div>
</body>

</html>
