@extends('layouts.admin')
@section('content')

    <style>
        .modal-dialog {
            max-width: 90%;
        }

        /* .row {
            padding-bottom: 5px;
        } */

        table td:nth-child(3) {
            word-wrap: break-word;
            word-break: break-all;
            white-space: normal;
        }
    </style>
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            @if (session('error'))
                <div class="alert alert-danger alert-dismissible fade show mt-5" role="alert">
                    {{ session('error') }}
                    <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                </div>
            @endif

            <div class="content-body">
                <div class="card mt-50 mb-50">
                    <div class="card-header">
                        <h4 class="mb-2 p-1 fw-bold fs-3">{{ config('constants.RoleName')[session('role')] }} Bill List</h4>
                    </div>
                    <div class="card-body">
                        <form action="{{ route('submit-bill-report') }}" method="get">
                            <?php
                            $selectedBillStatus = old('bill_status', isset($_GET['bill_status']) ? $_GET['bill_status'] : '');
                            ?>
                            <div class="custom-form">
                                <div class="row mb-5">
                                    <div class="form-group col-md-4">
                                        <label>Bill status:</label>
                                        <select class="form-select form-control p-2" name="bill_status" id="bill_status">
                                            <option value="">Select Bill Status</option>
                                            <option value="0" {{ $selectedBillStatus === '0' ? 'selected' : '' }}>
                                                Submitted</option>
                                            <option value="1" {{ $selectedBillStatus === '1' || $selectedBillStatus === '2' || $selectedBillStatus === '4' ? 'selected' : '' }}>
                                                In Process</option>
                                            <option value="3" {{ $selectedBillStatus === '3' ? 'selected' : '' }}>Sent
                                                for clarification</option>
                                            <option value="5" {{ $selectedBillStatus === '5' ? 'selected' : '' }}>
                                                Settled</option>
                                        </select>
                                    </div>
                                    <div class="form-group col-md-6">
                                        <div class="row">
                                            <div class="col-md-4">
                                                <label>&nbsp;</label>
                                                <button type="submit"
                                                    class="btn btn-block btn-success form-control border-0">Search</button>
                                            </div>
                                            <div class="col-md-4">
                                                <label>&nbsp;</label>
                                                <a href="{{ route('submit-bill-report') }}"
                                                    class="form-control btn btn-block btn-secondary border-0">
                                                    Reset
                                                </a>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                        </form>
                        @if (isset($role) && ($role == 1 || $role == 11 || $role == 12 || $role == 13 || $role == 14))
                            <div class="table-responsive">
                                <table id="exportR" class="table table-striped table-bordered">
                                    <thead class="thead-light">
                                        <tr>
                                            <th>S.No</th>
                                            <th>Reference No.</th>
                                            <th>Centre Number</th>
                                            <th>City</th>
                                            <th>Exam Details</th>
                                            <th>Total Amount</th>
                                            <th>Bill Date</th>
                                            <th>Status</th>
                                            <th>Remark</th>
                                            <th>Actions</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @if (count($billsDetails) > 0)
                                            @foreach ($billsDetails as $key => $billData)
                                                @php
                                                    if ($billData->billStatus == 0) {
                                                        $Billstatus = 'Submitted';
                                                    } elseif ($billData->billStatus == 1 || $billData->billStatus == 2 || $billData->billStatus == 4) {
                                                        $Billstatus = 'In Process';
                                                    } elseif ($billData->billStatus == 3) {
                                                        $Billstatus = 'Sent for clarification';
                                                    } elseif ($billData->billStatus == 5) {
                                                        $Billstatus = 'Settled';
                                                    } else {
                                                        $Billstatus = '';
                                                    }

                                                    $remark = '-';
                                                    if ($billData->billStatus == 3 && isset($billData->RejectionRemark) && !empty($billData->RejectionRemark)) {
                                                        $remark = $billData->RejectionRemark;
                                                    } elseif ($billData->billStatus == 5 && isset($billData->{'Remark'}) &&!empty($billData->{'Remark'})) {
                                                        $remark = $billData->{'Remark'};
                                                    }

                                                @endphp
                                                <tr>
                                                    <td>{{ $key + 1 }}</td>
                                                    <td style="width:5%;">
                                                        {{ isset($billData->{'ReferenceNo'}) ? $billData->{'ReferenceNo'} : null }}
                                                    </td>
                                                    <td style="width:30%;">
                                                        {{ isset($billData->{'CENTNO'}) ? $billData->{'CENTNO'} : null }}
                                                    </td>
                                                    <td style="width:10%;">
                                                        {{ isset($billData->{'centerCity'}) ? $billData->{'centerCity'} : null }}
                                                    </td>
                                                    <td style="width:10%;">
                                                        {{ isset($billData->{'examName'}) ? $billData->{'examName'} : null }}
                                                    </td>
                                                    <td style="width:8%;">
                                                        {{ isset($billData->{'netAmountPayable'}) ? number_format($billData->{'netAmountPayable'}, 2) : null }}
                                                    </td>
                                                    <td style="width:10%;">
                                                        {{ isset($billData->{'billDate'}) ? date('d-m-Y', strtotime($billData->{'billDate'})) : null }}
                                                    </td>
                                                    <td style="width:5%;">{{ $Billstatus }}</td>
                                                    <td style="width:5%;">{{ $remark }}</td>
                                                    <td style="width:15%;">

                                                        <a id="openModalLink" data-bs-toggle="modal" data-bs-target="#myModal"
                                                            onclick="ViewCCBillDetails('<?= $billData->ObserverID ?>','<?= $billData->ExamType ?>','<?= $billData->ReferenceNo ?>','<?=session('role') ?>','<?=$billData->IsNewBill?>','<?= $billData->{'CENTNO'}?>')"
                                                            data-placement="top" title="View"
                                                            class="btn btn-success text-white">
                                                            View
                                                        </a>
                                                        @if($billData->IsNewBill==1)
                                                        @if($role == 14)
                                                            <a class="btn btn-warning text-white"
                                                            href="{{ route('CS_PDF_Report', ["$billData->ReferenceNo", "$billData->ExamType", session('role'), 'pdf', "$billData->ObserverID", "$billData->CENTNO"]) }}">
                                                                Download
                                                            </a>
                                                            @else
                                                                <a class="btn btn-warning text-white"
                                                                href="{{ route('downloadPdf_Single', ["$billData->ReferenceNo", "$billData->ExamType", session('role'), 'pdf', "$billData->ObserverID"]) }}">
                                                                    Download
                                                                </a>

                                                        @endif
                                                        @else
                                                            |@if($role == 14)
                                                            <a class="btn btn-warning text-white"
                                                            href="<?=route('cs-old-report-pdf',[$billData->{'ReferenceNo'}, $billData->ExamType,$billData->ObserverID,'pdf'])?>">Download</a>
                                                            @else
                                                            <a class="btn btn-warning text-white"
                                                                href="{{ route('cc-old-report-pdf', [$billData->{'ReferenceNo'}, $billData->ExamType,$billData->ObserverID,'pdf']) }}">Download</a>
                                                            @endif
                                                        @endif
                                                    </td>
                                                </tr>
                                            @endforeach
                                        @else
                                            <tr>
                                                <td colspan="9">
                                                    <center>No Data Found !!</center>
                                                </td>
                                            </tr>
                                        @endif
                                    </tbody>
                                </table>
                                    {!! $billsDetails->withQueryString()->links('pagination::bootstrap-5') !!}
                            </div>
                        @endif

                        @if (isset($role) && ($role == 5 || $role == 2 || $role == 3 || $role == 7 || $role == 10))

                         {{-- @php prd($billsDetails);@endphp --}}
                            <div class="table-responsive">
                                <table id="exportR" class="table table-striped table-bordered">
                                    <thead class="thead-light">
                                        <tr>
                                        <th>S.No</th>
                                            <th>Reference No.</th>
                                            <th>Centre Number</th>
                                            <th>Exam Details</th>
                                            <th>Total Amount</th>
                                            <th>Bill Date</th>
                                            <th>Status</th>
                                            <th>Remark</th>
                                            <th>Actions</th>
                                        </tr>
                                    </thead>
                                    <tbody>

                                        @if (count($billsDetails) > 0)

                                            @foreach ($billsDetails as $key => $billData)
                                                @php

                                                    if ($billData->billStatus == 0) {
                                                        $Billstatus = 'Submitted';
                                                    } elseif ($billData->billStatus == 1 || $billData->billStatus == 2 || $billData->billStatus == 4) {
                                                        $Billstatus = 'In Process';
                                                    } elseif ($billData->billStatus == 3) {
                                                        $Billstatus = 'Sent for clarification';
                                                    } elseif ($billData->billStatus == 5) {
                                                        $Billstatus = 'Settled';
                                                    } else {
                                                        $Billstatus = '';
                                                    }
                                                    $remark = '-';
                                                    if ($billData->billStatus == 3 && isset($billData->RejectionRemark) && !empty($billData->RejectionRemark)) {
                                                        $remark = $billData->RejectionRemark;
                                                    } elseif ($billData->billStatus == 5 && isset($billData->{'Remark'}) &&!empty($billData->{'Remark'})) {
                                                        $remark = $billData->{'Remark'};
                                                    }

                                                @endphp
                                                <tr>
                                                    <td>{{ $key + 1 }}</td>
                                                    <td>{{ isset($billData->{'ReferenceNo'}) ? $billData->{'ReferenceNo'} : null }}
                                                    </td>
                                                    <td>{{ isset($billData->{'CENTNO'}) ? $billData->{'CENTNO'} : null }}
                                                    </td>
                                                    <td>{{ isset($billData->{'examName'}) ? $billData->{'examName'} : null }}
                                                    </td>
                                                    <td>
                                                        {{ isset($billData->{'netAmountPayableAfterDeduction'}) && is_numeric($billData->{'netAmountPayableAfterDeduction'}) ? number_format($billData->{'netAmountPayableAfterDeduction'}, 2) : '' }}
                                                    </td>
                                                    <td>{{ isset($billData->{'billDate'}) ? date('d-m-Y', strtotime($billData->{'billDate'})) : null }}
                                                    </td>
                                                    <td>{{ $Billstatus }}</td>
                                                    <td>{{ $remark }}</td>
                                                    <td>
                                                        <a id="openModalLink" data-bs-toggle="modal" data-bs-target="#myModal"
                                                            onclick="ViewOBSDetails('<?= $billData->ObserverID ?>','<?= $billData->ExamType ?>','<?= $billData->ReferenceNo ?>','<?= $billData->IsNewBill ?>')"
                                                            data-placement="top" title="View"
                                                            class="btn btn-success text-white">
                                                            View
                                                        </a>
                                                        |
                                                        <a class="btn btn-warning text-white"
                                                        href="<?=route('OBS_PDF_Report_Single',[$billData->{'ReferenceNo'},$billData->ExamType,session('role'),'pdf',$billData->ObserverID,$billData->CENTNO])?>">Download</a>
                                                    </td>
                                                </tr>
                                            @endforeach
                                        @else
                                            <tr>
                                                <td colspan="9">
                                                    <center>No Data Found !!</center>
                                                </td>
                                            </tr>
                                        @endif
                                    </tbody>
                                </table>
                                {!! $billsDetails->withQueryString()->links('pagination::bootstrap-5') !!}
                            </div>
                        @endif

                    </div>
                </div>
            </div>
        </div>
        </div>
    </main>
    <div class="modal fade" id="myModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="exampleModalLabel">Bill Details</h5>

              <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>

            </div>
            <div class="modal-body">
                <span class="text-danger" id="errorMsg"></span>
              <div class="appendHtml"></div>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
            </div>
          </div>
        </div>
    </div>
@endsection

<!-- Bootstrap JS -->
<script src="https://stackpath.bootstrapcdn.com/bootstrap/5.3.0/js/bootstrap.bundle.min.js"></script>
@section('script')
    <script type="text/javascript">
        function ViewCCBillDetails(ObserverID, ExamType, ReferenceNo,role,IsNewBill,CenterNo) {
           if(IsNewBill==1)
           {
                if(role==14)
                {
                    var route="{{route('cs-bill-preview')}}";
                }else{
                    var route="{{route('get-offline-CC-bill-data')}}";
                }
            }else{
                if(role==14)
                {
                var route="{{route('cs-old-report')}}";
                }else{
                    var route="{{route('cc-old-report')}}";
                }
            }
            $.ajax({
                url: route,
                type: 'POST',
                data: {
                    ObserverID: ObserverID,
                    ExamType: ExamType,
                    referenceID: ReferenceNo,
                    role: role,
                    CENTNO:CenterNo,
                    _token: '{{ csrf_token() }}'
                },
                beforeSend: function() {
                    $('.overlay').show();
                },
                success: function(response) { //alert(response);
                    $('.appendHtml').html(response);
                    $('.overlay').hide();
                },
                error: function(xhr, status, error) {
                    console.error("AJAX Error: ", status, error);
                    // Check if the server response contains a JSON error message
                    if (xhr.responseJSON && xhr.responseJSON.message) {
                        errorMessage = xhr.responseJSON.message;
                    } else if (xhr.responseText) {
                        // If not JSON, try to parse as text
                        try {
                            const responseObj = JSON.parse(xhr.responseText);
                            if (responseObj.message) {
                                errorMessage = responseObj.message;
                            }
                        } catch (e) {
                            console.error("Error parsing response:", e);
                        }
                    }
                    console.log(errorMessage);
                    $('#errorMsg').html('An error occurred while processing your request. Please try again.<br> <b>Error: </b>'  + errorMessage);
                    $('.overlay').hide();
                }
            });
        }

        function ViewOBSDetails(ObserverID, ExamType, ReferenceNo, IsNewBill) {

            $.ajax({
                url: "{{ route('get-obs-bill-data') }}",
                type: 'POST',
                data: {
                    ObserverID: ObserverID,
                    ExamType: ExamType,
                    ReferenceNo: ReferenceNo,
                    IsNewBill: IsNewBill,
                    _token: '{{ csrf_token() }}'
                },
                beforeSend: function() {
                    $('.overlay').show();
                },
                success: function(response) { //alert(response);
                    $('.appendHtml').html(response);
                    $('.overlay').hide();
                },
                error: function(xhr, status, error) {
                    console.error("AJAX Error: ", status, error);
                    // Check if the server response contains a JSON error message
                    if (xhr.responseJSON && xhr.responseJSON.message) {
                        errorMessage = xhr.responseJSON.message;
                    } else if (xhr.responseText) {
                        // If not JSON, try to parse as text
                        try {
                            const responseObj = JSON.parse(xhr.responseText);
                            if (responseObj.message) {
                                errorMessage = responseObj.message;
                            }
                        } catch (e) {
                            console.error("Error parsing response:", e);
                        }
                    }
                    console.log(errorMessage);
                    $('#errorMsg').html('An error occurred while processing your request. Please try again.<br> <b>Error: </b>'  + errorMessage);
                    $('.overlay').hide();
                }
            });
        }
    </script>
@endsection
