@extends('layouts.admin')
@section('content')
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        @include('layouts.partials.left_navbar')

                        <div class="col-sm-8">
                            <div class="content-body">
                                <div class="tab-content">
                                    <div class="tab-pane active" id="local">
                                        <div class="row no-gutters">
                                            <div class="col-sm-12">
                                                <div id="main">
                                                    <div class="card">
                                                        <div class="card-header" style="background-color: #d0d9d4;">
                                                            <span class="font-weight-bold fs-5"> Personal
                                                                &amp; Bank Details</span>
                                                        </div>
                                                        <div id="faq1" class="collapse show" aria-labelledby="faqhead1"
                                                            data-parent="#faq">
                                                            <div class="card-body">
                                                                <div class="custom-form">
                                                                    <div class="row">
                                                                        <div class="form-group col-md-6">
                                                                            <label>Full Name </label>
                                                                            <div class="mb-3 field-FullName required">

                                                                                <input type="text" id="FullName"
                                                                                    class="form-control form-control-sm required"
                                                                                    value="{{ isset($userProfile->vendorDetails->{'Name'}) ? $userProfile->vendorDetails->{'Name'} : null }}"
                                                                                    disabled="" maxlength="200"
                                                                                    placeholder="Enter Full Name"
                                                                                    minlength="2" aria-required="true">

                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                        </div>

                                                                        <div class="form-group col-md-6">
                                                                            <label>Email </label>
                                                                            <div class="mb-3 field-Email required">

                                                                                <input type="text" id="Email"
                                                                                    class="form-control form-control-sm"
                                                                                    disabled="" maxlength="200"
                                                                                    placeholder="Enter Email"
                                                                                    value="{{ isset($userProfile->vendorDetails->{'E-Mail'}) ? $userProfile->vendorDetails->{'E-Mail'} : null }}"
                                                                                    minlength="2" aria-required="true">

                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                        </div>

                                                                        <div class="form-group col-md-6">
                                                                            <label>Mobile No </label>
                                                                            <div class="mb-3 field-MobileNo required">

                                                                                <input type="text" id="MobileNo"
                                                                                    class="form-control form-control-sm"
                                                                                    value="{{ isset($userProfile->vendorDetails->{'Mobile Phone No_'}) ? $userProfile->vendorDetails->{'Mobile Phone No_'} : null }}"
                                                                                    disabled="" maxlength="12"
                                                                                    placeholder="Enter Mobile No"
                                                                                    minlength="12" aria-required="true">

                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                        </div>

                                                                        <div class="form-group col-md-6">
                                                                            <label>Date of Birth </label>
                                                                            <div class="mb-3 field-dashboard-dob required">

                                                                                <input type="text" id="dashboard-dob"
                                                                                    class="form-control hasDatepicker"
                                                                                    value="{{ isset($userProfile->{'Vendor D_O_B'}) ? date('Y-m-d', strtotime($userProfile->{'Vendor D_O_B'})) : null }}"
                                                                                    disabled="" autocomplete="off"
                                                                                    onpaste="return false"
                                                                                    placeholder="dd-mm-yyyy" size="10">


                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                        </div>
                                                                        <div class="form-group col-md-6">
                                                                            <label>Address </label>

                                                                            <div class="mb-3 field-Address required">

                                                                                <input type="text" id="Address"
                                                                                    class="form-control form-control-sm"
                                                                                    value="{{ isset($userProfile->vendorDetails->{'Address'}) ? $userProfile->vendorDetails->{'Address'} : null }}"
                                                                                    disabled="" maxlength="500"
                                                                                    placeholder="Enter Aadhar Number"
                                                                                    minlength="12" aria-required="true">

                                                                                <div class="invalid-feedback">
                                                                                </div>
                                                                            </div>

                                                                        </div>

                                                                        <div class="form-group col-md-6">
                                                                            <label>Bank Name </label>
                                                                            <div class="mb-3 field-BankName required">

                                                                                <input type="text" id="BankName"
                                                                                    class="form-control form-control-sm"
                                                                                    name="Dashboard[BankName]"
                                                                                    value="{{ isset($userProfile->{'Bank Name'}) ? $userProfile->{'Bank Name'} : null }}"
                                                                                    disabled="" maxlength="200"
                                                                                    placeholder="Enter Bank Name"
                                                                                    minlength="2" aria-required="true">

                                                                                <div class="invalid-feedback">
                                                                                </div>
                                                                            </div>
                                                                        </div>
                                                                        <div class="form-group col-md-6">
                                                                            <label>Branch Name </label>
                                                                            <div class="mb-3 field-BankName required">

                                                                                <input type="text" id="BankName"
                                                                                    class="form-control form-control-sm"
                                                                                    value="{{ isset($userProfile->{'Branch'}) ? $userProfile->{'Branch'} : null }}"
                                                                                    disabled="" maxlength="200"
                                                                                    placeholder="Enter Branch Name"
                                                                                    minlength="2" aria-required="true">

                                                                                <div class="invalid-feedback">
                                                                                </div>
                                                                            </div>
                                                                        </div>

                                                                        <div class="form-group col-md-6">
                                                                            <label>IFSC </label>
                                                                            <div class="mb-3 field-IfscNumber required">

                                                                                <input type="text" id="IfscNumber"
                                                                                    class="form-control form-control-sm"
                                                                                    value="{{ isset($userProfile->{'IFSC Code'}) ? $userProfile->{'IFSC Code'} : null }}"
                                                                                    disabled="" maxlength="8"
                                                                                    placeholder="Enter IFSC"
                                                                                    minlength="8" aria-required="true">

                                                                                <div class="invalid-feedback">
                                                                                </div>
                                                                            </div>
                                                                        </div>

                                                                        <div class="form-group col-md-6">
                                                                            <label>Account Holder Name </label>
                                                                            <div class="mb-3 field-AccountHolderName  required">

                                                                                <input type="text" id="AccountHolderName"
                                                                                    class="form-control form-control-sm required"
                                                                                    value="{{ isset($userProfile->{'Account Holder Name'}) ? $userProfile->{'Account Holder Name'} : null }}"
                                                                                    disabled="" maxlength="16"
                                                                                    placeholder="Enter Account Holder Name"
                                                                                    minlength="16" aria-required="true">

                                                                                <div class="invalid-feedback">
                                                                                </div>
                                                                            </div>
                                                                        </div>
                                                                        <div class="form-group col-md-6">
                                                                            <label>Account Number </label>
                                                                            <div class="mb-3 field-AccountNumber required">

                                                                                <input type="text" id="AccountNumber"
                                                                                    class="form-control form-control-sm required"
                                                                                    value="{{ isset($userProfile->{'Vendor Account No_'}) ? $userProfile->{'Vendor Account No_'} : null }}"
                                                                                    disabled="" maxlength="16"
                                                                                    placeholder="Enter Account Number"
                                                                                    minlength="16" aria-required="true">

                                                                                <div class="invalid-feedback">
                                                                                </div>
                                                                            </div>
                                                                        </div>
                                                                        <div class="form-group col-md-6">
                                                                            <label>PAN Number </label>

                                                                            <div class="mb-3 field-PanNumber required">

                                                                                <input type="text" id="PanNumber"
                                                                                    class="form-control form-control-sm"
                                                                                    value="{{ isset($userProfile->VendorPanDetails->{'P_A_N_ No_'}) ? $userProfile->VendorPanDetails->{'P_A_N_ No_'} : null }}"
                                                                                    disabled="" maxlength="10"
                                                                                    placeholder="Enter PAN Number"
                                                                                    minlength="10" aria-required="true">

                                                                                <div class="invalid-feedback">
                                                                                </div>
                                                                            </div>
                                                                        </div>

                                                                        @if (isset($userProfile) && !empty($userProfile->{'PAN Image Path'}) && $userProfile->{'PAN Image Path'} != 'NULL')
                                                                            <div class="form-group col-md-6">
                                                                                <label>PAN Image: </label>

                                                                                <a href="{{ $userProfile->{'PAN Image Path'} }}"
                                                                                    download="{{ $userProfile->{'PAN Image Path'} }}">
                                                                                    <i class="fa fa-download"
                                                                                        title="Download"
                                                                                        aria-hidden="true"></i></a>&nbsp;&nbsp;
                                                                                <a href="{{ route('deleteImg', [app()->getLocale(), 'id' => $userProfile->No_, 'type' => 'PAN Image Path']) }}"
                                                                                    class="deleteDataR"
                                                                                    onclick="return confirm('Are you sure?')"
                                                                                    data-id="panImage"> <i
                                                                                        class="fa fa-trash text-danger"
                                                                                        aria-hidden="true"
                                                                                        title="Delete"></i> </a>


                                                                            </div>
                                                                        @endif
                                                                        @if (isset($userProfile->{'Cancelled Cheque Path'}) &&
                                                                                !empty($userProfile->{'Cancelled Cheque Path'}) &&
                                                                                $userProfile->{'Cancelled Cheque Path'} != 'NULL')
                                                                            <div class="form-group col-md-6">
                                                                                <label>Cancelled Cheque: </label>

                                                                                <a href="{{ $userProfile->{'Cancelled Cheque Path'} }}"
                                                                                    download=""> <i
                                                                                        class="fa fa-download"
                                                                                        title="Download"
                                                                                        aria-hidden="true"></i></a>&nbsp;&nbsp;
                                                                                <a href="{{ route('deleteImg', [app()->getLocale(), 'id' => $userProfile->No_, 'type' => 'Cancelled Cheque Path']) }}"
                                                                                    class="deleteDataR"
                                                                                    onclick="return confirm('Are you sure?')"
                                                                                    data-id="cancelImage"> <i
                                                                                        class="fa fa-trash  text-danger"
                                                                                        aria-hidden="true"
                                                                                        title="Delete"></i> </a>

                                                                            </div>
                                                                        @endif
                                                                        @if (isset($userProfile) && !empty($userProfile->{'Profile Image'}) && $userProfile->{'Profile Image'} != 'NULL')
                                                                            <div class="form-group col-md-6">
                                                                                <label>Profile Image: </label>

                                                                                <a href="{{ $userProfile->{'Profile Image'} }}"
                                                                                    download=""> <i
                                                                                        class="fa fa-download"
                                                                                        title="Download"
                                                                                        aria-hidden="true"></i></a>&nbsp;&nbsp;
                                                                                <a href="{{ route('deleteImg', [app()->getLocale(), 'id' => $userProfile->No_, 'type' => 'Profile Image']) }}"
                                                                                    class="deleteDataR"
                                                                                    onclick="return confirm('Are you sure?')"
                                                                                    data-id="profileImage"> <i
                                                                                        class="fa fa-trash  text-danger"
                                                                                        aria-hidden="true"
                                                                                        title="Delete"></i> </a>


                                                                            </div>
                                                                        @endif

                                                                        <div class="form-group col-md-12 text-right">
                                                                            <a href="{{ route('edit-profile') }}"><button
                                                                                    type="button"
                                                                                    class="btn btn-warning mt-10 pull-right"
                                                                                    maxlength="10">Edit</button></a>
                                                                        </div>
                                                                    </div>

                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
