<?php

use DaveJamesMiller\Breadcrumbs\Facades\Breadcrumbs;
use Illuminate\Support\Facades\Route;

Breadcrumbs::for('home', function ($trail) {
    $trail->push('Home', route('admin.superdashboard'));
});

//Exam List Breadcrumb

Breadcrumbs::for('examList', function ($trail) {
    $trail->parent('home');
    $trail->push('Exam Master List', route('exam.index'));
});

// Add Exam Breadcrumb
Breadcrumbs::for('examadd', function ($trail) {
    $trail->parent('examList');
    $trail->push('Add New Exam', route('exam.add'));
});

// Edit Exam Breadcrumb
Breadcrumbs::for('examedits', function ($trail) {
    $trail->parent('examList');
    $trail->push('Edit Exam', route('exam.add'));
});

//Duty data List Breadcrumb
Breadcrumbs::for('dutyDataList', function ($trail) {
    $trail->parent('home');
    $trail->push('Duty Data List', route('importrem.index'));
});

//Add Duty data Breadcrumb
Breadcrumbs::for('dutyDataadd', function ($trail) {
    $trail->parent('dutyDataList');
    $trail->push('Add New Duty Data', route('importrem.add'));
});

// Update Shift Remuneration data Breadcrumb
Breadcrumbs::for('UpdateDutyDays', function ($trail) {
    $trail->parent('dutyDataList');
    $trail->push('Update Duty Data', route('edit.dutydays'));
});

//Shift remuneration  data List Breadcrumb
Breadcrumbs::for('shiftRemunerationList', function ($trail) {
    $trail->parent('home');
    $trail->push('Shift Wise Duty Data List', route('importrem.indexshift'));
});

// Add Shift Remuneration data Breadcrumb
Breadcrumbs::for('AddshiftRemuneration', function ($trail) {
    $trail->parent('shiftRemunerationList');
    $trail->push('Add New Shift Remuneration Data', route('importrem.addshift'));
});

// Update Shift Remuneration data Breadcrumb
Breadcrumbs::for('UpdateShiftRemuneration', function ($trail) {
    $trail->parent('shiftRemunerationList');
    $trail->push('Update Shiftwise Duty Data', route('shiftwise.dutyDays.update'));
});


//Vendor List Breadcrumb
Breadcrumbs::for('vendorList', function ($trail) {
    $trail->parent('home');
    $trail->push('Functionary List', route('import-vendor-details'));
});

//Add Vendor Breadcrumb
Breadcrumbs::for('AddVendor', function ($trail) {
    $trail->parent('vendorList');
    $trail->push('Add New Functionary', route('import-vendor-details.add'));
});

//Edit Vendor Breadcrumb
Breadcrumbs::for('EditVendor', function ($trail,$vendor) {
    $trail->parent('vendorList');
    $trail->push('Edit Functionary', route('admin.vendor-details-edit',$vendor->No_));
});

//Financial Norms List Breadcrumb
Breadcrumbs::for('financialNormsList', function ($trail) {
    $trail->parent('home');
    $trail->push('Financial Norms List', route('import-financial-norms'));
});

//Add Financial Norms Breadcrumb
Breadcrumbs::for('AddFinancialNorms', function ($trail) {
    $trail->parent('financialNormsList');
    $trail->push('Add New Financial Norms', route('importfinancial.add'));
});

//Edit Financial Norms Breadcrumb
Breadcrumbs::for('EditFinancialNorms', function ($trail,$financeNorms) {
    $trail->parent('financialNormsList');
    $trail->push('Edit Financial Norms', route('importfinance.edit',$financeNorms->{'Document No_'}));
});

//Import Financial Norms Breadcrumb
Breadcrumbs::for('ImportFinancialNorms', function ($trail) {
    $trail->parent('financialNormsList');
    $trail->push('Import Financial Norms', route('importfinancial_bulk.add'));
});

//Advance Payment List Breadcrumb
Breadcrumbs::for('AdvancePaymentList', function ($trail) {
    $trail->parent('home');
    $trail->push('Advance Payment List', route('list-advance'));
});

//Add Advance Payment Breadcrumb
Breadcrumbs::for('AddAdvancePayment', function ($trail) {
    $trail->parent('AdvancePaymentList');
    $trail->push('Add Advance Payment Details', route('add-advance'));
});

//Edit Advance Payment Breadcrumb
Breadcrumbs::for('EditAdvancePayment', function ($trail,$advance) {
    $trail->parent('AdvancePaymentList');
    $trail->push('Edit Advance Payment Details', route('edit-advance',$advance->{'Advance No_'}));
});

//Import Advance Payment Breadcrumb
Breadcrumbs::for('ImportAdvancePayment', function ($trail) {
    $trail->parent('AdvancePaymentList');
    $trail->push('Import Advance Payment Details', route('import-advance'));
});

//Form Field List Breadcrumb
Breadcrumbs::for('FormFieldList', function ($trail) {
    $trail->parent('home');
    $trail->push('Form Fields List', route('form-fields'));
});

//Add Form Field  Breadcrumb
Breadcrumbs::for('AddFormFields', function ($trail) {
    $trail->parent('FormFieldList');
    $trail->push('Add Form Fields', route('form-fields.add'));
});




//Count Payment List Breadcrumb
Breadcrumbs::for('CountPaymentList', function ($trail) {
    $trail->parent('home');
    $trail->push('Candidate Wise Count List', route('list-count'));
});

//Add Count Payment Breadcrumb
Breadcrumbs::for('AddCountPayment', function ($trail) {
    $trail->parent('CountPaymentList');
    $trail->push('Add Candidate Wise Count Details', route('add-count'));
});

//Edit Count Payment Breadcrumb
Breadcrumbs::for('EditCountPayment', function ($trail,$count) {
    $trail->parent('CountPaymentList');
    $trail->push('Edit Candidate Wise Count Details', route('edit-count',$count->ID));
});

//Import Count Payment Breadcrumb
Breadcrumbs::for('ImportCountPayment', function ($trail) {
    $trail->parent('CountPaymentList');
    $trail->push('Import Count Payment Details', route('import-count'));
});


//changes log
Breadcrumbs::for('ChangesLog', function ($trail) {
    $trail->parent('home');
    $trail->push('Log List', route('changesLog'));
});

//Bill Reports
Breadcrumbs::for('billReports', function ($trail) {
    $trail->parent('home');
    $trail->push('Bill Reports', route('billReports'));
});

//Setting Payment List Breadcrumb
Breadcrumbs::for('CommonSettingsList', function ($trail) {
    $trail->parent('home');
    $trail->push('Common Settings List', route('setting-list'));
});

//Add Setting Payment Breadcrumb
Breadcrumbs::for('AddSettingPayment', function ($trail) {
    $trail->parent('CommonSettingsList');
    $trail->push('Add Common Settings Details', route('setting-add'));
});

//Edit Setting Payment Breadcrumb
Breadcrumbs::for('EditSettingPayment', function ($trail,$count) {
    $trail->parent('CommonSettingsList');
    $trail->push('Edit Common Settings Details', route('setting-edit',$count->id));
});



