<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\SubmitBillController;
use App\Http\Controllers\ContactController;
use App\Http\Controllers\ExamDetailController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\ActivityLogController;
use App\Http\Controllers\ReportController;
use App\Http\Controllers\EmailVerificationController;
use App\Http\Controllers\markAttendanceController;
use App\Http\Controllers\ObserverController;
use App\Http\Controllers\SubmitBillReportController;
use App\Http\Controllers\PdfDownloadController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\OldReportController;

Route::middleware(['guest'])->group(function () {
    Route::get('/', [HomeController::class, 'index'])->name('home');
    Route::get('/home', [HomeController::class, 'index'])->name('home.index');
    Route::post('/user-login', [HomeController::class, 'username'])->name('username');
    Route::match(['POST', 'GET'], 'login', [HomeController::class, 'login'])->name('login');
    Route::post('/resetpassword', [HomeController::class, 'ResetPassword'])->name('resetpassword');
    Route::get('/createcredentials', [HomeController::class, 'CreateCredentials'])->name('createcredentials');

    Route::get('/forgot-password', [HomeController::class, 'forgotPassword'])->name('forgot-password');
    Route::post('/user-forgot-password', [HomeController::class, 'userForgotPassword'])->name('forgotpassworduser');
    // Route::match(['POST', 'GET'],'/userforgotpassword/{token}', [HomeController::class, 'userForgotPasswordGet'])->name('userforgotpassword.get');
    Route::get('/reset-password/{token}', [HomeController::class, 'showResetForm'])->name('password.reset');
    Route::post('/setformgotpassword', [HomeController::class, 'setFormgotPassword'])->name('setformgotpassword');
});
//auth
Route::any('/logout', [UserController::class, 'logout'])->name('logout');
Route::middleware(['auth', 'role:1,14,5'])->group(function () {
    Route::controller(DashboardController::class)->group(function () {
        Route::get('/dashboard', 'index')->name("dashboard");
        Route::match(['POST', 'GET'], '/my-profile', 'myProfile')->name("my-profile");
        Route::match(['POST', 'GET'], '/exam-dashboard', 'ExamDashboard')->name("exam-dashboard");
        Route::match(['POST', 'GET'], '/exam-subdashboard', 'ExamSubDashboard')->name('exam-subdashboard');
        Route::post('/serachExam', 'serachExam')->name("serachExam");
        Route::match(['POST', 'GET'], '/switchExam', 'switchExam')->name("switchExam");
    });
    Route::controller(UserController::class)->group(function () {
        Route::get('/view-profile', 'index')->name("view-profile");
        Route::get('/edit-profile', 'edit')->name("edit-profile");
        Route::post('/update-profile', 'update')->name("update-profile");
        Route::get('/deleteImg/{id}/{type}', 'DeleteImg')->name('deleteImg');
        Route::get('/change-password', 'ChangePassword')->name("change-password");
        Route::post('/update-password', 'UpdatePassword')->name("update-password");
    });
    Route::controller(ActivityLogController::class)->group(function () {
        Route::get('/activitylog', 'index')->name("activity-log");
    });
    Route::controller(ContactController::class)->group(function () {
        Route::match(['POST', 'GET'], '/contact', 'index')->name("contact");
        Route::get('/contact-detail', 'contactDetail')->name("contact-detail");
        Route::get('/submit-feedback', 'submitFeedback')->name("submit-feedback");
        Route::post('/submit-data', 'submitData')->name("submit-data");
    });
    Route::middleware(['checksession'])->group(function () {
        Route::match(['POST', 'GET'], '/mark-attendance', [markAttendanceController::class, 'index'])->name('mark-attendance');
        Route::post('/marked', [markAttendanceController::class, 'marked'])->name('marked');
        Route::post('/check-observer-details', [markAttendanceController::class, 'ckeckObserverDetails'])->name('check-observer-details');
        Route::post('/create-attendance', [markAttendanceController::class, 'createAttendance'])->name('create-attendance');
        // this route for create database
        Route::controller(PdfDownloadController::class)->group(function () {
            Route::get('/downloadPdf/{ReferenceNo}/{ExamType}/{role}/{pdf}/{ObserverID}/{CenterNo}', 'downloadPdf')->name('downloadPdf');
            Route::get('/CS_PDF_Report/{ReferenceNo}/{ExamType}/{role}/{pdf}/{ObserverID}/{CenterNo}', 'CS_PDF_Report')->name('CS_PDF_Report');
            Route::get('/OBS_PDF_Report/{ReferenceNo}/{ExamType}/{role}/{pdf}/{ObserverID}/{CenterNo}', 'OBS_PDF_Report')->name('OBS_PDF_Report');
            Route::get('/OBS_PDF_Report_Single/{ReferenceNo}/{ExamType}/{role}/{pdf}/{ObserverID}/{CenterNo}', 'old____OBS_PDF_Report')->name('OBS_PDF_Report_Single');
            Route::get('/downloadPdf_Single/{ReferenceNo}/{ExamType}/{role}/{pdf}/{ObserverID}', 'old___downloadPdf')->name('downloadPdf_Single');

        });
        Route::controller(ObserverController::class)->group(function () {
            Route::get('/contact-details', 'index')->name("contact-details");
        });

        Route::controller(ExamDetailController::class)->group(function () {
            Route::match(['POST', 'GET'], '/exam-detail', 'index')->name("exam-detail");
            Route::POST('/exam-detail-search', 'examDetailSearch')->name("exam-detail-search");
        });

        Route::controller(SubmitBillController::class)->group(function () {
            Route::get('/exambill', 'index')->name("exambill");
            Route::get('/exambillcs', 'index')->name("exambillcs");
            Route::get('/get-observer-details/{observer_id}', 'getObserverDetails')->name("get-observer-details");
            Route::post('/exam-bill-save', 'examBillSave')->name("examBillSave");
            Route::post('/cs-exam-bill-save', 'examBillSaveCS')->name("examBillSaveCS");
            Route::get('/tabill', 'tabill')->name("tabill");
            Route::post('/observerSave', 'observerSave')->name("observerSave");
            Route::post('/tabillSave', 'tabillSave')->name("tabillSave");
            Route::post('/check-bill-status', 'checkBillStatus')->name("check-bill-status");
            Route::post('/get-center-details', 'getCenterDetails')->name("get-center-details");
            Route::post('/get-shiftwise-data', 'getShiftWiseData')->name("get-shiftwise-data");
            Route::post('/get-daywise-count-details', 'getDaywiseCountDetails')->name("get-daywise-count-details");
        });

        Route::controller(ReportController::class)->group(function () {
            Route::get('/reports', 'index')->name("reports");
            Route::match(['POST', 'GET'], '/city-coordinator-report', 'cityCoordinatorReport')->name("city-coordinator-report");
            Route::match(['POST', 'GET'], '/city-coordinator-report/{excel}', 'cityCoordinatorReport')->name("city-coordinator-excel");
            Route::match(['POST', 'GET'], '/observer-report', 'observerReport')->name("observer-report");
            Route::match(['POST', 'GET'], '/observer-report/{excel}', 'observerReport')->name("observer-report-excel");
            Route::match(['POST', 'GET'], '/cs-report', 'CSReport')->name("cs-report");
            Route::match(['POST', 'GET'], '/cs-report/{excel}', 'CSReport')->name("cs-report-excel");
        });

        Route::controller(EmailVerificationController::class)->group(function () {
            Route::get('/email-verify', 'index')->name("email-verify");
            Route::post('/generatemailotp', 'generatemailotp')->name("generatemailotp");
            Route::post('/validatemailotp', 'validatemailotp')->name("validatemailotp");
        });
        Route::controller(SubmitBillReportController::class)->group(function () {
            Route::get('/submit-bill-report', 'index')->name("submit-bill-report");
            Route::post('/get-offline-CC-bill-data', 'getOfflineCCBillData')->name("get-offline-CC-bill-data");
            Route::post('/get-obs-bill-data', 'getObserverBillData')->name("get-obs-bill-data");
            Route::post('/cs-bill-preview', 'getCSBillData')->name("cs-bill-preview");
            Route::get('/get-observer-data/{referrence_no}/{type}', 'getObsDobsData')->name("get-observer-data");
        });
        Route::controller(OldReportController::class)->group(function () {
            Route::post('/cc-old-report', 'ccOldReport')->name("cc-old-report");
            Route::get('/cc-old-report-pdf/{referenceID}/{ExamType}/{observerID}/{pdf}', 'ccOldReport')->name("cc-old-report-pdf");
            Route::post('/cs-old-report', 'csOldReport')->name("cs-old-report");
            Route::get('/cs-old-report-pdf/{referenceID}/{ExamType}/{observerID}/{pdf}', 'csOldReport')->name("cs-old-report-pdf");
            Route::post('/ob-old-report', 'obOldReport')->name("ob-old-report");
        });
    });
});

require __DIR__ . '/superadmin.php';

